#!/bin/sh

# 起動時に設定したいIPアドレス
ipaddress_first="192.168.14.10";
# ゲートウェイ
gateway_first="192.168.14.1";

#必要なconnection名取得
ifname=$(ifconfig | grep enx | cut -d' ' -f1);

# enxを含む行のconnection名を取得
name=$(nmcli c | grep enx | cut -d' ' -f1);

# まずnameが空でないことを確認
if [ -n "$name" ]; then 
    # connection名とdevice名が一致しなければ処理する
    # （一致していたら、既に設定済みということ）
    if [ "$name" != "$ifname" ]; then

        config="/home/toa/StartupShell/ipaddress.conf";

        ipaddress=$(cat $config | cut -d' ' -f1);
        subnetmask_=$(cat $config | cut -d' ' -f2);
        gateway=$(cat $config | cut -d' ' -f3);

        subnetmask=`sh /home/toa/StartupShell/calc_subnet_bit.sh $subnetmask_`;

        # 現在のUUIDを削除する
        uuid=$(nmcli -t -f uuid c);
        nmcli connection delete $uuid;
        echo "Delete all UUID."

        # 新しい接続を追加する
        nmcli c add type ethernet ifname $ifname con-name $ifname;
        echo "Add new connection."

        # IPアドレスを変更  
        nmcli c m $ifname ipv4.method manual ipv4.addresses "$ipaddress/$subnetmask" ipv4.gateway $gateway connection.autoconnect "yes" ipv6.method ignore;
        echo "Change IP address."

        # IPアドレス変更を反映する
        nmcli con down $ifname;
        nmcli con up $ifname;

        # 各htmlページのapacheのIPを書き換える
        dir="/home/toa/TOA_AM-CF1/Webserver/static/js/";
        sed -i -e '2, 2d' ${dir}ws_set.js;
        sed -i -e "1a var NOW_IPADDRESS =\"$ipaddress\";" ${dir}ws_set.js;

        mount -o remount,rw /
        cp "/home/toa/StartupShell/ipaddress.conf" "/home/toa/TOA_AM-CF1/Application/data/config/config_net.txt"
        cp "/home/toa/StartupShell/ipaddress.conf" "/home_org/toa/TOA_AM-CF1/Application/data/config/config_net.txt"
        mount -o remount,ro /
   
        # connection名がdevice名と一致していれば、ブラウザから設定されたIPアドレスに変更する
    else
        config="/home/toa/StartupShell/ipaddress.conf";

        ipaddress=$(cat $config | cut -d' ' -f1);
        subnetmask_=$(cat $config | cut -d' ' -f2);
        gateway=$(cat $config | cut -d' ' -f3);

        subnetmask=`sh /home/toa/StartupShell/calc_subnet_bit.sh $subnetmask_`;

        nmcli c m $ifname ipv4.method manual ipv4.addresses "$ipaddress/$subnetmask" ipv4.gateway $gateway connection.autoconnect "yes" ipv6.method ignore;
        nmcli c d $ifname;
        nmcli c u $ifname;
        
        # 各htmlページのapacheのIPを書き換える
        dir="/home/toa/TOA_AM-CF1/Webserver/static/js/";
        sed -i -e '2, 2d' ${dir}ws_set.js;
        sed -i -e "1a var NOW_IPADDRESS =\"$ipaddress\";" ${dir}ws_set.js;

        mount -o remount,rw /
        cp "/home/toa/StartupShell/ipaddress.conf" "/home/toa/TOA_AM-CF1/Application/data/config/config_net.txt"
        cp "/home/toa/StartupShell/ipaddress.conf" "/home_org/toa/TOA_AM-CF1/Application/data/config/config_net.txt"
        mount -o remount,ro /

    fi
else # nameが空の時
    # 新しい接続を追加する
    nmcli c add type ethernet ifname $ifname con-name $ifname;
    echo "Add new connection."

    # IPアドレスを変更  
    nmcli c m $ifname ipv4.method manual ipv4.addresses "$ipaddress_first/24" ipv4.gateway $gateway_first connection.autoconnect "yes" ipv6.method ignore;
    echo "Change IP address."

    # IPアドレス変更を反映する
    nmcli con down $ifname;
    nmcli con up $ifname;
fi

