#include <iostream>
#include <stdint.h>
#include <picojson_misc.h>
#include "command_peak.h"
#include <dsp_lib/include/dsp/peak.h>
#include <spi/spi_api.h>
#include <control/misc.h>

using namespace std;

namespace control {

bool
CommandPeak(
	picojson::object				&command_obj_,
	std::string						access_,
	dsp_lib::DspManager::NetList	netlist_
)
{
	//uint32_t config_base	= reinterpret_cast<uint32_t>(netlist_.config);
	//uint32_t param_base		= reinterpret_cast<uint32_t>(netlist_.param);
	uint32_t status_base	= reinterpret_cast<uint32_t>(netlist_.status);

	//dsp_lib::Peak::Config*	config_offset	= 0x00000000;
	//dsp_lib::Peak::Param*	param_offset	= 0x00000000;
	dsp_lib::Peak::Status*	status_offset = 0x00000000;

	// Set, Getはswitchの外で分岐させるべき？
	if (access_ == "set") {
		cout << "no setter!" << endl;
		return false;
	}
	else if (access_ == "get") {
		if (object_member_check(command_obj_, "status", picojson::object_type) == false) {
			cout << "invalid command!" << endl;
			return false;
		}

		picojson::object status_obj = command_obj_["status"].get<picojson::object>();

		if (status_obj.count("level") == 1) {
			float level;
			if (ReadSharedRam(status_base + ToDspAddressing(&status_offset->peak_release), &level) == false) {
				cout << "read failed!" << endl;
				return false;
			}
			float level_db = PowerToDb(level);

			command_obj_["status"].get<picojson::object>().erase("level");
			command_obj_["status"].get<picojson::object>()["level"] = get_number_value(level_db);
		}
	}
	else {
		cout << "invalid accessor!\n" << endl;
		return false;
	}
	command_obj_["result"] = static_cast<picojson::value>(true);
	return true;
}

} // namespace command
