#include <iostream>
#include <stdint.h>
#include <picojson_misc.h>
#include <control/misc.h>
#include "command_rms.h"
#include <dsp_lib/include/dsp/rms.h>
#include <dsp_lib/misc/biquad/fdesign.h>
#include <dsp_lib/misc/biquad/fdesign_prototypes.h>
#include <spi/spi_api.h>

using namespace std;

namespace {
	const uint32_t SIZE_OF_IIR_COEF = 5;
}

namespace control {

bool
CommandRms(
	picojson::object				&command_obj_,
	std::string						access_,
	dsp_lib::DspManager::NetList	netlist_
)
{
	//uint32_t config_base	= reinterpret_cast<uint32_t>(netlist_.config);
	//uint32_t param_base		= reinterpret_cast<uint32_t>(netlist_.param);
	uint32_t status_base	= reinterpret_cast<uint32_t>(netlist_.status);

	//dsp_lib::Rms::Config*	config_offset	= 0x00000000;
	//dsp_lib::Rms::Param*	param_offset	= 0x00000000;
	dsp_lib::Rms::Status*	status_offset	= 0x00000000;

	if (access_ == "set") {
		cout << "no setter!" << endl;
		return false;
	} else if (access_ == "get") {
		picojson::object status_obj;
		if (get_object_member(command_obj_, "status", status_obj) == false) {
			cout << "invalid command!" << endl;
			return false;
		}

		if (status_obj.count("level") == 1) {
			float level;
			if (ReadSharedRam(status_base + ToDspAddressing(&status_offset->rms), &level) == false) {
				cout << "read failed!" << endl;
				return false;
			}
			float level_db = PowerToDb(level);

			set_object_member(status_obj, "level", level_db);
			set_object_member(command_obj_, "status", status_obj);
			//command_obj_["status"].get<picojson::object>().erase("level");
			//command_obj_["status"].get<picojson::object>()["level"] = get_number_value(level_db);
		}
	} else {
		cout << "invalid accessor!\n" << endl;
		return false;
	}
	set_object_member(command_obj_, "result", true);
	return true;
}

} // namespace command
