/*
 * dsp_module.h
 *
 *  Created on: 2016/12/14
 *      Author: toa29548
 */

#pragma once

namespace dsp_lib {

class DspModule {
public:
	/*
	各モジュールで用意するもの

	コンストラクタ(Config*, Param*, Status*);

	struct Config{
		実行時に変更しないパラメータ
	};
	struct Param{
		実行時に変更する パラメータ
	};
	struct Status{
		DSPが出力するステータス
	};

	bool Configure(Config*, Configに設定する値);
	bool Attach(Param*, Status*, Param/Statusに登録する可変長配列のアドレス);
	 */

	/*!
	 * 不正なアドレス登録、メモリ確保の失敗がないことを確認する
	 * @note インスタンス生成後、信号処理orタスク処理の実行前に必ず呼び出す
	 * @return
	 */
	virtual bool
	Ready(void) = 0;

	/*!
	 * 信号処理を実行する
	 * @note 割込みで呼び出す
	 * @param input_
	 * @param output_
	 * @return
	 */
	virtual bool
	Execute(
			const float*	input_,
				  float*	output_
	) = 0;

	/*!
	 * 時間的制約のない処理を実行する
	 * @note タスクで呼び出す
	 * @return
	 */
	virtual bool
	Task(void) = 0;

private:
	/*
	各モジュールで用意するもの

	Config	m_config;
	Param	m_param;
	Status	m_status;
	*/
};

} // namespace dsp_lib
