/*
 * instant_gain.h
 *
 *  Created on: 2014/07/02
 *      Author: toa29548
 */

#pragma once

#include <stdint.h>
#include <dsp_lib/include/dsp/instant_gain.h>
#include <dsp_lib/include/misc/null_check.h>
#include <dsp_lib/include/dsp/dsp_module.h>

namespace dsp_lib {

class InstantGain : public DspModule {
	friend class Gain;
public:
	// -------------------------------------------------------------
	// データ型
	// -------------------------------------------------------------

	struct Config{};

	struct Param{
		float gain;		//!< ゲインの目標値[真数]
	};

	struct Status{};

	// -------------------------------------------------------------
	// コンフィギュレーション（実行時に変化しないパラメータ設定）
	// -------------------------------------------------------------
	static bool Configure(void) {
		return true;
	};
	static bool Attach(void) {
		return true;
	}
	// -------------------------------------------------------------
	// パラメータ変更
	// -------------------------------------------------------------
	/*!
	 *
	 * @param param_ ゲインパラメータ構造体
	 * @param gain_ ゲイン[真数]
	 * @return
	 */
	static bool
	SetGain(
		Param*	param_,
		float		gain_
	)
	{
		if (NullCheck(param_) == false) {
			return false;
		}

		param_->gain = gain_;

		return true;
	}

public:
	InstantGain(
			Config*	/*config_*/,
			Param*	param_,
			Status*	/*status_*/
			);
	bool Ready(void);
	bool Execute(
			const float*	input_,
			float*	output_
	);
	bool Task(void);

protected:

//	Config*	m_config;
	Param*	m_param;
//	Status*	m_status;

};

} //namespace dsp_lib
