/*
 * dsp_nop.h
 *
 *  Created on: 2016/09/20
 *      Author: toa29548
 */

#pragma once

/*!
 * 信号処理を行わないダミー関数
 */

#include <dsp_lib/include/dsp/dsp_module.h>

namespace dsp_lib {

class Nop : public DspModule {
public:
	// -------------------------------------------------------------
	// データ型
	// -------------------------------------------------------------
	struct Config{};
	struct Param{};
	struct Status{};

	// -------------------------------------------------------------
	// コンフィギュレーション（実行時に変化しないパラメータ設定）
	// -------------------------------------------------------------
	static bool Configure(void) {
		return true;
	};
	static bool Attach(void) {
		return true;
	}

	Nop(
			Config*	/*config_*/,
			Param*	/*param_*/,
			Status*	/*status_*/
	);

	bool Ready(void);

	bool Execute(
			const float*	/*input_*/,
				  float*	/*output_*/
	);
	bool Task(void);

protected:
//	Config*		m_config;
//	Param*		m_param;
//	Status*		m_status;
};

} //namespace dsp_lib
