/************************************************************************
 *
 *	fdesign_prototypes.h
 *
 *	20020906	Tsuyoshi Ogawa
 *
 ************************************************************************/

#pragma once

//======================================================================
namespace dsp_lib {

extern float  Fdesign_BandWidthToQ(float	bw_);
extern void   Fdesign_Copy(const float  *src_, float  *dest_);
extern int    Fdesign_IsSameValue(const float  *coeff1_, const float  *coeff2_);

/*--------------------------------------------------------------------------------*/
extern void  Fdesign_Gain(float  gain_, float  *coeff_);

/*--------------------------------------------------------------------------------*/
extern void  Fdesign_Through(float  *coeff_);

extern void  Fdesign_DCCut(float  *coeff_);

/*--------------------------------------------------------------------------------*/
extern void  Fdesign_PEQ_CheckParameter(float  *f_, float  *q_, float  *gain_);

extern void  Fdesign_PEQ(float  f_, float  q_, float  gain_, int  bypass_, float  *coeff_);

/*--------------------------------------------------------------------------------*/
extern void  Fdesign_LowShelving_CheckParameter(float  *f_, float  *gain_);
extern void  Fdesign_HighShelving_CheckParameter(float  *f_, float  *gain_);

extern void  Fdesign_LowShelving(float  f_, float  gain_, int  bypass_, float  *coeff_);
extern void  Fdesign_HighShelving(float  f_, float  gain_, int  bypass_, float  *coeff_);

/*--------------------------------------------------------------------------------*/
extern void  Fdesign_LPF6_CheckParameter(float  *f_);
extern void  Fdesign_HPF6_CheckParameter(float  *f_);

extern void  Fdesign_LPF12_CheckParameter(float  *f_, float  *q_);
extern void  Fdesign_HPF12_CheckParameter(float  *f_, float  *q_);


extern void  Fdesign_LPF6(float  f_, int  bypass_, float  *coeff_);
extern void  Fdesign_HPF6(float  f_, int  bypass_, float  *coeff_);

extern void  Fdesign_LPF12(float  f_, float  q_, int  bypass_, float  *coeff_);
extern void  Fdesign_HPF12(float  f_, float  q_, int  bypass_, float  *coeff_);

/*--------------------------------------------------------------------------------*/
extern void  Fdesign_APF_CheckParameter(float  *f_, float  *q_);

extern void  Fdesign_APF(float  f_, float  q_, int  bypass_, float  *coeff_);

/*--------------------------------------------------------------------------------*/
extern void  Fdesign_BPF_CheckParameter(float  *f_, float  *q_);

extern void  Fdesign_BPF(float  f_, float  q_, int  bypass_, float  *coeff_);

/*--------------------------------------------------------------------------------*/
extern void  Fdesign_NotchFilter_CheckParameter(float  *f_, float  *q_);

extern void  Fdesign_NotchFilter(float  f_, float  q_, int  bypass_, float  *coeff_);

/*--------------------------------------------------------------------------------*/
extern void  Fdesign_HornEQ_CheckParameter(int*	gain_no_);

extern void  Fdesign_HornEQ(int  gain_no_, int  bypass_, float  *coeff_);

/*--------------------------------------------------------------------------------*/
extern void  Fdesign_XOverLPF6_CheckParameter(float  *f_, float  *alpha_);
extern void  Fdesign_XOverHPF6_CheckParameter(float  *f_, float  *alpha_);

extern void  Fdesign_XOverLPF12_CheckParameter(float  *f_, float  *q_, float  *alpha_);
extern void  Fdesign_XOverHPF12_CheckParameter(float  *f_, float  *q_, float  *alpha_);

extern void  Fdesign_XOverLPF6(float  f_, float  alpha_, int  bypass_, float  *coeff_);
extern void  Fdesign_XOverHPF6(float  f_, float  alpha_, int  bypass_, float  *coeff_);

extern void  Fdesign_XOverLPF12(float  f_, float  q_, float  alpha_, int  bypass_, float  *coeff_);
extern void  Fdesign_XOverHPF12(float  f_, float  q_, float  alpha_, int  bypass_, float  *coeff_);

/*================================================================================*/
extern void  Fdesign_LPF18_CheckParameter(float  *f_, float  *q_);
extern void  Fdesign_HPF18_CheckParameter(float  *f_, float  *q_);

extern void  Fdesign_LPF24_CheckParameter(float  *f_, float  *q1_, float  *q2_);
extern void  Fdesign_HPF24_CheckParameter(float  *f_, float  *q1_, float  *q2_);

extern void  Fdesign_LPF18(float  f_, float  q_, int  bypass_, float  *coeff1_, float  *coeff2_);
extern void  Fdesign_HPF18(float  f_, float  q_, int  bypass_, float  *coeff1_, float  *coeff2_);

extern void  Fdesign_LPF24(float  f_, float  q1_, float  q2_, int  bypass_, float  *coeff1_, float  *coeff2_);
extern void  Fdesign_HPF24(float  f_, float  q1_, float  q2_, int  bypass_, float  *coeff1_, float  *coeff2_);

/*================================================================================*/
extern void  Fdesign_XOverLPF_CheckParameter(float  *f_);
extern void  Fdesign_XOverHPF_CheckParameter(float  *f_);

/*--------------------------------------------------------------------------------*/
extern void  Fdesign_XOverLPF_BS12(float  f_, int  bypass_, float  *coeff1_, float*  coeff2_);
extern void  Fdesign_XOverLPF_BS18(float  f_, int  bypass_, float  *coeff1_, float*  coeff2_);
extern void  Fdesign_XOverLPF_BS24(float  f_, int  bypass_, float  *coeff1_, float*  coeff2_);

extern void  Fdesign_XOverHPF_BS12(float  f_, int  bypass_, float  *coeff1_, float*  coeff2_);
extern void  Fdesign_XOverHPF_BS18(float  f_, int  bypass_, float  *coeff1_, float*  coeff2_);
extern void  Fdesign_XOverHPF_BS24(float  f_, int  bypass_, float  *coeff1_, float*  coeff2_);

/*--------------------------------------------------------------------------------*/
extern void  Fdesign_XOverLPF_BW12(float  f_, int  bypass_, float  *coeff1_, float*  coeff2_);
extern void  Fdesign_XOverLPF_BW18(float  f_, int  bypass_, float  *coeff1_, float*  coeff2_);
extern void  Fdesign_XOverLPF_BW24(float  f_, int  bypass_, float  *coeff1_, float*  coeff2_);

extern void  Fdesign_XOverHPF_BW12(float  f_, int  bypass_, float  *coeff1_, float*  coeff2_);
extern void  Fdesign_XOverHPF_BW18(float  f_, int  bypass_, float  *coeff1_, float*  coeff2_);
extern void  Fdesign_XOverHPF_BW24(float  f_, int  bypass_, float  *coeff1_, float*  coeff2_);

/*--------------------------------------------------------------------------------*/
extern void  Fdesign_XOverLPF_LR12(float  f_, int  bypass_, float  *coeff1_, float*  coeff2_);
extern void  Fdesign_XOverLPF_LR24(float  f_, int  bypass_, float  *coeff1_, float*  coeff2_);

extern void  Fdesign_XOverHPF_LR12(float  f_, int  bypass_, float  *coeff1_, float*  coeff2_);
extern void  Fdesign_XOverHPF_LR24(float  f_, int  bypass_, float  *coeff1_, float*  coeff2_);

} // namespace dsp_lib
//======================================================================
