#include <sys/time.h>

#include <stdio.h>
#include <stdlib.h>
#include <vector>
#include <string>
#include <fstream>
#include <control/read_command.h>
#include <control/read_netlist.h>
#include <control/execute_command.h>

#include <cmath> // powf

#define pm // ADIのキーワードを無効化
#include <dsp_lib/include/dsp_lib.h>

#define DEBUG

using namespace std;

uint32_t NUMBER_OF_NETLIST_MAX = 100;
uint32_t ELEMENT_NUMBER_OF_NETLIST = 8;

int main(int argc, char *argv[])
{
#if 0
	struct timeval sta, eta; //time
	gettimeofday(&sta, NULL);
#endif

	if(argc != 4){
		cout << "usage: control.out COMMAND.json NETLIST.bin RESULT.json" << endl;
		return -1;
	}

	/* コマンドファイル読み込み */
	//cout << "Reading command..." << endl;
	picojson::array	command_array;

	if (control::ReadCommand(argv[1], command_array) == false) {
		cout << "failed!" << endl;
		return -1;
	}

	/* ネットリスト読み込み */
	//cout << "Reading netlist..." << endl;
	dsp_lib::DspManager::NetList*	netlists;
	uint32_t						number_of_netlist;

	if (control::ReadNetlist(argv[2], netlists, number_of_netlist) == false) {
		cout << "failed!" << endl;
		return -1;
	}
	
	/* パラメータ設定 or ステータス取得 */
	//cout << "Execute Command..." << endl;
	if (control::ExecuteCommand(argv[3], command_array, netlists, number_of_netlist) == false) {
		cout << "failed!" << endl;
		return -1;
	}

#if 0
	cout << "finished!" << endl;

	gettimeofday(&eta, NULL);
	printf("ALL control.out time = %lf\n", (eta.tv_sec - sta.tv_sec) + (eta.tv_usec - sta.tv_usec)*1.0E-6);
#endif
	return 0;
}