/*
 * shared_ram.h
 *
 *  Created on: 2017/03/14
 *      Author: toa29548
 */

#pragma once

#include <stdint.h>
#include <stddef.h>

// 変更する場合、.ldfにも変更が必要

const uint32_t SHAREDRAM_ADDRESS	= 0x000E0000;
const uint32_t SHAREDRAM_LENGTH		= 0x00000B00;
const uint32_t SHAREDRAM_ADDRESS_UNIT_BYTE = 4;	// アドレス1番地あたりのBYTE数(ADIは4、普通は1)

const uint32_t BOOT_INFO_LENGTH		= 0x00000004;	// word
const uint32_t MAP_LENGTH			= 0x0000007C;	// word
const uint32_t SHAREDRAM_DM_LENGTH	= 0x00000780;	// word
const uint32_t SHAREDRAM_PM_LENGTH	= 0x00000300;	// word

const uint32_t SHAREDRAM_POSITION_BOOT_INFO	= 0;
const uint32_t SHAREDRAM_POSITION_MAP 		= SHAREDRAM_POSITION_BOOT_INFO 	+ BOOT_INFO_LENGTH;
const uint32_t SHAREDRAM_POSITION_DM		= SHAREDRAM_POSITION_MAP 		+ MAP_LENGTH;
const uint32_t SHAREDRAM_POSITION_PM		= SHAREDRAM_POSITION_DM			+ SHAREDRAM_DM_LENGTH;

const uint32_t BOOT_INFO_ADDRESS	= SHAREDRAM_ADDRESS	+ SHAREDRAM_POSITION_BOOT_INFO;
const uint32_t MAP_ADDRESS 			= SHAREDRAM_ADDRESS + SHAREDRAM_POSITION_MAP;
const uint32_t SHAREDRAM_DM_ADDRESS	= SHAREDRAM_ADDRESS + SHAREDRAM_POSITION_DM;
const uint32_t SHAREDRAM_PM_ADDRESS	= SHAREDRAM_ADDRESS + SHAREDRAM_POSITION_PM;
