import ctypes

class CommStatus(ctypes.Structure):
    """AM-CF1の各状態を保持する。LibCF1CommCtrlとのやり取りに使用する。"""
    """LibCF1CommCtrl.hの stCommStatus と構造を合わせる"""

    _fields_ = [('gain', ctypes.c_uint8),
                ('mute_mic', ctypes.c_uint8),
                ('mute_spk', ctypes.c_uint8),
                ('bluetooth_mode', ctypes.c_uint8),

                ('focus_x', ctypes.c_float),

                ('focus_y', ctypes.c_float),

                ('focus_mode', ctypes.c_uint8),
                ('focus_direction', ctypes.c_int8),
                ('focus_unit', ctypes.c_uint8),
                ('dummy2', ctypes.c_uint8),

                ('focus_distance', ctypes.c_float),

                ('standby', ctypes.c_uint8),
                ('preset', ctypes.c_uint8),
                ('dummy3', ctypes.c_uint8),
                ('dummy4', ctypes.c_uint8),

                ('isGainResponse', ctypes.c_uint8),
                ('isMuteMicResponse', ctypes.c_uint8),
                ('isMuteSpkResponse', ctypes.c_uint8),
                ('isBluetoothResponse', ctypes.c_uint8),

                ('isFocusSetResponse', ctypes.c_uint8),
                ('isStandbyResponse', ctypes.c_uint8),
                ('isPresetResponse', ctypes.c_uint8),
                ('isPresetAutoResponse', ctypes.c_uint8)]
