# -*- coding:utf-8 -*-
import json
import subprocess as sp
import copy

# sp.run(['control.out', arg1, arg2, arg3])

command_file_name = 'command.json'
netlist_file_name = 'netlist.bin'
result_file_name = 'result_test.json'

# --- command.jsonを作成 ---

command = {
    'access': None,
    'block_no': None,
    'type': None,
    'config': {},
    'param': {},
    'status': {}
}

commands = []

for i in range(24):
    commands.append(copy.copy(command))

for i in range(24):
    commands[i]['access'] = 'get'
#    commands[i]['block_no'] = i
    commands[i]['type'] = 'peak'
    commands[i]['status'] = {'level': None}

commands[0]["block_no"] = 0
commands[1]["block_no"] = 2
commands[2]["block_no"] = 4
commands[3]["block_no"] = 6
commands[4]["block_no"] = 8
commands[5]["block_no"] = 10
commands[6]["block_no"] = 12
commands[7]["block_no"] = 14
commands[8]["block_no"] = 16
commands[9]["block_no"] = 18
commands[10]["block_no"] = 20
commands[11]["block_no"] = 22
commands[12]["block_no"] = 24
commands[13]["block_no"] = 26
commands[14]["block_no"] = 28
commands[15]["block_no"] = 32
commands[16]["block_no"] = 34
commands[17]["block_no"] = 36
commands[18]["block_no"] = 38
commands[19]["block_no"] = 40
commands[20]["block_no"] = 42
commands[21]["block_no"] = 44
commands[22]["block_no"] = 46
commands[23]["block_no"] = 48



with open('./' + command_file_name, 'w') as f:
    # 辞書型をjsonとして出力
    json.dump(commands, f, indent=True)

# --- control.out を実行 ---

sp.run(['./control.out', command_file_name, netlist_file_name, result_file_name])

# --- result.json を読み込み ---

with open('./' + result_file_name, 'r') as f:
    # jsonファイルを辞書型として読み込み
    result = json.load(f)

if isinstance(result, list) is False:
    print('result.json must be array!')

levels = []

for result_no, result_obj in enumerate(result):
    if 'type' in result_obj:
        if result_obj['type'] == 'peak':
            try:
                levels.append(result_obj['status']['level'])
            except KeyError:
                print('result[' + result_no + ']: invalid key!')

#for level in levels:
#    print(level)
index = 0

#print('\n' * 1)
print('\nINPUT')
#print('\n' * 1)
print('[1]MIC1 [2] MIC2 [3] MIC3 [4] MIC4 [5] MIC5 [6] MIC6 [7] MIC7 [8] MIC8')
print('[9]USBL [10]USBR [11]CODE [12]BTL  [13]BTR  [14]AUXL [15]AUXR [16]NC\n')


for level_no, level in enumerate(levels):
    index = index + 1
    if level_no == 15:
        print('\n' * 1)
        print('OUTPUT')
        print('[0]CODEC [1]USBR [2]AUXL [3]SPR [4]SPL [5]AUXR [6]USBL [7]BT [8]NC\n')

        index = 0
    print('[{0}]{1}'.format(index,level))
