# -*- coding:utf-8 -*-
# -----------------------------------------
def Clear_ExceptionLog():
    exc_fpass = '/home/toa/TOA_AM-CF1/Webserver/templates/exception.txt'
    with open(exc_fpass, 'w') as file:
        log = [str(0), str(sys.exc_info()), str(traceback.format_exc()), "import_section"]
        file.seek(0)
        file.write(str(log))
# -----------------------------------------
def Dump_ExceptionLog(i_locate):
    times = 0
    retry = 0
    exc_fpass = '/home/toa/TOA_AM-CF1/Webserver/templates/exception.txt'

    with open(exc_fpass, 'r') as file:
        fsize = os.path.getsize(exc_fpass)
        if fsize != 0:
            log = file.read()
            if '0' <= log[2] and log[2] <= '4':
                times = int(log[2])
            if '4' < log[2]:
                Clear_ExceptionLog()
    times += 1
    if times <= 3:
        retry = 1
    else :
        times = 0

    with open(exc_fpass, 'w') as file:
        log = [str(times), str(sys.exc_info()), str(traceback.format_exc()), i_locate]
        print("Save Exception Log File")
        file.seek(0)
        file.write(str(log))
        print(log)

    if retry == 1:
        print("Retry Main.py")
        sp.call("sudo killall AMCF1-WebServer", shell=True)  # at first, Popen was used
        os.system("sudo python3 /home/toa/TOA_AM-CF1/Application/data/main.py")
    else:
        sp.call("sudo killall AMCF1-WebServer", shell=True)     # at first, Popen was used
        sp.call("sudo killall python3", shell=True)     # at first, Popen was used
        sys.exit()

# -----------------------------------------
def Show_Error():
    libDrivers.Ctrl_PowerLED(2)         # I2C-SP
    libDrivers.Ctrl_BluetoothLED(1)     # I2C-SP
    libDrivers.Ctrl_USBConnectionLED(1) # I2C-SP

# -----------------------------------------
def Activate_WebServer():
    if os.path.isfile("/home/toa/TOA_AM-CF1/Webserver/manage.py") == True:
        sp.Popen("sudo python3 /home/toa/TOA_AM-CF1/Webserver/manage.py runserver --insecure 0.0.0.0:8000", shell=True)
    else:
        Show_Error()

# -----------------------------------------

def RunWebServerAndExitWithError():
    while True:
        if os.path.isfile("/home/toa/TOA_AM-CF1/Webserver_only_fwupdate/manage.py") == True:
            # if webserver is called by Popen, Webserver will work asynchronasly but if main.py will be killed, webserver will be killed too.
            # So we use call instead of Popen, and main.py will not be killed or exited.
            sp.call("sudo python3 /home/toa/TOA_AM-CF1/Webserver_only_fwupdate/manage.py runserver --insecure 0.0.0.0:8000", shell=True)
        else:
            Show_Error()
        # if sp.call ends, web server exits by exception, so try to run webserver again and again
        time.sleep(1)
    # if sys.exit is called, exception handler will work
    sys.exit(0)

import traceback
try:
    locate = "section_import_python_files"
    import sys, os.path
    from ctypes import *
    from cf1_init_func import Make_Init_Command_json
    from cf1_init_func import Make_FactoryPreset_Command_Json
    from cf1_init_func import startup
    from cf1_init_func import Load_PresetData
    from get_output_gain_func import Get_OutputGain
    from get_output_gain_func import Get_OutputGain_init
    from set_output_gain_func import Set_OutputGain_init
    from set_output_gain_func import Set_OutputGain
    from set_mute_func import Mute_Init
    from set_mute_func import Set_Mute
    from set_mute_func import Release_Mute
    from set_mute_func import Set_Mute_for_StandbyMode
    from set_mute_func import Release_Mute_from_StandbyMode
    from get_input_bf_level_func import Get_Bf_Level_in_init
    from get_input_bf_level_func import Get_Bf_Level_in
    from set_bf_func import Set_Bf_init
    from set_bf_func import Set_Bf
    from comm_status import CommStatus

    from set_output_matrix_func import Set_Speaker_Output_Assign

    sys.path.append('/home/toa/TOA_AM-CF1/Webserver/hello/')
    from param_set_get_flag import Comfirm_Param_Set_Get_Flag_Init
    from send_command import send_command
    from sum_gain_SPout import Sum_SP_Gain
    import lbl_const as lbl
    import define_const as dc

    import subprocess as sp
    import json, time, os, fcntl, math
    import ctypes       # C言語で作られた共有ライブラリ呼び出しに使用
    import threading    # 遅延処理スレッドに使用
    import copy         # オブジェクトのコピーに使用
    import inspect      # ログ用

    from get_develop_setting import Get_develop_config
    from get_develop_setting import Get_skip_login_from_json_data
    # DSP Update function
    import dspupdate
    from enum import IntEnum

    locate = "section_import_shared_library"
    libDrivers = CDLL("/home/toa/TOA_AM-CF1/Driver/libCF1DriversLib.so")
    time_setting_fname ='/home/toa/TOA_AM-CF1/Webserver/templates/time_setting'
    libCF1CommCtrl = CDLL("/home/toa/TOA_AM-CF1/LibCF1CommCtrl/libCF1CommCtrl.so")

    locate = "section_make_init_command"
    Make_Init_Command_json()
    g_Count_RTC_Check = 0
    g_Count_USBAudioConnectCheck = 0
    g_Count_ConfigCheck = 0
    g_standby_mode = 0
    g_last_mute_status = 0    #For No191
    g_mute_sys_status = 0
    g_mute_ctrl_pulse = 0
    g_sp_vol_index = 7
    g_Status_Level_Mute = [0, 0]
    g_Cfg_CtrlInput = []
    g_Test_Enable = 0 # S1-Test
    g_key_lock = {                                  # キーロックの有無を管理する
        dc.SIDE_PANLE_POWER        : dc.OFF,
        dc.SIDE_PANLE_BLUETOOTH    : dc.OFF,
        dc.SIDE_PANLE_VOLUME_UP    : dc.OFF,
        dc.SIDE_PANLE_VOLUME_DOWN  : dc.OFF,
        dc.SIDE_PANLE_MUTE         : dc.OFF
    }
    g_mic_mute = dc.OFF
    g_mic_mute_pre = g_mic_mute
    g_bluetooth_mode = 0
    g_bluetooth_status = 0
    g_spout_assign_aux = dc.ON
    g_spout_assign_aux_pre = g_spout_assign_aux
    g_spout_assign_codec = dc.ON
    g_spout_assign_codec_pre = g_spout_assign_codec
    

    class FLAG_ONOFF(IntEnum):
        OFF = 0
        ON = 1

    g_bt_remote_processed_flag = ctypes.c_uint32(FLAG_ONOFF.OFF) #外部制御プロトコルによるBT処理完了フラグ

    # ビームステアリングの値
    g_focus_x = 0.0
    g_focus_y = 0.0
    g_focus_mode = 0                    # [0]: auto, [1]: manual
    g_focus_dir = 0
    g_focus_dis = 1.0
    g_focus_unit = 0

    # CommCtrlへの制御応答フラグ
    #   [0]: GAIN, [1]: MUTE_MIC, [2]: MUTE_SPK, [3]: STANDBY, [4]: PRESET, [5]: FOCUS_SET, [6]: BLUETOOTH
    #   PRESET は 応答なし(NONE), 処理中(PROCESSING), 応答する(DONE), 自動応答可能(OTHER_DONE) とする
    COMM_CTRL_TYPE_GAIN = 0
    COMM_CTRL_TYPE_MUTE_MIC = 1
    COMM_CTRL_TYPE_MUTE_SPK = 2
    COMM_CTRL_TYPE_STANDBY = 3
    COMM_CTRL_TYPE_PRESET = 4
    COMM_CTRL_TYPE_FOCUS_SET = 5
    COMM_CTRL_TYPE_BLUETOOTH = 6

    class RESP(IntEnum):
        NONE = 0
        PROCESSING = 1
        DONE = 2
        OTHER_DONE = 3

    g_resp_required = [False, False, False, False, RESP.NONE, False, RESP.NONE]

    locate = "section_make_sp_gain_status"
    main_SPgain_sts_fname = "/home/toa/TOA_AM-CF1/tmp/volume/main_SPgain_sts.txt"
    web_SPgain_sts_fname = "/home/toa/TOA_AM-CF1/tmp/volume/web_SPgain_sts.txt"
    with open(main_SPgain_sts_fname,'w') as f:
        f.write(str(0))
    mute_sts_file_name = "/home/toa/TOA_AM-CF1/tmp/volume/mute_sts.txt"
    volume_cmd_file_name = "/home/toa/TOA_AM-CF1/tmp/command/volume.json"

    g_comm_status = None

    develop_config = Get_develop_config()
    isSkipLogin = Get_skip_login_from_json_data(develop_config)

except KeyboardInterrupt:
    sys.exit()
except:
    traceback.print_exc()
    RunWebServerAndExitWithError()
    #Dump_ExceptionLog(locate)

# -----------------------------------------
def TimeAdjust():
    print('time adjusting...')
    weekDayList = ["Sun","Mon","Tue","Wed","Thu","Fri","Sat"]
    YY = 17
    MM = 1
    DD = 1
    day = 1
    hh = 0
    mm = 0
    ss = 0
    # the value at first power on :01/01/00 01(Sun) 00:00:00 (DD:MM:YY DOW HH:MM:SS)
    tmp_yy = libDrivers.Get_Year()      # I2C-RTC
    tmp_mm = libDrivers.Get_Month()     # I2C-RTC
    tmp_dd = libDrivers.Get_Date()      # I2C-RTC
    if tmp_yy < 17 and tmp_mm == 1 and tmp_dd == 1: # kura add 20171011 RTC minimum 2017/1/1 00:00:00
        libDrivers.Initialize_RTC(YY, MM, DD, day, hh, mm, ss)  # I2C-RTC
    else:
        try:
            with open(time_setting_fname, 'r+') as file:
                strings = file.read()
                datetime = strings.split(",")
                if datetime[0] == '1':
                    file.seek(0)
                    file.write('0')
                    if int(datetime[1]) > 2034: # kura add 20171011 RTC set block 2035
                        YY = 34  # kura add 20171011 RTC maximum year 2034
                    else:
                        YY = int(datetime[1])%100
                    MM = int(datetime[2])
                    DD = int(datetime[3])
                    hh = int(datetime[4])
                    mm = int(datetime[5])
                    ss = int(datetime[6])
                    day = datetime[7]
                    day = day[:-1]
                    for i in range(7):
                        if weekDayList[i] == day:
                            day = int(i+1)
                    libDrivers.Initialize_RTC(YY, MM, DD, day, hh, mm, ss)  # I2C-RTC
        except:
            libDrivers.Initialize_RTC(YY, MM, DD, day, hh, mm, ss)          # I2C-RTC
    YY = libDrivers.Get_Year()                                              # I2C-RTC
    MM = libDrivers.Get_Month()                                             # I2C-RTC
    DD = libDrivers.Get_Date()                                              # I2C-RTC
    hh = libDrivers.Get_Hour()                                              # I2C-RTC
    mm = libDrivers.Get_Minute()                                            # I2C-RTC
    if YY < 10:
        YY = '0'+str(YY)
    script = 'sudo date --set "20'+str(YY)+'/'+str(MM)+'/'+str(DD)+' '+str(hh)+':'+str(mm)+':00"'
    os.system(script)
# -----------------------------------------
def Initialize_Device():
    libDrivers.LibCTIMER_Init()     # CTimer
    libDrivers.Initialize_I2C()     # I2C
    libDrivers.Initialize_GPIO()    # GPIO

    _bt_device_file_name = lbl.SETTING_DATA_PATH + './config/config_bt.json'
    bt_device_file_name = _bt_device_file_name.encode('utf-8')
    libDrivers.LibBT_Init.argtypes = [c_char_p, c_int]
    libDrivers.LibBT_Init(bt_device_file_name, len(bt_device_file_name))         # BT
# -----------------------------------------
def Is_FactoryReset():
    count_power_sw = 0
    i = 0
    if libDrivers.Get_PowerSwitch():            # I2C-SP POWER SW MODIFY
        libDrivers.Ctrl_USBConnectionLED(1)     # I2C-SP 1秒点灯

        for i in range(3):      # 1秒消灯 i=0、 1秒点灯 i=1、1秒消灯 i=2
            time.sleep(0.5)
            if libDrivers.Get_PowerSwitch():    # I2C-SP POWER SW MODIFY
                libDrivers.Ctrl_USBConnectionLED(count_power_sw % 2)    # I2C-SP
                count_power_sw += 1
            else:
                return 0    # ３秒以内に離したら抜ける
    else:
        return 0    # 押されていなければ抜ける

    # libDrivers.Ctrl_USBConnectionLED(0)

    if 3 <= count_power_sw:  # 3秒以上押されていれば、工場出荷状態に設定する
        return 1

    else:
        return 0


# -----------------------------------------
def Exec_FactoryReset():
    time.sleep(0.5)
    libDrivers.Ctrl_USBConnectionLED(2)         # I2C-SP 青をつける

    while 1:
        if (not libDrivers.Get_PowerSwitch()):  # I2C-SP
            break;

    Make_FactoryPreset_Command_Json()
    Ipchange = sp.Popen("sh /home/toa/StartupShell/set_ip_FactoryPreset.sh", shell=True)
    Ipchange.wait()
    libDrivers.Ctrl_USBConnectionLED(0)         # I2C-SP 消す

# -----------------------------------------
def Get_DspVersion():
    #戻り値：DSPバージョン

    #DSPバージョン取得、一時ファイル保存
    dsp_version_fname = "/home/toa/TOA_AM-CF1/tmp/dsp_version.json"

    #DSPバージョン取得実行ファイル "get_dspversion"
    #jsonファイルパスを引数にし、json形式でdspバージョンを出力する。
    #DSPバージョンが取得できないときは、"0.0.0.0"として返す。
    exec_get_dspversion_file = "/home/toa/TOA_AM-CF1/dspversion/get_dspversion"

    cmd = exec_get_dspversion_file + " " + dsp_version_fname
    exec_get_dspversion = sp.Popen(cmd, shell=True)
    exec_get_dspversion.wait()

    #戻り値 jsonファイルから取得したDSPバージョンを変数DSP_versionの取得
    #("1.1.1.1")等の形式でdspバージョンを取得する場合は、DSP_version["dsp_version"]としてください。
    with open(dsp_version_fname,"r") as f:
        DSP_version = json.load(f)

    return DSP_version

# -----------------------------------------
def Initialize_DspParameter():

    #libDrivers.Ctrl_PowerLED(1) #LED_ON_GREEN
    #ここでハード制御　電源BlueLEDを消す
    #libDrivers.Ctrl_POWER_Blue_LED_HARD(0)  #LED_OFF

    libDrivers.Ctrl_PowerLED(3) # I2C-SP LED_ON_ORANGE
    startup()      # only 1 raspberry pi startup
    time.sleep(1)  # only 1 raspberry pi startup
    libDrivers.Ctrl_PowerLED(1) # I2C-SP LED_ON_GREEN
# -----------------------------------------
def Create_Command():
    Comfirm_Param_Set_Get_Flag_Init()
    Mute_Init()
    Get_Bf_Level_in_init()
    Set_Bf_init()
    #Get_OutputGain_init() #無意味なDSP通信を削除
    Set_OutputGain_init() #無意味なDSP通信を削除
# -----------------------------------------
def Set_Config():
    with open("/home/toa/TOA_AM-CF1/Application/data/config/config_contled.txt",'r') as f:
        config = f.readlines()

    track = 1
    level = 1
    mute = 1
    ctrlin1 = 0
    ctrlin2 = 0
    ctrlout1 = 0
    ctrlout2 = 0
    table_cin = ['None','Mute(One-shot)','Mute(Edge)','Volume_Up','Volume_Down','Preset1','Preset2']
    table_cout = ['None','Mute_Status','Synch_Input1','Synch_Input2']
    global g_key_lock
    global g_mic_mute
    global g_spout_assign_aux
    global g_spout_assign_codec

    # Tracking: 0:off, 1:on(default)
    value = config[4].split(",")
    if 'OFF' in value[1]:
        track = 0
    # Level display: 0:off, 1:on(default)
    value = config[5].split(",")
    if 'OFF' in value[1]:
        level = 0
    # Mute LED Pattern: 0:center, 1:all(default)
    value = config[6].split(",")
    if 'Only_Center' in value[1]:
        mute = 0
    # Control input
    value = config[0].split(",")
    for i in range(7):
        if table_cin[i] in value[1]:
            ctrlin1 = i
    value = config[1].split(",")
    for i in range(7):
        if table_cin[i] in value[1]:
            ctrlin2 = i
    # Control output
    value = config[2].split(",")
    for i in range(4):
        if table_cout[i] in value[1]:
            ctrlout1 = i
    value = config[3].split(",")
    for i in range(4):
        if table_cout[i] in value[1]:
            ctrlout2 = i
    # Key Lock: 0:off(default), 1:on
    # TODO : 個別に設定できるようになれば以下の処理を変更する
    value = config[7].split(",")
    if dc.ON in value[1]:
        g_key_lock[dc.SIDE_PANLE_POWER]          = dc.ON
        g_key_lock[dc.SIDE_PANLE_BLUETOOTH]      = dc.ON
        g_key_lock[dc.SIDE_PANLE_VOLUME_UP]      = dc.ON
        g_key_lock[dc.SIDE_PANLE_VOLUME_DOWN]    = dc.ON
        g_key_lock[dc.SIDE_PANLE_MUTE]           = dc.ON
    else:
        g_key_lock[dc.SIDE_PANLE_POWER]          = dc.OFF
        g_key_lock[dc.SIDE_PANLE_BLUETOOTH]      = dc.OFF
        g_key_lock[dc.SIDE_PANLE_VOLUME_UP]      = dc.OFF
        g_key_lock[dc.SIDE_PANLE_VOLUME_DOWN]    = dc.OFF
        g_key_lock[dc.SIDE_PANLE_MUTE]           = dc.OFF
    # Mic Mute Func: 0:off, 1:on(default)
    value = config[8].split(",")
    if (dc.ON in value[1]):
        g_mic_mute = dc.ON
        # config画面のMicMuteがONの時はフロントLEDの表示を全てOFFにする
        track = 0           # OFF
        level = 0           # OFF
        mute = 2            # OFF
    else:
        g_mic_mute = dc.OFF

    libDrivers.Initialize_LedConfig(track,level,mute)           # I2C-FP
    libDrivers.Initialize_CtrlInputConfig(ctrlin1,ctrlin2)      # GPIO
    libDrivers.Initialize_CtrlOutputConfig(ctrlout1,ctrlout2)   # GPIO
    # Key Lock
    if g_key_lock[dc.SIDE_PANLE_VOLUME_UP] == dc.ON:
        libDrivers.Set_CfgVolumeUpSwitch_Lock(libDrivers.Get_VolumeUpSwitch_Lock_Enable())
    else:
        libDrivers.Set_CfgVolumeUpSwitch_Lock(libDrivers.Get_VolumeUpSwitch_Lock_Disable())
    if g_key_lock[dc.SIDE_PANLE_VOLUME_DOWN] == dc.ON:
        libDrivers.Set_CfgVolumeDownSwitch_Lock(libDrivers.Get_VolumeDownSwitch_Lock_Enable())
    else:
        libDrivers.Set_CfgVolumeDownSwitch_Lock(libDrivers.Get_VolumeDownSwitch_Lock_Disable())

    # Speaker Output Assign(codec): 0:off, 1:on(default)
    value = config[9].split(",")
    if (dc.OFF in value[1]):
        g_spout_assign_codec = dc.OFF
    else:
        g_spout_assign_codec = dc.ON

    # Speaker Output Assign(AUX): 0:off, 1:on(default)
    value = config[10].split(",")
    
    if (dc.OFF in value[1]):
        g_spout_assign_aux = dc.OFF
    else:
        g_spout_assign_aux = dc.ON

# -----------------------------------------
def Initialize_Status():
    global g_mute_ctrl_pulse
    global g_mute_sys_status    #For No191
    global g_Status_Level_Mute  #For No191

    #For No191
    if g_mute_ctrl_pulse == 1:
        g_mute_ctrl_pulse = 0
        Update_MuteStatus(g_mute_ctrl_pulse)
    g_mute_sys_status = g_mute_ctrl_pulse | g_Status_Level_Mute[0] | g_Status_Level_Mute[1]
    libDrivers.Initialize_GPIOStatus()      # GPIO
    libDrivers.Initialize_SwitchStatus()    # I2C-SP
    libDrivers.Set_gpioMuteStatus(0)        # GPIO
    libDrivers.Set_i2cMuteStatus(0)         # I2C-SP
    libDrivers.Ctrl_USBConnectionLED(0)     # I2C-SP
    libDrivers.Ctrl_BluetoothLED(0)         # I2C-SP
    libDrivers.Set_ControlOutput1(0)        # GPIO
    libDrivers.Set_ControlOutput2(0)        # GPIO


# -----------------------------------------
def Update_BeamAngle():
    levels_in = []
    ch_mic_input = 0
    global bf_LED_Num_prev
    global g_focus_x
    global g_focus_y
    global g_focus_mode
    global g_focus_dir
    global g_focus_dis
    BF_LED_TURNOFF = -5000.0

    # スタンバイモードでなければ、DSPから取得し実行する
    if g_standby_mode == 0:
        datas = Get_Bf_Level_in()

        # 設定情報はスタンバイモードでなければ、常に取得した値で更新する
        if datas[4] == 'auto':
            g_focus_mode = 0
        else:
            g_focus_mode = 1
            g_focus_dir = datas[5]
            g_focus_dis = datas[6]

        # MICミュートでなければ、取得した値で更新する。
        # それ以外は値の更新をしない。
        if g_mute_ctrl_pulse == 0:
            g_focus_x = datas[2]
            g_focus_y = datas[3]

        if libDrivers.Get_IndicateMode() == 0:  # I2C-FP
            levels_in = [float(datas[0])]
            bf_LED_Num_curr = datas[1]

            # --- Determine LED position
            if type(levels_in[ch_mic_input]) == float:
                if bf_LED_Num_prev == bf_LED_Num_curr:
                    libDrivers.Chg_LEDBrightness(bf_LED_Num_curr, c_float(levels_in[ch_mic_input]))  # I2C-FP
                else:
                    libDrivers.Chg_LEDBrightness(bf_LED_Num_curr, c_float(levels_in[ch_mic_input]))
                    libDrivers.Chg_LEDBrightness(bf_LED_Num_prev, c_float(BF_LED_TURNOFF))
                bf_LED_Num_prev = bf_LED_Num_curr
# -----------------------------------------
def Update_MuteStatus(i_st_sw):
    WEB_STOP_flag = '/home/toa/TOA_AM-CF1/tmp/WEB_STOP_flag' #if file exists then WEB_STOP
    global g_mute_sys_status
    global g_mute_ctrl_pulse
    global g_Status_Level_Mute

    if i_st_sw:
        if g_mute_sys_status == 0:
            #if g_Test_Enable == 0: # S1-Test
            #    if not os.path.exists(WEB_STOP_flag):
            #        with open(WEB_STOP_flag, 'w') as wsf:
            #            fcntl.flock(wsf, fcntl.LOCK_EX)
            #            wsf.write("")
            if os.path.exists(WEB_STOP_flag) == False:
                with open(WEB_STOP_flag, 'w') as wsf:
                    fcntl.flock(wsf, fcntl.LOCK_EX)
                    wsf.write("")
            Set_Mute()
            libDrivers.Chg_IndicateMode(2)  # I2C-FP
    else:
        if (g_mute_ctrl_pulse | g_Status_Level_Mute[0] | g_Status_Level_Mute[1]) == 0:
            Release_Mute()
            libDrivers.Chg_IndicateMode(0)  # I2C-FP
    g_mute_sys_status = g_mute_ctrl_pulse | g_Status_Level_Mute[0] | g_Status_Level_Mute[1]
    if g_standby_mode == 0:
        # g_mute_ctrl_pulse は システムのミュート状態と同期させる(通常モードのみ)
        g_mute_ctrl_pulse = g_mute_sys_status
    #For No202
    libDrivers.Set_gpioMuteStatus(g_mute_sys_status)    # GPIO
    libDrivers.Set_i2cMuteStatus(g_mute_sys_status)     # I2C-SP

# -----------------------------------------
def Update_MuteStatus_for_ForcedMute():
    global g_mute_ctrl_pulse
    global g_mute_sys_status

    # 一度フロントLEDを通常に戻す
    # これでミュートON中のマイク機能OFF(ミュートON)が反映される
    libDrivers.Chg_IndicateMode(0)  # I2C-FP

    # システムのミュート状態をリセットすることでミュートONを強制する
    g_mute_sys_status = 0
    # さらにミュートボタン押下と同じ流れでミュートONにする
    g_mute_ctrl_pulse = 1
    Update_MuteStatus(g_mute_ctrl_pulse)

# -----------------------------------------
# 起動時にマイク機能OFFであった場合の強制マイクミュートON処理(DSP通信はしない)
# DSPはマイク機能OFF反映済のため、Update_MuteStatus_for_ForcedMute()におけるDSP通信以外のマイクミュートOFF→ONの処理を実施する。
# 接点出力、リモートマイクミュート状態(g_mute_ctrl_pulse)状態の変更漏れがあった。
def Update_MuteStatus_for_Boot():
    global g_mute_ctrl_pulse
    global g_mute_sys_status
    # さらにミュートボタン押下と同じ流れでミュートONにする
    g_mute_ctrl_pulse = 1
    libDrivers.Chg_IndicateMode(2)  # I2C-FP Muteモードに
    g_mute_sys_status = g_mute_ctrl_pulse | g_Status_Level_Mute[0] | g_Status_Level_Mute[1]
    # g_mute_ctrl_pulse は システムのミュート状態と同期させる
    g_mute_ctrl_pulse = g_mute_sys_status
    #For No202
    libDrivers.Set_gpioMuteStatus(g_mute_sys_status)    # GPIO
    libDrivers.Set_i2cMuteStatus(g_mute_sys_status)     # I2C-SP

# -----------------------------------------
def set_web_gain(i_pos):
    # Volumeテーブル(64段階)
    sp_vol_table = [-60, -60, -59, -58, -57, -56, -55, -54, -53, -52, -51, -50, -49, -48, -47, -46,
                    -45, -44, -43, -42, -41, -40, -39, -38, -37, -36, -35, -34, -33, -32, -31, -30,
                    -29, -28, -27, -26, -25, -24, -23, -22, -21, -20, -19, -18, -17, -16, -15, -14,
                    -13, -12, -11, -10,  -9,  -8,  -7,  -6,  -5,  -4,  -3,  -2,  -1,   0,   0,   0]

    try:
        # -- volume/web_SPgain_sts.txt の更新 --
        # CF1CommCtrlライブラリからの設定時は Web のGAINを制御する
        web_gain_setting = []
        with open(web_SPgain_sts_fname, 'r') as file_web_gain:
            try:
                # read 時は共有ロック
                fcntl.flock(file_web_gain, fcntl.LOCK_SH)

                web_gain_setting = file_web_gain.readlines()
            except IOError as io_ex:
                print('[{0}] exception : {1}'.format(
                    inspect.currentframe().f_code.co_name, io_ex))

        if len(web_gain_setting) == 2:
            web_gain_setting[0] = str(sp_vol_table[i_pos])

            # 書き戻し
            with open(web_SPgain_sts_fname, 'r+' if os.path.exists(web_SPgain_sts_fname) else 'w') as file_web_gain:
                try:
                    # write 時は排他ロック
                    fcntl.flock(file_web_gain, fcntl.LOCK_EX)
                    if file_web_gain.mode == 'r+':
                        file_web_gain.truncate(0)
                        file_web_gain.seek(os.SEEK_SET)

                    file_web_gain.writelines('\n'.join(web_gain_setting))
                except IOError as io_ex:
                    print('[{0}] exception : {1}'.format(
                        inspect.currentframe().f_code.co_name, io_ex))
        else:
            print('[{0}] {1} is broken.'.format(
                inspect.currentframe().f_code.co_name, web_SPgain_sts_fname))

        # -- volume/mute_sts.txt の更新 --
        # 現在の設定を読み込んで更新
        mute_sts_data = []
        with open(mute_sts_file_name, 'r') as file_mute_sts:
            try:
                # read 時は共有ロック
                fcntl.flock(file_mute_sts, fcntl.LOCK_SH)

                mute_sts_data = file_mute_sts.readlines()
            except IOError as io_ex:
                print('[{0}] exception : {1}'.format(
                    inspect.currentframe().f_code.co_name, io_ex))

        if len(mute_sts_data) == 2:
            # 1行目(MUTE)をカンマで分割した各要素に対して、空白除去してリストに格納
            mute_sts_data_mute = [x.strip() for x in mute_sts_data[0].split(',')]
            # 2行目(GAIN)をカンマで分割した各要素に対して、空白除去してリストに格納
            mute_sts_data_gain = [x.strip() for x in mute_sts_data[1].split(',')]
            # 5つ目の要素(Speaker)を書き換え
            mute_sts_data_gain[4] = str(sp_vol_table[i_pos])

            # 書き戻し
            with open(mute_sts_file_name, 'r+' if os.path.exists(mute_sts_file_name) else 'w') as file_mute_sts:
                try:
                    # write 時は'r+'で open して排他ロック
                    fcntl.flock(file_mute_sts, fcntl.LOCK_EX)
                    if file_mute_sts.mode == 'r+':
                        file_mute_sts.truncate(0)
                        file_mute_sts.seek(os.SEEK_SET)

                    file_mute_sts.write(','.join(mute_sts_data_mute))
                    file_mute_sts.write('\n')
                    file_mute_sts.write(','.join(mute_sts_data_gain))
                except IOError as io_ex:
                    print('[{0}] exception : {1}'.format(
                        inspect.currentframe().f_code.co_name, io_ex))

        else:
            print('[{0}] {1} is broken.'.format(
                inspect.currentframe().f_code.co_name, mute_sts_file_name))

        sp_gain = Sum_SP_Gain(main_SPgain_sts_fname, web_SPgain_sts_fname)
        # [0]:main, [1]:web, [2]:DSP

        Set_OutputGain(sp_gain[2])

    except Exception as e:
        print(e, 'exception occurred @ set_web_gain().')
        raise e


# -----------------------------------------
def set_web_mute(mute):
    try:
        # #### SP OUT gain SUM txt write ####
        with open(web_SPgain_sts_fname, 'r+' if os.path.exists(web_SPgain_sts_fname) else 'w') as file_web_gain:
            try:
                # write 時は'r+'で open して排他ロック
                fcntl.flock(file_web_gain, fcntl.LOCK_EX)

                web_gain_setting = file_web_gain.readlines()

                if file_web_gain.mode == 'r+':
                    file_web_gain.truncate(0)
                    file_web_gain.seek(os.SEEK_SET)

                file_web_gain.write(web_gain_setting[0])            # gain
                file_web_gain.write(str(0 if mute == 1 else 1))     # web_mute
            except IOError as io_ex:
                print('[{0}] exception : {1}'.format(
                    inspect.currentframe().f_code.co_name, io_ex))

        sp_gain_data = Sum_SP_Gain(main_SPgain_sts_fname, web_SPgain_sts_fname)
        # sp_gain_data [0]: main_gain [1]: web_gain [2]: DSP send_gain
        Set_OutputGain(sp_gain_data[2])

        # 現在の設定を読み込んで更新
        mute_sts_data = []
        with open(mute_sts_file_name, 'r') as file_mute_sts:
            try:
                # read 時は共有ロック
                fcntl.flock(file_mute_sts, fcntl.LOCK_SH)

                mute_sts_data = file_mute_sts.readlines()
            except IOError as io_ex:
                print('[{0}] exception : {1}'.format(
                    inspect.currentframe().f_code.co_name, io_ex))

        if len(mute_sts_data) == 2:
            # 1行目(MUTE)をカンマで分割した各要素に対して、空白削除してリストに格納
            mute_sts_data_mute = [x.strip() for x in mute_sts_data[0].split(',')]
            # 5つ目の要素(Speaker)を書き換え
            mute_sts_data_mute[4] = str(0 if mute == 1 else 1)
            # 2行目(GAIN)をカンマで分割した各要素に対して、空白削除してリストに格納
            mute_sts_data_gain = [x.strip() for x in mute_sts_data[1].split(',')]

            # 書き戻し
            with open(mute_sts_file_name, 'r+' if os.path.exists(mute_sts_file_name) else 'w') as file_mute_sts:
                try:
                    # write 時は'r+'で open して排他ロック
                    fcntl.flock(file_mute_sts, fcntl.LOCK_EX)
                    if file_mute_sts.mode == 'r+':
                        file_mute_sts.truncate(0)
                        file_mute_sts.seek(os.SEEK_SET)

                    file_mute_sts.write(",".join(mute_sts_data_mute))
                    file_mute_sts.write("\n")
                    file_mute_sts.write(",".join(mute_sts_data_gain))
                except IOError:
                    print('[{0}] {1} is locked...'.format(
                        inspect.currentframe().f_code.co_name, mute_sts_file_name))
        else:
            print('[{0}] {1} is broken.'.format(
                inspect.currentframe().f_code.co_name, mute_sts_file_name))

    except Exception as e:
        print(e, 'exception occurred @ set_web_mute().')
        raise e

# -----------------------------------------
def set_bluetooth_mode(bluetoothmode):
    global g_bluetooth_mode

    g_bluetooth_mode = bluetoothmode

# -----------------------------------------
def get_bluetooth_mode():
    return g_bluetooth_mode

# -----------------------------------------
def set_bluetooth_status(bluetoothStatus):
    global g_bluetooth_status

    g_bluetooth_status = bluetoothStatus

# -----------------------------------------
def get_bluetooth_status():
    return g_bluetooth_status

# -----------------------------------------
def Chg_SpeakerVolume(i_updown):
    global g_sp_vol_index
    global g_mute_ctrl_pulse
    sp_vol_table = [-70, -24, -18, -12, -9, -6, -3, 0]

    with open(main_SPgain_sts_fname,'r') as f:  #add kura 20171006
        g_sp_vol_index = sp_vol_table.index(int(f.read()))    #add kura 20171006

    if i_updown:
        if 7 <= g_sp_vol_index:
            g_sp_vol_index = 7
        else:
            g_sp_vol_index += 1
    else:
        if g_sp_vol_index <= 0:
            g_sp_vol_index = 0
        else:
            g_sp_vol_index -= 1

    libDrivers.Chg_IndicateMode(1)                  # I2C-FP
    libDrivers.Chg_VolumePosition(g_sp_vol_index)   # I2C-FP

    with open(main_SPgain_sts_fname,'w') as f:
        f.write(str(sp_vol_table[g_sp_vol_index]))

    SP_gain = Sum_SP_Gain(main_SPgain_sts_fname, web_SPgain_sts_fname)
    #[0]:main, [1]:web, [2]:DSP

    Set_OutputGain(SP_gain[2])

    #if g_Test_Enable:   #Kura-Test #180,214
    #    g_Status_Level_Mute[0] ^= 1
    #    Update_MuteStatus(g_Status_Level_Mute[0] | g_Status_Level_Mute[1])

    #For No195
#    if g_mute_ctrl_pulse == 1:
#        g_mute_ctrl_pulse = 0
#        Update_MuteStatus(g_mute_ctrl_pulse)

# -----------------------------------------
def Chg_StandbyMode():
    global g_last_mute_status
    global g_mute_ctrl_pulse
    global g_mute_sys_status

    if g_standby_mode:
        libDrivers.Ctrl_Smute(1)    # I2C-DAC
        #OUTPUT MUTE & AMP Power Off 制御　
        libDrivers.Ctrl_AUDIO_OUTPUT_ENABLE(0)  # I2C-MB DISABLE
        Initialize_Status()
        #For No191
        g_last_mute_status = g_Status_Level_Mute[0] | g_Status_Level_Mute[1]
    else:
        with open(main_SPgain_sts_fname,'w') as f:
            f.write(str(0))
        SP_gain = Sum_SP_Gain(main_SPgain_sts_fname, web_SPgain_sts_fname)
        #[0]:main, [1]:web, [2]:DSP
        #print(SP_gain)
        Set_OutputGain(SP_gain[2])
        #libDrivers.Initialize_DAC()
        #Set_Config()                #For No16,No120
        Update_CinConfigTable()
        # マイク入力のミュートを強制的にONにする
        if (g_mic_mute == dc.ON):
            Update_MuteStatus_for_ForcedMute()
    libDrivers.Ctrl_LEDforPowerStandby(g_standby_mode)  # I2C-FP
    #For No191
    if g_standby_mode == 0:
        if (g_mic_mute == dc.OFF):
            # スタンバイ解除時、すべてのパターンでマイクミュート制御必要（スタンバイ中にプリセットロードやアップロードが発生するとマイクゲインが戻る）
            # または、リモートプロトコルで通常モード中にさらにスタンバイ解除される場合にも対応する。
            g_mute_sys_status = 0 #強制ミュート処理（ミュートONorOFF)
            g_mute_ctrl_pulse = 0 #強制ミュート処理 (パルストリガのミュートは解除する。通常モードからリモートでスタンバイ解除してもマイクミュートは解除する)
            Update_MuteStatus( g_Status_Level_Mute[0] | g_Status_Level_Mute[1] )

        # OUTPUT MUTE & AMP Power Off 解除　
        libDrivers.Ctrl_AUDIO_OUTPUT_ENABLE(1)  # I2C-MB ENABLE
        libDrivers.Ctrl_Smute(0)    # I2C-DAC
        # マイク機能OFF時の強制マイクミュートONはアンプミュート解除前に実行する必要があるため、
        # ここでは何もしない

# -----------------------------------------
def Update_SideSwitchStatus(i_num):
    global g_mute_ctrl_pulse

    #muteBT = libDrivers.LibBT_getMuteEvent()
    #if i_num == 1 or  muteBT == 1:
    #    if libDrivers.Read_MuteSwitch() == 1 or muteBT == 1:
            #if (g_Status_Level_Mute[0] or g_Status_Level_Mute[1]) == 0:    #S1

    if i_num == 1:
        if (g_key_lock[dc.SIDE_PANLE_MUTE] == dc.OFF) and (g_mic_mute == dc.OFF):
            if libDrivers.Read_MuteSwitch() == 1:       # I2C-SP
                #if (g_Status_Level_Mute[0] or g_Status_Level_Mute[1]) == 0:    #S1
                g_mute_ctrl_pulse ^= 1
                Update_MuteStatus(g_mute_ctrl_pulse)
    # --- Volume Up Switch Changed ---
    elif i_num == 2:
        if g_key_lock[dc.SIDE_PANLE_VOLUME_UP] == dc.OFF:
            if libDrivers.Read_VolumeUpSwitch() == 1:   # I2C-SP
                Chg_SpeakerVolume(1)
    # --- Volume Down Switch Changed ---
    elif i_num == 3:
        if g_key_lock[dc.SIDE_PANLE_VOLUME_DOWN] == dc.OFF:
            if libDrivers.Read_VolumeDownSwitch() == 1: # I2C-SP
                Chg_SpeakerVolume(0)
# -----------------------------------------
def Update_CinConfigTable():
    global g_Cfg_CtrlInput
    for i in range(2):
        g_Cfg_CtrlInput[i] = libDrivers.Get_CtrlInputCfg(i)     # GPIO
# -----------------------------------------
def Update_ControlInputStatus(i_num):
    global g_Cfg_CtrlInput
    global g_Status_Level_Mute
    global g_mute_ctrl_pulse

    if i_num == 2 or i_num == 3:
        array = i_num - 2
        if g_Cfg_CtrlInput[array] == 1:   # Mute(Pulse)
            if (g_mic_mute == dc.OFF):
                g_mute_ctrl_pulse ^= 1
                Update_MuteStatus(g_mute_ctrl_pulse)
        elif g_Cfg_CtrlInput[array] == 2: # Mute(Level)
            pre_mute_status = g_Status_Level_Mute[0] | g_Status_Level_Mute[1]
            if array == 0:
                g_Status_Level_Mute[0] = libDrivers.Read_ControlInput1Status()  # GPIO
            else:
                g_Status_Level_Mute[1] = libDrivers.Read_ControlInput2Status()  # GPIO
            if (g_mic_mute == dc.OFF):
                if(pre_mute_status != (g_Status_Level_Mute[0] | g_Status_Level_Mute[1])):
                    g_mute_ctrl_pulse = (g_Status_Level_Mute[0] | g_Status_Level_Mute[1]) #For No288
                    Update_MuteStatus(g_Status_Level_Mute[0] | g_Status_Level_Mute[1])
        elif g_Cfg_CtrlInput[array] == 3: # Vol up
            Chg_SpeakerVolume(1)
        elif g_Cfg_CtrlInput[array] == 4: # Vol down
            Chg_SpeakerVolume(0)
        elif g_Cfg_CtrlInput[array] == 5: # preset1 load
            Load_PresetData(1)
        elif g_Cfg_CtrlInput[array] == 6: # preset2 load
            Load_PresetData(2)
# -----------------------------------------
#For No191,No197
def Update_ControlInputStatus_forStandbyMode(i_num): #add ishikawa
    if i_num == 2 or i_num == 3:
        array = i_num - 2
        if g_Cfg_CtrlInput[array] == 2: # Mute(Level)
            if array == 0:
                g_Status_Level_Mute[0] = libDrivers.Read_ControlInput1Status()  # GPIO
            else:
                g_Status_Level_Mute[1] = libDrivers.Read_ControlInput2Status()  # GPIO

# -----------------------------------------
def ConvertToLibBT(bluetooth_mode):
    if bluetooth_mode == libCF1CommCtrl.LibCF1CommCtrl_DefBtOn():
        result = libDrivers.LibBT_DefControlOn()
    elif bluetooth_mode == libCF1CommCtrl.LibCF1CommCtrl_DefBtOff():
        result = libDrivers.LibBT_DefControlOff()
    else:
        result = libDrivers.LibBT_DefControlInvalid()

    return result

# -----------------------------------------
def ConvertFromLibBT(bluetooth_status):
    if bluetooth_status == libDrivers.LibBT_DefModeStatusPairing():
        result = libCF1CommCtrl.LibCF1CommCtrl_DefBtStatusPairing()
    elif bluetooth_status == libDrivers.LibBT_DefModeStatusConnected():
        result = libCF1CommCtrl.LibCF1CommCtrl_DefBtStatusConnected()
    else:
        result = libCF1CommCtrl.LibCF1CommCtrl_DefBtStatusOff()

    return result

# -----------------------------------------
def Control_Bluetooth():
    global g_bt_remote_processed_flag
    # 前処理 ----
    # ペアリングスイッチのキーロック情報を取得する
    if g_key_lock[dc.SIDE_PANLE_BLUETOOTH] == dc.ON:
        bluetooth_key_lock = libDrivers.LibBT_DefKeyLock()
    else:
        bluetooth_key_lock = libDrivers.LibBT_DefKeyUnLock()

    # 外部制御プロトコルによる制御指示を取得する
    bluetooth_mode = get_bluetooth_mode()
    bluetooth_mode = ConvertToLibBT(bluetooth_mode)
    # -----------

    # Bluetoothを制御する
    bluetooth_status = libDrivers.LibBT_Control( g_standby_mode, bluetooth_mode, bluetooth_key_lock, ctypes.byref(g_bt_remote_processed_flag) )  # BT
    bluetooth_status = ConvertFromLibBT(bluetooth_status)

    # 後処理 ----
    # Bluetoothの制御指示情報を更新する
    if (get_resp_required(COMM_CTRL_TYPE_BLUETOOTH) == RESP.PROCESSING) and (g_bt_remote_processed_flag.value == FLAG_ONOFF.ON):
        set_bluetooth_mode(libDrivers.LibBT_DefControlInvalid())
        set_resp_required(COMM_CTRL_TYPE_BLUETOOTH, RESP.DONE)

    # 外部制御プロトコル応答用にBluetoothの制御状態を更新する
    set_bluetooth_status(bluetooth_status)
    # -----------

# -----------------------------------------
def Update_PowerSwitchStatus():
    global g_standby_mode

    if g_key_lock[dc.SIDE_PANLE_POWER] == dc.OFF:
        if libDrivers.PowerSW_KeyScan() == 0:       # I2C-FP POWER SW MODIFY

            if libDrivers.Read_PowerSwitchStatus(): # I2C-FP POWER SW MODIFY
                g_standby_mode ^= 1

                Chg_StandbyMode()

# -----------------------------------------
def Exec_ShutdownSeq():
    if g_key_lock[dc.SIDE_PANLE_POWER] == dc.OFF:
        if libDrivers.Is_ShutdownMode() == 1:       # I2C-FP POWER SW MODIFY

            Set_Mute_for_StandbyMode()  #DSP MUTE

            libDrivers.Ctrl_Smute(1)                # I2C-DAC MUTE

            #OUTPUT MUTE & AMP Power Off 制御　
            libDrivers.Ctrl_AUDIO_OUTPUT_ENABLE(0)  # I2C-MB DISABLE

            libDrivers.Set_ADDA_Reset(0)            # GPIO
            libDrivers.Chg_AllLEDState(0)           # I2C-FP
            libDrivers.Ctrl_PowerLED(0)             # I2C-SP
            libDrivers.Ctrl_BluetoothLED(0)         # I2C-SP
            libDrivers.Ctrl_USBConnectionLED(0)     # I2C-SP
            libDrivers.Set_ControlOutput1(0)        # GPIO
            libDrivers.Set_ControlOutput2(0)        # GPIO

            #HeartBeat端子を出力ピンに設定
            libDrivers.Set_HeartBeat_OUTPUT()       # GPIO
            #ここでハード制御　BlueLEDを点灯
            libDrivers.Ctrl_POWER_Blue_LED_HARD(1)  # I2C-SP LED_ON

            kill = sp.Popen("sudo killall AMCF1-WebServer", shell=True)
            kill.wait()
            sp.run(["sh","/home/toa/StartupShell/instead_saveoverlays.sh","&"]) # Execute Shutdown command
# -----------------------------------------
def Update_RTC_Setting():
    global g_Count_RTC_Check
    Req_RTC_Setting = 0
    g_Count_RTC_Check += 1
    if(200 < g_Count_RTC_Check) :
        g_Count_RTC_Check = 0
        with open(time_setting_fname, 'r') as file:
            strings = file.read()
            if strings[0] == '1':
                Req_RTC_Setting = 1
        if Req_RTC_Setting == 1:
            WEBSTOP = sp.Popen("sudo killall AMCF1-WebServer", shell=True)
            WEBSTOP.wait()
            TimeAdjust()
            sp.Popen("sudo python3 /home/toa/TOA_AM-CF1/Webserver/manage.py runserver --insecure 0.0.0.0:8000", shell=True)
# -----------------------------------------
def Update_USBAudioConnectStatus():
    global g_Count_USBAudioConnectCheck
    g_Count_USBAudioConnectCheck += 1
    if 100 < g_Count_USBAudioConnectCheck:
        g_Count_USBAudioConnectCheck = 0
        if libDrivers.Get_UsbAudioStatus():     # GPIO
            libDrivers.Ctrl_USBConnectionLED(1) # I2C-SP
        else :
            libDrivers.Ctrl_USBConnectionLED(0) # I2C-SP
# -----------------------------------------
def Pre_Apply_Mic_Mute_Config():
    global g_mic_mute_pre
    g_mic_mute_pre = g_mic_mute
# -----------------------------------------
def Apply_Mic_Mute_Config():
    global g_mute_ctrl_pulse
    global g_mute_sys_status

    if (g_mic_mute_pre != g_mic_mute):
        if (g_standby_mode == 0):
            # 通常モード(スタンバイでない)時に反映
            # Mic機能がOFF→ON
            if (g_mic_mute == dc.OFF):
                # 一度フロントLEDを通常に戻す
                # これでレベル信号のミュート状態が反映される
                libDrivers.Chg_IndicateMode(0)  # I2C-FP

                # 接点入力のレベル信号のミュート状態をマイク入力のミュート制御に反映する
                g_mute_ctrl_pulse = 0
                g_mute_sys_status = 0
                Update_MuteStatus(g_Status_Level_Mute[0] | g_Status_Level_Mute[1])
            # Mic機能がON→OFF
            else:
                # マイク入力のミュートを強制的にONにする
                Update_MuteStatus_for_ForcedMute()

def Pre_Apply_Spout_Assign_Config():
    global g_spout_assign_codec_pre   # g_spout_assign_codec_preの初期値は設定しない。g_spout_assign_codecで必ず上書きされるため。
    global g_spout_assign_aux_pre     # g_spout_assign_auxの初期値は設定しない。g_spout_assign_auxで必ず上書きされるため。
    g_spout_assign_codec_pre = g_spout_assign_codec
    g_spout_assign_aux_pre = g_spout_assign_aux

def Apply_Spout_Assign_Config():
    chg_spout_assign_flg = False
    # 前回値と差分あり
    if (g_spout_assign_codec_pre != g_spout_assign_codec):
        chg_spout_assign_flg = True
    # 前回値と差分あり
    if (g_spout_assign_aux_pre != g_spout_assign_aux):
        chg_spout_assign_flg = True
    # Config設定(Speaker Output Assign)に変化があれば、Matrix設定をまとめてDSPへ送信
    if chg_spout_assign_flg:
        Set_Speaker_Output_Assign(g_spout_assign_aux,g_spout_assign_codec)

# -----------------------------------------
def Update_Config():
    global g_Status_Level_Mute
    global g_mute_ctrl_pulse
    global g_Cfg_CtrlInput
    global g_Count_ConfigCheck
    global g_standby_mode
    global g_mute_sys_status

    g_Count_ConfigCheck += 1
    if 100 < g_Count_ConfigCheck:
        g_Count_ConfigCheck = 0
        state_change = 0
        if os.path.exists('/home/toa/TOA_AM-CF1/CONT_LED_FLAG'):
            Pre_Apply_Mic_Mute_Config()
            Pre_Apply_Spout_Assign_Config()

            Set_Config()
            Update_CinConfigTable()
            os.remove('/home/toa/TOA_AM-CF1/CONT_LED_FLAG')

            #For No196
            #if g_standby_mode == 0:    #For No191,197
            # IN1
            if (g_Cfg_CtrlInput[0] != 2):
                if (g_Status_Level_Mute[0] != 0):
                    g_Status_Level_Mute[0] = 0
                    state_change = 1
            else: #For No189
                if (libDrivers.Get_ControlInput1() == 1):   # GPIO
                    if g_Status_Level_Mute[0] == 0:
                        g_Status_Level_Mute[0] = 1
                        state_change = 1
            # IN2
            if (g_Cfg_CtrlInput[1] != 2):
                if (g_Status_Level_Mute[1] != 0):
                    g_Status_Level_Mute[1] = 0
                    state_change = 1
            else: #For No189
                if (libDrivers.Get_ControlInput2() == 1):   # GPIO
                    if g_Status_Level_Mute[1] == 0:
                        g_Status_Level_Mute[1] = 1
                        state_change = 1

            Apply_Mic_Mute_Config()
            Apply_Spout_Assign_Config()

            if g_standby_mode == 0:
                if (state_change == 1) and (g_mic_mute == dc.OFF):
                    #mute_status = g_is_edge_mute_in1 | g_is_edge_mute_in2 #For No133
                    g_mute_ctrl_pulse = 0
                    Update_MuteStatus(g_Status_Level_Mute[0] | g_Status_Level_Mute[1])
            #For No191,197
            #else:
            #    if state_change:
            #        g_mute_sys_status = g_mute_ctrl_pulse | g_Status_Level_Mute[0] | g_Status_Level_Mute[1]

# -----------------------------------------
def Update_Status():
    libDrivers.Update_FrontLEDStatus()      # I2C-FP
    Update_RTC_Setting()
    Update_Config()
# -----------------------------------------
def Confirm_Preset_Load():  #kura add 20171013 For No.180,214
    global g_mute_ctrl_pulse
    global g_mute_sys_status
    global g_Status_Level_Mute
    PRESET_LOAD_FLAG = "/home/toa/TOA_AM-CF1/tmp/PRESET_LOAD_FLAG"
    WEB_STOP_flag = '/home/toa/TOA_AM-CF1/tmp/WEB_STOP_flag' #if file exists then WEB_STOP

    if os.path.exists(PRESET_LOAD_FLAG):    #read Preset Load Flag from WEB or Control IN
        os.remove(PRESET_LOAD_FLAG)     #Delete FLAG
        # 外部制御プロトコルからの制御要求に対して"応答あり"にする
        if get_resp_required(COMM_CTRL_TYPE_PRESET) == RESP.PROCESSING:
            set_resp_required(COMM_CTRL_TYPE_PRESET, RESP.DONE)
        # プリセット番号の変化がなくても自動ステイタス応答を送信する仕様である。
        # そのため、プリセット処理完了時に応答を送信するためにここで”自動応答可能”にする
        elif get_resp_required(COMM_CTRL_TYPE_PRESET) == RESP.NONE:
            set_resp_required(COMM_CTRL_TYPE_PRESET, RESP.OTHER_DONE)

        if (g_mic_mute == dc.OFF):
            if g_mute_sys_status == 1:  # Not only pulse mute==1 (because no judged level)
                g_mute_ctrl_pulse = 0   # mute pulse set 0 (pulse mute is released)
                g_mute_sys_status = 0   # mute sys status set 0 (if sys_status=1 then not set mute)
                Update_MuteStatus(g_Status_Level_Mute[0] | g_Status_Level_Mute[1])  # if either mute level = 1 then Set_Mute
        else:
            # マイク入力のミュートを強制的にONにする
            Update_MuteStatus_for_ForcedMute()

        if os.path.exists(WEB_STOP_flag) == True:
            os.remove(WEB_STOP_flag)

# -----------------------------------------
def Confirm_Preset_Load_forStandbyMode():

    PRESET_LOAD_FLAG = "/home/toa/TOA_AM-CF1/tmp/PRESET_LOAD_FLAG"
    WEB_STOP_flag = '/home/toa/TOA_AM-CF1/tmp/WEB_STOP_flag' #if file exists then WEB_STOP

    if os.path.exists(PRESET_LOAD_FLAG):    #read Preset Load Flag from WEB or Control IN
        os.remove(PRESET_LOAD_FLAG)     #Delete FLAG
        # 外部制御プロトコルからの制御要求に対して"応答あり"にする
        if get_resp_required(COMM_CTRL_TYPE_PRESET) == RESP.PROCESSING:
            set_resp_required(COMM_CTRL_TYPE_PRESET, RESP.DONE)
        # プリセット番号の変化がなくても自動ステイタス応答を送信する仕様である。
        # そのため、プリセット処理完了時に応答を送信するためにここで”自動応答可能”にする
        elif get_resp_required(COMM_CTRL_TYPE_PRESET) == RESP.NONE:
            set_resp_required(COMM_CTRL_TYPE_PRESET, RESP.OTHER_DONE)

        if os.path.exists(WEB_STOP_flag) == True:
            os.remove(WEB_STOP_flag)


# -----------------------------------------
def set_resp_required(index, value):
    """CommCtrlへの制御応答フラグ設定"""

    global g_resp_required

    g_resp_required[index] = value


# -----------------------------------------
def get_resp_required(index):
    """CommCtrlへの制御応答フラグ取得"""

    return g_resp_required[index]


# -----------------------------------------
# 遅延応答(非同期)
#   condition:  Loop終了条件判定デリゲート
#   callback:   Callback処理デリゲート
#   interval:   Loop間隔(デフォルト: 0.1(100ms))
#   count:      Loop回数制限(デフォルト: 0(制限なし)、1以上: 設定回数までLoopする)
# -----------------------------------------
def DelayResponseAsync(condition, callback, interval=0.1, count=0):
    def run(_condition, _callback, _interval, _count):
        limited = False    # Loop回数制限有無
        counter = 0        # Loop回数カウンタ(ダウンカウンタ)

        # _countが0より大きい場合はLoop回数制限有
        if _count > 0:
            limited = True
            counter = _count

        # conditionの条件を満たすまでLoop
        while not _condition():
            if limited:
                # Loop回数制限有の場合、カウントダウン
                counter -= 1

                # 規定回数LoopしたらLoopを抜ける
                if counter == 0:
                    break

            # 規定間隔分Sleep
            time.sleep(_interval)

        # Loopを抜けたらcallbackFuncを実行しスレッド終了
        _callback()

    # スレッド生成・実行
    thread = threading.Thread(target=run, args=(condition, callback, interval, count,))
    thread.start()


# -----------------------------------------
# 機器状態通知
def ExecCommCtrlSetStatus():
    global g_comm_status

    # GAINポジションテーブル(64段階)
    # -61は-∞と扱うがWebブラウザでは-60dB～0dBの範囲をとるため、仕様上使用しない。
    sp_vol_table = [-61, -60, -59, -58, -57, -56, -55, -54, -53, -52, -51, -50, -49, -48, -47, -46,
                    -45, -44, -43, -42, -41, -40, -39, -38, -37, -36, -35, -34, -33, -32, -31, -30,
                    -29, -28, -27, -26, -25, -24, -23, -22, -21, -20, -19, -18, -17, -16, -15, -14,
                    -13, -12, -11, -10,  -9,  -8,  -7,  -6,  -5,  -4,  -3,  -2,  -1,   0,   0,   0]

    try:
        # -- GAIN --
        # -- MUTE_SPK --
        # web_SPgain_sts.txt から取得
        gain_setting = []
        mute_spk = 0
        with open(web_SPgain_sts_fname, 'r') as gain_file:
            try:
                # read 時は共有ロック
                fcntl.flock(gain_file, fcntl.LOCK_SH)

                gain_setting = gain_file.readlines()
            except IOError as io_ex:
                print('[{0}] exception : {1}'.format(
                    inspect.currentframe().f_code.co_name, io_ex))

        if len(gain_setting) == 2:
            # [GAIN]
            gain = sp_vol_table.index(int(gain_setting[0].strip()))

            # [MUTE_SPK]
            if gain_setting[1].strip() == '0':
                mute_spk = 1
            else:
                mute_spk = 0
        else:
            gain = 61 if g_comm_status is None else g_comm_status.gain
            print('[{0}] {1} is broken.'.format(
                inspect.currentframe().f_code.co_name, web_SPgain_sts_fname))

        if get_resp_required(COMM_CTRL_TYPE_GAIN):
            is_gain_resp = 1
            set_resp_required(COMM_CTRL_TYPE_GAIN, False)
        else:
            is_gain_resp = 0

        if get_resp_required(COMM_CTRL_TYPE_MUTE_SPK):
            is_mute_spk_resp = 1
            set_resp_required(COMM_CTRL_TYPE_MUTE_SPK, False)
        else:
            is_mute_spk_resp = 0

        # -- MUTE_MIC --
        # グローバル変数から取得
        mute_mic = g_mute_ctrl_pulse
        if get_resp_required(COMM_CTRL_TYPE_MUTE_MIC):
            is_mute_mic_resp = 1
            set_resp_required(COMM_CTRL_TYPE_MUTE_MIC, False)
        else:
            is_mute_mic_resp = 0

        # -- BLUETOOTH --
        bluetooth_status = get_bluetooth_status()
        if get_resp_required(COMM_CTRL_TYPE_BLUETOOTH) == RESP.DONE:
            is_bluetooth_resp = 1
            set_resp_required(COMM_CTRL_TYPE_BLUETOOTH, RESP.NONE)
        else:
            is_bluetooth_resp = 0

        # -- STN --
        # グローバル変数から取得
        stn = g_standby_mode
        if get_resp_required(COMM_CTRL_TYPE_STANDBY):
            is_standby_resp = 1
            set_resp_required(COMM_CTRL_TYPE_STANDBY, False)
        else:
            is_standby_resp = 0

        # -- PRESET --
        # 下記ファイルから取得
        preset_now_load_no_f_name = "/home/toa/TOA_AM-CF1/Application/data/preset/preset_nowloadNo.txt"
        preset_temp = 1 if g_comm_status is None else 2     # default:

        with open(preset_now_load_no_f_name, 'r') as current_preset_file:
            try:
                # read 時は共有ロック
                fcntl.flock(current_preset_file, fcntl.LOCK_SH)

                preset_temp = int(current_preset_file.read().strip())
            except IOError as io_ex:
                print('[{0}] exception : {1}'.format(
                    inspect.currentframe().f_code.co_name, io_ex))

        # CommCtrlライブラリAPIのI/Fに変換  default: プリセット1
        preset = 0x11 if preset_temp == 2 else 0x10

        if get_resp_required(COMM_CTRL_TYPE_PRESET) == RESP.DONE:
            is_preset_resp = 1
            is_preset_auto_resp = 0
            set_resp_required(COMM_CTRL_TYPE_PRESET, RESP.NONE)
        # プリセット番号の変化に関係なく自動ステイタス応答を送信できるようにする
        elif get_resp_required(COMM_CTRL_TYPE_PRESET) == RESP.OTHER_DONE:
            is_preset_resp = 0
            is_preset_auto_resp = 1
            set_resp_required(COMM_CTRL_TYPE_PRESET, RESP.NONE)
        else:
            is_preset_resp = 0
            is_preset_auto_resp = 0

        # -- Focus --
        # グローバル変数から取得
        focus_x = g_focus_x
        focus_y = g_focus_y
        focus_mode = g_focus_mode
        focus_dir = g_focus_dir
        focus_dis = g_focus_dis
        # もし設定してから応答するまでにWebブラウザで上書きされた場合はその設定を正とする
        conf_data_fname = '/home/toa/TOA_AM-CF1/tmp/audio/audio_set_conf.txt'
        with open(conf_data_fname, 'r') as f:
            try:
                # read 時は共有ロック
                fcntl.flock(f, fcntl.LOCK_SH)
                conf_data = f.read()
                confs = conf_data.strip().split(',')

                if confs[0] == 'inch':
                    g_focus_unit = 0
                else:
                    g_focus_unit = 1

            except IOError as io_ex:
                print('[{0}] exception : {1}'.format(
                    inspect.currentframe().f_code.co_name, io_ex))
        focus_unit = g_focus_unit
        if get_resp_required(COMM_CTRL_TYPE_FOCUS_SET):
            is_focus_set_resp = 1
            set_resp_required(COMM_CTRL_TYPE_FOCUS_SET, False)
        else:
            is_focus_set_resp = 0

        # 送信用クラス(構造体型)生成
        if g_comm_status is None:
            g_comm_status = CommStatus(
                gain, mute_mic, mute_spk, bluetooth_status, focus_x, focus_y, focus_mode, focus_dir, focus_unit, 0, focus_dis, stn, preset, 0, 0,
                is_gain_resp, is_mute_mic_resp, is_mute_spk_resp, is_bluetooth_resp, is_focus_set_resp, is_standby_resp, is_preset_resp, is_preset_auto_resp)
        else:
            g_comm_status.gain = gain
            g_comm_status.mute_mic = mute_mic
            g_comm_status.mute_spk = mute_spk
            g_comm_status.bluetooth_mode = bluetooth_status
            g_comm_status.focus_x = focus_x
            g_comm_status.focus_y = focus_y
            g_comm_status.focus_mode = focus_mode
            g_comm_status.focus_direction = focus_dir
            g_comm_status.focus_distance = focus_dis
            g_comm_status.focus_unit = focus_unit
            g_comm_status.standby = stn
            g_comm_status.preset = preset
            g_comm_status.isGainResponse = is_gain_resp
            g_comm_status.isMuteMicResponse = is_mute_mic_resp
            g_comm_status.isMuteSpkResponse = is_mute_spk_resp
            g_comm_status.isBluetoothResponse = is_bluetooth_resp
            g_comm_status.isFocusSetResponse = is_focus_set_resp
            g_comm_status.isStandbyResponse = is_standby_resp
            g_comm_status.isPresetResponse = is_preset_resp
            g_comm_status.isPresetAutoResponse = is_preset_auto_resp

        # libCF1CommCtrlライブラリ呼び出し
        if libCF1CommCtrl.LibCF1CommCtrl_setStatus(ctypes.byref(g_comm_status)) != 0:
            print('[{0}] Failed to libCF1CommCtrl.LibCF1CommCtrl_setStatus().'.format(
                inspect.currentframe().f_code.co_name))

    except Exception as e:
        print(e, 'exception occurred @ ExecCommCtrlSetStatus().')
        raise e


# -----------------------------------------
# コントローラからのイベント制御実施
def ExecCommCtrlEvent():
    trigger = '/home/toa/TOA_AM-CF1/tmp/PRESET_LOAD_FLAG'

    try:
        # 受信コマンド取得
        result = libCF1CommCtrl.LibCF1CommCtrl_Control()
        if result != 0:
            print('[{0}] Failed to libCF1CommCtrl.LibCF1CommCtrl_Control().'.format(
                inspect.currentframe().f_code.co_name))
            ExecCommCtrlSetStatus()     # 現在値を通知しておく
            return

        # イベントリスト   [0]:EventKey [1]:無効値  [2]:対応メソッド        [3]:応答判定メソッド
        # ビームステアリングは個別にイベントを処理する
        gain_event      = ('GAIN',      0xFF,       CommCtrlEventGain,      None                               )
        mute_mic_event  = ('MUTE_MIC',  0,          CommCtrlEventMuteMic,   None                               )
        mute_spk_event  = ('MUTE_SPK',  0,          CommCtrlEventMuteSpk,   None                               )
        bluetooth_event = ('BLUETOOTH', 0,          CommCtrlEventBluetooth, None                               )
        standby_event   = ('STN',       0,          CommCtrlEventStandby,   None                               )
        preset_event    = ('PRESET',    0,          CommCtrlEventPreset,    lambda: not os.path.exists(trigger))

        tpl_event = (gain_event, mute_mic_event, mute_spk_event, bluetooth_event, standby_event, preset_event)
        libCF1CommCtrl.SendCF1GetEvent.argtypes = [c_char_p]
        notified = False

        ret_value = ctypes.c_int(0)
        for ev in tpl_event:
            # 制御イベント取得
            result = libCF1CommCtrl.SendCF1GetEvent(
                ctypes.c_char_p(ev[0].encode('utf-8')), ctypes.byref(ret_value))

            if result != 0:
                print('[{0}] Failed to libCF1CommCtrl.SendCF1GetEvent().'.format(
                    inspect.currentframe().f_code.co_name))
                break

            value = ret_value.value

            # 値が無効値の場合は何もしない
            if value != ev[1] and ev[2] is not None:
                # 値が有効値の場合はイベントごとの対応メソッドコール
                ev[2](value)

                # 機器状態通知
                if ev[3] is not None:
                    # 設定が反映されるまで通知を遅延させる場合

                    DelayResponseAsync(ev[3], ExecCommCtrlSetStatus)
                else:
                    # 設定処理実施時点で通知する場合

                    ExecCommCtrlSetStatus()

                notified = True
                break      # 1ループで複数イベントを処理する場合はこのbreakを消す

        # ビームステアリングイベント取得
        # (仕様上、複数イベントは想定していない)
        mode = c_uint8(0)
        direction = c_int8(0)
        distance = c_float(0.0)
        unit = c_uint8(0)
        result = libCF1CommCtrl.SendCF1GetEventFocus(ctypes.byref(mode), ctypes.byref(direction), ctypes.byref(distance), ctypes.byref(unit))

        if result != 0:
            print('[{0}] Failed to libCF1CommCtrl.SendCF1GetEventFocus().'.format(
                inspect.currentframe().f_code.co_name))

        # 有効な値であれば、イベントを処理する
        if mode.value != 0:
            WEB_STOP_flag = '/home/toa/TOA_AM-CF1/tmp/WEB_STOP_flag'

            # 何も実行していなければ、通常通り実行する
            if not os.path.exists(trigger) and not os.path.exists(WEB_STOP_flag):
                CommCtrlEventFocusSet(mode.value, direction.value, distance.value, unit.value)
                ExecCommCtrlSetStatus()

            # 実行中は前回値を返す(NG応答)
            else:
                set_resp_required(COMM_CTRL_TYPE_FOCUS_SET, True)
                ExecCommCtrlSetStatus()

            # 実施の有無に関わらず、Trueにする
            notified = True

        # 何もイベントがなくても現在値をCommCtrlライブラリに通知する
        if not notified:
            ExecCommCtrlSetStatus()

    except Exception as e:
        print(e, 'exception occurred @ ExecCommCtrlEvent().')
        raise e


# -----------------------------------------
# "GAIN"イベント処理
def CommCtrlEventGain(value):
    set_web_gain(value)
    set_resp_required(COMM_CTRL_TYPE_GAIN, True)


# -----------------------------------------
# "MUTE_MIC"イベント処理
def CommCtrlEventMuteMic(value):
    global g_mute_ctrl_pulse

    if (g_mic_mute == dc.OFF):
        g_mute_ctrl_pulse = 1 if value == 1 else 0
        Update_MuteStatus(g_mute_ctrl_pulse)
    set_resp_required(COMM_CTRL_TYPE_MUTE_MIC, True)


# -----------------------------------------
# "MUTE_SPK"イベント処理
def CommCtrlEventMuteSpk(value):
    set_web_mute(value)
    set_resp_required(COMM_CTRL_TYPE_MUTE_SPK, True)


# -----------------------------------------
# "BLUETOOTH"イベント処理
def CommCtrlEventBluetooth(value):
    set_bluetooth_mode(value)
    set_resp_required(COMM_CTRL_TYPE_BLUETOOTH, RESP.PROCESSING)


# -----------------------------------------
# "STN"イベント処理
def CommCtrlEventStandby(value):
    global g_standby_mode

    g_standby_mode = 1 if value == 1 else 0
    Chg_StandbyMode()
    set_resp_required(COMM_CTRL_TYPE_STANDBY, True)


# -----------------------------------------
# "PRESET"イベント処理
def CommCtrlEventPreset(value):
    Load_PresetData(value)
    set_resp_required(COMM_CTRL_TYPE_PRESET, RESP.PROCESSING)


# -----------------------------------------
# "BEAMSTEERING"イベント処理
def CommCtrlEventFocusSet(mode, direction, distance, unit):
    global g_focus_mode
    global g_focus_dir
    global g_focus_dis
    global g_focus_unit

    # 機器状態通知の応答用に更新を掛ける
    # 基本的にUpdate_BeamAngleで更新する
    # auto
    if mode == 1:
        g_focus_mode = 0
    # manual
    else:
        g_focus_unit = unit
        # AM-CF1の仕様として距離は 0.2[m] ～ を設定範囲を取るため、
        # ここで 0.2[m] 未満であれば 0.2[m] に補正する
        if distance < 0.2:
            g_focus_dis = 0.2
        else:
            g_focus_dis = distance
        g_focus_dir = direction
        g_focus_mode = 1

        # 設定内容を読み出して、inch/cm設定だけを更新する
        conf_data_fname = '/home/toa/TOA_AM-CF1/tmp/audio/audio_set_conf.txt'
        confs = ''
        unit_text = ''
        if unit == 0:
            unit_text = 'inch'
        else:
            unit_text = 'cm'
        with open(conf_data_fname, 'r') as f:
            try:
                # read 時は共有ロック
                fcntl.flock(f, fcntl.LOCK_SH)
                conf_data = f.read()
                confs = conf_data.strip().split(',')

            except IOError as io_ex:
                print('[{0}] exception : {1}'.format(
                    inspect.currentframe().f_code.co_name, io_ex))

        with open(conf_data_fname, 'r+') as f:
            try:
                # write 時は'r+'で open して排他ロック
                fcntl.flock(f, fcntl.LOCK_EX)
                audio_setting_conf = unit_text + ',' + confs[1] + ',' + confs[2] + ',' + confs[3]
                f.write(audio_setting_conf)

            except IOError as io_ex:
                print('[{0}] exception : {1}'.format(
                    inspect.currentframe().f_code.co_name, io_ex))

    WEB_STOP_flag = '/home/toa/TOA_AM-CF1/tmp/WEB_STOP_flag'
    Set_Bf(mode, g_focus_dir, g_focus_dis, WEB_STOP_flag)
    set_resp_required(COMM_CTRL_TYPE_FOCUS_SET, True)


# -----------------------------------------
# 後片付け
def CleanUp():
    Show_Error()
    libDrivers.Initialize_FrontPanel()      # I2C-FP
    print("ADDA RESET")
    libDrivers.Set_ADDA_Reset(0)            # GPIO
    time.sleep(1)
    libDrivers.Set_ADDA_Reset(1)            # GPIO
    print("DSP RESET")

    # start = time.monotonic()
    if libCF1CommCtrl.LibCF1CommCtrl_Deinit() != 0:
        print('[{0}] Failed to libCF1CommCtrl.LibCF1CommCtrl_Deinit().'.format(
            inspect.currentframe().f_code.co_name))
    # elapsed = time.monotonic() - start
    # print ("elapsed_time:{0}".format(elapsed) + "[sec]")

    print("LibCF1CommCtrl Deinit")
    os.system("sudo python3 /home/toa/TOA_AM-CF1/Application/data/dspreset.py")

# この　firmware で対応しているファームか判定する
def IsSupportedDspVersionAndUpdateStatus():
    dsp_version = dspupdate.GetDspVersion()
    if dsp_version is None:
        dspupdate.Update_Status_Rewrite(dspupdate.STATUS_UPDATE.STATUS_DSP_1_0_0_0)
        return False
    elif dsp_version == "":
        dspupdate.Update_Status_Rewrite(dspupdate.STATUS_UPDATE.STATUS_DSP_1_0_0_0)
        return False
    elif dsp_version == "0.0.0.0":
        dspupdate.Update_Status_Rewrite(dspupdate.STATUS_UPDATE.STATUS_DSP_1_0_0_0)
        return False
    elif dsp_version == "1.0.0.0":
        dspupdate.Update_Status_Rewrite(dspupdate.STATUS_UPDATE.STATUS_DSP_1_0_0_0)
        return False
    elif dsp_version == "1.1.0.0":
        dspupdate.Update_Status_Rewrite(dspupdate.STATUS_UPDATE.STATUS_FAILURE_DSP_UPDATE)
        return False
    elif dsp_version == "1.2.0.0":
        dspupdate.Update_Status_Rewrite(dspupdate.STATUS_UPDATE.STATUS_FAILURE_DSP_UPDATE)
        return False
    else:
        return True

# -----------------------------------------
def Main():
    try:
        print("Start application")
        Initialize_Device()     # Init I2C & GPIO
        time.sleep(3)   # for DSP reset

        if dspupdate.IsDspUpdate() == True:
            print("DSP update starts")
            dspupdate.DspUpdate() # Dsp_Update Check DSP差分flagのLED制御の影響はここまで。ここから先はLED制御可

        # DSP update 後に version　をチェックして意図しないバージョンは弾く
        if IsSupportedDspVersionAndUpdateStatus() == False:
            libDrivers.Ctrl_POWER_Blue_LED_HARD(0)  # I2C-SP LED_OFF
            libDrivers.Ctrl_PowerLED(3) # I2C-SP LED_ON_ORANGE
            RunWebServerAndExitWithError()

        # OUTPUT MUTE & AMP Power Off 制御　
        libDrivers.Ctrl_AUDIO_OUTPUT_ENABLE(0)  # I2C-MB DISABLE

        # ここでハード制御　電源BlueLEDを消す
        libDrivers.Ctrl_POWER_Blue_LED_HARD(0)  # I2C-SP LED_OFF
        libDrivers.Ctrl_PowerLED(1)             # I2C-SP LED_ON_GREEN

        # --- Initialize and setting---
        TimeAdjust()

        if Is_FactoryReset():  # ここでPOWER_SWを呼んでいる
            Exec_FactoryReset()

        # NetworkManager STOP add kura 20171030
        sp.run(['sudo','service','NetworkManager-wait-online','stop'])
        sp.run(['sudo','service','NetworkManager','stop'])

        time.sleep(3)

        Get_DspVersion()

        Initialize_DspParameter()
        Create_Command()
        #Pre_Apply_Mic_Mute_Config()
        #Pre_Apply_Spout_Assign_Config()
        Set_Config()
        if (g_mic_mute == dc.ON):
            Update_MuteStatus_for_Boot() # DSPを除く強制マイクミュート処理(起動時固有の処理)
        #Apply_Mic_Mute_Config()
        #Apply_Spout_Assign_Config()
        Activate_WebServer()

        # libCF1CommCtrl初期化
        # start = time.monotonic()
        login_info_file_name = "/home/toa/TOA_AM-CF1/Application/data/config/config_userpass.txt".encode('utf-8')
        libCF1CommCtrl.LibCF1CommCtrl_Init.argtypes = [c_char_p, c_int, c_int]
        if libCF1CommCtrl.LibCF1CommCtrl_Init(login_info_file_name, len(login_info_file_name), isSkipLogin) != 0:
            print('[{0}] Failed to libCF1CommCtrl.LibCF1CommCtrl_Init().'.format(
                inspect.currentframe().f_code.co_name))
        # elapsed = time.monotonic() - start
        # print("elapsed_time:{0}".format(elapsed) + "[sec]")

        # OUTPUT MUTE & AMP Power Off 解除　
        libDrivers.Ctrl_AUDIO_OUTPUT_ENABLE(1)  # I2C-MB ENABLE

        # --- Define Variable
        global g_standby_mode
        global g_Cfg_CtrlInput
        for i in range(2):
            g_Cfg_CtrlInput.append(libDrivers.Get_CtrlInputCfg(i))  # GPIO

        WEB_STOP_flag = '/home/toa/TOA_AM-CF1/tmp/WEB_STOP_flag' #if file exists then WEB_STOP
        MAIN_STOP_FLAG = '/home/toa/TOA_AM-CF1/tmp/MAIN_STOP_FLAG' #add kura 20180913

        global bf_LED_Num_prev
        bf_LED_Num_prev = 0

        LOOP_MIN_TIME = 0.070 ## sec
        # --- main loop ---
        while 1:
            start_time = time.perf_counter()
            #----------------------------------
            if libDrivers.Is_VolMode() == 1:        # I2C-FP
                # print('WebApp Update Disable')
                if not os.path.exists(WEB_STOP_flag):
                    with open(WEB_STOP_flag, 'w') as wsf:
                        fcntl.flock(wsf, fcntl.LOCK_EX)
                        wsf.write(" ")
            if libDrivers.Is_NormalMode() == 1:     # I2C-FP
                # print('WebApp Update Enable')
                if os.path.exists(WEB_STOP_flag):
                    os.remove(WEB_STOP_flag)
                    #print('DELETE')
            # --- Display ArrayMicrophone angle & level  ---
            if not os.path.exists(MAIN_STOP_FLAG): #add kura 20180913
                #print("Update BeamAngle")
                Update_BeamAngle()

            if g_standby_mode == 0:
                # --- key scan and control (i2c)---
                Update_SideSwitchStatus(libDrivers.Exec_KeyScan())  # I2C-SP
                # --- Control Input Scan ---
                Update_ControlInputStatus(libDrivers.CinScan())     # GPIO
                # --- Control Output ---
                libDrivers.Update_CtrlOutput()                      # GPIO
                # --- USB Connection Check ---
                Update_USBAudioConnectStatus()
                # ---- Confirm Preset load flag --- For No214,180 add by kura
                Confirm_Preset_Load()

            # For No191,No197
            else:
                Update_ControlInputStatus_forStandbyMode(libDrivers.CinScan())  # GPIO
                Confirm_Preset_Load_forStandbyMode()

            # --- Bluetooth Control ---
            Control_Bluetooth()

            # --- key scan Power Switch ---
            Update_PowerSwitchStatus()

            # --- Controller Event Dispatch ---
            ExecCommCtrlEvent()

            # --- Shutdown ---
            Exec_ShutdownSeq()
            # --- Update LED, Control output, RTC ---
            Update_Status()  #Front LED Control

            end_time = time.perf_counter()
            if end_time > start_time:
                diff_time = end_time - start_time
                if LOOP_MIN_TIME > diff_time:
                    time.sleep(LOOP_MIN_TIME - diff_time)

    except KeyboardInterrupt:
        print('Keyboard Interrupt.')
        CleanUp()
        sys.exit()
    except json.decoder.JSONDecodeError:
        traceback.print_exc()
    except:
        traceback.print_exc()
        #pass    # at first, pass was used
# -----------------------------------------
if __name__ == '__main__':
    Main()
    print("Exception : Exit Main.py")
    # CleanUp()
    # Dump_ExceptionLog("section_main_loop")
    RunWebServerAndExitWithError()
