# -*- coding:utf-8 -*-
import json,os,fcntl
import copy,sys
sys.path.append('/home/toa/TOA_AM-CF1/Webserver/hello/')
from send_command import send_command
import math, time
import def_block_no as BlockNo

command_file_name = '../../tmp/command_cf1_set_bf.json'
result_file_name = '../../tmp/result_set_bf.json'

block_num = BlockNo.BF
type_name = 'microphonearray'

# ---------------------------------------------------------
def Set_Bf_init():
    # コマンド出力結果用のファイルを作成する
    with open(result_file_name, 'w') as f:
        f.write(" ")


# ---------------------------------------------------------
def Set_Bf(update_mode, dir_num, dis_num, web_stop_flag):
    # --- Web操作を停止する ---
    # ビームステアリング設定をコマンドキューに積んでWeb操作との排他を実現する
    if not os.path.exists(web_stop_flag):
        with open(web_stop_flag, 'w') as wsf:
            fcntl.flock(wsf, fcntl.LOCK_EX)
            wsf.write("")

    # -- ビームステアリング設定用のコマンドファイル生成 --
    commands = []
    commands.clear()

    # 音源推定モード設定コマンド
    if update_mode == 1:
        commands.append({
            'access': 'set',
            'block_no': block_num,
            'type': type_name,
            'param': {'update_mode': 'auto'}
        })
    # 音源固定モード設定コマンド
    elif update_mode == 2:
        commands.append({
            'access': 'set',
            'block_no': block_num,
            'type': type_name,
            'param': {'update_mode': 'manual', "dir": dir_num, "dis": dis_num}
        })
    else:
        print('error')
        return

    # コマンド実行用のファイルを作成する
    with open(command_file_name, 'w') as f:
        json.dump(commands, f, indent=True)

    # --- コマンドを実行する ---
    send_command(command_file_name, result_file_name)

    # --- Web操作を再開する ---
    if os.path.exists(web_stop_flag):
        os.remove(web_stop_flag)

