# -*- coding:utf-8 -*-
import json, copy, sys
sys.path.append('/home/toa/TOA_AM-CF1/Webserver/hello/')
import def_block_no as BlockNo
from send_command import send_command
from param_set_get_flag import Wait_Param_Set_Flag

command_muteoff_file_name = '../../tmp/command_cf1_set_mute_off.json' #MuteOFF(release)用ファイル
command_muteon_file_name = '../../tmp/command_cf1_set_mute_on.json' #MuteON(set_mute)用ファイル
result_mute_file_name = '../../tmp/result_mute.json'
# ---------------------------------------------------------
def Mute_Init():
    with open(result_mute_file_name, 'w') as f:
        f.write(" ")
    with open('result_get_all_gain_prev_standby.json', 'w') as f:
        f.write(" ")
    with open('result_set_mute_standby.json', 'w') as f:
        f.write(" ")
    with open('result_release_mute_standby.json', 'w') as f:
        f.write(" ")

    MUTE_ON_GAIN = -100
    MUTE_OFF_GAIN = 12 #注意。BlockNo.GAIN_MICのgainの初期値が変わるときに変更必要

    #--- Get input gain for array-microphone
    #Set_mute時に最新のMute値を取得するためのコマンドjsonを作成していたが、
    #マイクミュートは -100か0の2値のため、ここで前のゲイン値を覚える必要はない。削除。

    #--- Set mute for array-microphone
    set_micmute_on_commands = [
        {'access': 'set',
        'block_no': BlockNo.GAIN_MIC,
        'type': 'gain',
        'param': { 'gain':MUTE_ON_GAIN }},
        {
        'access': 'set',
        'block_no': BlockNo.AEC,
        'type': 'aec',
        'param': { 'mic_mute':True }
        },
        {
        'access': 'set',
        'block_no': BlockNo.AEC,
        'type': 'aec',
        'param': { 'param_set_flag':1 }
        }
        ]


    with open(command_muteon_file_name, 'w') as f:
        # jsonファイルを辞書型として読み込み
        json.dump(set_micmute_on_commands, f, indent=True)

    #--- Release mute for array-microphone
    set_micmute_off_commands = [
        {'access': 'set',
        'block_no': BlockNo.GAIN_MIC,
        'type': 'gain',
        'param': { 'gain':MUTE_OFF_GAIN }},
        {
        'access': 'set',
        'block_no': BlockNo.AEC,
        'type': 'aec',
        'param': { 'mic_mute':False }
        },
        {
        'access': 'set',
        'block_no': BlockNo.AEC,
        'type': 'aec',
        'param': { 'param_set_flag':1 }
        }
        ]


    with open(command_muteoff_file_name, 'w') as f:
        # jsonファイルを辞書型として読み込み
        json.dump(set_micmute_off_commands, f, indent=True)

    #--- Set mute for standby mode
    #シャットダウン前に強制的に各入出力ゲインを-100dBにする処理

        #--- Set mute for array-microphone
    set_shutdown_mute_on_commands = [
        {
        'access': 'set',
        'block_no': BlockNo.AEC,
        'type': 'aec',
        'param': { 'mic_mute':True }
        },
        {
        'access': 'set',
        'block_no': BlockNo.AEC,
        'type': 'aec',
        'param': { 'param_set_flag':1 }
        }
        ]

    blocknums = [
        BlockNo.GAIN_MIC,
        BlockNo.GAIN_USBinL,BlockNo.GAIN_USBinR,
        BlockNo.GAIN_CODECin,
        BlockNo.GAIN_BTinL,BlockNo.GAIN_BTinR,
        BlockNo.GAIN_AUXinL,BlockNo.GAIN_AUXinR,
        BlockNo.GAIN_CODECout,
        BlockNo.GAIN_USBoutL,BlockNo.GAIN_USBoutR,
        BlockNo.GAIN_SPoutL,BlockNo.GAIN_SPoutR,
        BlockNo.GAIN_AUXoutL,BlockNo.GAIN_AUXoutR,
        BlockNo.GAIN_BToutL]

    command = {
        'access': 'set',
        'block_no': None,
        'type': 'gain',
        'param': { 'gain':MUTE_ON_GAIN }
    }

    commands = []

    for n in range(len(blocknums)):
        commands.append(copy.copy(command))
        commands[n]['block_no'] = blocknums[n]
    
    #マイクミュート用のaecの設定が入っている。これまでのFWとコマンド配列順を入れ子にしないように、ミュートON時そのままの配列の流用は避ける。
    commands.extend(set_shutdown_mute_on_commands)

    with open('command_cf1_set_mute_standby.json', 'w') as f:
        json.dump(commands, f, indent=True)

    #--- Get input & output gain before enter standby mode
    #シャットダウン直前に、最新のゲインをRAMに残す意味はないため、削除。

# ---------------------------------------------------------
def Set_Mute():
    # --- save previous input gain ---
    #マイクミュートは -100か0の2値のため、ここで前のゲイン値を覚える必要はない。削除。
    # --- execute mute ---
    #マイクミュートON処理
    Wait_Param_Set_Flag()
    send_command(command_muteon_file_name, result_mute_file_name)
# ---------------------------------------------------------
def Release_Mute():
    #マイクミュートOFF処理
    Wait_Param_Set_Flag()
    send_command(command_muteoff_file_name, result_mute_file_name)
# ---------------------------------------------------------
def Set_Mute_for_StandbyMode():
    # --- save previous input & output gain ---
    #この関数、ファイルは、シャットダウン直前のみの使用であるため、最新のゲインを残す意味はない。削除。
    # --- execute mute ---
    Wait_Param_Set_Flag()
    send_command('command_cf1_set_mute_standby.json', 'result_set_mute_standby.json')
# ---------------------------------------------------------
def Release_Mute_from_StandbyMode():
    with open('./result_get_all_gain_prev_standby.json', 'r') as f:
        result = json.load(f)
    if isinstance(result, list) is False:
        print('result.json must be array!')
    for x in range(16):
        result[x]['access'] = 'set'
    with open('./command_cf1_release_mute_standby.json', 'w') as f:
        json.dump(result, f, indent=True)
    send_command('command_cf1_release_mute_standby.json', 'result_release_mute_standby.json')
