/************************************************************************
 *
 *	coeff_xover_butterworth.c
 *
 *	20020925	Tsuyoshi Ogawa
 *
 ************************************************************************/

#include "fdesign_prototypes.h"

namespace dsp_lib {

/*============================================================*/
#define	COEFF_XOVER_BW_ALPHA			1.0f

/*--------------------------------------------------------------------------------*/
#define	COEFF_XOVER_BW12_Q				(1.0f/1.4142f)
/*--------------------------------------------------------------------------------*/
#define	COEFF_XOVER_BW18_Q				1.0f
/*--------------------------------------------------------------------------------*/
#define	COEFF_XOVER_BW24_Q1				1.30656f
#define	COEFF_XOVER_BW24_Q2				0.5412f

/*============================================================*/
void
Fdesign_XOverLPF_BW12(
	float	f_,
	int		bypass_,
	float	*coeff1_,
	float	*coeff2_
)
{
	Fdesign_XOverLPF12(f_, COEFF_XOVER_BW12_Q, COEFF_XOVER_BW_ALPHA, bypass_, coeff1_);
	Fdesign_Through(coeff2_);
}


void
Fdesign_XOverLPF_BW18(
	float	f_,
	int		bypass_,
	float	*coeff1_,
	float	*coeff2_
)
{
	Fdesign_XOverLPF12(f_, COEFF_XOVER_BW18_Q, COEFF_XOVER_BW_ALPHA, bypass_, coeff1_);
	Fdesign_XOverLPF6 (f_,                     COEFF_XOVER_BW_ALPHA, bypass_, coeff2_);
}

void
Fdesign_XOverLPF_BW24(
	float	f_,
	int		bypass_,
	float	*coeff1_,
	float	*coeff2_
)
{
	Fdesign_XOverLPF12(f_, COEFF_XOVER_BW24_Q1, COEFF_XOVER_BW_ALPHA, bypass_, coeff1_);
	Fdesign_XOverLPF12(f_, COEFF_XOVER_BW24_Q2, COEFF_XOVER_BW_ALPHA, bypass_, coeff2_);
}

/*--------------------------------------------------------------------------------*/
void
Fdesign_XOverHPF_BW12(
	float	f_,
	int		bypass_,
	float	*coeff1_,
	float	*coeff2_
)
{
	Fdesign_XOverHPF12(f_, COEFF_XOVER_BW12_Q, COEFF_XOVER_BW_ALPHA, bypass_, coeff1_);
	Fdesign_Through(coeff2_);
}

void
Fdesign_XOverHPF_BW18(
	float	f_,
	int		bypass_,
	float	*coeff1_,
	float	*coeff2_
)
{
	Fdesign_XOverHPF12(f_, COEFF_XOVER_BW18_Q, COEFF_XOVER_BW_ALPHA, bypass_, coeff1_);
	Fdesign_XOverHPF6 (f_,                     COEFF_XOVER_BW_ALPHA, bypass_, coeff2_);
}

void
Fdesign_XOverHPF_BW24(
	float	f_,
	int		bypass_,
	float	*coeff1_,
	float	*coeff2_
)
{
	Fdesign_XOverHPF12(f_, COEFF_XOVER_BW24_Q1, COEFF_XOVER_BW_ALPHA, bypass_, coeff1_);
	Fdesign_XOverHPF12(f_, COEFF_XOVER_BW24_Q2, COEFF_XOVER_BW_ALPHA, bypass_, coeff2_);
}
/*============================================================*/
} // namespace dsp_lib
