#pragma once
#include <stdio.h>
#include <spi/spi_api.h>

namespace dsp_ctrl {

// uint32_t to uint32_t
uint32_t
GetSharedRamAddress(uint32_t local_address_);

// pointer to pointer
template <typename T_TYPE>
T_TYPE*
GetSharedRamPointer(T_TYPE* local_address_)
{
	T_TYPE*	ptr;

	if (local_address_ == NULL) {
		return NULL;
	}

	ptr = reinterpret_cast<T_TYPE*>(
			GetSharedRamAddress(reinterpret_cast<uint32_t>(local_address_))
	);

	return ptr;
}

// pointer to uint32_t
template <typename T_TYPE>
uint32_t
GetSharedRamAddress(T_TYPE* local_address_)
{
	uint32_t	address;

	if (local_address_ == NULL) {
		return NULL;
	}

	address = GetSharedRamAddress(reinterpret_cast<uint32_t>(local_address_));

	return address;
}
bool
WriteDspConfiguration(void);
bool
RequestToImportDspConfiguration(void);
bool
GetDspConfigurationImportedFlag(uint32_t*	flag_);
bool
RequestToImportDspSetup(void);
bool
GetDspSetupImportedFlag(uint32_t* flag_);

} // namespace dsp_ctrl
