/*
 * dsp_init.cpp
 *
 *  Created on: 2016/11/28
 *      Author: toa29548
 */

#include <dsp_ctrl/dsp_config.h>
#include <dsp_ctrl/map.h>
#include <dsp_ctrl/access_sharedram.h>
#include "dsp_init.h"
#include <picojson.h>

using namespace shared;

namespace dsp_ctrl {

bool
DspConfiguration(picojson::array& block_cfg_)
{
    /* メモリ確保 */
    if (AllocateMemory() == false) {
    	return false;
    }

    /* 変数マップ登録 */
    ConfigureVariableMap();

	/* DSPコンフィギュレーション作成 */
    if (CreateDspConfiguration(block_cfg_) == false) {
    	return false;
    }

    /* DSPコンフィギュレーション書き込み */
    if (WriteDspConfiguration() == false) {
    	return false;
    }	

    /* DSPコンフィギュレーション取り込みを要求 */
    if (RequestToImportDspConfiguration() == false) {
    	return false;
    }	

	return true;
}

} // namespace dsp_config
