/*
 * dsp_map.h
 *
 *  Created on: 2016/09/26
 *      Author: toa29548
 */

#pragma once

#include <stdint.h>
#include <stddef.h>

// TI
//#include <dsp_lib/substitute/TI_OMAPL138_app.h>
//#define AUDIO_BLOCK_SIZE		(384)

// ADI
//#include <dsp_lib/substitute/ADI_ADSP21489_app.h>
//#include <analog_audio.h>

// RaspberryPi
#include <dsp_lib/substitute/RaspberryPi_app.h>
#include <audio.h>

#include "../dsp_lib/include/dsp_lib.h"
#include "simulated_malloc.h"

#include <shared/map_no.h>

#if 0	// DSP
#define MALLOC_SHAREDRAM_DM(type, size)								\
	reinterpret_cast<type*>(heap_malloc( 							\
					heap_lookup(shared::HEAP_USER_ID_SHAREDRAM_DM), \
					sizeof(type) * size)							\
					);

#define MALLOC_SHAREDRAM_PM(type, size)								\
	reinterpret_cast<type*>(heap_malloc( 						\
					heap_lookup(shared::HEAP_USER_ID_SHAREDRAM_PM), \
					sizeof(type) * size)							\
					);
#else	// CPU
#define MALLOC_SHAREDRAM_DM(type, size)	reinterpret_cast<type*>(simulated_malloc_dm(sizeof(type) * size));
#define MALLOC_SHAREDRAM_PM(type, size)	reinterpret_cast<type*>(simulated_malloc_pm(sizeof(type) * size));
#endif

namespace dsp_ctrl {
extern	uint32_t*			g_map;


enum {
	DSP_BLOCK_SIZE = AUDIO_BLOCK_SIZE
};

enum NUMBER_OF {
	NUMBER_OF_NETLIST_MAX				= 100,	// とりあえず

	//NUMBER_OF_ADAT_IN					= NUMBER_OF_SLOT_ADAT_RX,
	//NUMBER_OF_ADAT_OUT					= NUMBER_OF_SLOT_ADAT_TX,
	//NUMBER_OF_DANTE_IN					= NUMBER_OF_SLOT_DANTE_RX,
	//NUMBER_OF_DANTE_OUT					= NUMBER_OF_SLOT_DANTE_TX,

	//NUMBER_OF_EXTERNAL_IO				= NUMBER_OF_ADAT_IN
	//									+ NUMBER_OF_ADAT_OUT
	//									+ NUMBER_OF_DANTE_IN
	//									+ NUMBER_OF_DANTE_OUT
								
	NUMBER_OF_AD_1						= NUMBER_OF_SLOT_AD_1,
	NUMBER_OF_AD_2						= NUMBER_OF_SLOT_AD_2,
	NUMBER_OF_DA_1						= NUMBER_OF_SLOT_DA_1,
	NUMBER_OF_DA_2						= NUMBER_OF_SLOT_DA_2,
	NUMBER_OF_CPU_IN					= NUMBER_OF_SLOT_CPU_RX,
	NUMBER_OF_CPU_OUT					= NUMBER_OF_SLOT_CPU_TX,

	NUMBER_OF_MIC						= 8,
	NUMBER_OF_USB_IN					= 2,
	NUMBER_OF_CODEC_IN					= 1,
	NUMBER_OF_BT_IN						= 2,
	NUMBER_OF_AUX_IN					= 2,
	
	NUMBER_OF_SP_OUT					= 2,
	NUMBER_OF_USB_OUT					= 2,
	NUMBER_OF_CODEC_OUT					= 1,
	NUMBER_OF_AUX_OUT					= 2,

	NUMBER_OF_EXTERNAL_IO				= NUMBER_OF_AD_1
										+ NUMBER_OF_AD_2
										+ NUMBER_OF_CPU_IN
										+ NUMBER_OF_DA_1
										+ NUMBER_OF_DA_2										
										+ NUMBER_OF_CPU_OUT,
};

enum SIZE_OF {
	SIZE_OF_DELAY_BUF		= 64
	// SIZE_OF_DELAY_BUF = 131072 の場合,	2^17[samples], 2730[msec] @FS=48kHz
	// SIZE_OF_DELAY_BUF = 1024 の場合,	2^10[samples], 21.3[msec] @FS=48kHz
};

#ifndef	DSP_MAP_NO
#define	MAP_NO(block_, no_)		(4*(block_) + (no_))
#endif

/* --- Shared RAM --- */
// ----- MAP
extern uint32_t*			g_map;
// ----- parameters
extern const uint32_t					g_map_size;

extern dsp_lib::DspManager::Config*		g_dsp_manager_config;
extern dsp_lib::DspManager::Param*		g_dsp_manager_param;
extern dsp_lib::DspManager::Status*		g_dsp_manager_status;
extern dsp_lib::DspManager::NetList*	g_dsp_manager_net_list;

/* ---- DSP RAM ---- */
typedef float IoBuffer[DSP_BLOCK_SIZE];

bool
AllocateMemory(void);
void
ConfigureVariableMap(void);

} // namespace dsp_ctrl
