#pragma warning(disable:4996)
#include <stdint.h>
#include <stdio.h>
#include <string>
#include <fstream>
#include <iostream>
#include <shared/shared_ram.h>
#include <dsp_lib/include/dsp/dsp_manager.h>
#include "simulated_malloc.h"
#include "access_sharedram.h"
#include "read_input_file.h"
#include "map.h"

using namespace std;

namespace dsp_ctrl {

void
WriteNetlistHeader(FILE *fp_)
{
	fprintf(fp_, "#%7s ", "type");
	fprintf(fp_, "%8s ", "input");
	fprintf(fp_, "%8s ", "output");
	fprintf(fp_, "%8s ", "config");
	fprintf(fp_, "%8s ", "param");
	fprintf(fp_, "%8s ", "status");
	fprintf(fp_, "%8s ", "rsvd_0");
	fprintf(fp_, "%8s\n", "rsvd_1");
}

void
WriteNetlist(FILE *fp_, dsp_lib::DspManager::NetList netlist_)
{
		fprintf(fp_, "%8d ", netlist_.type);
		fprintf(fp_, "%8d ", netlist_.input);
		fprintf(fp_, "%8d ", netlist_.output);
		fprintf(fp_, "%08x ", reinterpret_cast<uint32_t>(netlist_.config));
		fprintf(fp_, "%08x ", reinterpret_cast<uint32_t>(netlist_.param));
		fprintf(fp_, "%08x ", reinterpret_cast<uint32_t>(netlist_.status));
		fprintf(fp_, "%8d ", netlist_.reserved_0);
		fprintf(fp_, "%8d\n", netlist_.reserved_1);
}

bool
SaveNetList(char *output_file_name_)
{
	// localram_netlist
	{
		FILE *fp;
		//std::string filename = "/home/garyh/share/localram_netlist.txt";
		std::string filename = "./log_localram_netlist.txt";
		if ((fp = fopen(filename.c_str(), "w")) == NULL) {
			cout << "file open error: " << filename << endl;
			return false;
		}

		WriteNetlistHeader(fp);

		for (uint32_t list_no = 0; list_no < g_number_of_netlist; list_no++) {
			WriteNetlist(fp, g_dsp_manager_net_list[list_no]);
		}

		fclose(fp);
	}
	{
		fstream fs;
		fs.open("./log_localram_netlist.bin", ios::binary | ios::out);
		fs.write(
			reinterpret_cast<char*>(g_dsp_manager_net_list), 
			sizeof(dsp_lib::DspManager::NetList) * g_number_of_netlist
		);
	}
	// sharedram_netlist
	{
		FILE *fp;
		//std::string filename = "/home/garyh/share/sharedram_netlist.txt";
		std::string filename = "./log_sharedram_netlist.txt";
		if ((fp = fopen(filename.c_str(), "w")) == NULL) {
			cout << "file open error: " << filename << endl;
			return false;
		}

		WriteNetlistHeader(fp);

		ofstream ofs;
		//ofs.open("./sharedram_netlist.bin", ios::binary);
		ofs.open(output_file_name_, ios::binary);

		//dsp_lib::DspManager::NetList* dsp_netlist = new dsp_lib::DspManager::NetList[g_number_of_netlist];

		for (uint32_t list_no = 0; list_no < g_number_of_netlist; list_no++) {
			dsp_lib::DspManager::NetList netlist;
			bool ret = true;

			ret &= ReadSharedRam(
				GetSharedRamAddress(&g_dsp_manager_net_list[list_no].type), &netlist.type
			);
			ret &= ReadSharedRam(
				GetSharedRamAddress(&g_dsp_manager_net_list[list_no].input), &netlist.input
			);
			ret &= ReadSharedRam(
				GetSharedRamAddress(&g_dsp_manager_net_list[list_no].output), &netlist.output
			);
			ret &= ReadSharedRam(
				GetSharedRamAddress(&g_dsp_manager_net_list[list_no].config), &netlist.config
			);
			ret &= ReadSharedRam(
				GetSharedRamAddress(&g_dsp_manager_net_list[list_no].param), &netlist.param
			);
			ret &= ReadSharedRam(
				GetSharedRamAddress(&g_dsp_manager_net_list[list_no].status), &netlist.status
			);
			ret &= ReadSharedRam(
				GetSharedRamAddress(&g_dsp_manager_net_list[list_no].reserved_0), &netlist.reserved_0
			);
			ret &= ReadSharedRam(
				GetSharedRamAddress(&g_dsp_manager_net_list[list_no].reserved_1), &netlist.reserved_1
			);
			if (ret == false) {
				cout << "SaveNetList is failed!" << endl;
				return false;
			}
			WriteNetlist(fp, netlist);
			ofs.write(
				reinterpret_cast<char*>(&netlist),
				sizeof(dsp_lib::DspManager::NetList)
			);
		}

		fclose(fp);
	}
	return true;
}

} // namespace dsp_ctrl
