#include "picojson_misc.h"
#include <cmath>

using namespace std;

// オブジェクトにある型・名前のメンバが含まれるかを確認する
bool
object_member_check(
	picojson::object obj_,
	string member_name_,
	int member_type_
)
{
	// メンバの存在を確認
	if (obj_.count(member_name_) != 1) {
		cout << "object must have \"" << member_name_ << "\" !" << endl;
		return false;
	}

	// メンバの型を確認
	switch (member_type_) {
	case picojson::null_type:
		if (obj_[member_name_].is<picojson::null>() == false) {
			cout << "type must be null!" << endl;
			return false;
		}
		break;
	case picojson::boolean_type:
		if (obj_[member_name_].is<bool>() == false) {
			cout << "type must be boolean!" << endl;
			return false;
		}
		break;
	case picojson::number_type:
		if (obj_[member_name_].is<double>() == false) {
			cout << "type must be number!" << endl;
			return false;
		}
		break;
	case picojson::string_type:
		if (obj_[member_name_].is<string>() == false) {
			cout << "type must be string!" << endl;
			return false;
		}
		break;
	case picojson::array_type:
		if (obj_[member_name_].is<picojson::array>() == false) {
			cout << "type must be array!" << endl;
			return false;
		}
		break;
	case picojson::object_type:
		if (obj_[member_name_].is<picojson::object>() == false) {
			cout << "type must be object!" << endl;
			return false;
		}
		break;
	default:
		cout << "invalid expected_type!" << endl;
		return false;
	}

	return true;
}

//picojson::value
//get_number_value(float data_)
//{
//	picojson::value number_value;
//	if (isnan(data_) == true) {
//		number_value = static_cast<picojson::value>(string("NaN"));
//	}
//	else if (isinf(data_) == true) {
//		number_value = static_cast<picojson::value>(string("Infinity"));
//	}
//	else {
//		number_value = static_cast<picojson::value>(static_cast<double>(data_));
//	}
//
//	return number_value;
//}

bool
check_number_value(
	picojson::object obj_,
	string member_name_
)
{
	// メンバの存在を確認
	if (obj_.count(member_name_) != 1) {
		//cout << "object must have \"" << member_name_ << "\" !" << endl;
		return false;
	}

	// メンバの型が数値であることをを確認
	if (obj_[member_name_].is<double>() == false) {
		cout << member_name_ + ": invalid type!" << endl;
		return false;
	}
	return true;
}

void
erase_number_value(
	picojson::object	&obj_,
	string				member_name_
)
{
	// メンバが存在していれば削除
	if (obj_.count(member_name_) == 1) {
		obj_.erase("member_name_");
	}
}