#include <stdint.h>

#define		GAIN_INVALID		0xFF	// GAIN: 指示なし
#define		MUTE_INVALID		0		// MUTE: 指示なし
#define		MUTE_ON				1		// MUTE: ON
#define		MUTE_OFF			2		// MUTE: OFF
#define		BLUETOOTH_INVALID	0		// BLUETOOTH: 指示なし
#define		BLUETOOTH_ON		1		// BLUETOOTH: ON
#define		BLUETOOTH_OFF		2		// BLUETOOTH: OFF
#define		STANDBY_INVALID		0		// STANDBY: 指示なし
#define		STANDBY_ON			1		// STANDBY: ON
#define		STANDBY_OFF			2		// STANDBY: OFF
#define		PRESET_INVALID		0		// PRESET: 指示なし
#define		PRESET_1			1		// PRESET: プリセット1
#define		PRESET_2			2		// PRESET: プリセット2
#define		FOCUS_X_INVALID		0.0		// FOCUS_X: 指示なし
#define		FOCUS_Y_INVALID		0.0		// FOCUS_Y: 指示なし
#define		FOCUS_SET_INVALID	0		// FOCUS_SET: 指示なし
#define		FOCUS_SET_AUTO		1		// FOCUS_SET: AUTO
#define		FOCUS_SET_MANUAL	2		// FOCUS_SET: MANUAL
#define		FOCUS_UNIT_INCH		0		// 単位系 inch
#define		FOCUS_UNIT_CM		1		// 単位系 cm

// 機器状態フラグ構造体
typedef struct {
	int32_t	gainUpdated;		// GAIN更新(受信)フラグ
	int32_t	muteMicUpdated;		// MUTE(MIC)更新(受信)フラグ
	int32_t	muteSpkUpdated;		// MUTE(Speaker)更新(受信)フラグ
	int32_t bluetoothUpdated;	// BLUETOOTH更新(受信)フラグ
	int32_t	standbyUpdated;		// STANDBY更新(受信)フラグ
	int32_t	presetUpdated;		// PRESET更新(受信)フラグ
	int32_t	focusSetUpdated;	// FOCUS_SET更新(受信)フラグ
} stCommStatusFlg;

// 機器状態構造体 値変換処理（AM-CF1アプリ→CommCtrlライブラリ）
void ConvertCommStatusApp2Lib(const stCommStatus* src, stCommStatus* dst);

// 機器状態構造体 値変換処理（CommCtrlライブラリ→AM-CF1アプリ）
void ConvertCommStatusLib2App(const stCommStatus* src, const stCommStatusFlg* flgs, stCommStatus* dst);
