#define	RET_OK		0
#define RET_NG		-1

#define TRUE		1
#define FALSE		0

// 機器状態
typedef struct {
	uint8_t		gain; 					// ゲイン制御値
	uint8_t		muteMic;				// ミュート(MIC)状態
	uint8_t		muteSpk;				// ミュート(SPEAKER)状態
	uint8_t 	bluetoothMode;			// Bluetoothモード 0: OFF, 1:ペアリング登録中, 2:Bluetooth接続中

	float		focus_x;				// ビームステアリング X座標(m)

	float		focus_y;				// ビームステアリング Y座標(m)

	uint8_t		focus_mode;				// ビームステアリング 0: 音源推定, 1: 音源固定
	int8_t		focus_direction;		// ビームステアリング 音源固定の角度
	uint8_t		focus_unit;				// ビームステアリング 単位系 0: inch, 1: cm
	uint8_t 	dummy2;					// 4byteアライメントの調整用

	float		focus_distance;			// ビームステアリング 音源固定の距離(m)

	uint8_t		standby;				// スタンバイ状態
	uint8_t		preset;					// プリセット状態
	uint8_t 	dummy3;					// 4byteアライメントの調整用
	uint8_t 	dummy4;					// 4byteアライメントの調整用

	uint8_t		isGainResponse;			// ゲイン制御応答フラグ 0: OFF, 1: ON
	uint8_t		isMuteMicResponse;		// ミュート(MIC)制御応答フラグ 0: OFF, 1: ON
	uint8_t		isMuteSpkResponse;		// ミュート(SPEAKER)制御応答フラグ 0: OFF, 1: ON
	uint8_t		isBluetoothResponse;	// Bluetooth制御応答フラグ 0: OFF, 1: ON

	uint8_t		isFocusSetResponse;		// ビームステアリング制御応答フラグ 0: OFF, 1: ON
	uint8_t		isStandbyResponse;		// スタンバイ制御応答フラグ 0: OFF, 1: ON
	uint8_t		isPresetResponse;		// プリセット制御応答フラグ 0: OFF, 1: ON
	uint8_t		isPresetAutoResponse;	// プリセット制御自動ステイタス通知用の応答フラグ 0: OFF, 1: ON
} stCommStatus;

extern int32_t LibCF1CommCtrl_Init(const uint8_t* loginInfoPath, uint32_t pathSize, uint32_t isLoginEnable);
extern int32_t LibCF1CommCtrl_Deinit(void);
extern int32_t LibCF1CommCtrl_Control(void);
extern int32_t LibCF1CommCtrl_setStatus(stCommStatus *data);
extern int32_t SendCF1GetEvent(char* key, uint8_t* value);
extern int32_t SendCF1GetEventFocus(uint8_t* mode, int8_t* direction, float* distance, uint8_t* unit);

extern uint32_t LibCF1CommCtrl_DefBtInvalid( void );
extern uint32_t LibCF1CommCtrl_DefBtOn( void );
extern uint32_t LibCF1CommCtrl_DefBtOff( void );
extern uint32_t LibCF1CommCtrl_DefBtStatusOff( void );
extern uint32_t LibCF1CommCtrl_DefBtStatusPairing( void );
extern uint32_t LibCF1CommCtrl_DefBtStatusConnected( void );
