/*--------------------------------------------------------------------------*/
/*																			*/
/*	TCPIPReceiver.h (Rev 1.00)												*/
/*																			*/
/*	1.概要																	*/
/*		AM-CF1外部制御プロトコル											*/
/*																			*/
/*	2.改版履歴																*/
/*																			*/
/*																			*/
/*--------------------------------------------------------------------------*/

#define LEN_COMMAND 	1024	// 通信の最大バッファ
#define REG_COMMAND		32		// 最大保持コマンド数
#define TCP_HEADER_SIZE 2		// 通信ヘッダのbyte数
#define SOCKET_NULL 	-1		// 切断時のソケットの状態

// 保持コマンド
typedef struct {
	int32_t		num;
	uint8_t		receivedCommand[REG_COMMAND][LEN_COMMAND];
} stReceiveBuffer;

typedef void (* DISCONNECTED_CALLBACK)(void);		// 通信切断時のコールバック関数の定義

extern int32_t	GetSocket(void);
extern void		GetReceiveCommand(stReceiveBuffer *buf);
extern int32_t	TCPIPReceiver_Init(DISCONNECTED_CALLBACK pfunc);
extern int32_t	TCPIPReceiver_Deinit(void);
extern int32_t	TCPIPReceiverSocketSetup(void);
