# -*- coding:utf-8 -*-
import json
import subprocess
import copy,os, sys
import shutil
import codecs
import fcntl

codecs_open_char = 'utf-8'
codecs_open_ignore = 'ignore'

sys.path.append('/home/toa/TOA_AM-CF1/Webserver/hello/')
import def_block_no as BlockNo
import define_const as dc
from master_data_const import GetDefault_Conf_Bluetooth
from get_json_values import Check_Conf_Bluetooth_Value

sys.path.append('/home/toa/TOA_AM-CF1/Application/data/')
import dev_config

#本ファイル内でprint文を有効化すると、アップデート時の判定が正常に動作しなくなるため、
#デバッグ完了時は必ずprintをコメントアウトしてください。
#if __name__ == '__main__':以下はコメントアウトの必要はありません。

validNetmasks = [
    "128.0.0.0"      ,   # /1
    "192.0.0.0"      ,   # /2
    "224.0.0.0"      ,   # /3
    "240.0.0.0"      ,   # /4
    "248.0.0.0"      ,   # /5
    "252.0.0.0"      ,   # /6
    "254.0.0.0"      ,   # /7
    "255.0.0.0"      ,   # /8
    "255.128.0.0"    ,   # /9
    "255.192.0.0"    ,   # /10
    "255.224.0.0"    ,   # /11
    "255.240.0.0"    ,   # /12
    "255.248.0.0"    ,   # /13
    "255.252.0.0"    ,   # /14
    "255.254.0.0"    ,   # /15
    "255.255.0.0"    ,   # /16
    "255.255.128.0"  ,   # /17
    "255.255.192.0"  ,   # /18
    "255.255.224.0"  ,   # /19
    "255.255.240.0"  ,   # /20
    "255.255.248.0"  ,   # /21
    "255.255.252.0"  ,   # /22
    "255.255.254.0"  ,   # /23
    "255.255.255.0"  ,   # /24
    "255.255.255.128",   # /25
    "255.255.255.192",   # /26
    "255.255.255.224",   # /27
    "255.255.255.240",   # /28
    "255.255.255.248",   # /29
    "255.255.255.252",   # /30
]

def IsPrivateAddress(ip):
    ip1 = int(ip[0])
    ip2 = int(ip[1])
    ip3 = int(ip[2])
    ip4 = int(ip[3])

    # Class A (10.0.0.0 ~ 10.255.255.255)
    if ip1 == 10:
        if 0 <= ip2 and ip2 <= 255:
            if 0 <= ip3 and ip3 <= 255:
                if 0 < ip4 and ip4 < 255:
                    return True

    # Class B (172.16.0.0 ~ 172.31.255.255)
    if ip1 == 172:
        if 16 <= ip2 and ip2 <= 31:
            if 0 <= ip3 and ip3 <= 255:
                if 0 < ip4 and ip4 < 255:
                    return True

    # Class C (192.168.0.0 ~ 192.168.255.255)
    if ip1 == 192:
        if ip2 == 168:
            if 0 <= ip3 and ip3 <= 255:
                if 0 < ip4 and ip4 < 255:
                    return True
    
    return False

def IP_Check(ips,sms,dgs):
    MAX_IPVAL = 255
    MIN_IPVAL = 0

    ip = ips.split('.')
    sm = sms.split('.')
    dg = dgs.split('.')

    if len(ip) != 4 or len(sm) != 4 or len(dg) != 4:
        return -1

    if not IsPrivateAddress(ip):
        return -1

    if not IsPrivateAddress(dg):
        return -1

    #ip1.ip2.ip3.ip4
    ip1 = int(ip[0])
    ip2 = int(ip[1])
    ip3 = int(ip[2])
    ip4 = int(ip[3])

    #sm1.sm2.sm3.sm4
    sm1 = int(sm[0])
    sm2 = int(sm[1])
    sm3 = int(sm[2])
    sm4 = int(sm[3])

    #dg1.dg2.dg3.dg4
    dg1 = int(dg[0])
    dg2 = int(dg[1])
    dg3 = int(dg[2])
    dg4 = int(dg[3])

    #invalid ip == dg
    if ip == dg:
        return -1

    # check network address or broadcast address
    if ip4 == 0 or ip4 == MAX_IPVAL:

        return -1

    # check network address or broadcast address
    if dg4 == 0 or dg4 == MAX_IPVAL:
        return -1

    if sms not in validNetmasks:
        return -1

    # calc packed version of ip, default gateway, subnet mask
    ip_int = (ip1 << 24) + (ip2 << 16) + (ip3 << 8) + ip4
    dg_int = (dg1 << 24) + (dg2 << 16) + (dg3 << 8) + dg4
    sm_int = (sm1 << 24) + (sm2 << 16) + (sm3 << 8) + sm4

    # network for IP and default gateway must be same
    if (ip_int & sm_int) != (dg_int & sm_int):
        return -1

    return 0

def Check_Preset_Gain(fname):
    try:
        #line_length = 33 #行数規定削除
        colm_3_blockno = [
            BlockNo.GAIN_USBinL,BlockNo.GAIN_BTinL,BlockNo.GAIN_CODECin,BlockNo.GAIN_AUXinL,
            BlockNo.GAIN_SPoutL,BlockNo.GAIN_USBoutL,BlockNo.GAIN_BToutL,BlockNo.GAIN_CODECout,BlockNo.GAIN_AUXoutL
            ] #GAIN_Lch (change by web app) プリセットファイルの順序規定
        colm_2_blockno = [
            BlockNo.RAW_GAIN_MIC1,BlockNo.RAW_GAIN_MIC2,BlockNo.RAW_GAIN_MIC3,BlockNo.RAW_GAIN_MIC4,BlockNo.RAW_GAIN_MIC5,BlockNo.RAW_GAIN_MIC6,BlockNo.RAW_GAIN_MIC7,BlockNo.RAW_GAIN_MIC8,
            BlockNo.RAW_GAIN_USBinL,BlockNo.RAW_GAIN_USBinR,BlockNo.RAW_GAIN_CODECin,BlockNo.RAW_GAIN_BTinL,BlockNo.RAW_GAIN_BTinR,BlockNo.RAW_GAIN_AUXinL,BlockNo.RAW_GAIN_AUXinR,
            BlockNo.GAIN_MIC,BlockNo.GAIN_USBinR,BlockNo.GAIN_BTinR,BlockNo.GAIN_AUXinR,BlockNo.GAIN_SPoutR,BlockNo.GAIN_USBoutR,BlockNo.GAIN_AUXoutR
            ] #RAW_GAIN + GAIN_Rch(change by web app) プリセットファイルの順序規定
        BlockNo_Set = colm_3_blockno + colm_2_blockno
        GAIN_MIN = -60
        GAIN_MAX = 0
        MUTE_STS = [0,1]
        gain_index ="#Block_no,webGain,mute_sts"
        index_line_num = [0]

        with codecs.open(fname,'r', codecs_open_char, codecs_open_ignore) as f:
            preset_values = []
            cnt = 0
            for line in f:
                if line[0] == "#":
                    if cnt in index_line_num:
                        preset_values.append(line)
                    cnt = cnt + 1
                    continue
                else:
                    preset_values.append(line)
                    cnt = cnt + 1

        #Check index
        if preset_values[0].strip() != gain_index:
            #print("index error")
            return -1
        #Check format
        for i in range(1,len(preset_values)):
            vals = int(preset_values[i].strip().split(',')[0])
            if vals in colm_3_blockno:
                if len(preset_values[i].strip().split(',')) != 3:
                    #print("invalid format")
                    return -1
                else:
                    #WEBアプリ操作対象ゲイン(Lch)については、-60~0dBまでの整数を規定とする。
                    if (float(preset_values[i].strip().split(',')[1]).is_integer())==False or int(preset_values[i].strip().split(',')[1]) < GAIN_MIN or int(preset_values[i].strip().split(',')[1]) > GAIN_MAX:
                        #print("parameter is out of range")
                        return -1
                    #mute_statusにMUTE_STSで定義した整数が入っているか確認する。
                    if (float(preset_values[i].strip().split(',')[2]).is_integer())==False or (int(preset_values[i].strip().split(',')[2]) in MUTE_STS) == False:
                        #print("parameter is out of range")
                        return -1
                        
            elif vals in colm_2_blockno:
                if len(preset_values[i].strip().split(',')) != 2:
                    #print("invalid format")
                    return -1
                else:
                    #その他ゲインについては、-200~50dBまでの整数を規定とする。
                    if (float(preset_values[i].strip().split(',')[1]).is_integer())==False or int(preset_values[i].strip().split(',')[1]) < -200 or int(preset_values[i].strip().split(',')[1]) > 50:
                        #print("parameter is out of range")
                        return -1
            else:
                #print("block.No is wrong")
                return -1
    except:
        #print("unexpected error gain")
        return -1


def Check_Preset_Iir(fname):
    try:
        #line_length = 77 #行数規定削除
        stage_5_blockno = [
            BlockNo.EQ_USBinL,BlockNo.EQ_USBinR,BlockNo.EQ_CODECin,BlockNo.EQ_BTinL,BlockNo.EQ_BTinR,
            BlockNo.EQ_USBoutR,BlockNo.EQ_AUXoutR,BlockNo.EQ_AUXoutL,BlockNo.EQ_USBoutL
            ] #順不同
        stage_10_blockno = [
            BlockNo.EQ_MIC,BlockNo.EQ_SPoutR,BlockNo.EQ_SPoutL
            ] #順不同
        stage_1_blockno = [
            BlockNo.EQ_AUXinL,BlockNo.EQ_AUXinR,
            BlockNo.EQ_BToutL
            ] #順不同
        stage_3_blockno = [BlockNo.EQ_CODECout] #順不同

        BlockNo_Set = stage_5_blockno + stage_10_blockno + stage_1_blockno + stage_3_blockno

        TYPE_RANGE = ["peq","hpf12","lpf12","high_shelving","low_shelving"] #条件追加(high_shelving,low_shelving)
        #FREQ_TABLE = [20.0,21.2,22.4,23.6,25.0,26.5,28.0,30.0,31.5,33.5,35.5,37.5,40.0,42.5,45.0,47.5,50.0,53.0,56.0,60.0,63.0,67.0,71.0,75.0,80.0,85.0,90.0,95.0,100.0,106.0,112.0,118.0,125.0,132.0,140.0,150.0,160.0,170.0,180.0,190.0,200.0,212.0,224.0,236.0,250.0,265.0,280.0,300.0,315.0,335.0,375.0,400.0,425.0,450.0,475.0,500.0,530.0,560.0,600.0,630.0,670.0,710.0,750.0,800.0,850.0,900.0,950.0,1000.0,1060.0,1120.0,1180.0,1250.0,1320.0,1400.0,1500.0,1600.0,1700.0,1800.0,1900.0,2000.0,2120.0,2240.0,2360.0,2500.0,2650.0,2800.0,3000.0,3150.0,3350.0,3550.0,3750.0,4000.0,4250.0,4500.0,4750.0,5000.0,5300.0,5600.0,6000.0,6300.0,6700.0,7100.0,7500.0,8000.0,8500.0,9000.0,9500.0,10000.0,10600.0,11200.0,11800.0,12500.0,13200.0,14000.0,15000.0,16000.0,17000.0,18000.0,19000.0,20000.0]
        FREQ_RANGE_MIN = 20
        FREQ_RANGE_MAX = 20000
        Q_TABLE = [0.267,0.276,0.285,0.295,0.305,0.315,0.326,0.338,0.35,0.362,0.376,0.389,0.404,0.419,0.436,0.453,0.471,0.49,0.511,0.532,0.556,0.581,0.607,0.636,0.667,0.683,0.7,0.718,0.736,0.756,0.776,0.797,0.819,0.843,0.867,0.893,0.92,0.948,0.979,1.011,1.044,1.08,1.119,1.16,1.204,1.25,1.301,1.355,1.414,1.445,1.478,1.512,1.548,1.585,1.624,1.665,1.707,1.752,1.8,1.85,1.902,1.958,2.016,2.079,2.145,2.215,2.29,2.371,2.456,2.549,2.648,2.755,2.871,2.997,3.134,3.285,3.45,3.633,3.836,4.063,4.318,4.608,4.938,5.319,5.764,6.289,6.919,7.689,8.651,9.889,11.538,13.847,17.31,23.081,34.623,69.249]
        GAIN_RANGE_MIN = -15.0
        GAIN_RANGE_MAX = 15.0
        iir_index = "#Block_no, stage, type, freq, q, gain"
        index_line_num = [0]
        
        #Check param length
        lists_blockno = []
        lists_stageno = []
        lists_type = []
        lists_freq = []
        lists_q = []
        lists_gain = []

        with codecs.open(fname,'r', codecs_open_char, codecs_open_ignore) as f:
            preset_values = []
            cnt = 0
            for line in f:
                if line[0] == "#":
                    if cnt in index_line_num:
                        preset_values.append(line)
                    cnt = cnt + 1
                    continue
                else:
                    preset_values.append(line)
                    cnt = cnt + 1
                    
        for i in range(1,len(preset_values)):
            if (float(preset_values[i].strip().split(',')[0]).is_integer())==False:
                #print("invalid format")
                return -1
            if (float(preset_values[i].strip().split(',')[1]).is_integer())==False:
                #print("invalid format")
                return -1
            lists_blockno.append(int(preset_values[i].strip().split(',')[0]))
            lists_stageno.append(int(preset_values[i].strip().split(',')[1]))
            lists_type.append(preset_values[i].strip().split(',')[2])
            lists_freq.append(float(preset_values[i].strip().split(',')[3]))
            lists_q.append(float(preset_values[i].strip().split(',')[4]))
            lists_gain.append(float(preset_values[i].strip().split(',')[5]))

            #Check all colmn number
            if len(preset_values[i].strip().split(',')) != 6:
                #print("format error iir")
                return -1

        index_data = preset_values[0].strip()
        #Check index
        if index_data != iir_index:
            #print("index error")
            return -1
        #Check stage number
        for i in range(0,len(stage_5_blockno)):
            if lists_blockno.count(stage_5_blockno[i]) != 5:
                #print("invalid format 5")
                return -1
        for i in range(0,len(stage_10_blockno)):
            if lists_blockno.count(stage_10_blockno[i]) != 10:
                #print("invalid format 10")
                return -1
        for i in range(0,len(stage_1_blockno)):
            if lists_blockno.count(stage_1_blockno[i]) != 1:
                #print("invalid format 1")
                return -1
        for i in range(0,len(stage_3_blockno)):
            if lists_blockno.count(stage_3_blockno[i]) != 3:
                #print("invalid format 3")
                return -1

        for i in range(0,len(preset_values)-1):
            if (lists_type[i] in TYPE_RANGE ) == False:
                #print("out of range type")
                return -1
            if (lists_freq[i] >= FREQ_RANGE_MIN or lists_freq[i] <= FREQ_RANGE_MAX ) == False:
                #print("out of range freq")
                return -1
            if (lists_q[i] in Q_TABLE ) == False:
                #print("out of range q")
                return -1
            #ゲインは範囲外許容
            #if (lists_gain[i] >= GAIN_RANGE_MIN or lists_gain[i] <= GAIN_RANGE_MAX )==False:
                #print("out of range gain")
                #return -1
            if ((lists_gain[i]*10)%5 != 0):
                #print("out of range gain")
                return -1
    except:
        #print("unexpected error iir")
        return -1

def Check_Preset_Aecnc(fname):
    try:
        #line_length = 8 #行数規定削除
        aec_blockno = BlockNo.AEC
        nc_blockno = BlockNo.NC
        mic_blockno = BlockNo.BF
        AEC_COLM = 27
        NC_COLM = 3
        MIC_COLM = 10
        CONF_COLM = 2

        # AEC #
        AEC_ON = ["true","false"]

        ##TODO:max minの制限(変更すべきパラメータ、決定してから)
        ## Qモデルはすべてのパラメータを読み込むため、AECパラメータは全チェックが必要
        AEC_PARAM_LIMIT = {
            "param_set_flag":{
                "min":0,
                "max":1
            },
            "mu_":{
                "min":0,
                "max":1
            },
            "errmu_limit":{
                "min":0,
                "max":1
            },
            "rcv_dly_":{
                "min":0,
                "max":512
            },
            "nlp_ratio0":{
                "min":0,
                "max":1
            },
            #NLP Level WEBで調整するため規格値を指定
            "nlp_ratio1":{
                "min":0,
                "max":1
            },
            "nlp_enhance0":{
                "min":0,
                "max":99
            },
            "nlp_enhance1":{
                "min":0,
                "max":99
            },
            "nlp_alpha0":{
                "min":0,
                "max":1
            },
            "nlp_alpha1":{
                "min":0,
                "max":1
            },
            "nlp_alpha2":{
                "min":0,
                "max":1
            },
            "nlp_step":{
                "min":1,
                "max":128
            },
            "drc_compTh":{
                "min":0,
                "max":100
            },
            "drc_compRatio":{
                "min":0,
                "max":6
            },
            "drc_compGain":{
                "min":-20,
                "max":20
            },
            "drc_boostTh":{
                "min":0,
                "max":100
            },
            "drc_boostRatio":{
                "min":-6,
                "max":6
            },
            "drc_boostGain":{
                "min":-20,
                "max":20
            },
            "drc_AT":{
                "min":0,
                "max":200
            },
            "drc_RT":{
                "min":50,
                "max":10000
            },
            "cng_noise":{
                "min":0,
                "max":1
            },
            "bmInput_fixedGain":{
                "min":-100.0,
                "max":100.0
            },
            "nlp_fixedGain":{
                "min":-100.0,
                "max":100.0
            },
            "drc_fixedGain":{
                "min":-100.0,
                "max":100.0
            }
        }

        AEC_MIC_MUTE = ["true","false"]
        
        # NC #
        NC_BYPASS = ["true","false"]
        NC_REDL = [-12,-15,-18,-21]

        # MICROPHONE ARRAY #
        MIC_DIR = [-90,-80,-70,-60,-50,-40,-30,-20,-10,0,10,20,30,40,50,60,70,80,90]
        MIC_DIS = [0.2,0.3,0.4,0.5,0.6,0.7,0.8,0.9,1.0,1.1,1.2,1.3,1.4,1.5,1.6,1.7,1.8,1.9,2.0,
                    2.1,2.2,2.3,2.4,2.5,2.6,2.7,2.8,2.9,3.0,3.1,3.2,3.3,3.4,3.5,3.6,3.7,3.8,3.9,4.0,
                    4.1,4.2,4.3,4.4,4.5,4.6,4.7,4.8,4.9,5.0,5.1,5.2,5.3,5.4,5.5,5.6,5.7,5.8,5.9,6.0]
        MIC_UPDATE_MODE = ["auto","manual"]
        MIC_PEAK_THRE = [-13,-15,-20]
        MIC_SM_TC = [0.2]
        MIC_XMIN = [0.2,0.3,0.4,0.5,0.6,0.7,0.8,0.9,1.0,1.1,1.2,1.3,1.4,1.5,1.6,1.7,1.8,1.9,2.0,
                    2.1,2.2,2.3,2.4,2.5,2.6,2.7,2.8,2.9,3.0,3.1,3.2,3.3,3.4,3.5,3.6,3.7,3.8,3.9,4.0,
                    4.1,4.2,4.3,4.4,4.5,4.6,4.7,4.8,4.9,5.0,5.1,5.2,5.3,5.4,5.5,5.6,5.7,5.8,5.9]
        MIC_XMAX = [0.3,0.4,0.5,0.6,0.7,0.8,0.9,1.0,1.1,1.2,1.3,1.4,1.5,1.6,1.7,1.8,1.9,2.0,
                    2.1,2.2,2.3,2.4,2.5,2.6,2.7,2.8,2.9,3.0,3.1,3.2,3.3,3.4,3.5,3.6,3.7,3.8,3.9,4.0,
                    4.1,4.2,4.3,4.4,4.5,4.6,4.7,4.8,4.9,5.0,5.1,5.2,5.3,5.4,5.5,5.6,5.7,5.8,5.9,6.0]
        MIC_YMIN = [0.0,-0.1,-0.2,-0.3,-0.4,-0.5,-0.6,-0.7,-0.8,-0.9,-1.0,-1.1,-1.2,-1.3,-1.4,-1.5,-1.6,-1.7,-1.8,-1.9,-2.0,
                    -2.1,-2.2,-2.3,-2.4,-2.5,-2.6,-2.7,-2.8,-2.9,-3.0]
        MIC_YMAX = [0.0,0.1,0.2,0.3,0.4,0.5,0.6,0.7,0.8,0.9,1.0,1.1,1.2,1.3,1.4,1.5,1.6,1.7,1.8,1.9,2.0,
                    2.1,2.2,2.3,2.4,2.5,2.6,2.7,2.8,2.9,3.0]
        
        CONF_INCM = ["inch","cm"]
        CONF_SENS = ["LOW","MID","HIGH"]

        aec_index = "#(AEC)Block_no,on,mu_,errmu_limit,rcv_dly_,nlp_ratio0,nlp_ratio1,nlp_enhance0,nlp_enhance1,nlp_alpha0,nlp_alpha1,nlp_alpha2,nlp_step,drc_compTh,drc_compRatio,drc_compGain,drc_boostTh,drc_boostRatio,drc_boostGain,drc_AT,drc_RT,mic_mute,cng_noise,bmInput_fixedGain,nlp_fixedGain,drc_fixedGain,param_set_flag"
        nc_index = "#(NC)Block_no,bypass,reduction_level"
        mic_index = "#(microphonearray)Block_no,dir,dis,update_mode,peak_threshold,smooth_tc,source_pos_x_min,source_pos_x_max,source_pos_y_min,source_pos_y_max"
        conf_index = "#conf(inch/cm),sensing,nlplevel,aec_onoff"
        index_line_num = [0,2,4,6]

        MU_PRMS_NUM = 8

        BlockNo_Set = [aec_blockno, nc_blockno, mic_blockno]

        #Check param length
        # "#"が先頭文字であるindex行を飛ばして、パラメータ値のみ変数preset_valuesに格納する
        with codecs.open(fname,'r', codecs_open_char, codecs_open_ignore) as f:
            preset_values = []
            cnt = 0
            for line in f:
                if line[0] == "#":
                    if cnt in index_line_num:
                        preset_values.append(line)
                    cnt = cnt + 1
                    continue
                else:
                    preset_values.append(line)
                    cnt = cnt + 1
        
        aec_lists = preset_values[1].strip().split(',')
        nc_lists = preset_values[3].strip().split(',')
        mic_lists = preset_values[5].strip().split(',')
        conf_lists = preset_values[7].strip().split(',')

        ## mu_パラメータを抽出し、'[]'削除し、/'で区切り、floatに変換
        _mu_prms = aec_lists[2].lstrip('[').rstrip(']').split('/')
        mu_prms = [float(i) for i in _mu_prms]

        #mu_パラメータが8個でない場合はエラー
        if len(mu_prms) != MU_PRMS_NUM:
            #print("Too many parameters in mu_")
            return -1

        
        if preset_values[0].strip() != aec_index:
            #print(preset_values[0].strip().split(','))
            #print("index error aec")
            return -1
        if preset_values[2].strip() != nc_index:
            #print("index error nc")
            return -1
        if preset_values[4].strip() != mic_index:
            #print("index error mic")
            return -1
        if preset_values[6].strip() != conf_index:
            #print("index error conf")
            return -1
        
        #Check AEC
        if len(aec_lists) != AEC_COLM:
            #print("invalid format aec")
            return -1
        if int(aec_lists[0]) != aec_blockno or (float(aec_lists[0]).is_integer())==False:
            #print("wrong blockNo error aec")
            return -1
        if (aec_lists[1] in AEC_ON) == False:
            #print("invalid format aec 1")
            return -1
        ## mu_のcheck aec_lists[2]
        if Check_max_min(mu_prms,AEC_PARAM_LIMIT["mu_"]) == -1:
            #print("invalid format aec 2")
            return -1
        if Check_max_min(float(aec_lists[3]), AEC_PARAM_LIMIT["errmu_limit"]) == -1:
            #print("invalid format aec 3")
            return -1
        if Check_max_min(int(aec_lists[4]), AEC_PARAM_LIMIT["rcv_dly_"]) == -1:
            #print("invalid format aec 4")
            return -1
        if Check_max_min(float(aec_lists[5]), AEC_PARAM_LIMIT["nlp_ratio0"]) == -1:
            #print("invalid format aec 5")
            return -1
        if Check_max_min(float(aec_lists[6]), AEC_PARAM_LIMIT["nlp_ratio1"]) == -1:
            #print("invalid format aec 6")
            return -1
        if Check_max_min(float(aec_lists[7]), AEC_PARAM_LIMIT["nlp_enhance0"]) == -1:
            #print("invalid format aec 7")
            return -1
        if Check_max_min(float(aec_lists[8]), AEC_PARAM_LIMIT["nlp_enhance1"]) == -1:
            #print("invalid format aec 8")
            return -1
        if Check_max_min(float(aec_lists[9]), AEC_PARAM_LIMIT["nlp_alpha0"]) == -1:
            #print("invalid format aec 9")
            return -1
        if Check_max_min(float(aec_lists[10]), AEC_PARAM_LIMIT["nlp_alpha1"]) == -1:
            #print("invalid format aec 10")
            return -1
        if Check_max_min(float(aec_lists[11]), AEC_PARAM_LIMIT["nlp_alpha2"]) == -1:
            #print("invalid format aec 11")
            return -1
        if Check_max_min(int(aec_lists[12]), AEC_PARAM_LIMIT["nlp_step"]) == -1:
            #print("invalid format aec 12")
            return -1
        if Check_max_min(int(aec_lists[13]), AEC_PARAM_LIMIT["drc_compTh"]) == -1:
            #print("invalid format aec 13")
            return -1
        if Check_max_min(int(aec_lists[14]), AEC_PARAM_LIMIT["drc_compRatio"]) == -1:
            #print("invalid format aec 14")
            return -1
        if Check_max_min(int(aec_lists[15]), AEC_PARAM_LIMIT["drc_compGain"]) == -1:
            #print("invalid format aec 15")
            return -1
        if Check_max_min(int(aec_lists[16]), AEC_PARAM_LIMIT["drc_boostTh"]) == -1:
            #print("invalid format aec 16")
            return -1
        if Check_max_min(int(aec_lists[17]), AEC_PARAM_LIMIT["drc_boostRatio"]) == -1:
            #print("invalid format aec 17")
            return -1
        if Check_max_min(int(aec_lists[18]), AEC_PARAM_LIMIT["drc_boostGain"]) == -1:
            #print("invalid format aec 18")
            return -1
        if Check_max_min(int(aec_lists[19]), AEC_PARAM_LIMIT["drc_AT"]) == -1:
            #print("invalid format aec 19")
            return -1
        if Check_max_min(int(aec_lists[20]), AEC_PARAM_LIMIT["drc_RT"]) == -1:
            #print("invalid format aec 20")
            return -1
        if (aec_lists[21] in AEC_MIC_MUTE)==False:
            #print("invalid format aec 21")
            return -1
        if Check_max_min(float(aec_lists[22]), AEC_PARAM_LIMIT["cng_noise"]) == -1:
            #print("invalid format aec 22")
            return -1
        if Check_max_min(float(aec_lists[23]), AEC_PARAM_LIMIT["bmInput_fixedGain"]) == -1:
            #print("invalid format aec 23")
            return -1
        if Check_max_min(float(aec_lists[24]), AEC_PARAM_LIMIT["nlp_fixedGain"]) == -1:
            #print("invalid format aec 24")
            return -1
        if Check_max_min(float(aec_lists[25]), AEC_PARAM_LIMIT["drc_fixedGain"]) == -1:
            #print("invalid format aec 25")
            return -1
        if Check_max_min(int(aec_lists[26]), AEC_PARAM_LIMIT["param_set_flag"]) == -1:
            #print("invalid format aec 26")
            return -1

        #Check NC
        if len(nc_lists) != NC_COLM:
            #print("invalid format nc")
            return -1
        if int(nc_lists[0]) != nc_blockno:
            #print("wrong blockNo error nc")
            return -1
        if (nc_lists[1] in NC_BYPASS)==False:
            #print("invalid format nc")
            return -1
        if (int(nc_lists[2]) in NC_REDL)==False:
            #print("invalid format nc")
            return -1
        
        #Check MIC
        if len(mic_lists) != MIC_COLM:
            #print("invalid format mic")
            return -1
        if int(mic_lists[0]) != mic_blockno or (float(mic_lists[0]).is_integer())==False:
            #print("wrong blockNo error mic")
            return -1
        if (int(mic_lists[1]) in MIC_DIR)==False:
            #print("invalid format mic_dir")
            return -1
        if (float(mic_lists[2]) in MIC_DIS)==False:
            #print("invalid format mic_dis")
            return -1
        if (mic_lists[3] in MIC_UPDATE_MODE)==False:
            #print("invalid format mic_up")
            return -1
        if (float(mic_lists[4]) in MIC_PEAK_THRE)==False:
            #print("invalid format mic_pe")
            return -1
        if (float(mic_lists[5]) in MIC_SM_TC)==False:
            #print("invalid format mic_sm")
            return -1
        if (float(mic_lists[6]) in MIC_XMIN)==False:
            #print("invalid format mic_xmin")
            return -1
        if (float(mic_lists[7]) in MIC_XMAX)==False:
            #print("invalid format mic_xmax")
            return -1
        if (float(mic_lists[8]) in MIC_YMIN)==False:
            #print("invalid format mic_ymin")
            return -1
        if (float(mic_lists[9]) in MIC_YMAX)==False:
            #print("invalid format mic_ymax")
            return -1
    except:
        #print("unexpected error aec_nc")
        return -1

def Check_Preset_Data(pre_no,PresetPATH):
    # 0:check_ok -1:check_nok

    dpn_fname = PresetPATH + "preset_defNo.txt"
    if os.path.exists(dpn_fname) == False:
        #print("defNo.txt, NotFound")
        return -1
    else:
        with codecs.open(dpn_fname,'r', codecs_open_char, codecs_open_ignore) as f:
            dpn = f.read()
        if (dpn in ['1','2'])==False:
            #print("invalid format defNo")
            return -1

    gain_fname = PresetPATH + 'preset' + str(pre_no) + '_gain.txt'
    if os.path.exists(gain_fname) == False:
        #print("preset_gain.txt, NotFound")
        return -1
    else:
        if Check_Preset_Gain(gain_fname) == -1:
            #print("preset_gain.txt, invalid")
            return -1

    iir_fname = PresetPATH + 'preset' + str(pre_no) + '_iir.txt'
    if os.path.exists(iir_fname) == False:
        #print("preset_iir.txt, NotFound")
        return -1
    else:
        if Check_Preset_Iir(iir_fname) == -1:
            #print("preset_iir.txt, invalid")
            return -1

    aecnc_fname = PresetPATH + 'preset' + str(pre_no) + '_aec_nc.txt'
    if os.path.exists(aecnc_fname) == False:
        #print("preset_aec_nc.txt, NotFound")
        return -1
    else:
        if Check_Preset_Aecnc(aecnc_fname) == -1:
            #print("preset_aec_nc.txt, invalid")
            return -1
    return 0

########################################################################
########################################################################
########################################################################

def Check_Conf_Net(fname):
    try:
        line_length = 3
        #NETWORK
        NET_MIN = 0
        NET_MAX = 255

        with codecs.open(fname,'r', codecs_open_char, codecs_open_ignore) as f:
            num_lines = sum(1 for line in f)
            #Check file length
            if num_lines != line_length:
                #print("Wrong file length")
                return -1
        
        #Check file format
        with codecs.open(fname,'r', codecs_open_char, codecs_open_ignore) as f:
            config_values = f.readlines()

        ip_lists = config_values[0].strip().split(' ')

        for i in range(0,3):
            if len(ip_lists[i].split('.')) != 4:
                #print("invalid format ip")
                return -1
        
        ip = ip_lists[0].split('.')
        sm = ip_lists[1].split('.')
        dg = ip_lists[2].split('.')

        for i in range(0,4):
            if int(ip[i]) > NET_MAX or int(ip[i]) < NET_MIN or (float(ip[i]).is_integer()) == False:
                #print("invalid format ip")
                return -1
            if int(sm[i]) > NET_MAX or int(sm[i]) < NET_MIN or (float(sm[i]).is_integer()) == False:
                #print("invalid format sm")
                return -1
            if int(dg[i]) > NET_MAX or int(dg[i]) < NET_MIN or (float(dg[i]).is_integer()) == False:
                #print("invalid format dg")
                return -1
        cmd = ["sh","/home/toa/StartupShell/calc_subnet_bit.sh",ip_lists[1]]
        sm_res = subprocess.call(cmd,stdout=subprocess.PIPE,stderr=subprocess.PIPE)
        if (sm_res) == -10000000:
            #print("invalid subnet mask")
            return -1

        if IP_Check(ip_lists[0],ip_lists[1],ip_lists[2]) == -1:
            #print("invalid ip address")
            return -1

    except:
     #   #print("unexpected error net")
        return -1


def Check_Conf_Userpass(fname):
    try:
        line_length = 2

        USER_index = "USER"
        PASS_index = "PASS"

        #USERPASS
        UP_LENGTH_MIN = 4
        UP_LENGTH_MAX = 16
        # ***.isalnum() <- Kono Kansu- ha Hankaku Eisu-ji wo judge dekimasu.
        # javascript ha "_" wo Hankaku Eisu-ji to minashi masu. python ha "_" ha False desu.

        with codecs.open(fname,'r', codecs_open_char, codecs_open_ignore) as f:
            num_lines = sum(1 for line in f)
            #Check file length
            if num_lines != line_length:
                #print("Wrong file length")
                return -1
        
        #Check file format
        with codecs.open(fname,'r', codecs_open_char, codecs_open_ignore) as f:
            config_values = f.readlines()
        
        username = config_values[0].strip().split(',')
        password = config_values[1].strip().split(',')

        #Check param
        if username[0] != USER_index:
            #print("invalid format un")
            return -1
        if len(username[1]) > UP_LENGTH_MAX or len(username[1]) < UP_LENGTH_MIN:
            #print("invalid format un")
            return -1

        if password[0] != PASS_index:
            #print("invalid format ps")
            return -1
        if len(password[1]) > UP_LENGTH_MAX or len(password[1]) < UP_LENGTH_MIN:
            #print("invalid format ps")
            return -1
    except:
        #print("unexpected error userpass")
        return -1
    
def Check_Conf_Contled(fname):
    try:
        #line_length = 7 #行数規定削除 
        COLM_SIZE = 2

        #CONTROL
        CONT_index = ["CON_IN1","CON_IN2","CON_OU1","CON_OU2"]
        LED_index = ["TRACK","LEVEL","MUTE"]
        KEYLOCK_index = ["KEY_LOCK_ALL"]
        MIC_MUTE_index = ["MIC_MUTE"]
        SPOUT_ASSIGN_index = ["SPOUT_ASSIGN_CODEC","SPOUT_ASSIGN_AUX"]

        CONT_IN = ["None", "Mute(One-shot)", "Mute(Edge)", "Volume_Up", "Volume_Down", "Preset1", "Preset2"]
        CONT_OUT = ["None", "Mute_Status", "Synch_Input1", "Synch_Input2"]
        LED_setting = [dc.ON,dc.OFF]
        LED_mute_setting = ["Only_Center","ALL_LED"]
        key_lock_all_setting = [dc.ON,dc.OFF]
        mic_mute_func_setting = [dc.ON,dc.OFF] #選択範囲
        spout_assign_setting = [dc.ON,dc.OFF] #選択範囲
        
        #Check file format
        with codecs.open(fname,'r', codecs_open_char, codecs_open_ignore) as f:
            config_values = f.readlines()
        
        cont_in1 = config_values[0].strip().split(',')
        cont_in2 = config_values[1].strip().split(',')
        cont_out1 = config_values[2].strip().split(',')
        cont_out2 = config_values[3].strip().split(',')
        led_tra = config_values[4].strip().split(',')
        led_lev = config_values[5].strip().split(',')
        led_mute = config_values[6].strip().split(',')
        key_lock_all = config_values[7].strip().split(',')
        mic_mute_func = config_values[8].strip().split(',')
        spout_assign_codec = config_values[9].strip().split(',')
        spout_assign_aux = config_values[10].strip().split(',')

        if len(cont_in1) != COLM_SIZE:
            #print("invalid format cont_in1")
            return -1
        if cont_in1[0] != CONT_index[0] or (cont_in1[1] in CONT_IN)==False:
            #print("invalid format cont_in1")
            return -1
        
        if len(cont_in2) != COLM_SIZE:
            #print("invalid format cont_in2")
            return -1
        if cont_in2[0] != CONT_index[1] or (cont_in2[1] in CONT_IN)==False:
            #print("invalid format cont_in2")
            return -1
        
        if len(cont_out1) != COLM_SIZE:
            #print("invalid format cont_out1")
            return -1
        if cont_out1[0] != CONT_index[2] or (cont_out1[1] in CONT_OUT)==False:
            #print("invalid format cont_out1")
            return -1

        if len(cont_out2) != COLM_SIZE:
            #print("invalid format cont_out2")
            return -1
        if cont_out2[0] != CONT_index[3] or (cont_out2[1] in CONT_OUT)==False:
            #print("invalid format cont_out2")
            return -1
        
        if len(led_tra) != COLM_SIZE:
            #print("invalid format led_tra")
            return -1
        if led_tra[0] != LED_index[0] or (led_tra[1] in LED_setting)==False:
            #print("invalid format led_tra")
            return -1
        
        if len(led_lev) != COLM_SIZE:
            #print("invalid format led_lev")
            return -1
        if led_lev[0] != LED_index[1] or (led_lev[1] in LED_setting)==False:
            #print("invalid format led_lev")
            return -1

        if len(led_mute) != COLM_SIZE:
            #print("invalid format led_mute")
            return -1
        if led_mute[0] != LED_index[2] or (led_mute[1] in LED_mute_setting)==False:
            #print("invalid format led_mute")
            return -1
        
        if len(key_lock_all) != COLM_SIZE:
            #print("invalid format led_mute")
            return -1
        if key_lock_all[0] != KEYLOCK_index[0] or (key_lock_all[1] in key_lock_all_setting)==False:
            #print("invalid format led_mute")
            return -1

        if len(mic_mute_func) != COLM_SIZE:
            #print("invalid format mic_mute")
            return -1
        if mic_mute_func[0] != MIC_MUTE_index[0] or (mic_mute_func[1] in mic_mute_func_setting)==False:
            #print("invalid format mic_mute")
            return -1

        if len(spout_assign_codec) != COLM_SIZE:
            #print("invalid format spout_assign_codec")
            return -1
        if spout_assign_codec[0] != SPOUT_ASSIGN_index[0] or (spout_assign_codec[1] in spout_assign_setting)==False:
            #print("invalid format spout_assign_codec")
            return -1

        if len(spout_assign_aux) != COLM_SIZE:
            #print("invalid format spout_assign_aux")
            return -1
        if spout_assign_aux[0] != SPOUT_ASSIGN_index[1] or (spout_assign_aux[1] in spout_assign_setting)==False:
            #print("invalid format spout_assign_aux")
            return -1

    except:
        #print("unexpected error contled")
        return -1

# 概要   ："config_bt.json"の破損チェックを行う
# 引数   ：fname  : in  : "config_bt.json"のパス
#          Repair : in  : True=破損値の場合は修正する、False=破損値の場合はチェック処理を終了する
#          NgList : out : 破損していたラベル名リスト
# 戻り値 ：0=正常、-1=破損有り、-2=修復不可エラー
#          ※Repair=True時で破損を修正した場合でも-1を返す
def Check_Conf_Bluetooth(fname, Repair=False, NgList=None):
    try:
        inits = GetDefault_Conf_Bluetooth()  # デフォルト値取得

        values = inits
        with open(fname, 'a+' if Repair else 'r') as f:
            try:
                fcntl.flock(f, fcntl.LOCK_EX)
                f.seek(os.SEEK_SET)
                values = json.load(f)
                if isinstance(values, list) is False:
                    # 取得したデータがlist型で無い場合はエラー
                    values = inits
                    ret = -1
                else:
                    # 取得値の破損チェック。Repair=True時、破損値はinitsの該当値に置換される
                    ret = Check_Conf_Bluetooth_Value(values, inits, Repair, NgList)
            except:
                ret = -1
                if dev_config.debug_trace:
                    print("conf_bluetooth json error. [" + fname)
                    #import traceback
                    #traceback.print_exc()
            finally:
                if Repair and (ret != 0):
                    # 破損データが有ったため修正値でファイルを上書する
                    f.truncate(0)
                    f.seek(os.SEEK_SET)
                    json.dump(values, f, indent=True, sort_keys=True)
        return ret
    except:
        if dev_config.debug_trace:
            print("unexpected error bluetooth")
            #import traceback
            #traceback.print_exc()
        return -2

def Check_Config_Data(ConfPATH):
    # 0:check_ok -1:check_nok

    conf_net_fname = ConfPATH + "config_net.txt"
    conf_userpass_fname = ConfPATH + "config_userpass.txt"
    conf_contled_fname = ConfPATH + "config_contled.txt"
    conf_bt_fname = ConfPATH + "config_bt.json"

    if os.path.exists(conf_net_fname) == False:
        #print("conf_net.txt, NotFound")
        return -1
    else:
        if Check_Conf_Net(conf_net_fname) == -1:
            #print("conf_net.txt, invalid")
            return -1
    
    if os.path.exists(conf_userpass_fname) == False:
        #print("conf_userpass.txt, NotFound")
        return -1
    else:
        if Check_Conf_Userpass(conf_userpass_fname) == -1:
            #print("conf_userpass.txt, invalid")
            return -1

    if os.path.exists(conf_contled_fname) == False:
        #print("conf_contled.txt, NotFound")
        return -1
    else:
        if Check_Conf_Contled(conf_contled_fname) == -1:
            #print("conf_contled.txt, invalid")
            return -1

    if os.path.exists(conf_bt_fname) == False:
        #print("conf_contled.txt, NotFound")
        return -1
    else:
        if Check_Conf_Bluetooth(conf_bt_fname) == -1:
            #print("config_bt.json, invalid")
            return -1

    return 0

def Check_max_min(val,limit):
    #val:数値(リストの場合はすべて読む)。文字列は入力しないこと
    #limit:max,minのキーと値を持った配列
    #0:正常、-1:異常
    if isinstance(val,list):
        #リストが読み込まれた場合は、要素1つずつ取り出して判断
        val_num = len(val)

        for i in range(val_num):
            if (val[i] > limit["max"]) or (val[i] < limit["min"]):
                return -1

    else:
        #リストでなく数値が読み込まれた場合は、数値をそのまま判断
        if (val > limit["max"]) or (val < limit["min"]):
            return -1
    
    return 0

#DEBUG only
#print(Check_Preset_Data(1,'/home/toa/TOA_AM-CF1/Application/data/preset/'))
#print(Check_Config_Data('/home/toa/TOA_AM-CF1/Application/data/config/'))

if __name__ == '__main__':
    #Test of parameter check
    print("Test of parameter chk")
    test_val_1 = [-10.00001,
                -10.00000,
                -9.99999,
                10.00001,
                10.00000,
                9.99999]
    test_limit_1 = {
        "test_param":{
            "max":10.00000,
            "min":-10.00000
        }
    }

    test_val_2 = [-0.00001,
                0.00000,
                0.00001,
                100.00001,
                100.00000,
                99.99999
                ]
    test_limit_2 = {
        "test_param":{
            "max":100.00000,
            "min":0.00000
        }
    }

    for i in range(len(test_val_1)):
        if Check_max_min(test_val_1[i],test_limit_1["test_param"]):
            print("OK")
        else:
            print("NG")
    
    for i in range(len(test_val_2)):
        if Check_max_min(test_val_2[i],test_limit_2["test_param"]):
            print("OK")
        else:
            print("NG")
    
    NetworkTestPatterns = [
        [0, '10.0.0.1', '255.0.0.0', '10.0.0.10'],
        [0, '10.128.128.128', '255.0.0.0', '10.128.128.10'],
        [0, '10.255.255.254', '255.0.0.0', '10.255.255.10'],
        [0, '10.255.255.254', '255.255.255.0', '10.255.255.253'],
        [0, '10.255.255.253', '255.255.255.0', '10.255.255.254'],
        [0, '10.0.0.1', '255.0.0.0', '10.0.0.2'],
        [0, '10.0.0.2', '255.0.0.0', '10.0.0.1'],
        [-1,'10.0.0.0', '255.0.0.0', '10.0.0.1'],
        [-1,'10.0.0.1', '255.223.0.0', '10.0.0.2'],
        [0, '172.16.0.1', '255.240.0.0', '172.16.0.10'],
        [0, '172.23.128.128', '255.240.0.0', '172.23.128.10'],
        [0, '172.31.255.254', '255.240.0.0', '172.31.255.10'],
        [0, '172.31.255.254', '255.255.255.0', '172.31.255.253'],
        [0, '172.31.255.253', '255.255.255.0', '172.31.255.254'],
        [0, '172.16.0.1', '255.0.0.0', '172.16.0.2'],
        [0, '172.16.0.2', '255.0.0.0', '172.16.0.1'],
        [-1,'172.16.0.0', '255.0.0.0', '172.16.0.1'],
        [-1,'172.16.0.1', '255.253.0.0', '172.16.0.2'],
        [0, '192.168.0.1', '255.255.0.0', '192.168.0.10'],
        [0, '192.168.128.128', '255.255.0.0', '192.168.128.10'],
        [0, '192.168.255.254', '255.255.0.0', '192.168.255.10'],
        [0, '192.168.14.1', '255.255.255.0', '192.168.14.254'],
        [0, '192.168.255.254', '255.255.255.0', '192.168.255.253'],
        [0, '192.168.255.253', '255.255.255.0', '192.168.255.254'],
        [0, '192.168.0.1', '255.0.0.0', '192.168.0.2'],
        [0, '192.168.0.2', '255.0.0.0', '192.168.0.1'],
        [-1,'192.168.0.0', '255.0.0.0', '192.168.0.1'],
        [-1,'192.168.0.255', '255.0.0.0', '192.168.0.1'],
        [-1,'192.168.0.0', '255.0.0.0', '192.168.0.10'],
        [-1,'192.168.0.255', '255.0.0.0', '192.168.0.10'],
        [-1,'192.168.0.1', '255.255.255.255', '192.168.0.1'],
        [-1,'192.168.0.1', '223.0.0.0', '192.168.0.1'],
        [-1,'192.168.0.1', '255.0.0.0', '192.168.0.0'],
        [0, '192.168.0.1', '128.0.0.0', '192.168.0.2'],
        [0, '192.168.0.1', '192.0.0.0', '192.168.0.2'],
        [0, '192.168.0.1', '224.0.0.0', '192.168.0.2'],
        [0, '192.168.0.1', '240.0.0.0', '192.168.0.2'],
        [0, '192.168.0.1', '248.0.0.0', '192.168.0.2'],
        [0, '192.168.0.1', '252.0.0.0', '192.168.0.2'],
        [0, '192.168.0.1', '254.0.0.0', '192.168.0.2'],
        [0, '192.168.0.1', '255.0.0.0', '192.168.0.2'],
        [0, '192.168.0.1', '255.128.0.0', '192.168.0.2'],
        [0, '192.168.0.1', '255.192.0.0', '192.168.0.2'],
        [0, '192.168.0.1', '255.224.0.0', '192.168.0.2'],
        [0, '192.168.0.1', '255.240.0.0', '192.168.0.2'],
        [0, '192.168.0.1', '255.248.0.0', '192.168.0.2'],
        [0, '192.168.0.1', '255.252.0.0', '192.168.0.2'],
        [0, '192.168.0.1', '255.254.0.0', '192.168.0.2'],
        [0, '192.168.0.1', '255.255.0.0', '192.168.0.2'],
        [0, '192.168.0.1', '255.255.128.0', '192.168.0.2'],
        [0, '192.168.0.1', '255.255.192.0', '192.168.0.2'],
        [0, '192.168.0.1', '255.255.224.0', '192.168.0.2'],
        [0, '192.168.0.1', '255.255.240.0', '192.168.0.2'],
        [0, '192.168.0.1', '255.255.248.0', '192.168.0.2'],
        [0, '192.168.0.1', '255.255.252.0', '192.168.0.2'],
        [0, '192.168.0.1', '255.255.254.0', '192.168.0.2'],
        [0, '192.168.0.1', '255.255.255.0', '192.168.0.2'],
        [0, '192.168.0.1', '255.255.255.128', '192.168.0.2'],
        [0, '192.168.0.1', '255.255.255.192', '192.168.0.2'],
        [0, '192.168.0.1', '255.255.255.224', '192.168.0.2'],
        [0, '192.168.0.1', '255.255.255.240', '192.168.0.2'],
        [0, '192.168.0.1', '255.255.255.248', '192.168.0.2'],
        [0, '192.168.0.1', '255.255.255.252', '192.168.0.2'],
    ]

    for pattern in NetworkTestPatterns:
        expect = pattern[0]
        ips    = pattern[1]
        sms    = pattern[2]
        dgs    = pattern[3]
        
        ret = IP_Check(ips,sms,dgs)
        message = ",".join([ips,sms,dgs])
        if ret == expect:
            print ("PASS: " + message)
        else:
            print ("FAIL: " + message)
