import json
import collections as cl
import re
import sys
import subprocess as sp
import copy
import os, time
from hello.check_preset_config import Check_Config_Data
import lbl_const as lbl
import define_const as dc
from master_data_const import GetDefault_Conf_Bluetooth
from get_json_values import GetCorrected_Conf_Bluetooth

sys.path.append('/home/toa/TOA_AM-CF1/Application/data/')
import dev_config

s_config_usr_flag=False
s_config_cnt_flag=False
s_config_time_flag=False
s_config_bt_flag=False
g_config_flag=False
s_login_flag=False

def Get_Config(data,thisNAME_PATH):
    global g_config_flag
    if g_config_flag==True:
        #print(g_config_flag) #kura DEBUG
        return
    g_config_flag=True

    Config_PATH = '/home/toa/TOA_AM-CF1/Application/data/config/'

    config_net_filename = Config_PATH + 'config_net.txt'
    config_usps_filename = Config_PATH + 'config_userpass.txt'
    config_contled_filename = Config_PATH + 'config_contled.txt'
    config_bt_filename = Config_PATH + 'config_bt.json'

    ws_send_data = []
    ws_send_data.append('config')

    with open(config_net_filename,'r') as f:
        configs_net = f.readlines()
        net_info = configs_net[0].strip().split(' ')
        ws_send_data.append(net_info[0])   #ip
        ws_send_data.append(net_info[1])   #subnetmask
        ws_send_data.append(net_info[2])   #defaultgateway
    
    with open(config_usps_filename,'r') as f:
        configs_up = f.readlines()
        ws_send_data.append(configs_up[0].strip().split(',')[1])   #userid
        ws_send_data.append(configs_up[1].strip().split(',')[1])   #pass
    
    values = GetCorrected_Conf_Bluetooth(config_bt_filename)
    ws_send_data.append(values[0][lbl.LBL_BT][lbl.LBL_BT_NAME])  #btname

    with open(config_contled_filename,'r') as f:
        configs_cl = f.readlines()
        ws_send_data.append(configs_cl[0].strip().split(',')[1])   #c_in1
        ws_send_data.append(configs_cl[1].strip().split(',')[1])   #c_in2
        ws_send_data.append(configs_cl[2].strip().split(',')[1])   #c_ou1
        ws_send_data.append(configs_cl[3].strip().split(',')[1])   #c_ou2
        ws_send_data.append(configs_cl[4].strip().split(',')[1])   #trackingonoff
        ws_send_data.append(configs_cl[5].strip().split(',')[1])  #levelonoff
        ws_send_data.append(configs_cl[6].strip().split(',')[1])  #mute mode

    version_fname = thisNAME_PATH + 'config/amcf1_version.json'

    with open(version_fname,'r') as file:
        version_rdata = json.load(file)
        
    ws_send_data.append(version_rdata['version'])  #version

    cmd = 'date +" %Y %m %d %H %M %S "' 
    os_time = sp.Popen(cmd, stdout=sp.PIPE,shell=True).stdout.readlines()
    os_time = str(os_time).strip().split(' ')[1:7]
    os_time = "/".join(os_time)

    ws_send_data.append(os_time)

    ws_send_data.append(configs_cl[7].strip().split(',')[1])  #keylock
    ws_send_data.append(configs_cl[8].strip().split(',')[1])  #mic_mute_func
    ws_send_data.append(configs_cl[9].strip().split(',')[1])  #spout_assign_codec
    ws_send_data.append(configs_cl[10].strip().split(',')[1])  #spout_assign_aux

    ws_send = ",".join(ws_send_data)
    g_config_flag=False
    return ws_send

def Update_Conf_Bluetooth(config_bt_filename, config_org_bt_filename, btname = None):
    configs_all = GetDefault_Conf_Bluetooth()
    if type(btname) is str:
        configs_all[0][lbl.LBL_BT][lbl.LBL_BT_NAME] = btname    #user
    with open(config_bt_filename, 'w') as f:
        json.dump(configs_all, f, indent=True, sort_keys=True)

    # RAMからROMへコピー
    RWMOUNT = sp.Popen("sudo mount -o remount,rw /", shell=True)    # at first, Popen was used
    RWMOUNT.wait()
    cmd = "cp " + config_bt_filename + " " + config_org_bt_filename
    COPY = sp.Popen(cmd, shell=True)
    COPY.wait()

    # MEMO : 処理の流れとしてはここでread onlyでマウントするのが望ましい。
    #        全体の実装に合わせるため呼出元で対処することを前提とする。
    # ROMOUNT = sp.Popen("sudo mount -o remount,ro /", shell=True)    # at first, Popen was used
    # ROMOUNT.wait()

def Set_Config(data,thisNAME_PATH):
    Config_PATH = '/home/toa/TOA_AM-CF1/Application/data/config/'
    Config_org_PATH = '/home_org/toa/TOA_AM-CF1/Application/data/config/'

    config_def_net_filename = Config_PATH + 'config_net_def.txt'
    config_def_usps_filename = Config_PATH + 'config_userpass_def.txt'
    config_def_contled_filename = Config_PATH + 'config_contled_def.txt'

    config_net_filename = Config_PATH + 'config_net.txt'
    config_usps_filename = Config_PATH + 'config_userpass.txt'
    config_contled_filename = Config_PATH + 'config_contled.txt'
    config_bt_filename = Config_PATH + 'config_bt.json'

    config_org_net_filename = Config_org_PATH + 'config_net.txt'
    config_org_usps_filename = Config_org_PATH + 'config_userpass.txt'
    config_org_contled_filename = Config_org_PATH + 'config_contled.txt'
    config_org_bt_filename = Config_org_PATH + 'config_bt.json'

    if data[2] == 'user':
        global s_config_usr_flag
        if s_config_usr_flag==True:
            #print(s_config_usr_flag) #kura DEBUG
            return
        s_config_usr_flag=True

        if os.path.exists(config_usps_filename) == False or os.path.exists(config_org_usps_filename) == False:
            ws_send = "dialog,System error (file not found)"
            s_config_usr_flag=False
            return ws_send

        with open(config_def_usps_filename,'r') as f:
            configs_all = f.readlines()
        
        configs = []
        cnt = 3
        with open(config_usps_filename, 'w') as f:
            for i in range(0,len(configs_all)):
                configs.append(configs_all[i].strip().split(','))
                conf_vals = configs[i]
                conf_vals[1] = data[cnt]
                configs[i] = ",".join(conf_vals)
                cnt = cnt + 1
                f.write(str(configs[i]))
                f.write("\n")

        RWMOUNT = sp.Popen("sudo mount -o remount,rw /", shell=True)    # at first, Popen was used
        RWMOUNT.wait()
        cmd = "cp " + config_usps_filename + " " + config_org_usps_filename
        COPY = sp.Popen(cmd, shell=True)
        COPY.wait()
    
    elif data[2] == 'cont_led':
        global s_config_cnt_flag
        if s_config_cnt_flag==True:
            #print(s_config_cnt_flag) #kura DEBUG
            return
        s_config_cnt_flag=True

        CONT_LED_FLAG = "/home/toa/TOA_AM-CF1/CONT_LED_FLAG"

        if os.path.exists(config_contled_filename) == False or os.path.exists(config_org_contled_filename) == False:
            ws_send = "dialog,System error (file not found)"
            s_config_cnt_flag=False
            return ws_send

        with open(config_def_contled_filename,'r') as f:
            configs_all = f.readlines()
        
        configs = []
        cnt = 3
        with open(config_contled_filename, 'w') as f:
            for i in range(0,len(configs_all)):
                configs.append(configs_all[i].strip().split(','))
                conf_vals = configs[i]
                conf_vals[1] = str(data[cnt])
                configs[i] = ",".join(conf_vals)
                cnt = cnt + 1
                f.write(str(configs[i]))
                f.write("\n")
        
        RWMOUNT = sp.Popen("sudo mount -o remount,rw /", shell=True)    # at first, Popen was used
        RWMOUNT.wait()
        cmd = "cp " + config_contled_filename + " " + config_org_contled_filename
        COPY = sp.Popen(cmd, shell=True)
        COPY.wait()

        if os.path.exists(CONT_LED_FLAG) == False:
            with open(CONT_LED_FLAG,"w") as f:
                f.write("")
    
    elif data[2] == 'time_send':
        global s_config_time_flag
        if s_config_time_flag==True:
            #print(s_config_time_flag) #kura DEBUG
            return
        s_config_time_flag=True

        # time_setting is overwrited every time. So backup(def) is not required.
        TIME_PATH = '/home/toa/TOA_AM-CF1/'
        TIME_ORG_PATH = '/home_org/toa/TOA_AM-CF1/'
        time_setting_fname = TIME_PATH + 'Webserver/templates/time_setting'
        time_org_setting_fname = TIME_ORG_PATH + 'Webserver/templates/time_setting'
        time_write = ",".join(data[3:])
        with open(time_setting_fname, 'w') as file:
            file.seek(0)
            file.write('1,' + time_write)
        
        ws_send=""
        s_config_time_flag=False
        return ws_send

    elif data[2] == 'bt':
        global s_config_bt_flag
        if s_config_bt_flag==True:
            if dev_config.debug_trace:
                print(s_config_bt_flag) #kura DEBUG
            return
        s_config_bt_flag=True

        # RAMとROMにあるファイルが一致することを前提とする
        if os.path.exists(config_bt_filename) == False or os.path.exists(config_org_bt_filename) == False:
            ws_send = "dialog,System error (file not found)"
            s_config_bt_flag=False
            return ws_send

        btname_tmp = data[3]
        # &nbsp;をスペースに置換
        btname = btname_tmp.replace('&nbsp;',' ')
        print(btname)
        #Check param
        if (len(btname) > dc.BTNAME_MAX or len(btname) < dc.BTNAME_MIN):
            ws_send = "dialog,Must be 1-24 alphanumeric characters."
            s_config_bt_flag=False
            return ws_send

        Update_Conf_Bluetooth(config_bt_filename, config_org_bt_filename, btname)

    ROMOUNT = sp.Popen("sudo mount -o remount,ro /", shell=True)    # at first, Popen was used
    ROMOUNT.wait()

    ws_send_data = []
    ws_send_data.append('config')

    with open(config_net_filename,'r') as f:
        configs_net = f.readlines()
        net_info = configs_net[0].strip().split(' ')
        ws_send_data.append(net_info[0])   #ip
        ws_send_data.append(net_info[1])   #subnetmask
        ws_send_data.append(net_info[2])   #defaultgateway
    
    with open(config_usps_filename,'r') as f:
        configs_up = f.readlines()
        ws_send_data.append(configs_up[0].strip().split(',')[1])   #userid
        ws_send_data.append(configs_up[1].strip().split(',')[1])   #pass

    values = GetCorrected_Conf_Bluetooth(config_bt_filename)
    # websocketではスペース区切りとなるため、&nbsp;をスペースに置換
    btname_send = values[0][lbl.LBL_BT][lbl.LBL_BT_NAME].replace(' ','&nbsp;')
    ws_send_data.append(btname_send)    #btname
    
    with open(config_contled_filename,'r') as f:
        configs_cl = f.readlines()
        ws_send_data.append(configs_cl[0].strip().split(',')[1])   #c_in1
        ws_send_data.append(configs_cl[1].strip().split(',')[1])   #c_in2
        ws_send_data.append(configs_cl[2].strip().split(',')[1])   #c_ou1
        ws_send_data.append(configs_cl[3].strip().split(',')[1])   #c_ou2
        ws_send_data.append(configs_cl[4].strip().split(',')[1])   #trackingonoff
        ws_send_data.append(configs_cl[5].strip().split(',')[1])  #levelonoff
        ws_send_data.append(configs_cl[6].strip().split(',')[1])  #mute mode

    version_fname = thisNAME_PATH + 'config/amcf1_version.json'

    with open(version_fname,'r') as file:
        version_rdata = json.load(file)
        
    ws_send_data.append(version_rdata['version'])  #version
    
    cmd = 'date +" %Y %m %d %H %M %S "' 
    os_time = sp.Popen(cmd, stdout=sp.PIPE,shell=True).stdout.readlines()
    os_time = str(os_time).strip().split(' ')[1:7]
    os_time = "/".join(os_time)

    ws_send_data.append(os_time)

    ws_send_data.append(configs_cl[7].strip().split(',')[1])  #keylock
    ws_send_data.append(configs_cl[8].strip().split(',')[1])  #mic_mute_func
    ws_send_data.append(configs_cl[9].strip().split(',')[1])  #spout_assign_codec
    ws_send_data.append(configs_cl[10].strip().split(',')[1])  #spout_assign_aux

    ws_send = ",".join(ws_send_data)
    s_config_usr_flag=False
    s_config_cnt_flag=False
    s_config_time_flag=False
    s_config_bt_flag=False
    return ws_send

def Set_Login(data,thisNAME_PATH):
    global s_login_flag
    if s_login_flag==True:
        #print(s_login_flag) #kura DEBUG
        return
    s_login_flag=True

    Config_PATH = '/home/toa/TOA_AM-CF1/Application/data/config/'
    config_usps_filename = Config_PATH + 'config_userpass.txt'

    with open(config_usps_filename,'r') as f:
        configs_all = f.readlines()
    username = configs_all[0].strip().split(',')[1]
    password = configs_all[1].strip().split(',')[1]

    if (username == data[2] and password == data[3]):
        ws_send = 'login'
    else:
        ws_send = 'dialog, Incorrect username/password.'
    
    s_login_flag=False
    
    return ws_send