from django.http import HttpResponse
from channels.handler import AsgiHandler
from channels import Group

from hello.set_json import Set_Volume
from hello.set_json import Set_EQ
from hello.set_json import Set_Audio_Setting
from hello.get_json import Get_Volume
from hello.get_json import Get_EQ
from hello.get_json import Get_Level
from hello.get_json import Get_Audio_Setting

from hello.preset import Save_Preset
from hello.preset import Load_Preset
from hello.preset import Reset_Preset
from hello.preset import Get_Default_Preset
from hello.preset import Set_Default_Preset

from hello.config import Set_Config
from hello.config import Get_Config
from hello.config import Set_Login

from hello.inspection import Get_Mic_Level
from hello.inspection import Get_Aec_params
from hello.inspection import Set_Aec_params
from hello.inspection import Get_Version

import json
import collections as cl
import re
import sys
import subprocess as sp
import copy
import os, time

# status update
sys.path.append(os.path.join(os.path.dirname(__file__), "../../Application/data"))
import dspupdate

row =1
connection =1

#thisNAME_PATH = os.path.dirname(os.path.abspath(__name__))
thisNAME_PATH = "/home/toa/TOA_AM-CF1/Application/data/"
PATH = os.path.join(thisNAME_PATH, '../../tmp/')

UPDATE_FAILED_flag = "/home/toa/TOA_AM-CF1/FAIL_UPDATE_FLAG"
UPDATE_FAILED_flag_org = "/home_org/toa/TOA_AM-CF1/FAIL_UPDATE_FLAG"
WEB_STOP_flag = PATH + 'WEB_STOP_flag'

#websocket接続
def ws_add(message):
	#print('aaaaaaaaaaaaaaaaaaaa')
	message.reply_channel.send({"accept": True})
	Group("chat").add(message.reply_channel)

	global row
	global connection

#メッセージを受け取ったら、メッセージを返す
def ws_message(message):
	#print('bbbbbbbbbbbb')
	#msgに受け取ったメッセージ格納
	msg = message.content['text']
	global row

	input_value = msg.split()
	#print("{input_value}".format(**locals()))

	#WEBブラウザから受信した各種パラメータを以下でjson形式に整形、出力
	#beam_str state
	if input_value[0] == 'send':
		#以下WEBブラウザからのsend時
		if input_value[1] == 'volume':
			#サイドパネル動作中か確認(gainとレベル取得のところに持っていくこと)
			if os.path.exists(WEB_STOP_flag):
				dialog = "dialog,External controls in use. Please wait to sync."
				Group("chat").send({"text": "%s" %(str(dialog))})
				return
			else:
				ws_send = Set_Volume(input_value,thisNAME_PATH)
				#print(ws_send)
				Group("chat").send({"text": "%s" %(str(ws_send))})
		
		elif input_value[1] == 'audio':
			ws_send = Set_Audio_Setting(input_value,thisNAME_PATH)
			#print(ws_send)
			Group("chat").send({"text": "%s" %(str(ws_send))})

		elif input_value[1] == 'config':
			ws_send = Set_Config(input_value,thisNAME_PATH)
			#print(ws_send)
			Group("chat").send({"text": "%s" %(str(ws_send))})
		
		elif input_value[1] == 'config':
			ws_send = Set_Config(input_value,thisNAME_PATH)
			#print(ws_send)
			Group("chat").send({"text": "%s" %(str(ws_send))})

		elif input_value[1] == 'EQ':
			ws_send = Set_EQ(input_value,thisNAME_PATH)
			#print(ws_send)
			Group("chat").send({"text": "%s" %(str(ws_send))})
		
		elif input_value[1] == 'preset':
			ws_send = Set_Default_Preset(input_value,thisNAME_PATH)
			#print(ws_send)
			Group("chat").send({"text": "%s" %(str(ws_send))})
		
		elif input_value[1] == 'login':
			ws_send = Set_Login(input_value,thisNAME_PATH)
			#print(ws_send)
			Group("chat").send({"text": "%s" %(str(ws_send))})


	elif input_value[0] == 'read':
		#print(json_rdsd_flag)

		if (input_value[1] == 'volume'):
			ws_send = Get_Volume(input_value,thisNAME_PATH)
			#print(ws_send)
			Group("chat").send({"text": "%s" %(str(ws_send))})

		elif (input_value[1] == 'level'):
			#サイドパネル動作中か確認(gainとレベル取得のところに持っていくこと)
			if os.path.exists(WEB_STOP_flag):
				dialog = "dialog,External controls in use. Please wait to sync."
				Group("chat").send({"text": "%s" %(str(dialog))})
				return
			else:
				ws_send = Get_Level(input_value,thisNAME_PATH)
				#print(ws_send)
				Group("chat").send({"text": "%s" %(str(ws_send))})

		elif input_value[1] == 'audio':
			ws_send = Get_Audio_Setting(input_value,thisNAME_PATH)
			#print(ws_send)
			Group("chat").send({"text": "%s" %(str(ws_send))})

		elif input_value[1] == 'config':
			ws_send = Get_Config(input_value,thisNAME_PATH)
			#print(ws_send)
			Group("chat").send({"text": "%s" %(str(ws_send))})

		elif input_value[1] == 'EQ':
			ws_send = Get_EQ(input_value,thisNAME_PATH)
			#print(ws_send)
			Group("chat").send({"text": "%s" %(str(ws_send))})

		elif input_value[1] == 'preset':
			ws_send = Get_Default_Preset(input_value,thisNAME_PATH)
			#print(ws_send)
			Group("chat").send({"text": "%s" %(str(ws_send))})
	
	elif input_value[0] == 'store':
		ws_send = Save_Preset(input_value,thisNAME_PATH)
		#print(ws_send)
		Group("chat").send({"text": "%s" %(str(ws_send))})

	elif input_value[0] == 'load':
		ws_send = Load_Preset(input_value,thisNAME_PATH)
		#print(ws_send)
		Group("chat").send({"text": "%s" %(str(ws_send))})

	elif input_value[0] == 'reset':
		ws_send = Reset_Preset(input_value,thisNAME_PATH)
		#print(ws_send)
		Group("chat").send({"text": "%s" %(str(ws_send))})
	
	#inspection
	elif input_value[0] == 'insp':
		if input_value[1] == 'mic_level':
			ws_send = Get_Mic_Level(input_value,thisNAME_PATH)
			#print(ws_send)
			Group("chat").send({"text": "%s" %(str(ws_send))})
		## inspection version
		elif input_value[1] == 'version':
			ws_send = Get_Version(input_value,thisNAME_PATH)
			#print(ws_send)
			Group("chat").send({"text": "%s" %(str(ws_send))})
		## inspection aec ##
		elif input_value[1] == 'get_aec_params':
			ws_send = Get_Aec_params(input_value,thisNAME_PATH)
			#print(ws_send)
			Group("chat").send({"text": "%s" %(str(ws_send))})
		## inspection aec ##
		elif input_value[1] == 'set_aec_params':
			ws_send = Set_Aec_params(input_value,thisNAME_PATH)
			#print(ws_send)
			Group("chat").send({"text": "%s" %(str(ws_send))})

	#update_status(success or failure)
	elif input_value[0] == 'ud_state':
    	# old update failed flag
		if os.path.exists(UPDATE_FAILED_flag):
			dspupdate.Update_Status_Rewrite(dspupdate.STATUS_UPDATE.STATUS_FAILURE_CPU_UPDATE)
			os.remove(UPDATE_FAILED_flag)
			dspupdate.MountSyncCmmd_toRO("rm -rf " + UPDATE_FAILED_flag_org)

		upd_sts = dspupdate.Update_Status_Read()
		if upd_sts == dspupdate.STATUS_UPDATE.STATUS_NORMAL_BOOT.value:
			ws_send = ""
		elif upd_sts == dspupdate.STATUS_UPDATE.STATUS_SUCCESS_UPDATE.value:
			ws_send = "dialog,Completed! The firmware has been updated."
			dspupdate.Update_Status_Rewrite(dspupdate.STATUS_UPDATE.STATUS_NORMAL_BOOT)
		elif upd_sts == dspupdate.STATUS_UPDATE.STATUS_FAILURE_CPU_UPDATE.value:
			ws_send = "dialog,Firmware update failed."
		elif upd_sts == dspupdate.STATUS_UPDATE.STATUS_FAILURE_DSP_UPDATE.value:
			ws_send = "dialog,Firmware update failed."
		elif upd_sts == dspupdate.STATUS_UPDATE.STATUS_DSP_1_0_0_0.value:
			ws_send = "dialog,Internal Error. Please contact customer service."
		elif upd_sts == dspupdate.STATUS_UPDATE.STATUS_UPDATE_START.value:
			ws_send = "dialog,Firmware update failed."
		else:
			ws_send = "dialog,Firmware update failed."
				
		Group("chat").send({"text": "%s" %(str(ws_send))})
	
	#update_response(if message from web browser, return OK)
	elif input_value[0] == 'ud_response':
		ws_send = "UPLOAD OK."
		#print(ws_send)
		Group("chat").send({"text": "%s" %(str(ws_send))})

	##################################################

#websocket切断
def ws_disconnect(message):
	Group("chat").discard(message.reply_channel)

	global connection