# -*- coding:utf-8 -*-
import json
import define_const as dc
import lbl_const as lbl
import re

# 概要   :NGリストをファイルに出力する(kura追加)
# 引数   :Ngfname:NGリスト出力ファイル名
#         Nglist : NGリスト配列
# 戻り値 :なし
def NglistOutput(Nglist):
    BASE_DIR = '/home/toa/TOA_AM-CF1/tmp/NG_setting_filecheck/'
    NGLIST_FNAME= BASE_DIR + 'NGlabellist.txt'  #Preset defNo NG
    # if not Nglist:
    #     return # Nglistが空のときファイルに書き込まない
    # Nglist_str = ",".join(Nglist) + ","
    # with open(NGLIST_FNAME,'a') as f:
    #     f.write(Nglist_str)

# MEMO : 量産モデルのmaster_data_const.pyから流用
# 概要   ："config_bt.json"から設定値を取得し、破損値はinitsの該当値に置換して返す
# 引数   ：fname  : in  : "config_bt.json"のパス
#          inits  : in  : 破損存在時に置換する設定値。None時はデフォルト値を適用
# 戻り値 ：破損修正済設定値
def GetCorrected_Conf_Bluetooth(fname, inits=None):
    with open(fname, 'r') as f:
        # MEMO : Qモデルの他の設定と挙動を揃えるため、エラーチェックは一切しない。
        values = json.load(f)

    # try:
    #     if inits is None:
    #         inits = GetDefault_Conf_Bluetooth()  # デフォルト値を適用
    #     values = inits
    #     if (fname is not None) and os.path.exists(fname):
    #         with open(fname, 'r') as f:
    #             values = json.load(f)
    #             if (isinstance(values, list) is False) or (len(values) <= 0):
    #                 # 取得したデータがlist型で無い場合はエラー
    #                 values = inits
    #             else:
    #                 # 取得値の破損チェック。破損値はinitsの該当値に置換される
    #                 Check_Conf_Bluetooth_Value(values, inits, True)
    # except:
    #     if dev_config.debug_trace:
    #         print("GetCorrected_Conf_Bluetooth error.")
    #         #import traceback
    #         #traceback.print_exc()
    #     pass
    return values

# 概要   ：チェック対象値に対し"config_bt.json"フォーマットに基づいた破損チェックを行う。
#          ModifyValue=Trueの場合、破損値はinitsの該当値に置換される
# 引数   ：values      : in  : チェック対象値(list型)
#          inits       : in  : 破損存在時に置換する修正値。
#          ModifyValue : in  : True=破損値の場合は修正する、False=破損値の場合はチェック処理を終了する
#          NgList      : out : 破損していたラベル名リスト
# 戻り値 ：-1=データ破損有、0=正常
#          ※ModifyValue=True時で破損を修正した場合でも-1を返す
def Check_Conf_Bluetooth_Value(values, inits=None, ModifyValue=False, NgList=None):
    _nglist = []
    try:
        if inits is None:
            ModifyValue = False  # 修正値が未指定の場合は修正しない

        if len(values) <= 0:
            # 登録値が存在しない
            if dev_config.debug_trace:
                print("invalid format bt")
            if ModifyValue:
                values.append(inits[0])
            _nglist.append(lbl.LBL_BT)
            return -1
        if isinstance(values[0], dict) is False:
            # listの先頭要素がdict型でない
            if dev_config.debug_trace:
                print("invalid format bt")
            if ModifyValue is True:
                values[0] = inits[0]
            _nglist.append(lbl.LBL_BT)
            return -1
        if ((lbl.LBL_BT in values[0].keys()) is False) or ((isinstance(values[0][lbl.LBL_BT], dict)) is False):
            # 大項目ラベルが存在しない or 大項目設定値がdict型でない
            if dev_config.debug_trace:
                print("invalid format bt")
            if ModifyValue is True:
                values[0][lbl.LBL_BT] = inits[0][lbl.LBL_BT]
            _nglist.append(lbl.LBL_BT)
            return -1

        ret = 0
        val = values[0][lbl.LBL_BT]

        if (((lbl.LBL_BT_NAME in val.keys()) is False) or (len(val[lbl.LBL_BT_NAME]) > dc.BTNAME_MAX) or (len(val[lbl.LBL_BT_NAME]) < dc.BTNAME_MIN)):
            # 対象ラベルが存在しない or 設定値が範囲外
            if dev_config.debug_trace:
                print("invalid format bt. invalid device name")
            _nglist.append(lbl.LBL_BT_NAME)
            ret = -1
            if ModifyValue:
                val[lbl.LBL_BT_NAME] = inits[0][lbl.LBL_BT][lbl.LBL_BT_NAME]
            else:
                return ret

        regexp = re.compile(r'[^A-Za-z0-9_\. -]')
        result = regexp.search(val[lbl.LBL_BT_NAME]) #デバイス名が半角英数字、. - _ スペース以外を検出する。

        if result:
            #デバイス名が半角英数字、. - _ スペース以外
            if dev_config.debug_trace:
                print("invalid format bt. invalid device name")
            _nglist.append(lbl.LBL_BT_NAME)
            ret = -1
            if ModifyValue:
                val[lbl.LBL_BT_NAME] = inits[0][lbl.LBL_BT][lbl.LBL_BT_NAME]
            else:
                return ret

        return ret
    except:
        _nglist.clear()
        _nglist.append(lbl.LBL_BT)
        if ModifyValue:
            values[0] = inits[0]
        if dev_config.debug_trace:
            print("Check_Conf_Bluetooth_Value error.")
            #import traceback
            #traceback.print_exc()
        return -1
    finally:
        if NgList is not None:
            NglistOutput(_nglist)
