from django.http.response import HttpResponse
from django.shortcuts import render
import json

def Get_FW_Version():
	# スタイルシートのキャッシュ対策として、バージョンを末尾のクエリとして書き込むことで対応する。
	thisNAME_PATH = '/home/toa/TOA_AM-CF1/Application/data/'
	version_fname = thisNAME_PATH + 'config/amcf1_version.json'
	with open(version_fname,'r') as file:
		version_rdata = json.load(file)
	return version_rdata['version_for_developer']  #version

template_data = {
	'fwversion' : '?v=' + Get_FW_Version()
}

def hello_world(request):
	return HttpResponse('Hello world')

def page_Volume(request):
	return render(request, 'index.html', template_data)

def page_EQ_SP(request):
	return render(request, 'EQSP.html', template_data)

def page_EQ_AUX(request):
	return render(request, 'EQAUX.html', template_data)

def page_AudioSetting(request):
	return render(request, 'audiosetting.html', template_data)

def page_PresetSaveLoad(request):
	return render(request, 'presetsaveload.html', template_data)

def page_Login(request):
	return render(request, 'login.html', template_data)

def page_Mic_check(request):
	return render(request, 'inspection/mic_check.html')

def page_Aec_check(request):
	return render(request, 'inspection/aec_check.html')

def comm_json_vol(request):
	return render(request, 'command/volume.json')

def comm_json_lev(request):
	return render(request, 'command/level.json')

def resl_json_vol(request):
	return render(request, 'result/volume.json')

def resl_json_lev(request):
	return render(request, 'result/level.json')

def json_audio_i(request):
	return render(request, 'result/audio_in.json')

def json_audio_o(request):
	return render(request, 'result/audio_out.json')
	
def json_aec_nc(request):
	return render(request, 'result/aec_nc.json')