function Levels(screen) {

    var mod = this;
    mod.screen = screen;
    mod.type = "level";
    mod.level = ".level-meter";
    mod.bar = ".ul-vol";
    mod.maxVol = ".max-vol";

    mod.init = function() {
        app.addUpdateFunc(mod.screen, mod.type, mod.updateFunc);
        mod.updateAllValues(false);
    }

    mod.updateFunc = function(value, trigger) {

        var response;
        if( value>=limits[mod.screen].level.min && value<=limits[mod.screen].level.max && value%limits[mod.screen].level.step==0) {
            this.value = value;
            mod.updateValue(this.parentID, trigger);
            response = "ok";
        }
        else {
            console.log("[LEVEL METER] Incorrect value");
            response = "invalid";
        }
        return response;

    }

    mod.updateAllValues = function(trigger) {
        $(mod.level).each(function() {
            var controlID = $(this).attr("control-id");
            mod.updateValue(controlID, trigger);
        });
    }

    mod.updateValue = function(controlID, trigger) {
        var $level = $(mod.level+"[control-id='"+controlID+"']");
        var $bar = $level.find(mod.bar);
        var $max = $level.find(mod.maxVol);
        var data = app.getControlData(mod.screen, controlID);
        if( data.level.value%limits[mod.screen].level.step==0 ) {
            var per = ((data.level.value-limits[mod.screen].level.min)/(limits[mod.screen].level.max-limits[mod.screen].level.min))*100;
            $bar.css("height", per+"%");
            if( data.level.value>=0 ) $max.show();
            else $max.hide();
            if( trigger==null || trigger==true ) {
                $(window).trigger("valueUpdated");
                $(mod.level).trigger(controlID+"ValueUpdated");
            }
        }
        else console.log("[LEVEL] "+controlID+": value not respect step limit");
    }

    mod.getDom = function() {
        return $(mod.level);
    }

    mod.getType = function() {
        return mod.type;
    }

}
