function Textboxes(screen, type) {
    
    var mod = this;
    mod.screen = screen;
    mod.type = type;
    mod.textbox = ".text-box";
    
    mod.init = function() {
        app.addUpdateFunc(mod.screen, mod.type, mod.updateFunc);
        mod.updateAllValues(false);
        mod.events();
    }
    
    mod.updateFunc = function(value, trigger) {
        var response;
        var limit = limits[mod.screen][mod.type];
        if( value.length>=limit.minlength && value.length<=limit.maxlength ) { 
            this.value = value;
            mod.updateValue(this.parentID, trigger);
            response = "ok";
        }
        else {
            console.log("[TEXTBOX] Incorrect value");
            mod.updateValue(this.parentID, false);
            //if( limit.error ) alert(limit.error); //control.js文字数規定共通アラートの回避(bluetooth名変更対応)
            response = "invalid";
        }
        return response;
    }
    
    mod.updateAllValues = function(trigger) {
        $(mod.textbox).each(function() {
            var controlID = $(this).attr("control-id");
            mod.updateValue(controlID, trigger);
        });
    }

    mod.updateValue = function(controlID, trigger) {
        var $textbox = $(mod.textbox+"[control-id='"+controlID+"']");
        var data = app.getControlData(mod.screen, controlID);
        var vals = data[mod.type].value.split(".");
        $textbox.val(data[mod.type].value);
        if( trigger==null || trigger==true ) {
            $(window).trigger("valueUpdated");
            $(mod.listbox).trigger(controlID+"ValueUpdated");
        }
    }
    
    mod.events = function() {
        $(mod.textbox).on("change blur", function() {
            if( !$(this).hasClass("disabled") ) {
                var controlID = $(this).attr("control-id");
                var data = app.getControlData(mod.screen, controlID);
                data[mod.type].updateValue($(this).val());
            }
        });
    }
    
    mod.getDom = function() {
        return $(mod.textbox);
    }
    
    mod.getType = function() {
        return mod.type;
    }
    
}