var now_year = new Date().getFullYear()
if (now_year > 2034){
    now_year = 2034
}else if (now_year < 2017){
    now_year = 2017
}
var now_month = new Date().getMonth() + 1
var now_date = new Date().getDate()
var now_hour = ("0" + new Date().getHours()).slice(-2)
var now_minute = ("0" + new Date().getMinutes()).slice(-2)
var now_second = ("0" + new Date().getSeconds()).slice(-2)

var controls = {
    volume: {
        INPUT: {
            USB: {
                id: "input-usb",
                gain: { value: null, unit: "dB" },
                fader: { value: null, unit: "dB" },
                level: { value: -42, unit: "dB" },
                mute: { value: "OFF" }
            },
            BLUETOOTH: {
                id: "input-bluetooth",
                gain: { value: null, unit: "dB" },
                fader: { value: null, unit: "dB" },
                level: { value: -42, unit: "dB" },
                mute: { value: "OFF" }
            },
            CODEC: {
                id: "input-codec",
                gain: { value: null, unit: "dB" },
                fader: { value: null, unit: "dB" },
                level: { value: -42, unit: "dB" },
                mute: { value: "OFF" }
            },
            AUX: {
                id: "input-aux",
                gain: { value: null, unit: "dB" },
                fader: { value: null, unit: "dB" },
                level: { value: -42, unit: "dB" },
                mute: { value: "OFF" }
            }
        },
        OUTPUT: {
            SP: {
                id: "output-sp",
                gain: { value: null, unit: "dB" },
                fader: { value: null, unit: "dB" },
                level: { value: -42, unit: "dB" },
                mute: { value: "OFF" }
            },
            USB: {
                id: "output-usb",
                gain: { value: null, unit: "dB" },
                fader: { value: null, unit: "dB" },
                level: { value: -42, unit: "dB" },
                mute: { value: "OFF" }
            },
            BLUETOOTH: {
                id: "output-bluetooth",
                gain: { value: null, unit: "dB" },
                fader: { value: null, unit: "dB" },
                level: { value: -42, unit: "dB" },
                mute: { value: "OFF" }
            },
            CODEC: {
                id: "output-codec",
                gain: { value: null, unit: "dB" },
                fader: { value: null, unit: "dB" },
                level: { value: -42, unit: "dB" },
                mute: { value: "OFF" }
            },
            AUX: {
                id: "output-aux",
                gain: { value: null, unit: "dB" },
                fader: { value: null, unit: "dB" },
                level: { value: -42, unit: "dB" },
                mute: { value: "OFF" }
            }
        }
    },
    EQ: {
        FILTERS: {
            filter1: {
                id: "filter1",
                filter1: { value: null }
            },
            filter2: {
                id: "filter2",
                filter2: { value: null }
            }
        },
        FREQUENCY: {
            frequencies: [{
                id: "frequency-1",
                frequency: { value: null, unit: "Hz" }
            }, {
                id: "frequency-2",
                frequency: { value: null, unit: "Hz" }
            }, {
                id: "frequency-3",
                frequency: { value: null, unit: "Hz" }
            }, {
                id: "frequency-4",
                frequency: { value: null, unit: "Hz" }
            }, {
                id: "frequency-5",
                frequency: { value: null, unit: "Hz" }
            }]
        },
        GAIN: {
            gains: [{
                id: "gain-1",
                gain: { value: null, unit: "dB" }
            }, {
                id: "gain-2",
                gain: { value: null, unit: "dB" }
            }, {
                id: "gain-3",
                gain: { value: null, unit: "dB" }
            }, {
                id: "gain-4",
                gain: { value: null, unit: "dB" }
            }, {
                id: "gain-5",
                gain: { value: null, unit: "dB" }
            }]
        },
        Q: {
            qValues: [{
                id: "q-1",
                q: { value: null, unit: "" }
            }, {
                id: "q-2",
                q: { value: null, unit: "" }
            }, {
                id: "q-3",
                q: { value: null, unit: "" }
            }, {
                id: "q-4",
                q: { value: null, unit: "" }
            }, {
                id: "q-5",
                q: { value: null, unit: "" }
            }]
        }
    },
    audio: {
        TRACKING: {
            measure: {
                id: "tracking-measure-unit",
                unit: { value: "inch" }
            },
            coordinates: [{
                id: "tracking-coordinates-x1",
                coordinate: { value: null, unit: null }
            }, {
                id: "tracking-coordinates-x2",
                coordinate: { value: null, unit: null }
            }],
            depths: [{
                id: "tracking-depth-min",
                depth: { value: null, unit: null }
            }, {
                id: "tracking-depth-max",
                depth: { value: null, unit: null }
            }]
        },
        SENSING: {
            sensing: {
                id: "sensing",
                sensing: { value: null }
            }
        },
        MODE: {
            mode: {
                id: "mode",
                mode: { value: null }
            }
        },
        DISTANCE: {
            distance: {
                id: "distance",
                distance: { value: null, unit: "inch" }
            }
        },
        ANGLE: {
            angle: {
                id: "angle",
                angle: { value: null, unit: "deg" }
            }
        },
        AEC: {
            mode: {
                id: "aec-mode",
                aec: { value: null }
            },
            nlplevel: {
                id: "nlp-level",
                nlplevel: { value: null }
            },
            micgain: {
                id: "mic-gain",
                micgain: { value: null }
            }
        },
        NC: {
            mode: {
                id: "nc-mode",
                nc: { value: null }
            },
            reduction: {
                id: "nc-reduction-level",
                level: { value: null }
            }
        }
    },
    preset: {
        SETTINGS: {
            default: {
                id: "settings-default-preset",
                preset: { value: null }
            }
        }
    },
    config: {
        NETWORK: {
            ipfields: [{
                id: "network-ip-address",
                ip: { value: "192.168.14.10" }
            }, {
                id: "network-subnet-mask",
                ip: { value: "255.255.255.0" }
            }, {
                id: "network-default-gateway",
                ip: { value: "192.168.14.1" }
            }]
        },
        USER: {
            username: {
                id: "user-username",
                text: { value: "admin" }
            },
            password: {
                id: "user-password",
                text: { value: "admin" }
            }
        },
        BLUETOOTH: {
            devname: {
                id: "BT-devname",
                text: { value: "AM-CF1" }
            }
        },
        CONTACT: {
            inputs: [{
                id: "contact-input-1",
                input: { value: "None" }
            }, {
                id: "contact-input-2",
                input: { value: "None" }
            }],
            outputs: [{
                id: "contact-output-1",
                output: { value: "None" }
            }, {
                id: "contact-output-2",
                output: { value: "None" }
            }]
        },
        INDICATE: {
            toggles: [{
                id: "indicate-tracking",
                onoff: { value: "ON" }
            }, {
                id: "indicate-mic-gain-level",
                onoff: { value: "ON" }
            }],
            mute: {
                id: "indicate-mute",
                mute: { value: "ALL LED" }
            }
        },
        KEYLOCK: {
            toggles: [{
                id: "keylock-side-sw-all",
                onoff: { value: "OFF" }
            }]
        },
        TIME: {
            years: {
                id: "time-years",
                year: { value: now_year }
            },
            monthes: {
                id: "time-monthes",
                month: { value: now_month }
            },
            days: {
                id: "time-days",
                day: { value: now_date }
            },
            hours: {
                id: "time-hours",
                hour: { value: now_hour }
            },
            minutes: {
                id: "time-minutes",
                minute: { value: now_minute }
            },
            seconds: {
                id: "time-seconds",
                second: { value: now_second }
            }
        },
        MIC_MUTE_FUNC: {
            toggles: [{
                id: "mic-mute-func",
                onoff: { value: "OFF" }
            }]
        },
        SPOUT_ASSIGN: {
            toggles: [{
                id: "spout-assign-codec",
                onoff: { value: "ON" }
            }, {
                id: "spout-assign-aux",
                onoff: { value: "ON" }
            }]
        }
    }
}

var convertions = {
    coor: {
        cm: [0, 10, 20, 30, 40, 50, 60, 70, 80, 90, 100, 110, 120, 130, 140, 150, 160, 170, 180, 190, 200, 210, 220, 230, 240, 250, 260, 270, 280, 290, 300],
        inch: [0, 4, 8, 12, 16, 20, 24, 28, 32, 36, 40, 44, 48, 52, 56, 60, 64, 68, 72, 76, 80, 84, 88, 92, 96, 100, 104, 108, 112, 116, 120]
    },
    depth: {
        cm: [20, 30, 40, 50, 60, 70, 80, 90, 100, 110, 120, 130, 140, 150, 160, 170, 180, 190, 200, 210, 220, 230, 240, 250, 260, 270, 280, 290, 300, 310, 320, 330, 340, 350, 360, 370, 380, 390, 400, 410, 420, 430, 440, 450, 460, 470, 480, 490, 500, 510, 520, 530, 540, 550, 560, 570, 580, 590, 600],
        inch: [8, 12, 16, 20, 24, 28, 32, 36, 40, 44, 48, 52, 56, 60, 64, 68, 72, 76, 80, 84, 88, 92, 96, 100, 104, 108, 112, 116, 120, 124, 128, 132, 136, 140, 144, 148, 152, 156, 160, 164, 168, 172, 176, 180, 184, 188, 192, 196, 200, 204, 208, 212, 216, 220, 224, 228, 232, 236, 240]
    }
}

var limits = {
    volume: {
        gain: { min: -60, max: 0, step: 1 },
        fader: { min: -60, max: 0, step: 1 },
        level: { min: -42, max: 0, step: 1 },
        mute: { value1: "ON", value2: "OFF" }
    },
    EQ: {
        filter1: ["HPF", "PEQ"],
        filter2: ["LPF", "PEQ"],
        frequency: { values: [20.0, 21.2, 22.4, 23.6, 25.0, 26.5, 28.0, 30.0, 31.5, 33.5, 35.5, 37.5, 40.0, 42.5, 45.0, 47.5, 50.0, 53.0, 56.0, 60.0, 63.0, 67.0, 71.0, 75.0, 80.0, 85.0, 90.0, 95.0, 100.0, 106.0, 112.0, 118.0, 125.0, 132.0, 140.0, 150.0, 160.0, 170.0, 180.0, 190.0, 200.0, 212.0, 224.0, 236.0, 250.0, 265.0, 280.0, 300.0, 315.0, 335.0, 375.0, 400.0, 425.0, 450.0, 475.0, 500.0, 530.0, 560.0, 600.0, 630.0, 670.0, 710.0, 750.0, 800.0, 850.0, 900.0, 950.0, 1000.0, 1060.0, 1120.0, 1180.0, 1250.0, 1320.0, 1400.0, 1500.0, 1600.0, 1700.0, 1800.0, 1900.0, 2000.0, 2120.0, 2240.0, 2360.0, 2500.0, 2650.0, 2800.0, 3000.0, 3150.0, 3350.0, 3550.0, 3750.0, 4000.0, 4250.0, 4500.0, 4750.0, 5000.0, 5300.0, 5600.0, 6000.0, 6300.0, 6700.0, 7100.0, 7500.0, 8000.0, 8500.0, 9000.0, 9500.0, 10000.0, 10600.0, 11200.0, 11800.0, 12500.0, 13200.0, 14000.0, 15000.0, 16000.0, 17000.0, 18000.0, 19000.0, 20000.0] },
        gain: { min: -15, max: 15, step: 0.5 },
        q: { values: [0.267, 0.276, 0.285, 0.295, 0.305, 0.315, 0.326, 0.338, 0.35, 0.362, 0.376, 0.389, 0.404, 0.419, 0.436, 0.453, 0.471, 0.49, 0.511, 0.532, 0.556, 0.581, 0.607, 0.636, 0.667, 0.683, 0.7, 0.718, 0.736, 0.756, 0.776, 0.797, 0.819, 0.843, 0.867, 0.893, 0.92, 0.948, 0.979, 1.011, 1.044, 1.08, 1.119, 1.16, 1.204, 1.25, 1.301, 1.355, 1.414, 1.445, 1.478, 1.512, 1.548, 1.585, 1.624, 1.665, 1.707, 1.752, 1.8, 1.85, 1.902, 1.958, 2.016, 2.079, 2.145, 2.215, 2.29, 2.371, 2.456, 2.549, 2.648, 2.755, 2.871, 2.997, 3.134, 3.285, 3.45, 3.633, 3.836, 4.063, 4.318, 4.608, 4.938, 5.319, 5.764, 6.289, 6.919, 7.689, 8.651, 9.889, 11.538, 13.847, 17.31, 23.081, 34.623, 69.249] }
    },
    audio: {
        unit: { value1: "inch", value2: "cm" },
        coordinate: { values: convertions.coor.inch },
        depth: { values: convertions.depth.inch, order: "INC", error: "Depth(max) must be larger than Depth(min)." },
        sensing: ["LOW", "MID", "HIGH"],
        mode: { value1: "Auto", value2: "Manual" },
        distance: { values: convertions.depth.inch },
        angle: { min: -90, max: 90, step: 10 },
        aec: { value1: "OFF", value2: "ON" },
        nc: { value1: "OFF", value2: "ON" },
        level: ["12dB", "15dB", "18dB", "21dB"],
        nlplevel: ["LOW", "MID", "HIGH"],
        micgain: ["-6dB", "-4dB", "-2dB", "0dB", "2dB", "4dB", "6dB"]
    },
    preset: {
        preset: ["Preset 1", "Preset 2"]
    },
    config: {
        ip: { min: 0, max: 255, maxlength: 3 },
        text: { minlength: 1, maxlength: 24 },
        input: ["None", "Mute(One-shot)", "Mute(Edge)", "Volume Up", "Volume Down", "Preset1", "Preset2"],
        output: ["None", "Mute Status", "Synch Input1", "Synch Input2"],
        onoff: { value1: "OFF", value2: "ON" },
        mute: ["Only Center", "ALL LED"],
        year: { min: 2017, max: 2034, step: 1 },
        month: { min: 1, max: 12, step: 1 },
        day: { min: 1, max: new Date(controls.config.TIME.years.year.value, controls.config.TIME.monthes.month.value, 0).getDate(), step: 1 },
        hour: { min: 0, max: 23, step: 1, double_digits: true },
        minute: { min: 0, max: 59, step: 1, double_digits: true },
        second: { min: 0, max: 59, step: 1, double_digits: true },
    }
}
