function exec_upload_php() {
    // フォームデータを取得
    var formdata = new FormData($('#form_upload').get(0));

    //ip取得
    var ipaddress = document.getElementById('ipaddress').title;

    $.blockUI({
        message: "Please wait...",
        baseZ: 1000000  //一番手前で表示する
    });

    // POSTでアップロード
    $.ajax({
        url: "http://" + ipaddress + "/upload.php",
        type: "POST",
        data: formdata,
        cache: false,
        contentType: false,
        processData: false,
        dataType: "html"
    })
        .done(function (data, textStatus, jqXHR) {
            $.unblockUI();

            //ajaxでjsonp取得
            $.ajax({
                url: 'http://' + ipaddress + '/jsonp_upload_php.js',
                dataType: 'jsonp',
                jsonpCallback: 'callback'
            })
                .then(
                function (json) {
                    var error_messages = json.error_messages;
                    //messagesが入っていたらエラー表示するだけ
                    if (error_messages) {
                        alert(error_messages);
                    } else {	//正常にアップロードできた場合
                        var version = json.version;
                        var new_dev_ver = json.new_dev_ver.split(".");
                        var old_dev_ver = json.old_dev_ver.split(".");
                        var fwup_comment = json.fwup_comment;
                        var new_ver_flag = false;

                        //バージョン番号を上位の桁から順に比較(新バージョン、同バージョンしか受け付けない)
                        for (i_ver = 0; i_ver < old_dev_ver.length; i_ver++) {
                            // old より new のバージョン番号が大きい = 即update可
                            if (Number(old_dev_ver[i_ver]) < Number(new_dev_ver[i_ver])) {
                                new_ver_flag = true;
                                break;
                                // old より new のバージョン番号が小さい = 即update不可
                            } else if (Number(old_dev_ver[i_ver]) > Number(new_dev_ver[i_ver])) {
                                new_ver_flag = false;
                                break;
                                // old と new のバージョン番号が同じ = バージョンが全部同じならtrue
                            } else {
                                new_ver_flag = true;
                            }
                        }

                        if (!version || !new_ver_flag) {
                            if (!version) {
                                alert("Improperly configured file.");
                            }
                            if (!new_ver_flag) {
                                alert("Older firmware version. Please upload newer version.");
                            }

                            //アップロードファイルの削除
                            $.ajax({
                                url: "http://" + ipaddress + "/delete.php",
                                type: "POST",
                                data: formdata,
                                cache: false,
                                contentType: false,
                                processData: false,
                                dataType: "html"
                            })
                                .then(
                                function (data) {
                                },
                                function () {
                                }
                                );
                        } else {
                            var msg_sure = "Uploaded firmware version is " + version + "\n"
                                + "Are you sure you want to update?\n\n" + fwup_comment + "\n";
                            //Dialog
                            if (window.confirm(msg_sure)) {	//Dialog OK時の処理
                                //indicator
                                $.blockUI({
                                    message: "Updating. Do not shutdown.",
                                    baseZ: 1000000  //一番手前で表示する
                                });
                                //ajaxでupdate.php
                                $.ajax({
                                    url: "http://" + ipaddress + "/update.php",
                                    type: "POST",
                                    data: formdata,
                                    cache: false,
                                    contentType: false,
                                    processData: false,
                                    dataType: "html"
                                })
                                    .then(
                                    function (data) {
                                    },
                                    function () {
                                    });
                                $.unblockUI();
                                //くるくるアニメーション
                                $('#loadingmask').fadeIn(0);
                                $('#floatingCirclesG').fadeIn(0);
                                //アップデート後のサーバ起動まで繰り返し
                                var ws_response_confirm = function () {
                                    ws = new WebSocket(WS_URL);
                                    ws.onopen = function () {
                                        ws.send('ud_response');
                                        ws.onmessage = function (e) {
                                            var arrayString = e.data.split(",");
                                            if (arrayString[0] == 'UPLOAD OK.') {
                                                //alert('OK') for debug
                                                clearInterval(confirm_serverON_timer);
                                                window.location.reload()
                                            }
                                        }
                                    }
                                }
                                confirm_serverON_timer = setInterval(ws_response_confirm, 5000);
                            } else {	//Dialog NG時の処理
                                //アップロードファイルの削除
                                $.ajax({
                                    url: "http://" + ipaddress + "/delete.php",
                                    type: "POST",
                                    data: formdata,
                                    cache: false,
                                    contentType: false,
                                    processData: false,
                                    dataType: "html"
                                })
                                    .then(
                                    function (data) {
                                    },
                                    function () {
                                    }
                                    );
                            }
                        }
                    }
                },
                function () {
                    $.unblockUI();
                    alert('System error (File not found)');	//jsonpが見つからなかった時
                }
                );
        })
        .fail(function (jqXHR, textStatus, errorThrown) {
            $.unblockUI();
            alert("System error");	//POSTアップロードのphp失敗
            //アップロードファイルの削除
            $.ajax({
                url: "http://" + ipaddress + "/delete.php",
                type: "POST",
                data: formdata,
                cache: false,
                contentType: false,
                processData: false,
                dataType: "html"
            })
                .then(
                function (data) {
                },
                function () {
                }
                );
        });
}