function config_upload_php() {
    // フォームデータを取得
    var formdata = new FormData($('#config_upload').get(0));

    //ip取得
    var ipaddress = document.getElementById('ipaddress').title;

    $.blockUI({
        message: "Please wait...",
        baseZ: 1000000  //一番手前で表示する
    });

    // POSTでアップロード
    $.ajax({
        url: "http://" + ipaddress + "/config_upload.php",
        type: "POST",
        data: formdata,
        cache: false,
        contentType: false,
        processData: false,
        dataType: "html"
    })
        .done(function (data, textStatus, jqXHR) {
            $.unblockUI();

            //ajaxでjsonp取得
            $.ajax({
                url: 'http://' + ipaddress + '/jsonp_upload_php.js',
                dataType: 'jsonp',
                jsonpCallback: 'callback'
            })
                .then(
                function (json) {
                    var error_messages = json.error_messages;
                    //messagesが入っていたらエラー表示するだけ
                    if (error_messages) {
                        alert(error_messages);
                    } else {	//正常にアップロードできた場合
                        var check_result = json.check_result;
                        if (check_result == -1) {
                            alert("Improperly configured file.");
                            //アップロードファイルの削除
                            $.ajax({
                                url: "http://" + ipaddress + "/delete.php",
                                type: "POST",
                                data: formdata,
                                cache: false,
                                contentType: false,
                                processData: false,
                                dataType: "html"
                            })
                                .then(
                                function (data) {
                                },
                                function () {
                                }
                                );

                        } else {
                            var msg_sure = "Are you sure you want to overwrite this config file?";
                            //Dialog
                            if (window.confirm(msg_sure)) {	//Dialog OK時の処理
                                //indicator
                                $.blockUI({
                                    message: "Updating. Do not shutdown.",
                                    baseZ: 1000000  //一番手前で表示する
                                });
                                //ajaxでconfig_update.php
                                $.ajax({
                                    url: "http://" + ipaddress + "/config_update.php",
                                    type: "POST",
                                    data: formdata,
                                    cache: false,
                                    contentType: false,
                                    processData: false,
                                    dataType: "html"
                                })
                                    .then(
                                    //config_update success
                                    function (data) {
                                        $.unblockUI();
                                        $.ajax({
                                            url: "http://" + ipaddress + "/delete.php",
                                            type: "POST",
                                            data: formdata,
                                            cache: false,
                                            contentType: false,
                                            processData: false,
                                            dataType: "html"
                                        })
                                            .then(
                                            function (data) {
                                                location.href= "http://" + ipaddress + "/ipchange_configupload.php";
                                            },
                                            function () {
                                                alert("System error.")
                                            }
                                            );
                                    },
                                    //dsp fail
                                    function () {
                                        $.unblockUI();
                                        $.ajax({
                                            url: "http://" + ipaddress + "/delete.php",
                                            type: "POST",
                                            data: formdata,
                                            cache: false,
                                            contentType: false,
                                            processData: false,
                                            dataType: "html"
                                        })
                                            .then(
                                            function (data) {
                                            },
                                            function () {
                                            }
                                            );
                                        alert("System error.")
                                    }
                                    );

                            } else {	//Dialog NG時の処理
                                //アップロードファイルの削除
                                $.unblockUI();
                                $.ajax({
                                    url: "http://" + ipaddress + "/delete.php",
                                    type: "POST",
                                    data: formdata,
                                    cache: false,
                                    contentType: false,
                                    processData: false,
                                    dataType: "html"
                                })
                                    .then(
                                    function (data) {
                                    },
                                    function () {
                                    }
                                    );
                            }
                        }
                    }
                },
                function () {
                    $.unblockUI();
                    alert('System error (file not found)');	//jsonpが見つからなかった時
                }
                );
        })
        .fail(function (jqXHR, textStatus, errorThrown) {
            $.unblockUI();
            alert("System error");	//POSTアップロードのphp失敗
            //アップロードファイルの削除
            $.ajax({
                url: "http://" + ipaddress + "/delete.php",
                type: "POST",
                data: formdata,
                cache: false,
                contentType: false,
                processData: false,
                dataType: "html"
            })
                .then(
                function (data) {
                },
                function () {
                }
                );
        });
}