function IPFields(screen) {
    
    var mod = this;
    mod.screen = screen;
    mod.type = "ip";
    mod.ip = ".ip-field";
    
    mod.init = function() {
        app.addUpdateFunc(mod.screen, mod.type, mod.updateFunc);
        mod.updateAllValues(false);
        mod.events();
    }
    
    mod.updateFunc = function(value, trigger) {
        var response;
        var vals = value.split(".");
        var limit = limits[mod.screen][mod.type];
        for(var i=0; i<vals.length; i++) {
            vals[i] = vals[i].substr(0, limit.maxlength);
            vals[i] = vals[i].replace(/\D/g,'');
            if( vals[i]=="" ) vals[i] = 0;
            if( vals[i]<limit.min ) vals[i] = limit.min;
            else if( vals[i]>limit.max ) vals[i] = limit.max;
        }
        this.value = vals.join(".");
        mod.updateValue(this.parentID, trigger);
        response = "ok";
        return response;
    }
    
    mod.updateAllValues = function(trigger) {
        $(mod.ip).each(function() {
            var controlID = $(this).attr("control-id");
            mod.updateValue(controlID, trigger);
        });
    }

    mod.updateValue = function(controlID, trigger) {
        var $ip = $(mod.ip+"[control-id='"+controlID+"']");
        var data = app.getControlData(mod.screen, controlID);
        var vals = data[mod.type].value.split(".");
        $ip.find("input").each(function(index) {
            $(this).val(vals[index]);
        });
        if( trigger==null || trigger==true ) {
            $(window).trigger("valueUpdated");
            $(mod.listbox).trigger(controlID+"ValueUpdated");
        }
    }
    
    mod.events = function() {
        $(mod.ip).find("input").on("change blur", function() {
            if( !$(this).hasClass("disabled") ) {
                var controlID = $(this).parents(mod.ip).attr("control-id");
                var data = app.getControlData(mod.screen, controlID);
                var vals = [];
                $(this).parents(mod.ip).find("input").each(function() {
                    vals.push($(this).val()); 
                });
                data[mod.type].updateValue(vals.join("."));
            }
        });
    }
    
    mod.getDom = function() {
        return $(mod.ip);
    }
    
    mod.getType = function() {
        return mod.type;
    }
    
}