var app = app || {};
var $_GET = {};

app.init = function () {

    app.checkParameters();
    app.height_win();
    app.select2();
    //app.btn_alert();
    app.selectb();
    app.fancybox();
    app.tabs();
    
    app.screen_init();
    app.checkValueChange();
}

app.screen_init = function() {
    
    var screenID = $("body").attr("screen-id");
    
    switch(screenID) {
        case "volume":
            var faders = new Faders("volume");
            var levels = new Levels("volume");
            var mutes = new Toggles("volume", "mute");
            var gains = new Spins("volume", "gain");
            faders.init();
            levels.init();
            mutes.init();
            gains.init();
            app.linkControls(faders, gains);
            app.volumeInit();
            break;
        case "EQ":
            var filter1 = new Listboxes("EQ", "filter1");
            var filter2 = new Listboxes("EQ", "filter2");
            var frequencies = new Spins("EQ", "frequency");
            var gains = new Spins("EQ", "gain");
            var qValues = new Spins("EQ", "q");
            filter1.init();
            filter2.init();
            frequencies.init();
            gains.init();
            qValues.init();
            app.eqInit();
            break;
        case "audio":
            var unit = new Toggles("audio", "unit");
            var coordinates = new Spins("audio", "coordinate");
            var depths = new Spins("audio", "depth");
            var sensing = new Listboxes("audio", "sensing");
            var mode = new Toggles("audio", "mode");
            var distance = new Spins("audio", "distance");
            var angle = new Spins("audio", "angle");
            var aec = new Toggles("audio", "aec");
            var nc = new Toggles("audio", "nc");
            var reductionLevel = new Listboxes("audio", "level");
            var nlplevel = new Listboxes("audio", "nlplevel");
            var micgain = new Listboxes("audio", "micgain");
            unit.init();
            coordinates.init();
            depths.init();
            sensing.init();
            mode.init();
            distance.init();
            angle.init();
            aec.init();
            nc.init();
            reductionLevel.init();
            nlplevel.init();
            micgain.init();
            app.audioInit();
            break;
        case "preset":
            var preset = new Listboxes("preset", "preset");
            preset.init();
            break;
    }
    
    var ipFields = new IPFields("config");
    var accountFields = new Textboxes("config", "text");
    var contactInput = new Listboxes("config", "input");
    var contactOutput = new Listboxes("config", "output");
    var indicateToggles = new Toggles("config", "onoff");
    var indicateMute = new Listboxes("config", "mute");
    var timeYears = new Spins("config", "year");
    var timeMonthes = new Spins("config", "month");
    var timeDays = new Spins("config", "day");
    var timeHours = new Spins("config", "hour");
    var timeMinutes = new Spins("config", "minute");
    var timeSeconds = new Spins("config", "second");
    ipFields.init();
    accountFields.init();
    contactInput.init();
    contactOutput.init();
    indicateToggles.init();
    indicateMute.init();
    timeYears.init();
    timeMonthes.init();
    timeDays.init();
    timeHours.init();
    timeMinutes.init();
    timeSeconds.init();
    app.configInit();
}

app.checkValueChange = function() {
    
    var valueChanged = false;
    var sendClicked = false;
    var changePage = false;
    
    var onleave = function() {
        if( valueChanged && !sendClicked ) {
            var conf = confirm("You don't send parameters. So parameters isn't saved.");
            if( !conf ) return false;
        }  
    }
    
    /*$(window).on("valueUpdated", function() {
        valueChanged = true;
    });
    $(".btn-send").on("click", function() {
        sendClicked = true; 
    });
    $(".change-page").on("click", function() {
        changePage = true;
        return onleave();
    });
    $(window).on("beforeunload", function() {
        if( !changePage ) return onleave();
        changePage = false;
    });*/
    
}

app.linkControls = function(control1, control2) {
    var screenID = $("body").attr("screen-id");
    var $dom1 = control1.getDom();
    var $dom2 = control2.getDom();
    var type1 = control1.getType();
    var type2 = control2.getType();
    var objects1 = app.getControls(screenID, type1);
    var objects2 = app.getControls(screenID, type2);
    objects1.forEach(function(control1) {
        $dom1.on(control1.parentID+"ValueUpdated", function() {
            objects2.forEach(function(control2) {
                if( control2.parentID==control1.parentID ) control2.updateValue(control1.value, false);
            });
        });
        $dom2.on(control1.parentID+"ValueUpdated", function() {
            objects2.forEach(function(control2) {
                if( control2.parentID==control1.parentID ) control1.updateValue(control2.value, false);
            });
        });
    });
    control1.updateAllValues();
    control2.updateAllValues();
}

app.addUpdateFunc = function(screenID, type, updateValueFunc, updateUnitFunc) {
    for(var cat in controls[screenID]) {
        for(var elem in controls[screenID][cat]) {
            if( Array.isArray(controls[screenID][cat][elem]) ) {
                var elems = controls[screenID][cat][elem];
                elems.forEach(function(control) {
                    for(var prop in control) {
                        if( prop==type ) {
                            control[prop].parentID = control.id;
                            control[prop].type = type;
                            control[prop].updateValue = updateValueFunc; 
                            if( updateUnitFunc!=null ) control[prop].updateUnit = updateUnitFunc; 
                        }
                    } 
                });
            }
            else {
                var control = controls[screenID][cat][elem];
                for(var prop in control) {
                    if( prop==type ) {
                        control[prop].parentID = control.id;
                        control[prop].type = type;
                        control[prop].updateValue = updateValueFunc; 
                        if( updateUnitFunc!=null ) control[prop].updateUnit = updateUnitFunc; 
                    }
                } 
            }
        }
    }
}

app.addLimitUpdateFunc = function(screenID, type, updateFunc) {
    limits[screenID][type].update = updateFunc;
}

app.getControls = function(screenID, type) {
    var objects = [];
    for(var cat in controls[screenID]) {
        for(var elem in controls[screenID][cat]) {
            if( Array.isArray(controls[screenID][cat][elem]) ) {
                var elements = controls[screenID][cat][elem];
                elements.forEach(function(control) {
                    if( type in control ) objects.push(control[type]);
                });
            }
            else {
                var control = controls[screenID][cat][elem];
                if( type in control ) objects.push(control[type]);
            }
        }
    }
    return objects;
}

app.getControlData = function(screenID, controlID) {
    var data = null;
    for(var cat in controls[screenID]) {
        for(var elem in controls[screenID][cat]) {
            if( Array.isArray(controls[screenID][cat][elem]) ) {
                var elements = controls[screenID][cat][elem];
                elements.forEach(function(control) {
                    if( control.id==controlID ) data = control;
                });
            }
            else {
                var control = controls[screenID][cat][elem];
                if( control.id==controlID ) data = control;
            }
        }
    }
    return data;
}

app.getControlParent = function(screenID, controlID) {
    var data = null;
    for(var cat in controls[screenID]) {
        for(var elem in controls[screenID][cat]) {
            if( Array.isArray(controls[screenID][cat][elem]) ) {
                var elements = controls[screenID][cat][elem];
                elements.forEach(function(control) {
                    if( control.id==controlID ) data = elements;
                });
            }
            else {
                var control = controls[screenID][cat][elem];
                if( control.id==controlID ) data = control;
            }
        }
    }
    return data;
}

app.getChildIndex = function(objects, controlID) {
    var index = -1;
    var found = false;
    var i = 0;
    while(!found && i<objects.length) {
        if( objects[i].id==controlID ) found = true;
        else i++;
    }
    if( found ) index = i;
    return index;
}

app.checkParameters = function() {
    $_GET = {};
    var hash = window.location.hash;
    var parts = window.location.search.substring(1).split("&");
    for (var i = 0; i < parts.length; i++) {
        var temp = parts[i].split("=");
        $_GET[decodeURIComponent(temp[0])] = decodeURIComponent(temp[1]);
    }
}

app.volumeInit = function() {
    
    var onMuteChange = function(controlID, object) {
        if( object.mute.value=="ON" ) {
            $(".slide[control-id='"+controlID+"']").addClass("disabled");
            $(".gain[control-id='"+controlID+"']").addClass("disabled");
            $(".gain[control-id='"+controlID+"']").find(".value .input").html("-∞");
        }
        else {
            $(".slide[control-id='"+controlID+"']").removeClass("disabled");
            $(".gain[control-id='"+controlID+"']").removeClass("disabled");
            $(".gain[control-id='"+controlID+"']").find(".value .input").html(object.gain.value);
        }
    }
    
    onMuteChange("input-usb", controls.volume.INPUT.USB);
    onMuteChange("input-bluetooth", controls.volume.INPUT.BLUETOOTH);
    onMuteChange("input-codec", controls.volume.INPUT.CODEC);
    onMuteChange("input-aux", controls.volume.INPUT.AUX);
    onMuteChange("output-sp", controls.volume.OUTPUT.SP);
    onMuteChange("output-usb", controls.volume.OUTPUT.USB);
    onMuteChange("output-bluetooth", controls.volume.OUTPUT.BLUETOOTH);
    onMuteChange("output-codec", controls.volume.OUTPUT.CODEC);
    onMuteChange("output-aux", controls.volume.OUTPUT.AUX);
    
    $(".mute").on("input-usbValueUpdated", function() {
        var object = controls.volume.INPUT.USB;
        onMuteChange("input-usb", object);
    });
    $(".mute").on("input-bluetoothValueUpdated", function() {
        var object = controls.volume.INPUT.BLUETOOTH;
        onMuteChange("input-bluetooth", object);
    });
    $(".mute").on("input-codecValueUpdated", function() {
        var object = controls.volume.INPUT.CODEC;
        onMuteChange("input-codec", object);
    });
    $(".mute").on("input-auxValueUpdated", function() {
        var object = controls.volume.INPUT.AUX;
        onMuteChange("input-aux", object);
    });
    $(".mute").on("output-spValueUpdated", function() {
        var object = controls.volume.OUTPUT.SP;
        onMuteChange("output-sp", object);
    });
    $(".mute").on("output-usbValueUpdated", function() {
        var object = controls.volume.OUTPUT.USB;
        onMuteChange("output-usb", object);
    });
    $(".mute").on("output-bluetoothValueUpdated", function() {
        var object = controls.volume.OUTPUT.BLUETOOTH;
        onMuteChange("output-bluetooth", object);
    });
    $(".mute").on("output-codecValueUpdated", function() {
        var object = controls.volume.OUTPUT.CODEC;
        onMuteChange("output-codec", object);
    });
    $(".mute").on("output-auxValueUpdated", function() {
        var object = controls.volume.OUTPUT.AUX;
        onMuteChange("output-aux", object);
    });
    
    $(".input .btn-reset").on("click", function() {
        controls.volume.INPUT.USB.gain.updateValue(0); 
        controls.volume.INPUT.BLUETOOTH.gain.updateValue(0); 
        controls.volume.INPUT.CODEC.gain.updateValue(0); 
        controls.volume.INPUT.AUX.gain.updateValue(0); 
        controls.volume.INPUT.USB.mute.updateValue("OFF");
        controls.volume.INPUT.BLUETOOTH.mute.updateValue("OFF"); 
        controls.volume.INPUT.CODEC.mute.updateValue("OFF"); 
        controls.volume.INPUT.AUX.mute.updateValue("OFF"); 
        //onMuteChange("input-usb", controls.volume.INPUT.USB);
        //onMuteChange("input-bluetooth", controls.volume.INPUT.BLUETOOTH);
        //onMuteChange("input-codec", controls.volume.INPUT.CODEC);
        //onMuteChange("input-aux", controls.volume.INPUT.AUX);
    });
    
    $(".output .btn-reset").on("click", function() {
        controls.volume.OUTPUT.SP.gain.updateValue(0); 
        controls.volume.OUTPUT.USB.gain.updateValue(0); 
        controls.volume.OUTPUT.BLUETOOTH.gain.updateValue(0); 
        controls.volume.OUTPUT.CODEC.gain.updateValue(0); 
        controls.volume.OUTPUT.AUX.gain.updateValue(0);
        controls.volume.OUTPUT.SP.mute.updateValue("OFF");
        controls.volume.OUTPUT.USB.mute.updateValue("OFF");
        controls.volume.OUTPUT.BLUETOOTH.mute.updateValue("OFF"); 
        controls.volume.OUTPUT.CODEC.mute.updateValue("OFF"); 
        controls.volume.OUTPUT.AUX.mute.updateValue("OFF"); 
        //onMuteChange("output-sp", controls.volume.OUTPUT.SP);
        //onMuteChange("output-usb", controls.volume.OUTPUT.USB);
        //onMuteChange("output-bluetooth", controls.volume.OUTPUT.BLUETOOTH);
        //onMuteChange("output-codec", controls.volume.OUTPUT.CODEC);
        //onMuteChange("output-aux", controls.volume.OUTPUT.AUX);
    });
    
}

app.eqInit = function() {
    
    if( $_GET["channel"] ) $(".channel-name").html($_GET["channel"]);
    
    var onFilter1Change = function() {
        var value = controls.EQ.FILTERS.filter1.filter1.value;
        if( value=="HPF" ) {
            $(".spin-btn[control-id='gain-1']").addClass("hidden");
            $(".spin-btn[control-id='q-1']").addClass("hidden");
        }
        else {
            $(".spin-btn[control-id='gain-1']").removeClass("hidden");
            $(".spin-btn[control-id='q-1']").removeClass("hidden");
        }
    }
    
    var onFilter2Change = function() {
        var value = controls.EQ.FILTERS.filter2.filter2.value;
        if( value=="LPF" ) {
            $(".spin-btn[control-id='gain-5']").addClass("hidden");
            $(".spin-btn[control-id='q-5']").addClass("hidden");
        }
        else {
            $(".spin-btn[control-id='gain-5']").removeClass("hidden");
            $(".spin-btn[control-id='q-5']").removeClass("hidden");
        }
    }
    
    onFilter1Change();
    onFilter2Change();
    $(".listbox").on("filter1ValueUpdated", onFilter1Change);
    $(".listbox").on("filter2ValueUpdated", onFilter2Change);
    
}

app.audioInit = function() {
    
    var onUnitUpdate = function() {
        var unit = controls.audio.TRACKING.measure.unit.value;
        if( unit=="inch" ) {
            $(".unit-base").html("20inch x 20inch");
        }
        else {
            $(".unit-base").html("50cm x 50cm");
        }
        controls.audio.TRACKING.coordinates[0].coordinate.updateUnit(unit);
        controls.audio.TRACKING.coordinates[1].coordinate.updateUnit(unit);
        controls.audio.TRACKING.depths[1].depth.updateUnit(unit);
        controls.audio.TRACKING.depths[0].depth.updateUnit(unit);
        controls.audio.DISTANCE.distance.distance.updateUnit(unit);
        var x1Index = limits.audio.coordinate.values.indexOf(controls.audio.TRACKING.coordinates[0].coordinate.value);
        var x2Index = limits.audio.coordinate.values.indexOf(controls.audio.TRACKING.coordinates[1].coordinate.value);
        var depthMaxIndex = limits.audio.depth.values.indexOf(controls.audio.TRACKING.depths[1].depth.value);
        var depthMinIndex = limits.audio.depth.values.indexOf(controls.audio.TRACKING.depths[0].depth.value);
        var distanceIndex = limits.audio.distance.values.indexOf(controls.audio.DISTANCE.distance.distance.value);
        limits.audio.coordinate.update(convertions.coor[unit]);
        limits.audio.depth.update(convertions.depth[unit]);
        limits.audio.distance.update(convertions.depth[unit]);
        var x1 = limits.audio.coordinate.values[x1Index];
        var x2 = limits.audio.coordinate.values[x2Index];
        var depthMin = limits.audio.depth.values[depthMinIndex];
        var depthMax = limits.audio.depth.values[depthMaxIndex];
        var depthMax = limits.audio.depth.values[depthMaxIndex];
        var depthMin = limits.audio.depth.values[depthMinIndex];
        var distance = limits.audio.distance.values[distanceIndex];
        controls.audio.TRACKING.coordinates[0].coordinate.updateValue(x1);
        controls.audio.TRACKING.coordinates[1].coordinate.updateValue(x2);
        if( unit=="inch" ) {
            controls.audio.TRACKING.depths[0].depth.updateValue(depthMin);
            controls.audio.TRACKING.depths[1].depth.updateValue(depthMax);
        }
        else{
            controls.audio.TRACKING.depths[1].depth.updateValue(depthMax);
            controls.audio.TRACKING.depths[0].depth.updateValue(depthMin);
        }
        controls.audio.DISTANCE.distance.distance.updateValue(distance);
    }
    
    var onModeUpdate = function() {
        var mode = controls.audio.MODE.mode.mode.value;
        if( mode=="Auto" ) {
            $(".dirdis").addClass("hidden");
            $(".wrap-frame .bar").addClass("hidden");
        }
        else {
            $(".dirdis").removeClass("hidden");
            $(".wrap-frame .bar").removeClass("hidden");
        }
    }
    
    var onGraphUpdate = function() {
        var $frame = $(".frame");
        var $square = $(".quares");
        var halfWidth = $frame.outerWidth()/2;
        var x1 = controls.audio.TRACKING.coordinates[0].coordinate.value;
        var x2 = controls.audio.TRACKING.coordinates[1].coordinate.value;
        var depthMin = controls.audio.TRACKING.depths[0].depth.value;
        var depthMax = controls.audio.TRACKING.depths[1].depth.value;
        var coorMaxVal = limits.audio.coordinate.values[limits.audio.coordinate.values.length-1];
        var depthMaxVal = limits.audio.depth.values[limits.audio.depth.values.length-1];
        var x1px = (x1 * halfWidth)/coorMaxVal;
        var left = halfWidth - x1px;
        var x2px = (x2 * halfWidth)/coorMaxVal;
        var width = x1px + x2px;
        var depthMinpx = (depthMin * $frame.outerHeight())/depthMaxVal;
        var depthMaxpx = (depthMax * $frame.outerHeight())/depthMaxVal;
        var top = depthMinpx; //changed
        var height = depthMaxpx - depthMinpx; //changed
        $square.css({
            left: left+"px",
            top: top+"px",
            width: width+"px",
            height: height+"px"
        });
    }
    
    var onBarUpdate = function() {
        var $frame = $(".frame");
        var $bar = $(".wrap-frame .bar");
        var dis = controls.audio.DISTANCE.distance.distance.value;
        var dir = controls.audio.ANGLE.angle.angle.value;
        var disMaxVal = limits.audio.distance.values[limits.audio.distance.values.length-1];
        var height = (dis*$frame.outerHeight())/disMaxVal;
        var rotate = "rotate3d(0, 0, 1, "+(-dir)+"deg)";
        $bar.css({
            "height": height+"px",
            "-webkit-transform": rotate, 
            "-moz-transform": rotate, 
            "-ms-transform": rotate, 
            "-o-transform": rotate, 
            "transform": rotate 
        });
    }
    
    onUnitUpdate();
    onModeUpdate();
    onGraphUpdate();
    onBarUpdate();
    $(".toggle-btn").on("tracking-measure-unitValueUpdated", onUnitUpdate);
    $(".toggle-btn").on("modeValueUpdated", onModeUpdate);
    $(".spin-btn").on("tracking-coordinates-x1ValueUpdated", onGraphUpdate);
    $(".spin-btn").on("tracking-coordinates-x2ValueUpdated", onGraphUpdate);
    $(".spin-btn").on("tracking-depth-minValueUpdated", onGraphUpdate);
    $(".spin-btn").on("tracking-depth-maxValueUpdated", onGraphUpdate);
    $(".spin-btn").on("distanceValueUpdated", onBarUpdate);
    $(".spin-btn").on("angleValueUpdated", onBarUpdate);
    
}

app.configInit = function() {
    
    var onChangeDate = function() {
        var year = controls.config.TIME.years.year.value;
        var month = controls.config.TIME.monthes.month.value;
        var day = controls.config.TIME.days.day.value;
        var limitDay = new Date(year, month, 0).getDate()
        limits.config.day.update({min: 1, max: limitDay, step: 1});
        if( day>limitDay ) controls.config.TIME.days.day.updateValue(limitDay);
    }
    $(".spin-btn").on("time-monthesValueUpdated", onChangeDate);
    $(".spin-btn").on("time-yearsValueUpdated", onChangeDate);
    
    var files = null;
    $("#file-7").on("change", function(e) {
        files = $(this)[0].files;
        if( files.length>0 ) $(".btn-send.update").removeClass("disabled");
        else $(".btn-send.update").addClass("disabled");
    });
    
    $(".btn-send.update").on("click", function() {
        if( files!=null ) {
            var filename = files[0].name;
            var ext = (/[.]/.exec(filename)) ? /[^.]+$/.exec(filename) : undefined;
            ext = ext[0];
            if( ext=="bin" ) alert("ok");
            else alert("Wrong file extension");
        }
    });
}

app.height_win = function() {

    $(window).on("load resize",function() {
        var height_h = $(window).height()-48;
        if($('.wrap-h').length > 0) {
            $('.wrap-h').css({'min-height':height_h});
        }
    });

}

app.select2 = function() {
    $(".select-bl").select2({
        minimumResultsForSearch: Infinity
    })
}

//app.btn_alert = function() {
//    $('.btn-alert').click(function(){
//        var text = $(this).attr('data-text');
//        confirm(text);
//    })
//}

app.selectb = function() {

    $('.select select[disabled]').parent().addClass('disabled');

    $('.w144').click(function(){
        $('.select2-container--open').addClass('select-open');
    })

    $('a.disabled').click(function(e){
        e.preventDefault();
    })

}

app.fancybox = function() {
    $('.fancybox').fancybox({
        padding: 0,
        autoScale: false,
        fitToView : false,
        helpers: {
        overlay: {
            locked: false
            }
        },
        tpl: {
            closeBtn: false,
        }
    });
}

app.tabs = function() {
    $('.tabs').each(function(){
        var $active, $content, $links = $(this).find('a');
        $active = $($links.filter('[href="'+location.hash+'"]')[0] || $links[0]);
        $active.addClass('active');
        $content = $($active.attr('href'));
        $links.not($active).each(function () {
            $($(this).attr('href')).hide();
        });
        $(this).on('click', 'a', function(e){
        $active.removeClass('active');
        $content.hide();
        $active = $(this);
        $content = $($(this).attr('href'));
        $active.addClass('active');
        $content.show();
        e.preventDefault();
        });
    });
}

$(function() {

    app.init();

});