//*voli_rdsd.js*//
var WS_URL = 'ws://' + NOW_IPADDRESS + ':8000';
var ws = new WebSocket(WS_URL);

ws.onerror = function () {
    alert('Failure to connect')
};


ws.onopen = function () {
    ws.send(
        'ud_state'
    );
    ws.send(
        ' read ' + ' config '
    );
    ws.send(
        ' read ' + ' audio '
    );
    ws.onmessage = function (e) {
        //arrayString =
        //0:type, 1:inch_or_cm, 2:X1,3:X2
        //4:Depth(min),5:Depth(max),
        //6:Sensing, 7:Mode,
        //8:dis, 9:dir,
        //10:AEC_on\off, 11:NC_on\off, 12:reduction
        var arrayString = e.data.split(",");
        if (arrayString[0] == 'dialog') {
            alert(arrayString[1])
        }
        else if (arrayString[0] == 'audio') {
            var DEF_INCH_DEPTH_MAX = 160
            controls.audio.TRACKING.measure.unit.updateValue(arrayString[1]); //str
            controls.audio.TRACKING.coordinates[0].coordinate.updateValue(arrayString[2]); //int
            controls.audio.TRACKING.coordinates[1].coordinate.updateValue(arrayString[3]); //int
            controls.audio.TRACKING.depths[1].depth.updateValue(arrayString[5]); //int max
            controls.audio.TRACKING.depths[0].depth.updateValue(arrayString[4]); //int min
            controls.audio.SENSING.sensing.sensing.updateValue(arrayString[6]); //str
            controls.audio.MODE.mode.mode.updateValue(arrayString[7]); //str
            controls.audio.DISTANCE.distance.distance.updateValue(arrayString[8]); //int
            controls.audio.ANGLE.angle.angle.updateValue(arrayString[9]); //int
            controls.audio.AEC.mode.aec.updateValue(arrayString[10]); //str
            controls.audio.NC.mode.nc.updateValue(arrayString[11]); //str
            controls.audio.NC.reduction.level.updateValue(arrayString[12]); //str
            controls.audio.AEC.nlplevel.nlplevel.updateValue(arrayString[13]); //str
            controls.audio.AEC.micgain.micgain.updateValue(arrayString[14]); //str

        } else if (arrayString[0] == 'config') {
            controls.config.NETWORK.ipfields[0].ip.updateValue(arrayString[1])
            controls.config.NETWORK.ipfields[1].ip.updateValue(arrayString[2])
            controls.config.NETWORK.ipfields[2].ip.updateValue(arrayString[3])
            controls.config.USER.username.text.updateValue(arrayString[4])
            controls.config.USER.password.text.updateValue(arrayString[5])

            if (arrayString[6] == 'Volume_Up') {
                controls.config.CONTACT.inputs[0].input.updateValue("Volume Up")
            } else if (arrayString[6] == 'Volume_Down') {
                controls.config.CONTACT.inputs[0].input.updateValue("Volume Down")
            } else {
                controls.config.CONTACT.inputs[0].input.updateValue(arrayString[6])
            }
            if (arrayString[7] == 'Volume_Up') {
                controls.config.CONTACT.inputs[1].input.updateValue("Volume Up")
            } else if (arrayString[7] == 'Volume_Down') {
                controls.config.CONTACT.inputs[1].input.updateValue("Volume Down")
            } else {
                controls.config.CONTACT.inputs[1].input.updateValue(arrayString[7])
            }

            if (arrayString[8] == 'Mute_Status') {
                controls.config.CONTACT.outputs[0].output.updateValue("Mute Status")
            } else if (arrayString[8] == 'Synch_Input1') {
                controls.config.CONTACT.outputs[0].output.updateValue("Synch Input1")
            } else if (arrayString[8] == 'Synch_Input2') {
                controls.config.CONTACT.outputs[0].output.updateValue("Synch Input2")
            } else {
                controls.config.CONTACT.outputs[0].output.updateValue(arrayString[8])
            }

            if (arrayString[9] == 'Mute_Status') {
                controls.config.CONTACT.outputs[1].output.updateValue("Mute Status")
            } else if (arrayString[9] == 'Synch_Input1') {
                controls.config.CONTACT.outputs[1].output.updateValue("Synch Input1")
            } else if (arrayString[9] == 'Synch_Input2') {
                controls.config.CONTACT.outputs[1].output.updateValue("Synch Input2")
            } else {
                controls.config.CONTACT.outputs[1].output.updateValue(arrayString[9])
            }

            controls.config.INDICATE.toggles[0].onoff.updateValue(arrayString[10])
            controls.config.INDICATE.toggles[1].onoff.updateValue(arrayString[11])
            if (arrayString[12] == 'Only_Center') {
                controls.config.INDICATE.mute.mute.updateValue("Only Center")
            } else if (arrayString[12] == 'ALL_LED') {
                controls.config.INDICATE.mute.mute.updateValue("ALL LED")
            }
            // Add CPU Version and DSP Version data
            document.getElementById("firm_version").textContent = arrayString[13];
            if (arrayString.length > 14){
                document.getElementById("os_nowtime").textContent = "Current Time of AM-CF1:  " +
                    arrayString[14] + "/" + arrayString[15] + "/" +
                    arrayString[16] + " " + arrayString[17] + ":" +
                    arrayString[18];
            }else{
                document.getElementById("os_nowtime").textContent = "Current Time of AM-CF1:  " +
                    "Failed to load.";
            }
        }
    }
}

$(function () {
    $('#audio_send').on('click', function () {
        //Sendボタンを押した時にwebsocketでサーバー側にデータを送信
        ws.send(
            ' send ' + ' audio ' +
            controls.audio.TRACKING.measure.unit.value + ' ' +
            controls.audio.TRACKING.coordinates[0].coordinate.value + ' ' +
            controls.audio.TRACKING.coordinates[1].coordinate.value + ' ' +
            controls.audio.TRACKING.depths[0].depth.value + ' ' +
            controls.audio.TRACKING.depths[1].depth.value + ' ' +
            controls.audio.SENSING.sensing.sensing.value + ' ' +
            controls.audio.MODE.mode.mode.value + ' ' +
            controls.audio.DISTANCE.distance.distance.value + ' ' +
            controls.audio.ANGLE.angle.angle.value + ' ' +
            controls.audio.AEC.mode.aec.value + ' ' +
            controls.audio.NC.mode.nc.value + ' ' +
            controls.audio.NC.reduction.level.value + ' ' +
            controls.audio.AEC.nlplevel.nlplevel.value + ' ' +
            controls.audio.AEC.micgain.micgain.value
        );
        // websokcet already close? readyState:2 closing, 3 closed
        if (ws.readyState == 3 || ws.readyState == 2) {
            alert('Failure to connect')
        }
    });
});

(function () {
    var ip_form = document.getElementById("ipchange")
    var config_down = document.getElementById("config_down")
    var div_ip = document.getElementById("ipaddress")
    

    ip_form.setAttribute("action", "http://" + NOW_IPADDRESS + "/ipchange.php");
    config_down.setAttribute("action", "http://" + NOW_IPADDRESS + "/config_download.php");
    div_ip.setAttribute("title", NOW_IPADDRESS);

})();

$(window).on('load resize', function () {
    var w = $(window).width();
    var x = 360;
    if (w <= x) {
        $('.btn-send.fixed').css({ 'position': 'fixed' });
        $('.btn-send.fixed').css({ 'left': '250px' });
    } else {
        $('.btn-send.fixed').css({ 'position': 'fixed' });
        $('.btn-send.fixed').css({ 'left': '' });
        $('.btn-send.fixed').css({ 'right': '10px' });
    }
});