//*voli_rdsd.js*//
var WS_URL = 'ws://' + NOW_IPADDRESS + ':8000';
var ws = new WebSocket(WS_URL);

ws.onerror = function () {
    alert('Failure to connect')
};

ws.onopen = function () {
    ws.send(
        ' insp ' + ' mic_level '
    );
    ws.send(
        ' insp ' + ' version '
    );
    ws.onmessage = function (e) {
        //arrayString =
        //0:type, 1:usbin_gain, 2:BTin_gain,
        //3:Codecin_gain, 4:AUXin_gain,
        //5:SPout_gain, 6:USBout_gain,
        //7:BT_gain, 8:Codecout_gain,
        //9:AUX_gain, 10～18:mute_sts*9 (0:ON 1:OFF)
        var LOOP = 100;
        var arrayString = e.data.split(",");
        if (arrayString[0] == "insp_miclevel") {
            $("#input_level01").val(arrayString[1])
            $("#input_level02").val(arrayString[2])
            $("#input_level03").val(arrayString[3])
            $("#input_level04").val(arrayString[4])
            $("#input_level05").val(arrayString[5])
            $("#input_level06").val(arrayString[6])
            $("#input_level07").val(arrayString[7])
            $("#input_level08").val(arrayString[8])
            $("#drc_gain").val(arrayString[9])
            $("#bf_status_x").val(arrayString[10])
            $("#bf_status_y").val(arrayString[11])

            let {r,theta} = Polar_Coordinates_Conv(parseFloat(arrayString[10]),parseFloat(arrayString[11]))

            angle = (180/Math.PI) * theta

            $("#bf_status_r").val(String(r.toFixed(2)))
            $("#bf_status_theta").val(String(angle.toFixed(2)))


            ws.send(
                ' insp ' + ' mic_level '
            );
        }
        else if (arrayString[0] == "insp_version") {
            $("#cpu_version").val(arrayString[1])
            $("#dsp_version").val(arrayString[2])
            $("#mac_addr").val(arrayString[3])
        }
    }
}

function Polar_Coordinates_Conv(x,y){
    //引数入力時、DSPのパラメータはx,yがテレコであることに注意
    r = 0;
    theta = 0;

    X = Math.pow(x,2);
    Y = Math.pow(y,2)

    r = Math.sqrt(X+Y);
    theta = Math.atan2(y,x);

    return {r, theta};

}