#!/bin/bash
#********************************************************************************
# Firmware Installer 
# 
# confirm update success or failed by touch file and rm file
# mkdir,filecopy process: to /home/toa/TOA_AM-CF1/ud_**
# process END: to /home/toa/TOA_AM-CF1_new/ud_**
#
# 2019/06/07
#********************************************************************************
#********************************************************************************
# function definition
#********************************************************************************
# copy to ROM as _new_broken and chmod
#  $1: src directory
#  $2: dst directory
#  $3: target directory name
#  $4: permission (i.e. 777)
function cp_new_broken () {
	srcdir=$1
	dstdir=$2
	target=$3
	permission=$4

	cp -a $srcdir/$target $dstdir/${target}_new_broken
	chmod -R $permission $dstdir/${target}_new_broken
}

# copy etc_new_broken
function cp_etc_new_broken () {
	cp_new_broken $directory "/home_org/toa" "etc" "777"
}

# copy etc_new_broken
function cp_boot_new_broken () {
	cp_new_broken $directory "/home_org/toa" "boot" "777"
}

# copy varwww_new_broken
function cp_varwww_new_broken () {
	cp_new_broken "$directory/var_www" "/var_org/www" "html" "777"
}

# copy TOA_AM-CF1_new_broken
function cp_TOA_AMCF1_new_broken () {
	cp_new_broken $directory "/home_org/toa" "TOA_AM-CF1" "777"
}

# copy StartupShell_new_broken
function cp_StartupShell_new_broken () {
	cp_new_broken $directory "/home_org/toa" "StartupShell" "777"
}

# DSP RESET
function DSP_Reset () {
	# DSP RESET(OFF->ON)
	sudo gpio -g mode 7 out
	sudo gpio -g write 7 0
	sleep 1
	sudo gpio -g write 7 1
}

## START ##
set -x
sudo mount -o remount,rw /

homedir=$(cd $(dirname $0); pwd)

DSP_Reset;
# WAIT DSP START
sleep 3

ret=$(sudo python3 ${homedir}/get_judge_dspversion.py)

# DSP RESET(OFF)
sudo gpio -g write 7 0

if [ $ret -eq 0 ]; then
	# New Firm Update
	## update status
	STATUS_NORMAL_BOOT=0
	STATUS_SUCCESS_UPDATE=1
	STATUS_FAILURE_CPU_UPDATE=2
	STATUS_FAILURE_DSP_UPDATE=3
	STATUS_DSP_1_0_0_0=4
	STATUS_UPDATE_START=5
	python3 ${homedir}/TOA_AM-CF1/Application/data/update_status_rewrite.py $STATUS_UPDATE_START

	#********************************************************************************
	# Unnecessary folder delete
	#********************************************************************************
	rm -rf /home/toa/TOA_AM-CF1_new
	rm -rf /home/toa/TOA_AM-CF1_new_broken
	rm -rf /home/toa/StartupShell_new
	rm -rf /home/toa/StartupShell_new_broken
	rm -rf /var/www/html_new
	rm -rf /var/www/html_new_broken
	rm -rf /home/toa/etc_new
	rm -rf /home/toa/etc_new_broken
	rm -rf /home/toa/boot_new
	rm -rf /home/toa/boot_new_broken
	rm -rf /home/toa/startup_firmupdate.sh
	rm -rf /home_org/toa/TOA_AM-CF1_new
	rm -rf /home_org/toa/TOA_AM-CF1_new_broken
	rm -rf /home_org/toa/StartupShell_new
	rm -rf /home_org/toa/StartupShell_new_broken
	rm -rf /var_org/www/html_new
	rm -rf /var_org/www/html_new_broken
	rm -rf /home_org/toa/etc_new
	rm -rf /home_org/toa/etc_new_broken
	rm -rf /home_org/toa/boot_new
	rm -rf /home_org/toa/boot_new_broken
	rm -rf /home_org/toa/startup_firmupdate.sh

	directory="/var/www/file/amcf1_installer"

	#********************************************************************************
	# Copy to the rom data
	#********************************************************************************
	echo "# File Copy to the rom data #";

	cp_etc_new_broken; sync;
	cp_boot_new_broken; sync;
	cp_varwww_new_broken; sync;
	cp_TOA_AMCF1_new_broken; sync;
	cp_StartupShell_new_broken; sync;

    # /var/www/file/amcf1_installer/home/toa/TOA_AM-CF1/Application/data/config/config_bt.jsonにMACアドレスを書き込む
    ret=$(sudo python3 ${homedir}/init_config_bt.py)

	# for inspection
	cp -R $directory/TOA_AM-CF1/Application/data/preset /home/toa/etc_new_broken
	cp -R $directory/TOA_AM-CF1/Application/data/config /home/toa/etc_new_broken
	cp -R $directory/TOA_AM-CF1/Application/data/preset /home_org/toa/etc_new_broken
	cp -R $directory/TOA_AM-CF1/Application/data/config /home_org/toa/etc_new_broken

	sync; sync; sync; sleep 3

	echo "# File Copy OK #";

	echo "# Folder Rename _new_broken -> _new #";

	#SATO_COMMENT orgにはnew_brokenを保存しないとだめ
	#mkdir -m 777 /home_org/toa/TOA_AM-CF1_new_broken 
	#mkdir -m 777 /home_org/toa/StartupShell_new_broken 
	#mkdir -m 777 /var_org/www/html_new_broken 
	#mkdir -m 777 /home_org/toa/etc_new_broken 
	#mkdir -m 777 /home_org/toa/boot_new_broken

	# copy _new_broken to _new
	cp -a /home_org/toa/TOA_AM-CF1_new_broken /home/toa/TOA_AM-CF1_new;
	cp -a /home_org/toa/StartupShell_new_broken /home/toa/StartupShell_new;
	cp -a /var_org/www/html_new_broken /var/www/html_new;
	cp -a /home_org/toa/boot_new_broken /home/toa/boot_new;

	cp -a /home_org/toa/TOA_AM-CF1_new_broken /home_org/toa/TOA_AM-CF1_new;
	cp -a /home_org/toa/StartupShell_new_broken /home_org/toa/StartupShell_new;
	cp -a /var_org/www/html_new_broken /var_org/www/html_new;
	cp -a /home_org/toa/boot_new_broken /home_org/toa/boot_new;
	sync; sync; sync; sleep 2

	#SATO_COMMENT etc_changeは最後にコピー
	cp -a /home_org/toa/etc_new_broken /home/toa/etc_new;

	cp -a /home_org/toa/etc_new_broken /home_org/toa/etc_new;
	sync; sync; sync; sleep 1

	# remove _new_broken from org
	rm -R /home_org/toa/TOA_AM-CF1_new_broken 
	rm -R /home_org/toa/StartupShell_new_broken 
	rm -R /var_org/www/html_new_broken 
	rm -R /home_org/toa/etc_new_broken 
	rm -R /home_org/toa/boot_new_broken

	rm -R /home/toa/TOA_AM-CF1_new_broken 
	rm -R /home/toa/StartupShell_new_broken 
	rm -R /var/www/html_new_broken 
	rm -R /home/toa/etc_new_broken 
	rm -R /home/toa/boot_new_broken

	sync; sync; sync; sleep 1

	echo "# Folder Rename _new_broken -> _new OK #";

	sudo mount -o remount,ro /

	#cp /home/toa/TOA_AM-CF1/install.log /home/toa/TOA_AM-CF1_new/install.log
else
	# 1.3.3.1 Firm Update
	#********************************************************************************
	# Unnecessary folder delete
	#********************************************************************************
	rm -rf /home/toa/TOA_AM-CF1_new
	rm -rf /home/toa/TOA_AM-CF1_new_broken
	rm -rf /home/toa/StartupShell_new
	rm -rf /home/toa/StartupShell_new_broken
	rm -rf /var/www/html_new
	rm -rf /var/www/html_new_broken
	rm -rf /home/toa/etc_new
	rm -rf /home/toa/etc_new_broken
	rm -rf /home/toa/boot_new
	rm -rf /home/toa/boot_new_broken
	rm -rf /home/toa/startup_firmupdate.sh
	rm -rf /home_org/toa/TOA_AM-CF1_new
	rm -rf /home_org/toa/TOA_AM-CF1_new_broken
	rm -rf /home_org/toa/StartupShell_new
	rm -rf /home_org/toa/StartupShell_new_broken
	rm -rf /var_org/www/html_new
	rm -rf /var_org/www/html_new_broken
	rm -rf /home_org/toa/etc_new
	rm -rf /home_org/toa/etc_new_broken
	rm -rf /home_org/toa/boot_new
	rm -rf /home_org/toa/boot_new_broken
	rm -rf /home_org/toa/startup_firmupdate.sh

	directory="/var/www/file/amcf1_installer/support_CPU_firmware"

	#********************************************************************************
	# Copy to the rom data
	#********************************************************************************
	echo "# File Copy to the rom data #";

	cp_etc_new_broken; sync;
	cp_boot_new_broken; sync;
	cp_varwww_new_broken; sync;
	cp_TOA_AMCF1_new_broken; sync;
	cp_StartupShell_new_broken; sync;
	
	# for inspection
	cp -R $directory/TOA_AM-CF1/Application/data/preset /home/toa/etc_new_broken
	cp -R $directory/TOA_AM-CF1/Application/data/config /home/toa/etc_new_broken
	cp -R $directory/TOA_AM-CF1/Application/data/preset /home_org/toa/etc_new_broken
	cp -R $directory/TOA_AM-CF1/Application/data/config /home_org/toa/etc_new_broken

	sync; sync; sync; sleep 3

	echo "# File Copy OK #";

	echo "# Folder Rename _new_broken -> _new #";

	#SATO_COMMENT orgにはnew_brokenを保存しないとだめ
	#mkdir -m 777 /home_org/toa/TOA_AM-CF1_new_broken 
	#mkdir -m 777 /home_org/toa/StartupShell_new_broken 
	#mkdir -m 777 /var_org/www/html_new_broken 
	#mkdir -m 777 /home_org/toa/etc_new_broken 
	#mkdir -m 777 /home_org/toa/boot_new_broken

	# copy _new_broken to _new
	cp -a /home_org/toa/TOA_AM-CF1_new_broken /home/toa/TOA_AM-CF1_new;
	cp -a /home_org/toa/StartupShell_new_broken /home/toa/StartupShell_new;
	cp -a /var_org/www/html_new_broken /var/www/html_new;
	cp -a /home_org/toa/boot_new_broken /home/toa/boot_new;

	cp -a /home_org/toa/TOA_AM-CF1_new_broken /home_org/toa/TOA_AM-CF1_new;
	cp -a /home_org/toa/StartupShell_new_broken /home_org/toa/StartupShell_new;
	cp -a /var_org/www/html_new_broken /var_org/www/html_new;
	cp -a /home_org/toa/boot_new_broken /home_org/toa/boot_new;
	sync; sync; sync; sleep 2

	#SATO_COMMENT etc_changeは最後にコピー
	cp -a /home_org/toa/etc_new_broken /home/toa/etc_new;

	cp -a /home_org/toa/etc_new_broken /home_org/toa/etc_new;
	sync; sync; sync; sleep 1

	# remove _new_broken from org
	rm -R /home_org/toa/TOA_AM-CF1_new_broken 
	rm -R /home_org/toa/StartupShell_new_broken 
	rm -R /var_org/www/html_new_broken 
	rm -R /home_org/toa/etc_new_broken 
	rm -R /home_org/toa/boot_new_broken

	rm -R /home/toa/TOA_AM-CF1_new_broken 
	rm -R /home/toa/StartupShell_new_broken 
	rm -R /var/www/html_new_broken 
	rm -R /home/toa/etc_new_broken 
	rm -R /home/toa/boot_new_broken

	sync; sync; sync; sleep 1

	echo "# Folder Rename _new_broken -> _new OK #";

	sudo mount -o remount,ro /

	#cp /home/toa/TOA_AM-CF1/install.log /home/toa/TOA_AM-CF1_new/install.log

fi