# -*- coding:utf-8 -*-
# -----------------------------------------
#DSPバージョン取得、1.0.0.0判定
#呼び元のシェルスクリプトの条件分岐に影響するため、新たにprint文を入れないでください。
import subprocess as sp
import json
import time

# Test: OK (version can be obtained, if remove dsp_version.json before open None will be printed) 2019/06/21 sato
def GetDspVersion():
    ret = None
    WORK_DIR = "/var/www/file/amcf1_installer/"
    try:
        #DSPバージョン取得、一時ファイル保存
        dsp_version_fname = WORK_DIR + "dsp_version.json"
        dsp_version_getter = WORK_DIR + "TOA_AM-CF1/dspversion/get_dspversion"
        sp.call(dsp_version_getter + " " + dsp_version_fname, shell=True)

        # ローカルJSONファイルの読み込み
        with open(dsp_version_fname, 'r') as f:
            DSP_version = json.load(f)
            #print(DSP_version)
            #ret = DSP_version['dsp_version']
            ret = DSP_version.get('dsp_version')
    except:
        ret = None

    return ret


def Get_Judge_Dspversion():
    result = 0

    #DSPのFWにより、新FWアップデートするか1.3.3.1にアップデートするか判断
    #return 0だと新FWにアップデート
    #return 1だと1.3.3.1にアップデート
    for i in range(10):
        dsp_version = GetDspVersion()
        if dsp_version is None:
            result = 1
        else:
            #DSP FW 1.0.0.0の場合も0.0.0.0を取得する。DSP通信に失敗した際も初期値0.0.0.0を取得する。
            if dsp_version == "0.0.0.0":
                result = 1
            #1度でもバージョン番号を取得できれば中断する
            else:
                result = 0
                break
        #FWが0.0.0.0であれば時間を空けてから取得する
        #500msecの10回リトライの計5秒以内にプリセットロード(2,3秒)などは終了するはず。
        time.sleep(0.5)

    return result


print(Get_Judge_Dspversion())