# -*- coding: utf-8 -*-
import sys
import json
import uuid
sys.path.append('/var/www/file/amcf1_installer/TOA_AM-CF1/Webserver/hello/')
import lbl_const as lbl

Config_PATH = '/var/www/file/amcf1_installer/TOA_AM-CF1/Application/data/config/'
config_bt_filename = Config_PATH + 'config_bt.json'

# MEMO : 量産モデルのmaster_data_const.pyから流用
# 概要   ："config_bt.json"のデフォルト値を返す
# 戻り値 ：デフォルト値情報
def GetDefault_Conf_Bluetooth():
    try:
        # MACアドレスをベースにデフォルト値を作成
        DEF_NAME = 'AM-CF1_{:04X}'.format(uuid.getnode() & 0xffff)
    except:
        # if dev_config.debug_trace:
        #     print("GetDefault_Conf_Bluetooth error.")
        DEF_NAME = 'AM-CF1'
    defs = [{
        lbl.LBL_BT :{
          lbl.LBL_BT_NAME :DEF_NAME,
        }}]
    return defs

# MEMO : config.pyから流用
def Update_Conf_Bluetooth(config_bt_filename, btname = None):
    configs_all = GetDefault_Conf_Bluetooth()
    if type(btname) is str:
        configs_all[0][lbl.LBL_BT][lbl.LBL_BT_NAME] = btname    #user
    with open(config_bt_filename, 'w') as f:
        json.dump(configs_all, f, indent=True, sort_keys=True)

# "AM-CF_(MACアドレス)"を初期値として書き込む
Update_Conf_Bluetooth(config_bt_filename, None)
