#include <iostream>
#include <stdint.h>
#include <picojson_misc.h>
#include "command_gain.h"
#include <dsp_lib/include/dsp/gain.h>
#include <spi/spi_api.h>
#include <control/misc.h>

using namespace std;

namespace control {

bool
CommandGain(
	picojson::object				&command_obj_,
	std::string						access_,
	dsp_lib::DspManager::NetList	netlist_
)
{
	//uint32_t config_base	= reinterpret_cast<uint32_t>(netlist_.config);
	uint32_t param_base		= reinterpret_cast<uint32_t>(netlist_.param);
	//uint32_t status_base	= reinterpret_cast<uint32_t>(netlist_.status);

	//dsp_lib::Gain::Config*	config_offset	= 0x00000000;
	dsp_lib::Gain::Param*	param_offset = 0x00000000;
	//dsp_lib::Gain::Status*	status_offset	= 0x00000000;

	if (access_ == "set") {
		// paramがないとエラー
		picojson::object param_obj;
		if (get_object_member(command_obj_, "param", param_obj) == false) {
			cout << "\"param\" not found!" << endl;
			return false;
		}

		if (param_obj.count("gain") == 1) {
			if (param_obj["gain"].is<double>() == false) {
				cout << "param.gain must be number!" << endl;
				return false;
			}

			float gain = ToAntiLog(static_cast<float>(param_obj["gain"].get<double>()));

			if (WriteSharedRam(param_base + ToDspAddressing(&param_offset->gain_target), gain) == false) {
				return false;
			}
		}
	}
	else if (access_ == "get") {
		// paramがなくてもOK
		if (command_obj_.count("param") == 1) {
			if (command_obj_["param"].is<picojson::object>() == false) {
				cout << "\"param\" must be object!" << endl;
			}
			picojson::object param_obj = command_obj_["param"].get<picojson::object>();

			if (param_obj.count("gain") == 1) {
				float gain;
				if (ReadSharedRam(param_base + ToDspAddressing(&param_offset->gain_target), &gain) == false) {
					cout << "read failed!" << endl;
					return false;
				}
				float gain_db = ToDb(gain);

				set_object_member(param_obj, "gain", gain_db);
				set_object_member(command_obj_, "param", param_obj);
			}
		}
	}
	else {
		cout << "invalid accessor!\n" << endl;
		return false;
	}
	command_obj_["result"] = static_cast<picojson::value>(true);
	return true;
}

} // namespace command
