#include <iostream>
#include <stdint.h>
#include <picojson_misc.h>
#include "command_nc.h"
#include <dsp_lib/include/dsp/nc.h>
#include <spi/spi_api.h>
#include <control/misc.h>

using namespace std;

namespace control {

bool
CommandNc(
	picojson::object				&command_obj_,
	std::string						access_,
	dsp_lib::DspManager::NetList	netlist_
)
{
	//uint32_t config_base	= reinterpret_cast<uint32_t>(netlist_.config);
	uint32_t param_base		= reinterpret_cast<uint32_t>(netlist_.param);
	//uint32_t status_base	= reinterpret_cast<uint32_t>(netlist_.status);

	//dsp_lib::Nc::Config*	config_offset	= 0x00000000;
	dsp_lib::Nc::Param*		param_offset	= 0x00000000;
	//dsp_lib::Nc::Status*	status_offset	= 0x00000000;

	if (access_ == "set") {
		// paramがないとエラー
		picojson::object param_obj;
		if (get_object_member(command_obj_, "param", param_obj) == false) {
			cout << "\"param\" not found!" << endl;
			return false;
		}

		if (param_obj.count("bypass") == 1) {
			if (param_obj["bypass"].is<bool>() == false) {
				cout << "param.bypass must be bool!" << endl;
				return false;
			}

			bool	 bypass = param_obj["bypass"].get<bool>();
			uint32_t bypass_uint32;

			if (bypass == true) {
				bypass_uint32 = 1;
			} else {
				bypass_uint32 = 0;
			}


			if (WriteSharedRam(param_base + ToDspAddressing(&param_offset->bypass), bypass_uint32) == false) {
				return false;
			}
		}
		if (param_obj.count("reduction_level") == 1) {
			if (param_obj["reduction_level"].is<double>() == false) {
				cout << "param.reduction_level must be number!" << endl;
				return false;
			}

			float reduction_level = static_cast<float>(param_obj["reduction_level"].get<double>());

			if (WriteSharedRam(param_base + ToDspAddressing(&param_offset->flr_db), reduction_level) == false) {
				return false;
			}
		}
	}
	else if (access_ == "get") {
		// paramがなくてもOK
		if (command_obj_.count("param") == 1) {
			if (command_obj_["param"].is<picojson::object>() == false) {
				cout << "\"param\" must be object!" << endl;
			}
			picojson::object param_obj = command_obj_["param"].get<picojson::object>();

			if (param_obj.count("bypass") == 1) {
				bool	 bypass;
				uint32_t bypass_uint32;
				if (ReadSharedRam(param_base + ToDspAddressing(&param_offset->bypass), &bypass_uint32) == false) {
					cout << "read failed!" << endl;
					return false;
				}
				if (bypass_uint32 == 0) {
					bypass = false;
				} else {
					bypass = true;
				}

				set_object_member(param_obj, "bypass", bypass);
			}
			if (param_obj.count("reduction_level") == 1) {
				float reduction_level;
				if (ReadSharedRam(param_base + ToDspAddressing(&param_offset->flr_db), &reduction_level) == false) {
					cout << "read failed!" << endl;
					return false;
				}

				set_object_member(param_obj, "reduction_level", reduction_level);
			}
			set_object_member(command_obj_, "param", param_obj);
		}
	}
	else {
		cout << "invalid accessor!\n" << endl;
		return false;
	}
	command_obj_["result"] = static_cast<picojson::value>(true);
	return true;
}

} // namespace command
