#include <iostream>
#include <fstream>
#include "read_command.h"

using namespace std;

namespace control {

void skip_utf8_bom(std::ifstream& fs) {
	int dst[3];
	for (auto& i : dst) i = fs.get();
	constexpr int utf8[] = { 0xEF, 0xBB, 0xBF };
	if (!std::equal(std::begin(dst), std::end(dst), utf8)) {
		fs.seekg(0);
	}
}

bool
ReadCommand(char *command_file_name_, picojson::array &command_array_)
{
	picojson::value command_val;

	{
		std::string filename = string(command_file_name_);
		//std::string	filename = "/home/garyh/1PUSW/AM-2/startup/block.json";
		ifstream ifs(filename);
		if (!ifs) {
			cout << "file: " << filename << " cannot be opened!" << endl;
			return false;
		}

		skip_utf8_bom(ifs);

		ifs >> command_val;
	}
	//cout << command_val.serialize(true) << endl;		// true: 整形あり

	if (command_val.is<picojson::array>() == false) {
		cout << "command must be array!" << endl;
		return false;
	}
	for (uint32_t command_no = 0; command_no < command_val.get<picojson::array>().size(); command_no++) {
		if (command_val.get<picojson::array>()[command_no].is<picojson::object>() == false) {
			cout << "command[" << command_no << "]: element must be object!" << endl;
			return false;
		}
	}

	command_array_ = command_val.get<picojson::array>();

	return true;
}

} // namespace control
