#include <string>
#include <iostream>
#include <fstream>
#include "read_netlist.h"

using namespace std;

namespace control {

bool
ReadNetlist(
	char*							netlist_file_name_, 
	dsp_lib::DspManager::NetList*	&netlists_,
	uint32_t						&number_of_netlist_
)
{
	std::string filename = string(netlist_file_name_);
	//std::string	filename = "/home/garyh/1PUSW/AM-2/startup/netlist.bin";
	ifstream ifs(filename, ios::binary);
	if (!ifs) {
		cout << "file: " << filename << " cannot be opened!" << endl;
		return false;
	}
	size_t filesize = (size_t)ifs.seekg(0, std::ios::end).tellg();
	ifs.seekg(0, std::ios::beg);	// ストリームのポインタを戻す

	number_of_netlist_ = filesize/sizeof(dsp_lib::DspManager::NetList);

	netlists_ = new dsp_lib::DspManager::NetList[number_of_netlist_];
	
	if (netlists_ == NULL) {
		return false;
	}

	ifs.read(reinterpret_cast<char*>(netlists_), filesize);

	return true;
}

} // namespace control
