# -*- coding:utf-8 -*-
import json
import subprocess as sp
import copy,sys
sys.path.append('/home/toa/TOA_AM-CF1/Webserver/hello/')
import def_block_no as BlockNo
from send_command import send_command
import math, time
import subprocess

command_file_name = '../../tmp/command_cf1_get_input_bf_level.json'
netlist_file_name = 'netlist.bin'
result_file_name = '../../tmp/result_get_input_bf_level.json'

# ---------------------------------------------------------
def Get_Bf_Level_in_init():
    # --- command.jsonを作成 ---
    #必要最小限のjsonに削減するため、config paramは省略
    command = {
        'access': 'get',
        'block_no': None,
        'type': 'peak',
        'status': {}
    }
    commands = [command.copy(), command.copy()]

    commands[0]['block_no'] = BlockNo.LEV_MIC
    commands[0]['status'] = {'level': None}
    commands[1]['block_no'] = BlockNo.BF
    commands[1]['type'] = 'microphonearray'
    commands[1]['status']['bf']= {'focus_x':None,'focus_y':None}

    with open('./' + command_file_name, 'w') as f:
        # 辞書型をjsonとして出力
        json.dump(commands, f, indent=True)

    #削除用のresult空ファイル作成（これがないと1回目のos.removeが通らない）
    with open('./' + result_file_name, 'w') as f:
        f.write(" ")

# ---------------------------------------------------------
def Get_Bf_Level_in():
    # --- control.out を実行 ---
    # --- control.out を実行 ---
    send_command(command_file_name, result_file_name)
    # --- result.json を読み込み ---
    with open('./' + result_file_name, 'r') as f:
        # jsonファイルを辞書型として読み込み
        result = json.load(f)

    if isinstance(result, list) is False:
        print('result.json must be array!')

    datas = []
    focus = []

    datas.append(result[0]['status']['level'])
    focus.append(result[1]['status']['bf']['focus_x'])
    focus.append(result[1]['status']['bf']['focus_y'])

    if float(focus[0]) < 0:
        focus[0] = float(focus[0]) * (-1)

    if (float(focus[1]) == 0):
        bf_LED_Num_curr = 3
    else:
        radian_v = math.atan(float(focus[0])/float(focus[1]))

        rad_tb = [0.0,
                -0.916298,
                -1.178097,
                -1.439897,
                1.439897,
                1.178097,
                0.916298,
                0.0]

        if(radian_v < rad_tb[0] and radian_v >= rad_tb[1]):
            bf_LED_Num_curr = 0
        elif(radian_v < rad_tb[1] and radian_v >= rad_tb[2]):
            bf_LED_Num_curr = 1
        elif(radian_v < rad_tb[2] and radian_v >= rad_tb[3]):
            bf_LED_Num_curr = 2
        elif(radian_v < rad_tb[3] or radian_v > rad_tb[4]):
            bf_LED_Num_curr = 3
        elif(radian_v < rad_tb[4] and radian_v >= rad_tb[5]):
            bf_LED_Num_curr = 4
        elif(radian_v < rad_tb[5] and radian_v >= rad_tb[6]):
            bf_LED_Num_curr = 5
        elif(radian_v < rad_tb[6] and radian_v > rad_tb[7]):
            bf_LED_Num_curr = 6

    datas.append(bf_LED_Num_curr)
    return datas
