# -*- coding:utf-8 -*-
import json
import subprocess as sp
import copy

# sp.run(['control.out', arg1, arg2, arg3])

command_file_name = 'command.json'
netlist_file_name = 'netlist.bin'
result_file_name = 'result.json'

# --- command.jsonを作成 ---

command = {
    'access': None,
    'block_no': None,
    'type': None,
    'config': {},
    'param': {},
    'status': {}
}

commands = []

for i in range(8):
    commands.append(copy.copy(command))

for i in range(8):
    commands[i]['access'] = 'get'
#    commands[i]['block_no'] = i
    commands[i]['type'] = 'peak'
    commands[i]['status'] = {'level': None}

commands[0]["block_no"] = 0
commands[1]["block_no"] = 2
commands[2]["block_no"] = 4
commands[3]["block_no"] = 6
commands[4]["block_no"] = 8
commands[5]["block_no"] = 10
commands[6]["block_no"] = 12
commands[7]["block_no"] = 14



with open('./' + command_file_name, 'w') as f:
    # 辞書型をjsonとして出力
    json.dump(commands, f, indent=True)

# --- control.out を実行 ---

sp.run(['./control.out', command_file_name, netlist_file_name, result_file_name])

# --- result.json を読み込み ---

with open('./' + result_file_name, 'r') as f:
    # jsonファイルを辞書型として読み込み
    result = json.load(f)

if isinstance(result, list) is False:
    print('result.json must be array!')

levels = []

for result_no, result_obj in enumerate(result):
    if 'type' in result_obj:
        if result_obj['type'] == 'peak':
            try:
                levels.append(result_obj['status']['level'])
            except KeyError:
                print('result[' + result_no + ']: invalid key!')

for level in levels:
    print(level)




