# -*- coding:utf-8 -*-
import json, copy, sys
sys.path.append('/home/toa/TOA_AM-CF1/Webserver/hello/')
import def_block_no as BlockNo
from send_command import send_command

command_sig_file_name = '../../tmp/command_cf1_set_input_gain.json'
command_gig_file_name = '../../tmp/command_cf1_get_input_gain.json'
command_sm_file_name = '../../tmp/command_cf1_set_mute.json'
result_gig_file_name = '../../tmp/result_get_input_gain.json'
result_sig_file_name = '../../tmp/result_set_input_gain.json'
result_sm_file_name = '../../tmp/result_set_mute.json'
# ---------------------------------------------------------
def Mute_Init():
    with open(result_gig_file_name, 'w') as f:
        f.write(" ")
    with open(result_sm_file_name, 'w') as f:
        f.write(" ")
    with open(result_sig_file_name, 'w') as f:
        f.write(" ")
    with open('result_get_all_gain_prev_standby.json', 'w') as f:
        f.write(" ")
    with open('result_set_mute_standby.json', 'w') as f:
        f.write(" ")
    with open('result_release_mute_standby.json', 'w') as f:
        f.write(" ")

    #--- Get input gain for array-microphone
    command = {
        'access': 'get',
        'block_no': BlockNo.GAIN_MIC,
        'type': 'gain',
        'param': { 'gain':None }
    }
    commands = []
    commands.append(copy.copy(command))

    with open(command_gig_file_name, 'w') as f:
        # jsonファイルを辞書型として読み込み
        json.dump(commands, f, indent=True)

    #--- Set mute for array-microphone
    command = {
        'access': 'set',
        'block_no': BlockNo.GAIN_MIC,
        'type': 'gain',
        'param': { 'gain':-100 }
    }
    commands = []
    commands.append(copy.copy(command))

    with open(command_sm_file_name, 'w') as f:
        # jsonファイルを辞書型として読み込み
        json.dump(commands, f, indent=True)

    #--- Set mute for standby mode
    for x in range(15):
        commands.append(copy.copy(command))
#    commands[0]["block_no"] = BlockNo.GAIN_MIC
    commands[1]["block_no"] = BlockNo.GAIN_USBinL
    commands[2]["block_no"] = BlockNo.GAIN_USBinR
    commands[3]["block_no"] = BlockNo.GAIN_CODECin
    commands[4]["block_no"] = BlockNo.GAIN_BTinL
    commands[5]["block_no"] = BlockNo.GAIN_BTinR
    commands[6]["block_no"] = BlockNo.GAIN_AUXinL
    commands[7]["block_no"] = BlockNo.GAIN_AUXinR
    commands[8]["block_no"] = BlockNo.GAIN_CODECout
    commands[9]["block_no"] = BlockNo.GAIN_USBoutR
    commands[10]["block_no"] = BlockNo.GAIN_AUXoutR
    commands[11]["block_no"] = BlockNo.GAIN_SPoutR
    commands[12]["block_no"] = BlockNo.GAIN_SPoutL
    commands[13]["block_no"] = BlockNo.GAIN_AUXoutL
    commands[14]["block_no"] = BlockNo.GAIN_USBoutL
    commands[15]["block_no"] = BlockNo.GAIN_BToutL
    with open('command_cf1_set_mute_standby.json', 'w') as f:
        json.dump(commands, f, indent=True)

    #--- Get input & output gain before enter standby mode
    for x in range(16):
        commands[x]['access'] = 'get'
        commands[x]['param']['gain'] = None

    with open('command_cf1_get_all_gain_prev_standby.json', 'w') as f:
        json.dump(commands, f, indent=True)

# ---------------------------------------------------------
def Set_Mute():
    # --- save previous input gain ---
    send_command(command_gig_file_name, result_gig_file_name)
    # --- execute mute ---
    send_command(command_sm_file_name, result_sig_file_name)
# ---------------------------------------------------------
def Release_Mute():
    with open('./' + result_gig_file_name, 'r') as f:
        try:
            result = json.load(f)
            if isinstance(result, list) is False:
                print('result.json must be array!')
            result[0]['access'] = 'set'
            with open('./' + command_sig_file_name, 'w') as f:
                json.dump(result, f, indent=True)
            send_command(command_sig_file_name, result_sig_file_name)
        except:
            print("Mute file Load Failure...")
# ---------------------------------------------------------
def Set_Mute_for_StandbyMode():
    # --- save previous input & output gain ---
    send_command('command_cf1_get_all_gain_prev_standby.json', 'result_get_all_gain_prev_standby.json')
    # --- execute mute ---
    send_command('command_cf1_set_mute_standby.json', 'result_set_mute_standby.json')
# ---------------------------------------------------------
def Release_Mute_from_StandbyMode():
    with open('./result_get_all_gain_prev_standby.json', 'r') as f:
        result = json.load(f)
    if isinstance(result, list) is False:
        print('result.json must be array!')
    for x in range(16):
        result[x]['access'] = 'set'
    with open('./command_cf1_release_mute_standby.json', 'w') as f:
        json.dump(result, f, indent=True)
    send_command('command_cf1_release_mute_standby.json', 'result_release_mute_standby.json')
