/*
 * main.cpp
 */

//********************************************************************************
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <spi/spi_driver.h>
#include <unistd.h>
#include <cmath>

//********************************************************************************
#if 0
static const uint32_t	DEV_NUM = 0;		// soundbase ADSP-A
#else
static const uint32_t	DEV_NUM = 1;		// soundbase ADSP-B
#endif

//********************************************************************************
int main()
{
	//----------------------------------------
	uint32_t	address = 0x000e0538;		// microphonearray.status
	float		source_pos_x, source_pos_y;

	//----------------------------------------
	while (1) {
		if (SpiRead(address + 4, (uint32_t*)&source_pos_x, DEV_NUM) == false) {
			printf("main: SPI xfr error : RETURN = ERROR\n");
			return 1;
		}
		if (SpiRead(address + 5, (uint32_t*)&source_pos_y, DEV_NUM) == false) {
			printf("main: SPI xfr error : RETURN = ERROR\n");
			return 1;
		}
		if (std::isnan(source_pos_x)) {
			printf("\rx: NaN       , ");
		}
		else {
			printf("\rx: %6.3f [m], ", source_pos_x);
		}
		if (std::isnan(source_pos_y)) {
			printf("y: NaN       ");
		}
		else {
			printf("y: %6.3f [m] ", source_pos_y);
		}
		usleep(100000);
		fflush(stdout);
	}
	printf("\n");

	//----------------------------------------
	printf("main: RETURN = OK\n");
	return 0;
}
