/************************************************************************
 *
 *	coeff_xover_linkwitzriley.c
 *
 *	20020925	Tsuyoshi Ogawa
 *
 ************************************************************************/

#include "fdesign_prototypes.h"

/*============================================================*/
#define	COEFF_XOVER_LR_ALPHA		1.0f

/*--------------------------------------------------------------------------------*/
#define	COEFF_XOVER_LR12_Q			0.5f
#define	COEFF_XOVER_LR24_Q			(1.0f/1.4142f)

namespace dsp_lib {

/*============================================================*/
void
Fdesign_XOverLPF_LR12(
	float	f_,
	int		bypass_,
	float	*coeff1_,
	float	*coeff2_
)
{
	Fdesign_XOverLPF12(f_, COEFF_XOVER_LR12_Q, COEFF_XOVER_LR_ALPHA, bypass_, coeff1_);
	Fdesign_Through(coeff2_);
}

void
Fdesign_XOverLPF_LR24(
	float	f_,
	int		bypass_,
	float	*coeff1_,
	float	*coeff2_
)
{
	Fdesign_XOverLPF12(f_, COEFF_XOVER_LR24_Q, COEFF_XOVER_LR_ALPHA, bypass_, coeff1_);
	Fdesign_XOverLPF12(f_, COEFF_XOVER_LR24_Q, COEFF_XOVER_LR_ALPHA, bypass_, coeff2_);
}

/*--------------------------------------------------------------------------------*/
void
Fdesign_XOverHPF_LR12(
	float	f_,
	int		bypass_,
	float	*coeff1_,
	float	*coeff2_
)
{
	Fdesign_XOverHPF12(f_, COEFF_XOVER_LR12_Q, COEFF_XOVER_LR_ALPHA, bypass_, coeff1_);
	Fdesign_Through(coeff2_);
}

void
Fdesign_XOverHPF_LR24(
	float	f_,
	int		bypass_,
	float	*coeff1_,
	float	*coeff2_
)
{
	Fdesign_XOverHPF12(f_, COEFF_XOVER_LR24_Q, COEFF_XOVER_LR_ALPHA, bypass_, coeff1_);
	Fdesign_XOverHPF12(f_, COEFF_XOVER_LR24_Q, COEFF_XOVER_LR_ALPHA, bypass_, coeff2_);
}
/*============================================================*/
} // namespace dsp_lib
