/*
 * dsp_map.cpp
 *
 *  Created on: 2016/09/26
 *      Author: toa29548
 */

#include <stdint.h>
#include <stddef.h>
//#include <heapnew>
#include "map.h"
//#include <dsp_ctrl/dsp_heap_sharedram.h>
//#include <shared/heap_id.h>
#include "read_input_file.h"

using namespace shared;
using namespace dsp_lib;

namespace dsp_ctrl {
// ひとまず*_size, number_of_* は固定値を設定

/* --- Shared RAM --- */
// ----- MAP
//uint32_t*			g_map = reinterpret_cast<uint32_t*>(MAP_ADDRESS);
uint32_t*			g_map;

// ----- DspManager

DspManager::Config*		g_dsp_manager_config;
DspManager::Param*		g_dsp_manager_param;
DspManager::Status*		g_dsp_manager_status;
DspManager::NetList*	g_dsp_manager_net_list;

// ----- NUMBER_OF_IO
//uint32_t*					g_number_of_adat_in;
//uint32_t*					g_number_of_adat_out;
//uint32_t*					g_number_of_dante_in;
//uint32_t*					g_number_of_dante_out;

uint32_t*					g_number_of_ad_1;
uint32_t*					g_number_of_ad_2;
uint32_t*					g_number_of_cpu_in;
uint32_t*					g_number_of_da_1;
uint32_t*					g_number_of_da_2;
uint32_t*					g_number_of_cpu_out;

uint32_t*					g_number_of_mic;
uint32_t*					g_number_of_usb_in;
uint32_t*					g_number_of_codec_in;
uint32_t*					g_number_of_bt_in;
uint32_t*					g_number_of_aux_in;
uint32_t*					g_number_of_sp_out;
uint32_t*					g_number_of_usb_out;
uint32_t*					g_number_of_codec_out;
uint32_t*					g_number_of_aux_out;

bool
AllocateMemory(void)
{
#if 0
	/* SharedRAM上にヒープ確保 */
	InitializeHeapSharedRam();
#else
	/* ローカルRAM上にヒープ確保 */
	if (InitializeLocalHeap() == false) {
		return false;
	}
#endif
	/* DSP MANAGER */
	g_dsp_manager_config		= MALLOC_SHAREDRAM_DM(DspManager::Config,	1);
	g_dsp_manager_param			= MALLOC_SHAREDRAM_DM(DspManager::Param,	1);
	g_dsp_manager_status		= MALLOC_SHAREDRAM_DM(DspManager::Status,	1);
	g_dsp_manager_net_list		= MALLOC_SHAREDRAM_DM(DspManager::NetList,	g_number_of_netlist);

	/* I/O */
	//g_number_of_adat_in			= MALLOC_SHAREDRAM_DM(uint32_t,	1);
	//g_number_of_adat_out		= MALLOC_SHAREDRAM_DM(uint32_t,	1);
	//g_number_of_dante_in		= MALLOC_SHAREDRAM_DM(uint32_t,	1);
	//g_number_of_dante_out		= MALLOC_SHAREDRAM_DM(uint32_t,	1);

	//*g_number_of_adat_in		= NUMBER_OF_ADAT_IN;
	///*g_number_of_adat_out		= NUMBER_OF_ADAT_OUT;
	//*g_number_of_dante_in		= NUMBER_OF_DANTE_IN;
	//*g_number_of_dante_out		= NUMBER_OF_DANTE_OUT;


	g_number_of_ad_1			= MALLOC_SHAREDRAM_DM(uint32_t,	1);
	g_number_of_ad_2			= MALLOC_SHAREDRAM_DM(uint32_t,	1);
	g_number_of_cpu_in			= MALLOC_SHAREDRAM_DM(uint32_t,	1);
	g_number_of_da_1			= MALLOC_SHAREDRAM_DM(uint32_t,	1);
	g_number_of_da_2			= MALLOC_SHAREDRAM_DM(uint32_t,	1);
	g_number_of_cpu_out			= MALLOC_SHAREDRAM_DM(uint32_t,	1);

	g_number_of_mic				= MALLOC_SHAREDRAM_DM(uint32_t,	1);
	g_number_of_usb_in			= MALLOC_SHAREDRAM_DM(uint32_t,	1);
	g_number_of_codec_in		= MALLOC_SHAREDRAM_DM(uint32_t,	1);
	g_number_of_bt_in			= MALLOC_SHAREDRAM_DM(uint32_t,	1);
	g_number_of_aux_in			= MALLOC_SHAREDRAM_DM(uint32_t,	1);
	g_number_of_sp_out			= MALLOC_SHAREDRAM_DM(uint32_t,	1);
	g_number_of_usb_out			= MALLOC_SHAREDRAM_DM(uint32_t,	1);
	g_number_of_codec_out		= MALLOC_SHAREDRAM_DM(uint32_t,	1);
	g_number_of_aux_out			= MALLOC_SHAREDRAM_DM(uint32_t,	1);
	
	*g_number_of_ad_1			= NUMBER_OF_AD_1;
	*g_number_of_ad_2			= NUMBER_OF_AD_2;
	*g_number_of_cpu_in			= NUMBER_OF_CPU_IN;
	*g_number_of_da_1			= NUMBER_OF_DA_1;
	*g_number_of_da_2			= NUMBER_OF_DA_2;
	*g_number_of_cpu_out		= NUMBER_OF_CPU_OUT;

	*g_number_of_mic			= NUMBER_OF_MIC;
	*g_number_of_usb_in			= NUMBER_OF_USB_IN;
	*g_number_of_codec_in		= NUMBER_OF_CODEC_IN;
	*g_number_of_bt_in			= NUMBER_OF_BT_IN;
	*g_number_of_aux_in			= NUMBER_OF_AUX_IN;
	*g_number_of_sp_out			= NUMBER_OF_SP_OUT;
	*g_number_of_usb_out		= NUMBER_OF_USB_OUT;
	*g_number_of_codec_out		= NUMBER_OF_CODEC_OUT;
	*g_number_of_aux_out		= NUMBER_OF_AUX_OUT;

#if 0
	/* MATRIX */
	g_number_of_matrix			= NUMBER_OF_MATRIX;
	g_number_of_matrix_input	= NUMBER_OF_MATRIX_INPUT;
	g_number_of_matrix_output	= NUMBER_OF_MATRIX_OUTPUT;
	g_matrix_config				= MALLOC_SHAREDRAM_DM(Matrix::Config,	g_number_of_matrix);
	g_matrix_param				= MALLOC_SHAREDRAM_DM(Matrix::Param,	g_number_of_matrix);
	g_matrix_param_gain_target	= MALLOC_SHAREDRAM_DM(float, 			g_number_of_matrix_input * g_number_of_matrix_output);
//	g_matrix_status				= MALLOC_SHAREDRAM_DM(Matrix::Status,	g_number_of_matrix);

	/* GAIN */
	g_number_of_gain			= NUMBER_OF_GAIN;
//	g_gain_config				= MALLOC_SHAREDRAM_DM(Gain::Config,	g_number_of_gain);
	g_gain_param				= MALLOC_SHAREDRAM_DM(Gain::Param, 	g_number_of_gain);
//	g_gain_status				= MALLOC_SHAREDRAM_DM(Gain::Status,	g_number_of_gain);

	/* IIR */

	// 任意の個数を設定
	g_number_of_iir 		= NUMBER_OF_IIR;
	g_number_of_iir_stage	= MALLOC_SHAREDRAM_DM(uint32_t, g_number_of_iir);	// sharedRAMでなくてもよいが、この時点でnewは使えないのでとりあえず。

	// 任意のステージ数を設定
	for (int iir_no = 0; iir_no < g_number_of_iir; iir_no++) {
		g_number_of_iir_stage[iir_no] = NUMBER_OF_IIR_STAGE;
	}

	// ステージ数の合計を計算
	g_number_of_iir_stage_total = 0;
	for (int iir_no = 0; iir_no < g_number_of_iir; iir_no++) {
		g_number_of_iir_stage_total += g_number_of_iir_stage[iir_no];
	}

	g_iir_config				= MALLOC_SHAREDRAM_DM(Iir::Config,			g_number_of_iir);
	g_iir_param					= MALLOC_SHAREDRAM_DM(Iir::Param, 			g_number_of_iir);
	g_iir_param_coef			= MALLOC_SHAREDRAM_PM(Iir::IirCoef pm, 		g_number_of_iir_stage_total);
	g_iir_param_coef_group		= MALLOC_SHAREDRAM_DM(Iir::IirCoef pm *, 	g_number_of_iir);
//	g_iir_status				= MALLOC_SHAREDRAM_DM(Iir::Status,			g_number_of_iir);

	// IIRブロックごとに、係数ベクトルの先頭番地を求める
	g_iir_param_coef_group[0] = &g_iir_param_coef[0];
	for (int iir_no = 1; iir_no < g_number_of_iir; iir_no++) {
		g_iir_param_coef_group[iir_no] = g_iir_param_coef_group[iir_no - 1] + g_number_of_iir_stage[iir_no - 1];
	}

	/* Peak */
	g_number_of_peak			= NUMBER_OF_PEAK;
//	g_peak_config				= MALLOC_SHAREDRAM_DM(Peak::Config,	g_number_of_peak);
//	g_peak_param				= MALLOC_SHAREDRAM_DM(Peak::Param,	g_number_of_peak);
	g_peak_status				= MALLOC_SHAREDRAM_DM(Peak::Status,	g_number_of_peak);

	/* Rms */
	g_number_of_rms				= NUMBER_OF_RMS;
//	g_rms_config				= MALLOC_SHAREDRAM_DM(Rms::Config,	g_number_of_rms);
//	g_rms_param					= MALLOC_SHAREDRAM_DM(Rms::Param,	g_number_of_rms);
	g_rms_status				= MALLOC_SHAREDRAM_DM(Rms::Status,	g_number_of_rms);

	/* Comp */
	g_number_of_comp			= NUMBER_OF_COMP;
//	g_comp_config				= MALLOC_SHAREDRAM_DM(Comp::Config,	g_number_of_comp);
	g_comp_param				= MALLOC_SHAREDRAM_DM(Comp::Param,	g_number_of_comp);
	g_comp_status				= MALLOC_SHAREDRAM_DM(Comp::Status,	g_number_of_comp);

	/* Gate */
	g_number_of_gate			= NUMBER_OF_GATE;
//	g_gate_config				= MALLOC_SHAREDRAM_DM(Gate::Config,	g_number_of_gate);
	g_gate_param				= MALLOC_SHAREDRAM_DM(Gate::Param,	g_number_of_gate);
	g_gate_status				= MALLOC_SHAREDRAM_DM(Gate::Status,	g_number_of_gate);

	/* Delay */
	g_number_of_delay			= NUMBER_OF_DELAY;
	g_delay_config				= MALLOC_SHAREDRAM_DM(Delay::Config,	g_number_of_delay);
	g_delay_param				= MALLOC_SHAREDRAM_DM(Delay::Param,		g_number_of_delay);
//	g_delay_status				= MALLOC_SHAREDRAM_DM(Delay::Status,	g_number_of_delay);

	/* Aec */
	g_number_of_aec				= NUMBER_OF_AEC;
//	g_aec_config				= MALLOC_SHAREDRAM_DM(Aec::Config,	g_number_of_aec);
	g_aec_param					= MALLOC_SHAREDRAM_DM(Aec::Param,	g_number_of_aec);
//	g_aec_status				= MALLOC_SHAREDRAM_DM(Aec::Status,	g_number_of_aec);

	/* Nc */
	g_number_of_nc				= NUMBER_OF_NC;
//	g_nc_config					= MALLOC_SHAREDRAM_DM(Nc::Config,	g_number_of_nc);
	g_nc_param					= MALLOC_SHAREDRAM_DM(Nc::Param,	g_number_of_nc);
//	g_nc_status					= MALLOC_SHAREDRAM_DM(Nc::Status,	g_number_of_nc);

	/* Microphonearray */
	g_number_of_microphonearray			= NUMBER_OF_MICROPHONEARRAY;
	g_number_of_microphonearray_input	= NUMBER_OF_MICROPHONEARRAY_INPUT;
	g_microphonearray_config			= MALLOC_SHAREDRAM_DM(Microphonearray::Config,	g_number_of_microphonearray);
	g_microphonearray_param				= MALLOC_SHAREDRAM_DM(Microphonearray::Param,	g_number_of_microphonearray);
	g_microphonearray_status			= MALLOC_SHAREDRAM_DM(Microphonearray::Status,	g_number_of_microphonearray);
	g_microphonearray_sensor_pos_y		= MALLOC_SHAREDRAM_DM(float,					g_number_of_microphonearray * g_number_of_microphonearray_input);
	g_doa_config						= MALLOC_SHAREDRAM_DM(Doa::Config,				g_number_of_microphonearray);
	g_bf_config							= MALLOC_SHAREDRAM_DM(Bf::Config,				g_number_of_microphonearray);
	g_bf_config_subarray_ch				= MALLOC_SHAREDRAM_DM(Bf::SubarrayCh,			g_number_of_microphonearray);

	/* heap残量確認 */
	//GetHeapSharedRamUnused();
#endif
	return true;
}

void
ConfigureVariableMap(void)
{
	g_map = reinterpret_cast<uint32_t*>(g_local_heap_address_map);

	g_map[MAP_NO_DSP_MANAGER_CONFIG]		= reinterpret_cast<uint32_t>(g_dsp_manager_config);
	g_map[MAP_NO_DSP_MANAGER_PARAM]			= reinterpret_cast<uint32_t>(g_dsp_manager_param);
	g_map[MAP_NO_DSP_MANAGER_STATUS]		= reinterpret_cast<uint32_t>(g_dsp_manager_status);

	//g_map[MAP_NO_NUMBER_OF_ADAT_IN]			= reinterpret_cast<uint32_t>(g_number_of_adat_in);
	//g_map[MAP_NO_NUMBER_OF_ADAT_OUT]		= reinterpret_cast<uint32_t>(g_number_of_adat_out);
	//g_map[MAP_NO_NUMBER_OF_DANTE_IN]		= reinterpret_cast<uint32_t>(g_number_of_dante_in);
	//g_map[MAP_NO_NUMBER_OF_DANTE_OUT]		= reinterpret_cast<uint32_t>(g_number_of_dante_out);
	
	g_map[MAP_NO_NUMBER_OF_AD_1]			= reinterpret_cast<uint32_t>(g_number_of_ad_1);
	g_map[MAP_NO_NUMBER_OF_AD_2]			= reinterpret_cast<uint32_t>(g_number_of_ad_2);
	g_map[MAP_NO_NUMBER_OF_DA_1]			= reinterpret_cast<uint32_t>(g_number_of_da_1);
	g_map[MAP_NO_NUMBER_OF_DA_2]			= reinterpret_cast<uint32_t>(g_number_of_da_2);

	g_map[MAP_NO_NUMBER_OF_CPU_IN]			= reinterpret_cast<uint32_t>(g_number_of_cpu_in);
	g_map[MAP_NO_NUMBER_OF_CPU_OUT]			= reinterpret_cast<uint32_t>(g_number_of_cpu_out);
	
	g_map[MAP_NO_NUMBER_OF_MIC]				= reinterpret_cast<uint32_t>(g_number_of_mic);
	g_map[MAP_NO_NUMBER_OF_USB_IN]			= reinterpret_cast<uint32_t>(g_number_of_usb_in);
	
	g_map[MAP_NO_NUMBER_OF_CODEC_IN]		= reinterpret_cast<uint32_t>(g_number_of_codec_in);
	g_map[MAP_NO_NUMBER_OF_BT_IN]			= reinterpret_cast<uint32_t>(g_number_of_bt_in);
	g_map[MAP_NO_NUMBER_OF_AUX_IN]			= reinterpret_cast<uint32_t>(g_number_of_aux_in);
	g_map[MAP_NO_NUMBER_OF_SP_OUT]			= reinterpret_cast<uint32_t>(g_number_of_sp_out);
	
	g_map[MAP_NO_NUMBER_OF_USB_OUT]			= reinterpret_cast<uint32_t>(g_number_of_usb_out);
	g_map[MAP_NO_NUMBER_OF_CODEC_OUT]		= reinterpret_cast<uint32_t>(g_number_of_codec_out);
	g_map[MAP_NO_NUMBER_OF_AUX_OUT]			= reinterpret_cast<uint32_t>(g_number_of_aux_out);
	
}

} // namespace dsp_ctrl
