#pragma warning(disable:4996)
#include <stdint.h>
#include <stdio.h>
#include <string>
#include <iostream>
#include <shared/shared_ram.h>
#include "simulated_malloc.h"
#include "access_sharedram.h"

using namespace std;

namespace dsp_ctrl {

bool
DumpLocalRam(void)
{
	FILE *fp;
	std::string filename = "./log_localram.txt";
	if ((fp = fopen(filename.c_str(), "w")) == NULL) {
		cout << "file open error: " << filename << endl;
		return false;
	}

	for (int i = 0; i < SHAREDRAM_LENGTH; i++) {
		uint32_t*	address = reinterpret_cast<uint32_t*>(g_local_heap_address_base) + i;
		uint32_t	data    = *address;
		if ((i % 4) == 0) {
			fprintf(fp, "\n0x%08x", reinterpret_cast<uint32_t>(address));
		}
		fprintf(fp, " %08x", data);

	}
	fclose(fp);
	return true;
}

bool
DumpSharedRam(void)
{
	FILE *fp;
	std::string filename = "./log_sharedram.txt";
	if ((fp = fopen(filename.c_str(), "w")) == NULL) {
		cout << "file open error: " << filename << endl;
		return false;
	}

	for (int i = 0; i < SHAREDRAM_LENGTH; i++) {
		uint32_t	address = GetSharedRamAddress(g_local_heap_address_base) + i;
		uint32_t	data;
		if (ReadSharedRam(address, &data) == false) {
			cout << "DumpSharedRam is failed!" << endl;
			fclose(fp);
			return false;
		}
		if ((i % 4) == 0) {
			fprintf(fp, "\n0x%08x", address);
		}
		fprintf(fp, " %08x", data);
	}
	fclose(fp);
	return true;
}

bool
MemoryDump(void)
{
	if (DumpLocalRam() == false) {
		return false;
	}
	if (DumpSharedRam() == false) {
		return false;
	}
	return true;
}

} // namespace dsp_ctrl