#include <fstream>
#include <iostream>
#include <string>
#include "dsp_ctrl/map.h"
//#include "file_io/read_file.h"
#include <picojson.h>
#include <algorithm>
#include <codecvt>

void skip_utf8_bom(std::ifstream& fs) {
    int dst[3];
    for (auto& i : dst) i = fs.get();
    constexpr int utf8[] = { 0xEF, 0xBB, 0xBF };
    if (!std::equal(std::begin(dst), std::end(dst), utf8)) {
		fs.seekg(0);
	}
}

namespace dsp_ctrl {

uint32_t g_number_of_netlist;

bool
ReadInputFile(
	char *block_file_name_, 
	picojson::array& block_cfg_array_
)
{
	using namespace std;

	std::string filename = string(block_file_name_);
	//std::string	filename = "/home/garyh/1PUSW/AM-2/startup/block.cfg";

	ifstream ifs(filename);
	if (!ifs) {
		cout << "file: " << filename << " cannot be opened!" << endl;
		return false;
	}

	skip_utf8_bom(ifs);

	picojson::value block_cfg_val;
	ifs >> block_cfg_val;
	//cout << block_cfg_val.serialize(true) << endl;		// true: 整形あり

	if (block_cfg_val.is<picojson::array>() == false) {
		cout << "input must be array!" << endl;
		return false;
	}

	block_cfg_array_ = block_cfg_val.get<picojson::array>();

	g_number_of_netlist = block_cfg_array_.size();

	return true;
}

} // namespace dsp_ctrl
