/*
 * dsp_map_no.h
 *
 *  Created on: 2016/10/27
 *      Author: toa29548
 */

#pragma once

#include "shared_ram.h"

namespace shared {

#define MAP_POINT(type, no)	(reinterpret_cast<type>(g_map[no]))

#ifndef	MAP_BLOCK
#define	MAP_BLOCK(block_, no_)		(4*(block_) + (no_))
#endif

enum MAP_NO {
	// メモリダンプ時の視認性を考慮して、アドレス4個を1ブロックとみなす

	MAP_NO_DSP_MANAGER_CONFIG		= MAP_BLOCK(0, 0),
	MAP_NO_DSP_MANAGER_PARAM		= MAP_BLOCK(0, 1),
	MAP_NO_DSP_MANAGER_STATUS		= MAP_BLOCK(0, 2),

    //MAP_NO_NUMBER_OF_ADAT_IN        = MAP_BLOCK(1, 0),
    //MAP_NO_NUMBER_OF_ADAT_OUT       = MAP_BLOCK(1, 1),
    //MAP_NO_NUMBER_OF_DANTE_IN       = MAP_BLOCK(1, 2),
    //MAP_NO_NUMBER_OF_DANTE_OUT      = MAP_BLOCK(1, 3),
    
    MAP_NO_NUMBER_OF_AD_1			= MAP_BLOCK(1, 0),
	MAP_NO_NUMBER_OF_AD_2			= MAP_BLOCK(1, 1),
	MAP_NO_NUMBER_OF_CPU_IN			= MAP_BLOCK(1, 2),
	MAP_NO_NUMBER_OF_DA_1			= MAP_BLOCK(1, 3),

	MAP_NO_NUMBER_OF_DA_2			= MAP_BLOCK(2, 0),
	MAP_NO_NUMBER_OF_CPU_OUT		= MAP_BLOCK(2, 1),
	MAP_NO_NUMBER_OF_MIC			= MAP_BLOCK(2, 2),
	MAP_NO_NUMBER_OF_USB_IN			= MAP_BLOCK(2, 3),
	
	MAP_NO_NUMBER_OF_CODEC_IN		= MAP_BLOCK(3, 0),
	MAP_NO_NUMBER_OF_BT_IN			= MAP_BLOCK(3, 1),
	MAP_NO_NUMBER_OF_AUX_IN			= MAP_BLOCK(3, 2),
	MAP_NO_NUMBER_OF_SP_OUT			= MAP_BLOCK(3, 3),
	
	MAP_NO_NUMBER_OF_USB_OUT		= MAP_BLOCK(4, 0),
	MAP_NO_NUMBER_OF_CODEC_OUT		= MAP_BLOCK(4, 1),
	MAP_NO_NUMBER_OF_AUX_OUT		= MAP_BLOCK(4, 2)

};

} // namespace dsp
