#pragma once

#include "spi_driver.h"

#if 1
#define SPI_DEV_NUM	(0)		// soundbase ADSP-A
#else
#define SPI_DEV_NUM	(1)		// soundbase ADSP-B
#endif

template <typename T_TYPE>
bool
WriteSharedRam(
	uint32_t	shared_ram_address_,
	T_TYPE		data_
)
{
	if (SpiWrite(shared_ram_address_, *reinterpret_cast<uint32_t*>(&data_), SPI_DEV_NUM) == false) {
		printf("WriteSharedRam: SPI xfr error : RETURN = ERROR\n");
		return false;
	}
	return true;
}

template <typename T_TYPE>
bool
ReadSharedRam(
	uint32_t	shared_ram_address_,
	T_TYPE*		data_
)
{
	if (SpiRead(shared_ram_address_, reinterpret_cast<uint32_t*>(data_), SPI_DEV_NUM) == false) {
		printf("ReadSharedRam: SPI xfr error : RETURN = ERROR\n");
		return false;
	}
	return true;
}