import json
import collections as cl
import re
import sys
import subprocess as sp
import copy
import os, time
import numpy as np

from hello.send_command import send_command
import hello.def_block_no as BlockNo

# Countermeasure for continuous hits of APPLY button
g_mic_level_flag = False

#--------------------------------------------------------------------#
def Get_Mic_Level(data,thisNAME_PATH):
    global g_mic_level_flag
    if g_mic_level_flag==True:
        #print('G_LEVEL ->',g_mic_level_flag) #kura DEBUG
        return
    g_mic_level_flag=True

    PATH = os.path.join(thisNAME_PATH, '../../tmp/')
    netlist_file_name = thisNAME_PATH + 'netlist.bin'
    control_out = thisNAME_PATH + 'control.out'

    command_file_name = PATH + '/command/mic_level.json'
    result_file_name = PATH + '/result/mic_level.json'

    blocknums = [
        BlockNo.RAW_LEV_MIC1,BlockNo.RAW_LEV_MIC2,BlockNo.RAW_LEV_MIC3,BlockNo.RAW_LEV_MIC4,
        BlockNo.RAW_LEV_MIC5,BlockNo.RAW_LEV_MIC6,BlockNo.RAW_LEV_MIC7,BlockNo.RAW_LEV_MIC8
        ]
    # if 'get' then L and R gain ( because L!=R )

    # --- command.jsonを作成 ---
    command = {
        'access': 'get',
        'block_no': None,
        'type': 'peak',
        'status': {'level':None}
        }

    commands = []

    for i in range(0,len(blocknums)):
        commands.append(copy.copy(command))
        commands[i]['block_no'] = blocknums[i]
    
    with open(command_file_name, 'w') as f:
        # 辞書型をjsonとして出力
        json.dump(commands, f, indent=True)

    #print('SEND START')
    # --- control.out を実行 ---
    mic_level = [0,0,0,0,0,0,0,0] #マイク数8 先に0dBを代入
    st_time = time.perf_counter()
    cnt = 0
    diff_time = 0
    while diff_time <= 1.0:
        send_command(command_file_name,result_file_name)
        #print('SEND END')
        with open(result_file_name, "r") as file:
            ws_send_rdata = json.load(file)
        
        for i in range(0,len(blocknums)) :
            mic_level[i] = mic_level[i] + float(ws_send_rdata[i]["status"]["level"])
            #print(str(float(ws_send_rdata[i]["status"]["level"])))
        
        ed_time = time.perf_counter()
        diff_time = ed_time - st_time
        cnt = cnt + 1

    #print('mic level get ->', ed_time - st_time)

    ws_send_data = []
    ws_send_data.append("insp_miclevel")
    for i in range(0,len(blocknums)) :
        ws_send_data.append(str("{0:4.1f}".format(mic_level[i]/cnt)))

    ws_send = ",".join(ws_send_data)

    g_mic_level_flag=False

    return ws_send
