import json
import collections as cl
import re
import sys
import subprocess as sp
import copy
import os, time
import numpy as np

from hello.send_command import send_command
from hello.make_json_load import Make_Json_For_Load
from hello.check_preset_config import Check_Preset_Data
import hello.def_block_no as BlockNo

# Countermeasure for continuous hits of APPLY button
s_dp_flag = False
g_dp_flag = False
now_load_flag = False
now_store_flag = False
now_reset_flag = False

def Set_Default_Preset(data,thisNAME_PATH):
    global s_dp_flag
    if s_dp_flag==True:
        #print(s_dp_flag) #kura DEBUG
        return
    s_dp_flag=True

    Preset_org_PATH = '/home_org/toa/TOA_AM-CF1/Application/data/'
    Preset_PATH = '/home/toa/TOA_AM-CF1/Application/data/'
    default_org_presetNo_fname = Preset_org_PATH + 'preset/preset_defNo.txt'
    default_presetNo_fname = Preset_PATH + 'preset/preset_defNo.txt'

    with open(default_presetNo_fname,'w') as f:
        f.write(data[2])

    RWMOUNT = sp.Popen("sudo mount -o remount,rw /", shell=True)
    RWMOUNT.wait()
    cmd = "cp " + default_presetNo_fname + " " + default_org_presetNo_fname
    COPY = sp.Popen(cmd, shell=True)
    COPY.wait()
    ROMOUNT = sp.Popen("sudo mount -o remount,ro /", shell=True)
    ROMOUNT.wait()

    ws_send_data = []

    ws_send_data.append('preset')
    ws_send_data.append('df')
    ws_send_data.append(data[2])

    ws_send = ",".join(ws_send_data)
    s_dp_flag=False
    return ws_send

def Get_Default_Preset(data,thisNAME_PATH):
    global g_dp_flag
    if g_dp_flag==True:
        #print(g_dp_flag) #kura DEBUG
        return
    g_dp_flag=True

    PATH = os.path.join(thisNAME_PATH, '../../tmp/')
    default_presetNo_fname = thisNAME_PATH + 'preset/preset_defNo.txt'
    preset_nowloadNo_fname = thisNAME_PATH + 'preset/preset_nowloadNo.txt'

    ws_send_data = []

    ws_send_data.append('preset')
    ws_send_data.append('df')

    with open(default_presetNo_fname,'r') as f:
        df = f.read()
    ws_send_data.append(df.strip())

    with open(preset_nowloadNo_fname,'r') as f:
        nf = f.read()
    ws_send_data.append(nf.strip())

    ws_send = ",".join(ws_send_data)
    g_dp_flag=False
    return ws_send

#######################################################################3
def Save_Preset(data,thisNAME_PATH):
    global now_store_flag
    #if now_store_flag==True:
    #    print(now_store_flag) #kura DEBUG
    #    return
    #now_store_flag=True

    PATH = os.path.join(thisNAME_PATH, '../../tmp/')
    # which presetNo save?
    if data[2] == 'p1':
        preset_no = 1
    elif data[2] == 'p2':
        preset_no = 2

    Preset_org_PATH = '/home_org/toa/TOA_AM-CF1/Application/data/'
    Preset_PATH = '/home/toa/TOA_AM-CF1/Application/data/'

    Preset_def_txt_aec_nc = Preset_PATH + './preset/preset0_aec_nc.txt'
    Preset_def_txt_iir = Preset_PATH + './preset/preset0_iir.txt'
    Preset_def_txt_gain = Preset_PATH + './preset/preset0_gain.txt'
    Preset_org_txt_aec_nc = Preset_org_PATH + './preset/preset' + str(preset_no) + '_aec_nc.txt'
    Preset_org_txt_iir = Preset_org_PATH + './preset/preset' + str(preset_no) + '_iir.txt'
    Preset_org_txt_gain = Preset_org_PATH + './preset/preset' + str(preset_no) + '_gain.txt'
    Preset_txt_aec_nc = Preset_PATH + './preset/preset' + str(preset_no) + '_aec_nc.txt'
    Preset_txt_iir = Preset_PATH + './preset/preset' + str(preset_no) + '_iir.txt'
    Preset_txt_gain = Preset_PATH + './preset/preset' + str(preset_no) + '_gain.txt'

    ################# Get json for preset & Write preset file #################
    ### 1: Audio_Setting (aec,nc,microphonearray) ###
    command_file_name = PATH + '/command/pre_audio.json'
    result_file_name = PATH + '/result/pre_audio.json'

    audio_setting_conf_file_name = PATH + '/audio/audio_set_conf.txt'

    blocknums = [BlockNo.BF,BlockNo.AEC,BlockNo.NC] # modify 20181119

    AEC_bln = blocknums[1]
    NC_bln = blocknums[2]
    MIC_bln = blocknums[0]
    # if 'get' then L gain only ( because L=R )

    # --- command.jsonを作成 ---
    command = {
        'access': 'get',
        'block_no': None,
        'type': None,
        'param': {}
    }

    commands = []

    for i in range(0,len(blocknums)):
        commands.append(copy.copy(command))
        commands[i]['block_no'] = blocknums[i]

    commands[0]['type'] = 'microphonearray'
    commands[1]['type'] = 'aec'
    commands[2]['type'] = 'nc'

    commands[0]['param'] = {'dir':None,'dis':None,'update_mode':None}
    commands[0]['param']['doa']= {'peak_threshold':None,'smooth_tc':None,'source_pos_x_max':None,'source_pos_y_max':None,'source_pos_x_min':None,'source_pos_y_min':None}
    commands[1]['param'] = {'on':None}
    commands[2]['param'] = {'bypass':None,'reduction_level':None}

    with open(command_file_name, 'w') as f:
        # 辞書型をjsonとして出力
        json.dump(commands, f, indent=True)

    # --- control.out を実行 ---
    if send_command(command_file_name,result_file_name) == -1:
        now_store_flag = False
        ws_send = "dialog,DSP error"
        return ws_send

    with open(result_file_name, "r") as file:
        ws_send_rdata = json.load(file)

    with open(audio_setting_conf_file_name, 'r') as f:
        conf_data = f.read()
        confs = conf_data.strip().split(',')

    #inch or cm
    inch_or_cm = confs[0]
    direct = round(float(ws_send_rdata[0]['param']['dir']))

    X1 = round(float(ws_send_rdata[0]['param']['doa']['source_pos_y_min']),1)
    X2 = round(float(ws_send_rdata[0]['param']['doa']['source_pos_y_max']),1)
    depth_min = round(float(ws_send_rdata[0]['param']['doa']['source_pos_x_min']),1)
    depth_max = round(float(ws_send_rdata[0]['param']['doa']['source_pos_x_max']),1)
    dis = round(float(ws_send_rdata[0]['param']['dis']),1)

    #SENSING
    if round(float(ws_send_rdata[0]['param']['doa']['peak_threshold'])) == -13:
        SENSING = 'LOW'
    elif round(float(ws_send_rdata[0]['param']['doa']['peak_threshold'])) == -15:
        SENSING = 'MID'
    elif round(float(ws_send_rdata[0]['param']['doa']['peak_threshold'])) == -20:
        SENSING = 'HIGH'

    if ws_send_rdata[0]['param']['update_mode'] == 'auto':
        update_mode = "auto"
    else:
        update_mode = "manual"

    if ws_send_rdata[1]['param']['on'] == True:
        AEC_onoff = "true"
    else:
        AEC_onoff = "false"

    if ws_send_rdata[2]['param']['bypass'] == False:
        NC_onoff = "false"
    else:
        NC_onoff = "true"

    reduction_level = round(float(ws_send_rdata[2]['param']['reduction_level']))
    peak_threshold = round(float(ws_send_rdata[0]['param']['doa']['peak_threshold']))
    smooth_tc = round(float(ws_send_rdata[0]['param']['doa']['smooth_tc']),1)

    if os.path.exists(Preset_txt_aec_nc) == True:
        with open(Preset_def_txt_aec_nc, 'r') as f:
            Pre_Preset_AEC_NC = f.readlines()
    else:
        ws_send = 'dialog,System error (file not found)'
        now_store_flag=False
        return ws_send

    New_Preset_AEC_NC = []

    #if len(Pre_Preset_AEC_NC) != 8:
    #    ws_send = 'dialog,Invalid file. Check file settings.'
    #    now_store_flag=False
    #    return ws_send

    with open(Preset_txt_aec_nc, 'w') as f:
        for i in range(0,len(Pre_Preset_AEC_NC)):
            New_Preset_AEC_NC.append(Pre_Preset_AEC_NC[i].strip().split(','))
            ## AEC ##
            if i == 1:
                AEC_data = New_Preset_AEC_NC[i]
                AEC_data[1] = AEC_onoff
                New_Preset_AEC_NC[i] = ",".join(AEC_data)
            ## NC ##
            elif i == 3:
                NC_data = New_Preset_AEC_NC[i]
                NC_data[1] = str(NC_onoff)
                NC_data[2] = str(reduction_level)
                New_Preset_AEC_NC[i] = ",".join(NC_data)
            ## microphonearray ##
            elif i == 5:
                MIC_data = New_Preset_AEC_NC[i]
                MIC_data[1] = str(direct)
                MIC_data[2] = str(dis)
                MIC_data[3] = update_mode
                MIC_data[4] = str(peak_threshold)
                MIC_data[5] = str(smooth_tc)
                MIC_data[6] = str(depth_min)
                MIC_data[7] = str(depth_max)
                MIC_data[8] = str(X1)
                MIC_data[9] = str(X2)
                New_Preset_AEC_NC[i] = ",".join(MIC_data)
            ##conf (inch,sensing)
            elif i == 7:
                Conf_data = New_Preset_AEC_NC[i]
                Conf_data[0] = inch_or_cm
                Conf_data[1] = SENSING
                New_Preset_AEC_NC[i] = ",".join(Conf_data)
            else:
                New_Preset_AEC_NC[i] = ",".join(New_Preset_AEC_NC[i])
            f.write(str(New_Preset_AEC_NC[i]))
            f.write("\n")

    ######### 1-2: EQ_Setting (iir) ##########
    blocknums = [BlockNo.EQ_SPoutL,BlockNo.EQ_SPoutR]
    EQSP_setting_param_file_name = PATH + '/EQ/EQSP_set_param.txt'
    blocknums = [BlockNo.EQ_AUXoutL,BlockNo.EQ_AUXoutR]
    EQAUX_setting_param_file_name = PATH + '/EQ/EQAUX_set_param.txt'

    with open(EQSP_setting_param_file_name,'r') as f:
        ws_send_rdata = f.readlines()
        re_SP_typevals = ws_send_rdata[0].strip().split(',')
        re_SP_freqvals = ws_send_rdata[1].strip().split(',')
        re_SP_qvals = ws_send_rdata[2].strip().split(',')
        re_SP_gainvals = ws_send_rdata[3].strip().split(',')

    with open(EQAUX_setting_param_file_name,'r') as f:
        ws_send_rdata = f.readlines()
        re_AUX_typevals = ws_send_rdata[0].strip().split(',')
        re_AUX_freqvals = ws_send_rdata[1].strip().split(',')
        re_AUX_qvals = ws_send_rdata[2].strip().split(',')
        re_AUX_gainvals = ws_send_rdata[3].strip().split(',')

    if os.path.exists(Preset_txt_iir) == True:
        with open(Preset_def_txt_iir, 'r') as f:
            Pre_Preset_IIR = f.readlines()
    else:
        ws_send = 'dialog,System error (file not found)'
        now_store_flag=False
        return ws_send

    New_Preset_IIR = []

    #if len(Pre_Preset_IIR) != 77:
    #    ws_send = 'dialog,Invalid file. Check file settings.'
    #    now_store_flag=False
    #    return ws_send

    cnt1 = 0
    cnt2 = 0
    cnt3 = 0
    cnt4 = 0
    with open(Preset_txt_iir, 'w') as f:
        for i in range(0,len(Pre_Preset_IIR)):
            New_Preset_IIR.append(Pre_Preset_IIR[i].strip().split(','))
            ## SP L ##
            if New_Preset_IIR[i][0] == str(BlockNo.EQ_SPoutL) and int(New_Preset_IIR[i][1]) <= 4:
                IIR_data = New_Preset_IIR[i]
                IIR_data[2] = re_SP_typevals[cnt1]
                IIR_data[3] = re_SP_freqvals[cnt1]
                IIR_data[4] = re_SP_qvals[cnt1]
                IIR_data[5] = re_SP_gainvals[cnt1]
                New_Preset_IIR[i] = ",".join(IIR_data)
                cnt1 = cnt1 + 1
            ## SP R ##
            elif New_Preset_IIR[i][0] == str(BlockNo.EQ_SPoutR) and int(New_Preset_IIR[i][1]) <= 4:
                IIR_data = New_Preset_IIR[i]
                IIR_data[2] = re_SP_typevals[cnt2]
                IIR_data[3] = re_SP_freqvals[cnt2]
                IIR_data[4] = re_SP_qvals[cnt2]
                IIR_data[5] = re_SP_gainvals[cnt2]
                New_Preset_IIR[i] = ",".join(IIR_data)
                cnt2 = cnt2 + 1

            ## AUX L ##
            elif New_Preset_IIR[i][0] == str(BlockNo.EQ_AUXoutL) and int(New_Preset_IIR[i][1]) <=4:
                IIR_data = New_Preset_IIR[i]
                IIR_data[2] = re_AUX_typevals[cnt3]
                IIR_data[3] = re_AUX_freqvals[cnt3]
                IIR_data[4] = re_AUX_qvals[cnt3]
                IIR_data[5] = re_AUX_gainvals[cnt3]
                New_Preset_IIR[i] = ",".join(IIR_data)
                cnt3 = cnt3 + 1

            ## AUX R ##
            elif New_Preset_IIR[i][0] == str(BlockNo.EQ_AUXoutR) and int(New_Preset_IIR[i][1]) <=4:
                IIR_data = New_Preset_IIR[i]
                IIR_data[2] = re_AUX_typevals[cnt4]
                IIR_data[3] = re_AUX_freqvals[cnt4]
                IIR_data[4] = re_AUX_qvals[cnt4]
                IIR_data[5] = re_AUX_gainvals[cnt4]
                New_Preset_IIR[i] = ",".join(IIR_data)
                cnt4 = cnt4 + 1
            else:
                New_Preset_IIR[i] = ",".join(New_Preset_IIR[i])
            f.write(str(New_Preset_IIR[i]))
            f.write("\n")

    ######## 3: Volume_Setting (gain) ########
    mute_sts_file_name = PATH + 'volume/mute_sts.txt'
    command_file_name = PATH + 'command/pre_volume.json'
    result_file_name = PATH + 'result/pre_volume.json'
    web_sp_gain_file_name = PATH + 'volume/web_SPgain_sts.txt'
    main_sp_gain_file_name = PATH + 'volume/main_SPgain_sts.txt'

    MUTE_GAIN = -150 #  < web sp min + main sp min

    blocknums = [
        BlockNo.GAIN_USBinL,BlockNo.GAIN_BTinL,BlockNo.GAIN_CODECin,BlockNo.GAIN_AUXinL,
        BlockNo.GAIN_SPoutL,BlockNo.GAIN_USBoutL,BlockNo.GAIN_BToutL,BlockNo.GAIN_CODECout,BlockNo.GAIN_AUXoutL
        ]
    # if 'get' then L gain only ( because L=R )

    # --- command.jsonを作成 ---
    command = {
        'access': 'get',
        'block_no': None,
        'type': 'gain',
        'param': {'gain':None},
        }

    commands = []

    for i in range(0,len(blocknums)):
        commands.append(copy.copy(command))
        commands[i]['block_no'] = blocknums[i]

    with open(command_file_name, 'w') as f:
        # 辞書型をjsonとして出力
        json.dump(commands, f, indent=True)

    if send_command(command_file_name,result_file_name) == -1:
        now_store_flag = False
        ws_send = "dialog,DSP error"
        return ws_send

    with open(result_file_name, "r") as file:
        ws_send_rdata = json.load(file)

    gains = []
    gain_sts = []
    mute_sts = []

    for i in range(0,len(blocknums)) :
        if type(ws_send_rdata[i]["param"]["gain"]) is str:
            gains.append(-60)
        else:
            gains.append(round(float(ws_send_rdata[i]["param"]["gain"])))

    with open(mute_sts_file_name,'r') as f:
        gain_vals_input = f.readlines()
        gain_vals = gain_vals_input[1].strip().split(',')

    if gains[0] <= MUTE_GAIN:
        mute_sts.extend('0')   #USB in
        gain_sts.append(str(gain_vals[0]))
    else:
        mute_sts.extend('1')
        gain_sts.append(str(gains[0]))

    if gains[1] <= MUTE_GAIN:
        mute_sts.extend('0')   #BT in
        gain_sts.append(str(gain_vals[1]))
    else:
        mute_sts.extend('1')
        gain_sts.append(str(gains[1]))

    if gains[2] <= MUTE_GAIN:
        mute_sts.extend('0')   #Codec in
        gain_sts.append(str(gain_vals[2]))
    else:
        mute_sts.extend('1')
        gain_sts.append(str(gains[2]))

    if gains[3] <= MUTE_GAIN:
        mute_sts.extend('0')   #AUX in
        gain_sts.append(str(gain_vals[3]))
    else:
        mute_sts.extend('1')
        gain_sts.append(str(gains[3]))

    if gains[4] <= MUTE_GAIN:
        mute_sts.extend('0')   #SP out
        gain_sts.append(str(gain_vals[4]))
    else:
        mute_sts.extend('1')
        gain_sts.append(str(gain_vals[4]))

    if gains[5] <= MUTE_GAIN:
        mute_sts.extend('0')   #USB out
        gain_sts.append(str(gain_vals[5]))
    else:
        mute_sts.extend('1')
        gain_sts.append(str(gains[5]))

    if gains[6] <= MUTE_GAIN:
        mute_sts.extend('0')   #BT out
        gain_sts.append(str(gain_vals[6]))
    else:
        mute_sts.extend('1')
        gain_sts.append(str(gains[6]))

    if gains[7] <= MUTE_GAIN:
        mute_sts.extend('0')   #Codec out
        gain_sts.append(gain_vals[7])
    else:
        mute_sts.extend('1')
        gain_sts.append(str(gains[7]))

    if gains[8] <= MUTE_GAIN:
        mute_sts.extend('0')   #AUX out
        gain_sts.append(str(gain_vals[8]))
    else:
        mute_sts.extend('1')
        gain_sts.append(str(gains[8]))

    if os.path.exists(Preset_txt_gain) == True:
        with open(Preset_def_txt_gain, 'r') as f:
            Pre_Preset_GAIN = f.readlines()
        gain_line_len = 1 # Preset_gain.txt include line 1 comment
        for line in Pre_Preset_GAIN:
                if line[0] == "#":
                    continue
                else:
                    gain_line_len = gain_line_len + 1
    else:
        ws_send = 'dialog,System error (file not found)'
        now_store_flag = False
        return ws_send

    New_Preset_GAIN = []

    #if len(Pre_Preset_GAIN) != 33:
    #    ws_send = 'dialog,Invalid file. Check file settings.'
    #    now_store_flag = False
    #    return ws_send

    cnt = 0
    with open(Preset_txt_gain, 'w') as f:
        for i in range(0,gain_line_len):
            New_Preset_GAIN.append(Pre_Preset_GAIN[i].strip().split(','))
            if len(New_Preset_GAIN[i]) == 3 and i != 0:
                GAIN_data = New_Preset_GAIN[i]
                GAIN_data[1] = gain_sts[cnt]
                GAIN_data[2] = mute_sts[cnt]
                New_Preset_GAIN[i] = ",".join(GAIN_data)
                cnt = cnt + 1
            else:
                New_Preset_GAIN[i] = ",".join(New_Preset_GAIN[i])
            f.write(str(New_Preset_GAIN[i]))
            f.write("\n")

    RWMOUNT = sp.Popen("sudo mount -o remount,rw /", shell=True)
    RWMOUNT.wait()
    cmd = "cp " + Preset_txt_gain + " " + Preset_org_txt_gain
    COPY = sp.Popen(cmd, shell=True)
    COPY.wait()
    cmd = "cp " + Preset_txt_aec_nc + " " + Preset_org_txt_aec_nc
    COPY = sp.Popen(cmd, shell=True)
    COPY.wait()
    cmd = "cp " + Preset_txt_iir + " " + Preset_org_txt_iir
    COPY = sp.Popen(cmd, shell=True)
    COPY.wait()

    ROMOUNT = sp.Popen("sudo mount -o remount,ro /", shell=True)
    ROMOUNT.wait()

    ws_send = 'dialog,Store complete.'
    now_store_flag=False
    return ws_send

#######################################################################3
def Load_Preset(data,thisNAME_PATH):
    global now_load_flag
    if now_load_flag==True:
        #print(now_load_flag) #kura DEBUG
        return
    now_load_flag=True

    preset_nowloadNo_fname = thisNAME_PATH + 'preset/preset_nowloadNo.txt'
    # which presetNo save?
    if data[2] == 'p1':
        preset_no = 1
    elif data[2] == 'p2':
        preset_no = 2

    if Check_Preset_Data(preset_no,'/home/toa/TOA_AM-CF1/Application/data/preset/') == -1:
        ws_send = 'dialog,Invalid file. Check file settings.'
        now_load_flag=False
        return ws_send
    
    ### Process 1 : Make json from preset*.txt ###
    Make_Json_For_Load(preset_no)

    with open(preset_nowloadNo_fname,'w') as f:
        f.write(str(preset_no))

    ws_send = 'dialog,Load complete.'
    now_load_flag=False
    return ws_send

#######################################################################3
def Reset_Preset(data,thisNAME_PATH):
    global now_reset_flag
    if now_reset_flag==True:
        #print(now_reset_flag) #kura DEBUG
        return
    now_reset_flag=True
    PATH = os.path.join(thisNAME_PATH, '../../tmp/')

    # which presetNo save?
    if data[2] == 'p1':
        preset_no = 1
    elif data[2] == 'p2':
        preset_no = 2

    Preset_org_PATH = '/home_org/toa/TOA_AM-CF1/Application/data/'
    Preset_PATH = '/home/toa/TOA_AM-CF1/Application/data/'

    INIT_PRESET_FILES = [Preset_PATH + '/preset/preset0_aec_nc.txt',
                        Preset_PATH + '/preset/preset0_comp.txt',
                        Preset_PATH + '/preset/preset0_gain.txt',
                        Preset_PATH + '/preset/preset0_iir.txt']

    RESET_PRESET_FILES = [Preset_PATH + '/preset/preset' + str(preset_no) + '_aec_nc.txt',
                        Preset_PATH + '/preset/preset' + str(preset_no) + '_comp.txt',
                        Preset_PATH + '/preset/preset' + str(preset_no) + '_gain.txt',
                        Preset_PATH + '/preset/preset' + str(preset_no) + '_iir.txt']

    RESET_ORG_PRESET_FILES = [Preset_org_PATH + '/preset/preset' + str(preset_no) + '_aec_nc.txt',
                        Preset_org_PATH + '/preset/preset' + str(preset_no) + '_comp.txt',
                        Preset_org_PATH + '/preset/preset' + str(preset_no) + '_gain.txt',
                        Preset_org_PATH + '/preset/preset' + str(preset_no) + '_iir.txt']

    RWMOUNT = sp.Popen("sudo mount -o remount,rw /", shell=True)
    RWMOUNT.wait()

    ### Process 1 : preset0.txt to preset*.txt ###
    for i in range(0,len(INIT_PRESET_FILES)):
        cmd = "cp " + INIT_PRESET_FILES[i] + " " + RESET_PRESET_FILES[i]
        COPY = sp.Popen(cmd, shell=True)
        COPY.wait()
        cmd = "cp " + INIT_PRESET_FILES[i] + " " + RESET_ORG_PRESET_FILES[i]
        COPY = sp.Popen(cmd, shell=True)
        COPY.wait()

    ROMOUNT = sp.Popen("sudo mount -o remount,ro /", shell=True)
    ROMOUNT.wait()

    ws_send = 'dialog,Reset complete.'
    now_reset_flag=False
    return ws_send
