import json
import collections as cl
import re
import sys
import subprocess as sp
import copy
import os, time
import numpy as np

from hello.sum_gain_SPout import Sum_SP_Gain
from hello.send_command import send_command
import hello.def_block_no as BlockNo

# Countermeasure for continuous hits of APPLY button
s_volume_flag = False
s_audio_flag = False
s_EQ_flag = False


def getNearestValue(list, num):
    #param list: Data array
    #param num: input value
    #return input value nearest data array
    idx = np.abs(np.asarray(list) - num).argmin()
    return list[idx]

def getNearestIndex(list, num):
    #param list: Data array
    #param num: input value
    #return input value nearest data array
    idx = np.abs(np.asarray(list) - num).argmin()
    return idx

def Set_Volume(data,thisNAME_PATH):
    global s_volume_flag
    if s_volume_flag==True:
        #print(s_volume_flag) #kura DEBUG
        return
    s_volume_flag=True

    PATH = os.path.join(thisNAME_PATH, '../../tmp/')
    netlist_file_name = thisNAME_PATH + 'netlist.bin'
    control_out = thisNAME_PATH + 'control.out'
    FAIL_TIME = 1000
    MUTE_GAIN = -150 # < web_sp min + main_sp min
    blocknums = [
        BlockNo.GAIN_USBinL,BlockNo.GAIN_USBinR,BlockNo.GAIN_BTinL,BlockNo.GAIN_BTinR,BlockNo.GAIN_CODECin,BlockNo.GAIN_AUXinL,BlockNo.GAIN_AUXinR,
        BlockNo.GAIN_SPoutL,BlockNo.GAIN_SPoutR,BlockNo.GAIN_USBoutL,BlockNo.GAIN_USBoutR,BlockNo.GAIN_BToutL,BlockNo.GAIN_CODECout,BlockNo.GAIN_AUXoutL,BlockNo.GAIN_AUXoutR
        ]
    command_file_name = PATH + 'command/volume.json'
    result_file_name = PATH + 'result/volume.json'
    web_sp_gain_file_name = PATH + 'volume/web_SPgain_sts.txt'
    mute_sts_file_name = PATH + 'volume/mute_sts.txt'
    main_sp_gain_file_name = PATH + 'volume/main_SPgain_sts.txt'

	# --- command.jsonを作成 ---
    command = {
        'access': 'get',
        'block_no': None,
        'type': None,
        'config': {},
        'param': {},
        'status': {}
        }

    commands = []

    blocknums_2 = blocknums + blocknums

    #### SP OUT gain SUM txt write ####
    with open(web_sp_gain_file_name, 'w') as f:
        if (int(data[15]) == 1):
            f.write(data[6]) #合算用(SPOUTのみ)
            f.write('\n')
            f.write(data[15])
        else:
            f.write(data[6]) #合算用(SPOUTのみ)
            f.write('\n')
            f.write(data[15])

    for i in range(0,len(blocknums)*2):
        commands.append(copy.deepcopy(command))
        commands[i]['block_no'] = blocknums_2[i]
        commands[i]['type'] = 'gain'

    for i in range(0,len(blocknums)):
        commands[i]['access'] = 'set'
        commands[i]['param'] = {'gain':None}

    if (int(data[11]) == 1):
        commands[0]['param']['gain'] = int(data[2]) #USB in
        commands[1]['param']['gain'] = int(data[2]) #USB in
    else:
        commands[0]['param']['gain'] = MUTE_GAIN
        commands[1]['param']['gain'] = MUTE_GAIN

    if (int(data[12]) == 1):
        commands[2]['param']['gain'] = int(data[3]) #BT in
        commands[3]['param']['gain'] = int(data[3]) #BT in
    else:
        commands[2]['param']['gain'] = MUTE_GAIN #BT in
        commands[3]['param']['gain'] = MUTE_GAIN #BT in

    if (int(data[13]) == 1):
        commands[4]['param']['gain'] = int(data[4]) #Codec in
    else:
        commands[4]['param']['gain'] = MUTE_GAIN

    if (int(data[14]) == 1):
        commands[5]['param']['gain'] = int(data[5]) #AUX in
        commands[6]['param']['gain'] = int(data[5]) #AUX in
    else:
        commands[5]['param']['gain'] = MUTE_GAIN #AUX in
        commands[6]['param']['gain'] = MUTE_GAIN #AUX in

    if (int(data[16]) == 1):
        commands[9]['param']['gain'] = int(data[7]) #USB out
        commands[10]['param']['gain'] = int(data[7]) #USB out
    else:
        commands[9]['param']['gain'] = MUTE_GAIN #USB out
        commands[10]['param']['gain'] = MUTE_GAIN #USB out

    if (int(data[17]) == 1):
        commands[11]['param']['gain'] = int(data[8]) #BT out
    else:
        commands[11]['param']['gain'] = MUTE_GAIN #BT out

    if (int(data[18]) == 1):
        commands[12]['param']['gain'] = int(data[9]) #Codec out
    else:
        commands[12]['param']['gain'] = MUTE_GAIN

    if (int(data[19]) == 1):
        commands[13]['param']['gain'] = int(data[10]) #AUX out
        commands[14]['param']['gain'] = int(data[10]) #AUX out
    else:
        commands[13]['param']['gain'] = MUTE_GAIN #AUX out
        commands[14]['param']['gain'] = MUTE_GAIN #AUX out

    SP_gain_datas = Sum_SP_Gain(main_sp_gain_file_name,web_sp_gain_file_name)
    #SP_gain_datas [0]: main_gain [1]: web_gain [2]: DSP send_gain

    commands[7]['param']['gain'] = SP_gain_datas[2] #SP out
    commands[8]['param']['gain'] = SP_gain_datas[2] #SP out

    with open(command_file_name, 'w') as f:
        # 辞書型をjsonとして出力
        json.dump(commands, f, indent=True)

    if send_command(command_file_name,result_file_name) == -1:
        s_volume_flag = False
        ws_send = "dialog,DSP error"
        return ws_send

    with open(mute_sts_file_name, 'w') as f:
        f.write(",".join(data[11:20]))
        f.write("\n")
        f.write(",".join(data[2:11]))

    with open(result_file_name, "r") as file:
        ws_send_rdata = json.load(file)

    with open(result_file_name, "r") as file:
        ws_send_rdata = json.load(file)

    if (SP_gain_datas[1] != int(ws_send_rdata[7]["param"]["gain"]) - SP_gain_datas[0]):
        ws_send = 'dialog, DSP Error.'
        s_volume_flag = False
        return ws_send

    ws_send_data = []
    ws_send_data.append('volume')
    gains = []

    for i in range(0,len(blocknums)) :
        if type(ws_send_rdata[i]["param"]["gain"]) is str:
            gains.append(-60)
        else:
            gains.append(round(float(ws_send_rdata[i]["param"]["gain"]),1))

    with open(mute_sts_file_name,'r') as f:
        input_data = f.readlines()
        mute_sts = input_data[0].strip().split(",")
        gain_sts = input_data[1].strip().split(",")

    if mute_sts[0] == 0:
        ws_send_data.append(str(gain_sts[0]))   #USB in
    else:
        ws_send_data.append(str(gains[0]))

    if mute_sts[1] == 0:
        ws_send_data.append(str(gain_sts[1]))   #BT in
    else:
        ws_send_data.append(str(gains[2]))

    if mute_sts[2] == 0:
        ws_send_data.append(str(gain_sts[2]))   #Codec in
    else:
        ws_send_data.append(str(gains[4]))

    if mute_sts[3] == 0:
        ws_send_data.append(str(gain_sts[3]))   #AUX in
    else:
        ws_send_data.append(str(gains[5]))

    if mute_sts[4] == 0:
        ws_send_data.append(str(gain_sts[4]))   #SP out
    else:
        ws_send_data.append(str(SP_gain_datas[1]))

    if mute_sts[5] == 0:
        ws_send_data.append(str(gain_sts[5]))   #USB out
    else:
        ws_send_data.append(str(gains[9]))

    if mute_sts[6] == 0:
        ws_send_data.append(str(gain_sts[6]))   #BT out
    else:
        ws_send_data.append(str(gains[11]))

    if mute_sts[7] == 0:
        ws_send_data.append(str(gain_sts[7]))   #Codec out
    else:
        ws_send_data.append(str(gains[12]))

    if mute_sts[8] == 0:
        ws_send_data.append(str(gain_sts[8]))   #AUX out
    else:
        ws_send_data.append(str(gains[13]))

    ws_send_data.extend(mute_sts)

    ws_send = ",".join(ws_send_data)
    s_volume_flag = False
    return ws_send


def Set_Audio_Setting(data,thisNAME_PATH):
    global s_audio_flag
    if s_audio_flag==True:
        #print(s_audio_flag) #kura DEBUG
        return
    s_audio_flag=True

    PATH = os.path.join(thisNAME_PATH, '../../tmp/')
    netlist_file_name = thisNAME_PATH + 'netlist.bin'
    control_out = thisNAME_PATH + 'control.out'

    command_file_name = PATH + '/command/audio.json'
    result_file_name = PATH + '/result/audio.json'

    audio_setting_conf_file_name = PATH + '/audio/audio_set_conf.txt'

    FAIL_TIME = 1000
    blocknums = [BlockNo.BF,BlockNo.AEC,BlockNo.NC,BlockNo.BF,BlockNo.AEC,BlockNo.NC]
    # if 'get' then L gain only ( because L=R )

    with open(audio_setting_conf_file_name, 'w') as f:
        audio_setting_conf_w = data[2] + ',' +data[7]
        f.write(audio_setting_conf_w)


    cm_table = [0,10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,170,180,190,200,210,220,230,240,250,260,270,280,290,300,
                310,320,330,340,350,360,370,380,390,400,410,420,430,440,450,460,470,480,490,500,510,520,530,540,550,560,570,580,590,600]
    inch_table = [0,4,8,12,16,20,24,28,32,36,40,44,48,52,56,60,64,68,72,76,80,84,88,92,96,100,104,108,112,116,120,
                124,128,132,136,140,144,148,152,156,160,164,168,172,176,180,184,188,192,196,200,204,208,212,216,220,224,228,232,236,240]

    #inch cm transform
    if data[2] == 'inch':
        X1 = (-1) * cm_table[getNearestIndex(inch_table,int(data[3]))]/100
        X2 = cm_table[getNearestIndex(inch_table,int(data[4]))]/100
        depth_min = cm_table[getNearestIndex(inch_table,int(data[5]))]/100
        depth_max = cm_table[getNearestIndex(inch_table,int(data[6]))]/100
        dis = cm_table[getNearestIndex(inch_table,int(data[9]))]/100
    else:
        X1 = (-1) * getNearestValue(cm_table,int(data[3]))/100
        X2 = getNearestValue(cm_table,int(data[4]))/100
        depth_min = getNearestValue(cm_table,int(data[5]))/100
        depth_max = getNearestValue(cm_table,int(data[6]))/100
        dis = getNearestValue(cm_table,int(data[9]))/100

    #SENSING
    if data[7] == 'LOW':
        peak_th = -13
        sm_tc = 0.2
    elif data[7] == 'MID':
        peak_th = -15
        sm_tc = 0.2
    elif data[7] == 'HIGH':
        peak_th = -20
        sm_tc = 0.2

    if data[8] == 'Auto':
        update_mode = 'auto'
    else:
        update_mode = 'manual'

    if data[11] == 'ON':
        AEC_onoff = True
    else:
        AEC_onoff = False

    if data[12] == 'OFF':
        NC_onoff = True
    else:
        NC_onoff = False

    if data[13] == '6dB':
        reduction = -6
    elif data[13] == '9dB':
        reduction = -9
    else:
        reduction = -12

    # --- command.jsonを作成 ---
    command = {
        'access': 'get',
        'block_no': None,
        'type': None,
        'param': {}
    }

    commands = []

    for i in range(0,len(blocknums)):
        commands.append(copy.deepcopy(command))
        commands[i]['block_no'] = blocknums[i]
    commands[0]['access'] = 'set'
    commands[0]['type'] = 'microphonearray'
    commands[1]['access'] = 'set'
    commands[1]['type'] = 'aec'
    commands[2]['access'] = 'set'
    commands[2]['type'] = 'nc'
    commands[3]['type'] = 'microphonearray'
    commands[4]['type'] = 'aec'
    commands[5]['type'] = 'nc'

    commands[0]['param'] = {'dir':None,'dis':None,'update_mode':None}
    commands[0]['param']['doa']= {'peak_threshold':None,'smooth_tc':None,'source_pos_x_max':None,'source_pos_y_max':None,'source_pos_x_min':None,'source_pos_y_min':None}
    commands[1]['param'] = {'on':None}
    commands[2]['param'] = {'bypass':None,'reduction_level':None}

    commands[0]['param']['doa']['peak_threshold'] = peak_th
    commands[0]['param']['doa']['smooth_tc'] = sm_tc
    commands[0]['param']['doa']['source_pos_y_min'] = X1
    commands[0]['param']['doa']['source_pos_y_max'] = X2
    commands[0]['param']['doa']['source_pos_x_min'] = depth_min
    commands[0]['param']['doa']['source_pos_x_max'] = depth_max
    commands[0]['param']['update_mode'] = update_mode
    commands[0]['param']['dir'] = int(data[10])
    commands[0]['param']['dis'] = dis
    commands[1]['param']['on'] = AEC_onoff
    commands[2]['param']['bypass'] = NC_onoff
    commands[2]['param']['reduction_level'] = reduction

    commands[3]['param'] = {'dir':None,'dis':None,'update_mode':None}
    commands[3]['param']['doa']= {'peak_threshold':None,'smooth_tc':None,'source_pos_x_max':None,'source_pos_y_max':None,'source_pos_x_min':None,'source_pos_y_min':None}
    commands[4]['param'] = {'on':None}
    commands[5]['param'] = {'bypass':None,'reduction_level':None}

    with open(command_file_name, 'w') as f:
        # 辞書型をjsonとして出力
        json.dump(commands, f, indent=True)

    # --- control.out を実行 ---
    if send_command(command_file_name,result_file_name) == -1:
        s_audio_flag = False
        ws_send = "dialog,DSP error"
        return ws_send

    with open(result_file_name, "r") as file:
        ws_send_rdata = json.load(file)

    #inch or cm
    if data[2] == 'inch':
        X1 = inch_table[getNearestIndex(cm_table,(-1)*float(ws_send_rdata[0]['param']['doa']['source_pos_y_min'])*100)]
        X2 = inch_table[getNearestIndex(cm_table,float(ws_send_rdata[0]['param']['doa']['source_pos_y_max'])*100)]
        depth_min = inch_table[getNearestIndex(cm_table,float(ws_send_rdata[0]['param']['doa']['source_pos_x_min'])*100)]
        depth_max = inch_table[getNearestIndex(cm_table,float(ws_send_rdata[0]['param']['doa']['source_pos_x_max'])*100)]
        dis = inch_table[getNearestIndex(cm_table,float(ws_send_rdata[0]['param']['dis'])*100)]
    else:
        X1 = getNearestValue(cm_table, (-1)*float(ws_send_rdata[0]['param']['doa']['source_pos_y_min'])*100)
        X2 = getNearestValue(cm_table, float(ws_send_rdata[0]['param']['doa']['source_pos_y_max'])*100)
        depth_min = getNearestValue(cm_table, float(ws_send_rdata[0]['param']['doa']['source_pos_x_min'])*100)
        depth_max = getNearestValue(cm_table, float(ws_send_rdata[0]['param']['doa']['source_pos_x_max'])*100)
        dis = getNearestValue(cm_table, float(ws_send_rdata[0]['param']['dis'])*100)

    #SENSING
    if round(float(ws_send_rdata[3]['param']['doa']['peak_threshold'])) == -13:
        SENSING = 'LOW'
    elif round(float(ws_send_rdata[3]['param']['doa']['peak_threshold'])) == -15:
        SENSING = 'MID'
    elif round(float(ws_send_rdata[3]['param']['doa']['peak_threshold'])) == -20:
        SENSING = 'HIGH'

    if ws_send_rdata[3]['param']['update_mode'] == 'auto':
        update_mode = "Auto"
    else:
        update_mode = "Manual"

    if ws_send_rdata[4]['param']['on'] == True:
        AEC_onoff = "ON"
    else:
        AEC_onoff = "OFF"

    if ws_send_rdata[5]['param']['bypass'] == False:
        NC_onoff = "ON"
    else:
        NC_onoff = "OFF"

    ###SENSING###

    #############

    ws_send_data = []

    ws_send_data.append("audio")

    ws_send_data.append(data[2]) #inch or cm
    ws_send_data.append(str(int(X1))) #X1
    ws_send_data.append(str(int(X2))) #X2
    ws_send_data.append(str(int(depth_min))) #depthmin
    ws_send_data.append(str(int(depth_max))) #depthmax
    ws_send_data.append(SENSING) #sensing
    ws_send_data.append(update_mode) #mode
    ws_send_data.append(str(int(dis))) #dis
    ws_send_data.append(str(round(float(ws_send_rdata[3]['param']['dir'])))) #dir
    ws_send_data.append(AEC_onoff) #AEC_on/off
    ws_send_data.append(NC_onoff) #NC_on/off
    ws_send_data.append(str((-1)*round(float(ws_send_rdata[5]['param']['reduction_level']))) +"dB") #NC_reduction

    ws_send = ",".join(ws_send_data)
    s_audio_flag = False
    return ws_send


def Set_EQ(data,thisNAME_PATH):
    global s_EQ_flag
    if s_EQ_flag==True:
        #print(s_EQ_flag) #kura DEBUG
        return
    s_EQ_flag=True

    PATH = os.path.join(thisNAME_PATH, '../../tmp/')
    netlist_file_name = thisNAME_PATH + 'netlist.bin'
    control_out = thisNAME_PATH + 'control.out'

    command_file_name = PATH + '/command/EQ.json'
    result_file_name = PATH + '/result/EQ.json'

    FAIL_TIME = 1000

    if data[2] == 'SP':
        blocknums = [BlockNo.EQ_SPoutL,BlockNo.EQ_SPoutR]
        EQ_setting_param_file_name = PATH + '/EQ/EQSP_set_param.txt'
    elif data[2] == 'AUX':
        blocknums = [BlockNo.EQ_AUXoutL,BlockNo.EQ_AUXoutR]
        EQ_setting_param_file_name = PATH + '/EQ/EQAUX_set_param.txt'

    #data contents
    #[0]:send or read, [1]:EQ, [2]:SP or AUX
    #[3]~[7]:type
    #[8]~[12]:freq
    #[13]~[17]:q
    #[18]~[22]:gain

    typevals = data[3:8]
    freqvals = data[8:13]
    qvals = data[13:18]
    gainvals = data[18:23]

    typevals_t = data[3:8]
    freqvals_t = data[8:13]
    qvals_t = data[13:18]
    gainvals_t = data[18:23]

    typevals.extend(typevals)
    freqvals.extend(freqvals)
    qvals.extend(qvals)
    gainvals.extend(gainvals)

    # --- command.jsonを作成 ---
    command = {
        'access': 'get',
        'block_no': None,
        'type': 'iir',
        'param': {"stage":None,"type":None,"frequency":None,"q":None,"gain":None}
    }

    commands = []

    stage_no = 0
    for i in range(0,len(blocknums)*5):
        commands.append(copy.deepcopy(command))
        commands[i]['block_no'] = blocknums[int(i/5)]
        commands[i]['param']['stage'] = stage_no
        if stage_no == 4:
            stage_no = 0
        else:
            stage_no = stage_no + 1

    commands.extend(copy.deepcopy(commands))

    for i in range(0,10):
        commands[i]['access'] = 'set'
        commands[i]['param']['type'] = typevals[i]
        commands[i]['param']['frequency'] = float(freqvals[i])

        if commands[i]['param']['type'] == 'lpf12':
            commands[i]['param']['q'] = 0.718
            commands[i]['param']['gain'] = 0
            qvals_t[4] = '0.718'
            gainvals_t[4] = '0'
        elif commands[i]['param']['type'] == 'hpf12':
            commands[i]['param']['q'] = 0.718
            commands[i]['param']['gain'] = 0
            qvals_t[0] = '0.718'
            gainvals_t[0] = '0'
        else:
            commands[i]['param']['q'] = float(qvals[i])
            commands[i]['param']['gain'] = float(gainvals[i])

    with open(command_file_name, 'w') as f:
        # 辞書型をjsonとして出力
        json.dump(commands, f, indent=True)

    if send_command(command_file_name,result_file_name) == -1:
        s_EQ_flag = False
        ws_send = "dialog,DSP error"
        return ws_send

    with open(result_file_name, "r") as file:
        ws_send_rdata = json.load(file)

    ws_send_data = []
    re_typevals = []
    re_freqvals = []
    re_qvals = []
    re_gainvals = []

    if data[2] == 'SP':
        ws_send_data.append("EQ_SP")
    elif data[2] == 'AUX':
        ws_send_data.append("EQ_AUX")

    freq_table = [20.0,21.2,22.4,23.6,25.0,26.5,28.0,30.0,31.5,33.5,35.5,37.5,40.0,42.5,45.0,47.5,50.0,53.0,56.0,60.0,63.0,67.0,71.0,75.0,80.0,85.0,90.0,95.0,100.0,106.0,112.0,118.0,125.0,132.0,140.0,150.0,160.0,170.0,180.0,190.0,200.0,212.0,224.0,236.0,250.0,265.0,280.0,300.0,315.0,335.0,375.0,400.0,425.0,450.0,475.0,500.0,530.0,560.0,600.0,630.0,670.0,710.0,750.0,800.0,850.0,900.0,950.0,1000.0,1060.0,1120.0,1180.0,1250.0,1320.0,1400.0,1500.0,1600.0,1700.0,1800.0,1900.0,2000.0,2120.0,2240.0,2360.0,2500.0,2650.0,2800.0,3000.0,3150.0,3350.0,3550.0,3750.0,4000.0,4250.0,4500.0,4750.0,5000.0,5300.0,5600.0,6000.0,6300.0,6700.0,7100.0,7500.0,8000.0,8500.0,9000.0,9500.0,10000.0,10600.0,11200.0,11800.0,12500.0,13200.0,14000.0,15000.0,16000.0,17000.0,18000.0,19000.0,20000.0]
    q_table = [0.267,0.276,0.285,0.295,0.305,0.315,0.326,0.338,0.35,0.362,0.376,0.389,0.404,0.419,0.436,0.453,0.471,0.49,0.511,0.532,0.556,0.581,0.607,0.636,0.667,0.683,0.7,0.718,0.736,0.756,0.776,0.797,0.819,0.843,0.867,0.893,0.92,0.948,0.979,1.011,1.044,1.08,1.119,1.16,1.204,1.25,1.301,1.355,1.414,1.445,1.478,1.512,1.548,1.585,1.624,1.665,1.707,1.752,1.8,1.85,1.902,1.958,2.016,2.079,2.145,2.215,2.29,2.371,2.456,2.549,2.648,2.755,2.871,2.997,3.134,3.285,3.45,3.633,3.836,4.063,4.318,4.608,4.938,5.319,5.764,6.289,6.919,7.689,8.651,9.889,11.538,13.847,17.31,23.081,34.623,69.249]

    for i in range(0,int(len(ws_send_rdata)/4)):
        if ws_send_rdata[i]['param']['type'] == 'peq':
            re_typevals.append('PEQ')
        elif ws_send_rdata[i]['param']['type'] == 'hpf12':
            re_typevals.append('HPF')
        elif ws_send_rdata[i]['param']['type'] == 'lpf12':
            re_typevals.append('LPF')

        re_freqvals.append(str(getNearestValue(freq_table,float(ws_send_rdata[i]['param']['frequency']))))

        re_qvals.append(str(getNearestValue(q_table,float(ws_send_rdata[i]['param']['q']))))
        re_gainvals.append(str(round(float(ws_send_rdata[i]['param']['gain']),1)))

    ws_send_data.extend(re_typevals + re_freqvals + re_gainvals + re_qvals)

    with open(EQ_setting_param_file_name,'w') as f:
        f.write(",".join(typevals_t))
        f.write('\n')
        f.write(",".join(freqvals_t))
        f.write('\n')
        f.write(",".join(qvals_t))
        f.write('\n')
        f.write(",".join(gainvals_t))
        f.write('\n')

    #ws_send_data.append()
    ws_send = ",".join(ws_send_data)
    s_EQ_flag=False
    return ws_send
