function Faders(screen) {
    
    var mod = this;
    mod.screen = screen;
    mod.type = "fader";
    mod.fader = ".slide";
    mod.cursorWrap = ".vol-wrapper";
    mod.cursor = ".vol";

    mod.init = function() {
        app.addUpdateFunc(mod.screen, mod.type, mod.updateFunc);
        mod.updateAllValues(false);
        mod.events();
    }

    mod.updateFunc = function(value, trigger) {
        var response;
        if( value>=limits[mod.screen].fader.min && value<=limits[mod.screen].fader.max && value%limits[mod.screen].fader.step==0) {
            this.value = value;
            mod.updateValue(this.parentID, trigger);
            response = "ok";
        }
        else {
            console.log("[FADER] Incorrect value");
            response = "invalid";
        }
        return response;
    }

    mod.updateAllValues = function(trigger) {
        $(mod.fader).each(function() {
            var controlID = $(this).attr("control-id");
            mod.updateValue(controlID, trigger);
        });
    }

    mod.updateValue = function(controlID, trigger) {
        var $fader = $(mod.fader+"[control-id='"+controlID+"']");
        var $cursor = $fader.find(mod.cursor);
        var data = app.getControlData(mod.screen, controlID);
        if( data.fader.value%limits[mod.screen].fader.step==0 ) {
            var per = ((data.fader.value-limits[mod.screen].fader.min)/(limits[mod.screen].fader.max-limits[mod.screen].fader.min))*100;
            $cursor.css("bottom", per+"%");
            if( trigger==null || trigger==true ) {
                $(window).trigger("valueUpdated");
                $(mod.fader).trigger(controlID+"ValueUpdated");
            }
        }
        else console.log("[FADER] "+controlID+": value not respect step limit");
    }

    mod.updateCursor = function(e) {

        var $cursor = $(mod.cursor+".dragging").not(".disabled");
        var $wrap = $cursor.parents(mod.cursorWrap);
        var $fader = $cursor.parents(mod.fader);
        var controlID = $fader.attr("control-id");

        if( $cursor.length>0 ) {
            var y = e.pageY - $wrap.offset().top + ($cursor.outerHeight()/2);
            var per = 100 - ((y*100)/$wrap.outerHeight());
            if( per<0 ) per = 0;
            else if( per>100 ) per = 100;
            $cursor.css("bottom", per+"%");
            var data = app.getControlData(mod.screen, controlID);
            var range = limits[mod.screen].fader.min-limits[mod.screen].fader.max;
            data.fader.value = parseInt(range-((per*range)/100));
            $(window).trigger("valueUpdated");
            $(mod.fader).trigger(controlID+"ValueUpdated");
        }

    }

    mod.events = function() {
        
        $(mod.cursor).on("mousedown", function(e) {
            if( !$(this).parents(mod.fader).hasClass("disabled") ) {
                $(this).addClass("dragging"); 
                mod.updateCursor(e);
            }
        });
        $(document).on("mouseup", function() {
            $("*").removeClass("dragging"); 
        });

        $(document).on("mousemove", function(e) {
            mod.updateCursor(e);
        });

    }
    
    mod.getDom = function() {
        return $(mod.fader);
    }
    
    mod.getType = function() {
        return mod.type;
    }

}