function Listboxes(screen, type) {

    var mod = this;
    mod.screen = screen;
    mod.type = type;
    mod.listbox = ".listbox." + mod.type;

    mod.init = function () {
        app.addUpdateFunc(mod.screen, mod.type, mod.updateFunc);
        mod.updateAllValues(false);
        mod.events();
    }

    mod.updateFunc = function (value, trigger) {
        var response;
        if (limits[mod.screen][mod.type].indexOf(value) >= 0) {
            this.value = value;
            mod.updateValue(this.parentID, trigger);
            if ($('#filter1_fc').length) {
                changePeq_1();
                changePeq_2();
                changePeq_3();
                changePeq_4();
                changePeq_5();
            }
            response = "ok";
        }
        else {
            console.log("[LISTBOX] Incorrect value");
            response = "invalid";
        }
        return response;
    }

    mod.updateAllValues = function (trigger) {
        $(mod.listbox).each(function () {
            var controlID = $(this).attr("control-id");
            mod.updateValue(controlID, trigger);
        });
    }

    mod.updateValue = function (controlID, trigger) {
        var $listbox = $(mod.listbox + "[control-id='" + controlID + "']");
        var data = app.getControlData(mod.screen, controlID);
        $listbox.val(data[mod.type].value).trigger("change");
        if (trigger == null || trigger == true) {
            $(window).trigger("valueUpdated");
            $(mod.listbox).trigger(controlID + "ValueUpdated");
        }
    }

    mod.events = function () {
        $(mod.listbox).on("select2:select", function () {
            if (!$(this).hasClass("disabled")) {
                var controlID = $(this).attr("control-id");
                var data = app.getControlData(mod.screen, controlID);
                data[mod.type].updateValue($(this).val());
            }
        });
    }

    mod.getDom = function () {
        return $(mod.listbox);
    }

    mod.getType = function () {
        return mod.type;
    }

}