function Toggles(screen, type) {
    
    var mod = this;
    mod.screen = screen;
    mod.type = type;
    mod.toggle = ".toggle-btn."+mod.type;

    mod.init = function() {
        app.addUpdateFunc(mod.screen, mod.type, mod.updateFunc);
        mod.updateAllValues(false);
        mod.events();
    }
    
    mod.updateFunc = function(value, trigger) {
        var response;
        if( value==limits[mod.screen][mod.type].value1 || value==limits[mod.screen][mod.type].value2 ) {
            this.value = value;
            mod.updateValue(this.parentID, trigger);
            response = "ok";
        }
        else {
            console.log("[TOGGLE] Incorrect value");
            response = "invalid";
        }
        return response;
    }

    mod.updateAllValues = function(trigger) {
        $(mod.toggle).each(function() {
            var controlID = $(this).attr("control-id");
            mod.updateValue(controlID, trigger);
        });
    }

    mod.updateValue = function(controlID, trigger) {
        var $toggle = $(mod.toggle+"[control-id='"+controlID+"']");
        var data = app.getControlData(mod.screen, controlID);
        if( data[mod.type].value==limits[mod.screen][mod.type].value1 ) {
            if( $toggle.hasClass("choice") ) {
                $toggle.find(".value1").addClass("on");
                $toggle.find(".value2").removeClass("on");
            }
            else $toggle.addClass("selected");
        }
        else if( data[mod.type].value==limits[mod.screen][mod.type].value2 ) {
            if( $toggle.hasClass("choice") ) {
                $toggle.find(".value2").addClass("on");
                $toggle.find(".value1").removeClass("on");
            }
            else $toggle.removeClass("selected");
        }
        
        if( trigger==null || trigger==true ) {
            $(window).trigger("valueUpdated");
            $(mod.toggle).trigger(controlID+"ValueUpdated");
        }
    }

    mod.events = function() {
        $(mod.toggle).on("click", function() {
            if( !$(this).hasClass("disabled") ) {
                var controlID = $(this).attr("control-id");
                var data = app.getControlData(mod.screen, controlID);
                if( data[mod.type].value==limits[mod.screen][mod.type].value1 ) {
                    data[mod.type].value=limits[mod.screen][mod.type].value2;
                }
                else if( data[mod.type].value==limits[mod.screen][mod.type].value2 ) {
                    data[mod.type].value=limits[mod.screen][mod.type].value1;
                }
                mod.updateValue(controlID);
            }
        });
    }
    
    mod.getDom = function() {
        return $(mod.toggle);
    }
    
    mod.getType = function() {
        return mod.type;
    }

}