/**
 * TOA - PA SYSTEM
 * button.js
 */


//hpf,lpf,peqのボタンON/OFF (htmlのON/OFFを書き換えている)
//changeHpfでグラフ描画


//グラフ描画
var TRI_GRAPH = {
	FS: 48000,
	PARTING: 24,
	BASE: 1000,
	NUL: { a1: 0, a2: 0, b0: 0, b1: -1, b2: 0 }
};

TRI_GRAPH.PEQ1 = TRI_GRAPH.NUL;
TRI_GRAPH.PEQ2 = TRI_GRAPH.NUL;
TRI_GRAPH.PEQ3 = TRI_GRAPH.NUL;
TRI_GRAPH.PEQ4 = TRI_GRAPH.NUL;
TRI_GRAPH.PEQ5 = TRI_GRAPH.NUL;
TRI_GRAPH.HPF = TRI_GRAPH.NUL;
TRI_GRAPH.LPF = TRI_GRAPH.NUL;

var gFc, gF, H_p1, H_p2, H_p3, H_p4, H_p5, H_h, H_l, y;

function graphDraw() {
	//id=graghの要素を取得
	var graph = document.getElementById('graph');
	//2Dコンテキストのオブジェクトをctxに格納
	var ctx = graph.getContext('2d'),
		peq1 = TRI_GRAPH.PEQ1,
		peq2 = TRI_GRAPH.PEQ2,
		peq3 = TRI_GRAPH.PEQ3,
		peq4 = TRI_GRAPH.PEQ4,
		peq5 = TRI_GRAPH.PEQ5,
		hpf = TRI_GRAPH.HPF,
		lpf = TRI_GRAPH.LPF;
	//背景の色で描画画面を塗りつぶす
	graphClear(ctx);
	//図形を変形
	ctx.setTransform(3.11, 0, 0, 3.25, -10, 17.5);
	//線を描くと宣言
	ctx.beginPath();
	//枠線の色を指定（e67e22とは16進数の色コード(e67e22)
	ctx.strokeStyle = '#e67e22';
	//var Fc, F, H_p1, H_p2, H_p3, H_p4, H_p5, H_h, H_l, y;
	var dev = [];
	var dev2 = [];
	for (var x = -136; x < 105; x++) {
		//math.pow(a,b)でaをb乗する
		gFc = Math.pow(2, x / TRI_GRAPH.PARTING);
		//tofixed(a)でaだけ小数点表記
		gFc = gFc.toFixed(9) * 1000,
		gF = gFc.toFixed(9),
		H_p1 = transfer(peq1, gF, 'P1');
		H_p2 = transfer(peq2, gF, 'P2');
		H_p3 = transfer(peq3, gF, 'P3');
		H_p4 = transfer(peq4, gF, 'P4');
		H_p5 = transfer(peq5, gF, 'P5');
		H_h = transfer(hpf, gF, 'H');
		H_l = transfer(lpf, gF, 'L');
		y = H_p1 + H_p2 + H_p3 + H_p4 + H_p5 + H_h + H_l;
		//pushで配列の後ろに追加
		dev.push(x + ' :P1=' + H_p1 + ' :P2=' + H_p2 + ' :P3=' + H_p3 + ' :P4=' + H_p4 + ' :P5=' + H_p5 + ' H=' + H_h + ' L=' + H_l);
		dev2.push(gFc);
		//lineto(a,b)で(a,b)に直線を引く
		ctx.lineTo(144 + x, 17 - y);
	}
	//線を描画
	ctx.stroke();
};


//背景の色で描画画面を塗りつぶす
function graphClear(obj) {
	var ctx = obj;
	ctx.clearRect(0, -20, 755, 200);
};

//transfer
function transfer(obj, F, type) {
	var o = obj;

	var omg = 2 * Math.PI * F / TRI_GRAPH.FS,
		omg = parseFloat(omg.toFixed(9), 10),
		cos_r = parseFloat(Math.cos(-1 * omg).toFixed(9), 10),
		cos_i = parseFloat(Math.cos(-2 * omg).toFixed(9), 10),
		sin_r = parseFloat(Math.sin(-1 * omg).toFixed(9), 10),
		sin_i = parseFloat(Math.sin(-2 * omg).toFixed(9), 10);
	var numerator_r = (o.b0 - 0) + (((o.b1 - 0) * (cos_r - 0)) + ((o.b2 - 0) * (cos_i - 0)));
	//var numerator_r = Math.round(Number(numerator_r) * 100000) / 100000;							// a
	var numerator_i = o.b1 * sin_r + o.b2 * sin_i;
	//var numerator_i = Math.round(Number(numerator_i) * 100000) / 100000;							// b
	var numerator = numerator_r + numerator_i;
	var denominator_r = parseFloat(1 + o.a1 * cos_r + o.a2 * cos_i, 10);
	//var denominator_r = Math.round(Number(denominator_r) * 100000) / 100000;												// c
	var denominator_i = parseFloat(o.a1 * sin_r + o.a2 * sin_i, 10);
	//var denominator_i = Math.round(Number(denominator_i) * 100000) / 100000;						// d
	var denominator = denominator_r * denominator_r + denominator_i * denominator_i;
	//var denominator = Math.round(Number(denominator) * 100000) / 100000;
	var denom = parseFloat(denominator_r * denominator_r + denominator_i * denominator_i, 10);
	var r = (numerator_r * denominator_r + numerator_i * denominator_i) / denom;
	var r = r.toFixed(9);
	var i = (numerator_i * denominator_r - numerator_r * denominator_i) / denom;
	var i = i.toFixed(9);
	// var z = Math.sqrt(r * r + i * i);
	// var z = z.toFixed(9);
	// var g = 20 * Math.log10(z);
	var g = 20 * (Math.LOG10E * Math.log(Math.sqrt(r * r + i * i)));
	// denomer.push(type + ': a=' + numerator_r + ' b=' + numerator_i + ' c=' + denominator_r + ' d=' + denominator_i + ' num=' + numerator + ' den=' + denominator + ' denom=' + denom);
	// denomer.push(type + ': ω=' + omg + ' cos_r=' + cos_r + ' cos_i=' + cos_i + ' sin_r=' + sin_r + ' sin_i=' + sin_i);
	// omega.push(type + ' : a1=' + o.a1 + ' a2=' + o.a2 + ' b0=' + o.b0 + ' b1=' + o.b1 + ' b2=' + o.b2 + ' g=' + g);
	// omega.push((o.b0 +'') + (((o.b1 +'') +'*'+  (cos_r +'')) +'+'+ ((o.b2 +'') +'*'+ (cos_i +''))));

	return parseFloat(g.toFixed(3), 10);
};

//spinnerの値でグラフ座標設定
function changeValue(el_f, el_q, el_g, type, Fc, tilt, q, g) {

	if (type === 'HPF') {
		if (tilt === null) tilt = 12;
		if (Fc === null) Fc = $('#filter1_fc').text();
		Fc = $('#filter1_fc').text();
		data = coefficientHPF(Fc, tilt);
	} else if (type === 'LPF') {
		if (tilt === null) tilt = 12;
		if (Fc === null) Fc = $('#filter5_fc').text();
		Fc = $('#filter5_fc').text();
		//Fc = parseFloat(Fc) * 1000.0; // kHz -> Hz // 2015/04/09 (by 51.0) : 元々Hzでの設定なので単位の変換は不要
		tilt = 12;
		data = coefficientLPF(Fc, tilt);
	} else {
		if (Fc === null) Fc = $(el_f).text();
		if (q === null) q = $(el_q).text();
		if (g === null) g = $(el_g).text();
		Fc = $(el_f).text();
		q = $(el_q).text();
		g = $(el_g).text();
		data = coefficientPEQ(Fc, q, g);
	};
	return data;
};

//spinnerの値でグラフ描画
//function changeHpf(Fc, tilt) {
//	TRI_GRAPH.HPF = changeValue('HPF', Fc, tilt, null, null);
//	graphDraw();
//};
//function changeLpf(Fc, tilt) {
//	TRI_GRAPH.LPF = changeValue('LPF', Fc, tilt, null, null);
//	graphDraw();
//};
function changePeq_1() {
	type_f1 = controls.EQ.FILTERS.filter1.filter1.value;
	TRI_GRAPH.PEQ1 = changeValue('#filter1_fc','#filter1_q','#filter1_gain',type_f1, null, null, null, null);
	//graphDraw();
};

function changePeq_2() {
	TRI_GRAPH.PEQ2 = changeValue('#filter2_fc','#filter2_q','#filter2_gain','PEQ', null, null, null, null);
	//graphDraw();
};

function changePeq_3() {
	TRI_GRAPH.PEQ3 = changeValue('#filter3_fc','#filter3_q','#filter3_gain','PEQ', null, null, null, null);
	//graphDraw();
};

function changePeq_4() {
	TRI_GRAPH.PEQ4 = changeValue('#filter4_fc','#filter4_q','#filter4_gain','PEQ', null, null, null, null);
	//graphDraw();
};

function changePeq_5() {
	type_f5 = controls.EQ.FILTERS.filter2.filter2.value;
	TRI_GRAPH.PEQ5 = changeValue('#filter5_fc','#filter5_q','#filter5_gain',type_f5, null, null, null, null);
	graphDraw();
};

//1:Digital Filter Coefficient
function coefficientPEQ(Fc, Q, G) {
	var self = {};
	var Tx = Math.tan(Math.PI * Fc / TRI_GRAPH.FS),
		Tx2 = Tx * Tx,
		k = Math.pow(10, (Math.abs(G) / 20)); // 2015/04/09 (by 51.0) : G の絶対値を取るのが抜けていた

	if (G < 0) {
		var a1 = 2 * (Tx2 - 1) / (1 + (k * Tx / Q) + Tx2),
			a2 = (1 - (k * Tx / Q) + Tx2) / (1 + (k * Tx / Q) + Tx2),
			b0 = (1 + (Tx / Q) + Tx2) / (1 + (k * Tx / Q) + Tx2),
			b1 = 2 * (Tx2 - 1) / (1 + (k * Tx / Q) + Tx2),
			b2 = (1 - (Tx / Q) + Tx2) / (1 + (k * Tx / Q) + Tx2);
	} else {
		var a1 = 2 * (Tx2 - 1) / (1 + (Tx / Q) + Tx2),
			a2 = (1 - (Tx / Q) + Tx2) / (1 + (Tx / Q) + Tx2),
			b0 = (1 + (k * Tx / Q) + Tx2) / (1 + (Tx / Q) + Tx2),
			b1 = 2 * (Tx2 - 1) / (1 + (Tx / Q) + Tx2),
			b2 = (1 - (k * Tx / Q) + Tx2) / (1 + (Tx / Q) + Tx2);
	}

	self.a1 = Math.round(a1 * 1000000000) / 1000000000;
	self.a2 = Math.round(a2 * 1000000000) / 1000000000;
	self.b0 = Math.round(b0 * 1000000000) / 1000000000;
	self.b1 = Math.round(b1 * 1000000000) / 1000000000;
	self.b2 = Math.round(b2 * 1000000000) / 1000000000;
	return self;
};

function coefficientHPF(Fc, Tilt) {
	var self = {};
	var cos = Math.cos(2 * Math.PI * Fc / TRI_GRAPH.FS),
		alf1 = 1, alf2 = 1,
		Tx = Math.tan(Math.PI * Fc / TRI_GRAPH.FS) * 1,
		Tx = Math.ceil(Tx * 1000000000) / 1000000000,
		Tx2 = Tx * Tx;

	if (Tilt === 6) {
		var a1 = (1 - Tx) / (1 + Tx) * -1,
			a2 = 0,
			b0 = 1 / (1 + Tx),
			b1 = -1 * b0,
			b2 = 0;
	} else if (Tilt === 12) {
		//			BAKUP
		//			var Q1 = 1 / Math.sqrt(2),
		//				a1 = -1 * (2 * (1 - Tx2) / (1 + Tx / Q1 + Tx2)),
		//				a2 = (1 - Tx / Q1 + Tx2) / (1 + Tx / Q1 + Tx2),
		//				b0 = 1 / (1 + Tx / Q1 + Tx2),
		//				b1 = -1 * (2 * b0),
		//				b2 = b0;

		var Q1 = 1 / Math.sqrt(2),
			Q1 = Math.round(Q1 * 1000000000) / 1000000000;
		// var Q1 = 0.707,
		// AB5 = 1 / SQRT(2)
		a1 = -1 * 2 * (1 - (Tx * Tx)) / (1 + Tx / Q1 + Tx * Tx),
			// AD5 = -1 * 2 * (1 - ($L$5 * $L$5)) / (1 + $L$5 / AB5 + $L$5 * $L$5)
			a2 = (1 - Tx / Q1 + Tx * Tx) / (1 + Tx / Q1 + Tx * Tx),
			// AE5 = (1 - $L$5 / AB5 + $L$5*$L$5) / (1+ $L$5 / AB5 + $L$5 * $L$5)
			b0 = 1 / (1 + Tx / Q1 + Tx * Tx),
			// AF5 = 1 / (1 + $L$5 / AB5 + $L$5 * $L$5)
			b1 = -1 * 2 * b0,
			// AG5 = -1 * 2 * AF5
			b2 = b0;
		// AH5 = AF5
	}

	self.a1 = Math.round(a1 * 1000000000) / 1000000000;
	self.a2 = Math.round(a2 * 1000000000) / 1000000000;
	self.b0 = Math.round(b0 * 1000000000) / 1000000000;
	self.b1 = Math.round(b1 * 1000000000) / 1000000000;
	self.b2 = Math.round(b2 * 1000000000) / 1000000000;
	return self;
};


/*	LPF
	2015/04/09 (by 51.0) : 式がエクセル通りなことを確認済み
 -------------------------------------------------------------------------------- */
function coefficientLPF(Fc, Tilt) {

	var self = {};
	var cos = Math.cos(2 * Math.PI * Fc / TRI_GRAPH.FS),
		alf1 = 1, alf2 = 1,
		Tx = Math.tan(Math.PI * Fc / TRI_GRAPH.FS) * 1,
		Tx2 = Tx * Tx;

	if (Tilt === 6) {
		var a1 = -1 * ((1 - Tx) / (1 + Tx)),
			a2 = 0,
			b0 = Tx / (1 + Tx),
			b1 = b0,
			b2 = 0;
	} else if (Tilt === 12) {
		var Q1 = 1 / Math.sqrt(2),
			a1 = -1 * (2 * (1 - Tx2) / (1 + Tx / Q1 + Tx2)),
			a2 = (1 - Tx / Q1 + Tx2) / (1 + Tx / Q1 + Tx2),
			b0 = Tx2 / (1 + Tx / Q1 + Tx2),
			b1 = 2 * b0,
			b2 = b0;
	}

	self.a1 = Math.round(a1 * 10000000000) / 10000000000;
	self.a2 = Math.round(a2 * 10000000000) / 10000000000;
	self.b0 = Math.round(b0 * 10000000000) / 10000000000;
	self.b1 = Math.round(b1 * 10000000000) / 10000000000;
	self.b2 = Math.round(b2 * 10000000000) / 10000000000;
	return self;
};
