#!/bin/sh
#*************************************************
#          etc_change.sh
#                        ver.1.0.0.8
#*************************************************
#set -e
set -x

etc_src_dir=/home/toa/etc_new/;
etc_dir=/etc/;
boot_src_dir=/home/toa/boot_new/;
boot_dir=/boot/;
#etc_etc_src_dir=/home/toa/UPDATE_TEST/home/toa/etc_new/; for DEBUG
#etc_dir=/home/toa/UPDATE_TEST/etc/; for DEBUG

ChangeOwnerPermissionOfIPAddressFiles() {

    ## Change owner to root
    FILES_TO_CHANGE_OWNER_ROOT='
        /home/toa/StartupShell/ipaddress.conf
    /home_org/toa/StartupShell/ipaddress.conf
        /home/toa/TOA_AM-CF1/Webserver/static/js/ws_set.js
    /home_org/toa/TOA_AM-CF1/Webserver/static/js/ws_set.js
        /home/toa/TOA_AM-CF1/Application/data/config/config_net.txt
    /home_org/toa/TOA_AM-CF1/Application/data/config/config_net.txt
    ' # end of quote
    for file in ${FILES_TO_CHANGE_OWNER_ROOT}
    do
        chown root:root ${file}
    done
    
    ## Change permission to 777
    FILES_TO_CHANGE_PERMISSION_777='
        /home/toa/StartupShell/ipaddress.conf
    /home_org/toa/StartupShell/ipaddress.conf
        /home/toa/TOA_AM-CF1/Application/data/config/config_net.txt
    /home_org/toa/TOA_AM-CF1/Application/data/config/config_net.txt
        /home/toa/TOA_AM-CF1/Webserver/static/js/ws_set.js
    /home_org/toa/TOA_AM-CF1/Webserver/static/js/ws_set.js
    ' # end of quote
    for file in ${FILES_TO_CHANGE_PERMISSION_777}
    do
        chmod 777 ${file}
    done
}

echo "AM-CF1_Firm_Update FileCopy_2nd-process Copy etc START"
#
#*************************************************
# Change /etc files
#*************************************************

cd /home/toa/etc_new;

chown -R root:root .

# etc boot file permission modify
chmod -R 777 ./config
chmod -R 777 ./preset

chmod 755 ./ufw
chmod 640 ./ufw/user6.rules
chmod 640 ./ufw/user.rules
chmod 644 ./ufw/ufw.conf
chmod 755 ./systemd
chmod 644 ./systemd/journald.conf
chmod 755 ./ssh
chmod 644 ./ssh/sshd_config
chmod 755 ./samba
chmod 644 ./samba/smb.conf
chmod 755 ./php
chmod 755 ./php/7.1
chmod 755 ./php/7.1/apache2
chmod 644 ./php/7.1/apache2/php.ini
chmod 755 ./logrotate.d
chmod 644 ./logrotate.d/unattended-upgrades
chmod 644 ./logrotate.d/ufw
chmod 644 ./logrotate.d/speech-dispatcher
chmod 644 ./logrotate.d/samba
chmod 644 ./logrotate.d/rsyslog
chmod 644 ./logrotate.d/ppp
chmod 644 ./logrotate.d/pm-utils
chmod 644 ./logrotate.d/php7.0-fpm
chmod 644 ./logrotate.d/lightdm
chmod 644 ./logrotate.d/dpkg
chmod 644 ./logrotate.d/cups-daemon
chmod 644 ./logrotate.d/aptitude
chmod 644 ./logrotate.d/apt
chmod 644 ./logrotate.d/apport
chmod 644 ./logrotate.d/apache2
chmod 755 ./init.d
chmod 755 ./init.d/saveoverlays
chmod 755 ./cron.hourly
chmod 755 ./cron.hourly/logrotate
chmod 755 ./apt
chmod 755 ./apt/apt.conf.d
chmod 644 ./apt/apt.conf.d/20auto-upgrades
chmod 755 ./apache2
chmod 644 ./apache2/apache2.conf
chmod 640 ./shadow
chmod 755 ./rc.local
chmod 644 ./logrotate.conf
chmod 644 ./localtime
chmod 644 ./fstab
chmod 644 ./crontab

# for inspection (TVC ver1.0.0.11)
rm -r /home/toa/TOA_AM-CF1/Application/data/config/*.txt
rm -r /home/toa/TOA_AM-CF1/Application/data/preset/*

cp -r ./config ../TOA_AM-CF1/Application/data/
cp -r ./preset ../TOA_AM-CF1/Application/data/
cp -r ./config /home_org/toa/TOA_AM-CF1/Application/data/
cp -r ./preset /home_org/toa/TOA_AM-CF1/Application/data/

rm -r ./config
rm -r ./preset
################
# etc dir move
rm etc_boot_change.sh

for file in `\find ./ -type f -not -name 'etc_change.sh'`;
do
    cp -p -r -f $etc_src_dir$file $etc_dir$file;
done;

mount -o remount,ro /;

# boot dir move
cd /home/toa/boot_new;

mount -o remount,rw /boot;

chown -R root:root .

chmod 755 ./config.txt
chmod 755 ./cmdline.txt

for file in `\find ./ -type f`;
do
    cp -p -r -f $boot_src_dir$file $boot_dir$file;
done;
mount -o remount,ro /boot;

### Change directory to where will be not deleted
cd /home/toa

mount -o remount,rw /;

#*************************************************
# For updating from older than 1.3.0.2
#*************************************************
#permission modify home var
chmod 777 /home/toa/;
chmod -R 777 /home/toa/TOA_AM-CF1/;
chmod -R 777 /home/toa/StartupShell/;
chmod -R 777 /var/www/html/;
chmod 600 /home/toa/StartupShell/chkfile_dat.tar.xz

chown root:root /home/toa/;
chown -R root:root /home/toa/TOA_AM-CF1/;
chown -R root:root /home/toa/StartupShell/;
chown -R root:root /var/www/html/;

## delete ** from home_org,var_org
rm -r /home_org/toa/TOA_AM-CF1;
rm -r /home_org/toa/StartupShell;
rm -r /var_org/www/html;

## file copy home,var -> home_org,var_org
cp -r -f /home/toa/TOA_AM-CF1/ /home_org/toa/;
cp -r -f /home/toa/StartupShell/ /home_org/toa/;
cp -r -f /var/www/html/ /var_org/www/;

#permission modify home_org var_org (again)
chmod 777 /home_org/toa/;
chmod -R 777 /home_org/toa/TOA_AM-CF1/;
chmod -R 777 /home_org/toa/StartupShell/;
chmod -R 777 /var_org/www/html/;
chmod 600 /home_org/toa/StartupShell/chkfile_dat.tar.xz

chown root:root /home_org/toa/;
chown -R root:root /home_org/toa/TOA_AM-CF1/;
chown -R root:root /home_org/toa/StartupShell/;
chown -R root:root /var_org/www/html/;

ChangeOwnerPermissionOfIPAddressFiles

## delete for upgrade from v1.1.2.1
rm -r /home/toa/boot_new;

## delete **_new from home_org,var_org
rm -r /home_org/toa/TOA_AM-CF1_new;
rm -r /home_org/toa/StartupShell_new;
rm -r /var_org/www/html_new;
rm -r /home_org/toa/boot_new
rm -r /home_org/toa/etc_new

rm /home_org/toa/TOA_AM-CF1/install.log
cp -p -f /home/toa/TOA_AM-CF1/install.log /home_org/toa/TOA_AM-CF1/;

sync;sync;sync

if sh /home/toa/StartupShell/chkfile_for_update.sh ; then
    rm /home/toa/TOA_AM-CF1/install.log;
    rm /home_org/toa/TOA_AM-CF1/install.log;
else
    echo "# Chk file Contents/Owner/Permission NG #" ### The stdout of this program is redirected to "/home/toa/TOA_AM-CF1/install.log"
    rm /home_org/toa/TOA_AM-CF1/install.log
    cp -p -f /home/toa/TOA_AM-CF1/install.log /home_org/toa/TOA_AM-CF1/;
fi


sync;
sleep 3;
sync;
sleep 3;
sync;
sleep 3;

#*************************************************
# Remove /etc files
#*************************************************
# rm {UNNECESSARY_FILE};


#*************************************************
# Move /etc files
#*************************************************
# cp {OLD_DIR}/{FILENAME} {NEW_DIR}/{FILENAME};
# rm {OLD_DIR}/{FILENAME};

#add 20171025 ver1.0.1.15
#touch /home/toa/TOA_AM-CF1/REBOOT_2nd;

#add 20171201 ver1.0.2.1
