<?php

//DjangoからApacheのAjax実行の許可（本当は*をDjangoのOriginにしたいが。。。）
header('Access-Control-Allow-Origin: *');

//アップロードされたファイルをローカルに保存し、
//ファイルのバリデーションをして正常であれば解凍→展開→再起動するスクリプト

$uploaddir = '/var/www/file/';
$uploadfile = basename($_FILES['userfile']['name']);
$upload = $uploaddir . $uploadfile;
$update_foldername="config";

$json_array = array(); //json出力用array
$messages = array();  //errorメッセージ格納

//var/www/file以下全削除
shell_exec("rm -rf /var/www/file");

//正常にファイルがアップロードされたかを確認する
switch ($_FILES['userfile']['error']) {
  case UPLOAD_ERR_OK:
    //value: 0; ファイルが正常に送信された。
    break;
  case UPLOAD_ERR_INI_SIZE:
    //value: 1; php.iniで定めたupload_max_filesizeを超えている
    $messages[] = 'Please upload file smaller than '
      . ini_get('upload_max_filesize') . 'B';
    break;
  case UPLOAD_ERR_FORM_SIZE:
    //value: 2; HTML formで指定されたMAX_FILE_SIZEを越えている
    $messages[] = 'Please upload file smaller than '
      . ($_POST['MAX_FILE_SIZE'] / 1000) . 'KB';
    break;
  case UPLOAD_ERR_PARTIAL:
    //value: 3; アップロードされたファイルは一部のみしかアップロードされていない
    $messages[] = 'Connection error. Please upload again.';
    break;
  case UPLOAD_ERR_NO_FILE:
    //value: 4; ファイルがアップロードされなかった
    $messages[] = 'Select a file to upload.';
    break;
  case UPLOAD_ERR_NO_TMP_DIR:
    //value: 6; tmpフォルダが無い
    $messages[] = 'System error';
    break;
  default:
    //UPLOAD_ERR_CANT_WRITE: value: 7; ディスクへの書込に失敗
    //UPLOAD_ERR_EXTENSION: value: 8; ファイルのアップロードが拡張モジュールによって停止された
    $messages[] = 'System error';
    break;
}

//その他エラー（不正アクセス等）の場合
if (!$messages && !is_uploaded_file($_FILES['userfile']['tmp_name'])) {
  $messages[] = 'System error';
}

//errorが無ければ処理を進める
if ($messages) {
  echo "<b>error: $messages[0]</b>";
  echo nl2br("\n");
} else {
  // ファイルが選択されている場合拡張子チェック
  $fileType = pathinfo($_FILES['userfile']["name"], PATHINFO_EXTENSION);
  //.binのみ受付
  if ($fileType == 'cf1c') {
    //ファイル名が英数字 _ - .だけかチェックする
    if (is_ansi($uploadfile)) {
      //アップロードファイルを$uploadへ移動
      if (move_uploaded_file($_FILES['userfile']['tmp_name'], $upload)) {
          echo "<b>Upload success.</b>";
          echo nl2br("\n");
                  
          /// 最初から結果が出力されるように、多数の空白を出力する
          echo str_repeat( ' ', 1024 );

          //ファイルを解凍
          $output = shell_exec("xz -dc $uploaddir$uploadfile | tar xfv - -C $uploaddir");

          //アップロードファイルにパーミッション付加(所有者、グループ、他ユーザ（読み(4)、書き(2)、実行(1))）
          chmod("$uploaddir$uploadfile", 0777);
          chmod($uploaddir . "config", 0777);

          //ファイルチェック
          $check_result = intval(shell_exec("python3 /home/toa/TOA_AM-CF1/Application/data/check_preset_config_uploded_input.py $uploaddir$update_foldername/"));
          $json_array += array("check_result" => $check_result);

          //IPチェック
          //$ip_check_result = intval(exec("python3 "));
          //$json_array += array("file_check_result" => $ip_check_result);

          //SMチェック

      }
    } else {
      $messages[0] = "File name must be alphanumeric and/or special characters . _ - .";
      echo $messages[0];
      echo nl2br("\n");
    }
  } else {
    $messages[0] = "Select .cf1c file.";
    echo $messages[0];
    echo nl2br("\n");
  }
  echo nl2br("\n");
}

$json_array += array("error_messages" => $messages[0]);

//jsonpファイル作成
$json = json_encode( $json_array , JSON_PRETTY_PRINT|JSON_UNESCAPED_UNICODE|JSON_UNESCAPED_SLASHES );
header("Content-Type: text/javascript; charset=utf-8"); // JSONP用のヘッダを定義して出力
$jsonp = sprintf("callback(%s);", $json);
echo $jsonp;

$filename = "./jsonp_upload_php.js";
$fp = fopen($filename, 'w');    //w':上書き保存（無ければ作成）
fwrite($fp, $jsonp);
chmod($filename, 0777);
fclose($fp);

//ファイル名が英数字 _ - .だけかチェックする関数
function is_ansi( $str ) {
  if (strlen($str) <= 0)  return false;
  if (preg_match("/[^A-Za-z0-9_\.\-]/", $str))
    return false;
  else
    return true;
}


