#!/bin/sh

#IPアドレスを変更するシェルスクリプト

# 現状、サブネットマスクは２４ビット固定

# 引数１：IPアドレス（例：192.168.14.20）
# 引数２：サブネットマスク
# 引数３：デフォルトゲートウェイ

# www-dataにsudo nmcli権限(pwなし)を渡している

sudo mount -o remount,rw /;

# 各htmlページのapacheのIPを書き換える
dir="/home/toa/TOA_AM-CF1/Webserver/static/js/";
sed -i -e '2, 2d' ${dir}ws_set.js;
sed -i -e "1a var NOW_IPADDRESS =\"$1\";" ${dir}ws_set.js;

# set /home/toa/StartupShell/ipaddress.conf
sh /var/www/html/set_ipaddress.conf.sh $1 $2 $3;

#ファイル書き換え終了時にroへ
sudo mount -o remount,ro /;

#NetworkManager start
sudo service NetworkManager start
sudo service NetworkManager-wait-online start

#必要なconnection名取得 add 20171030 kura
ifname=$(ifconfig | grep enx | cut -d' ' -f1);

# UUIDを取得して削除
uuid=$(nmcli -t -f uuid c);
sudo nmcli connection delete $uuid;

# Get Subnet mask bit
submask=`sh /home/toa/StartupShell/calc_subnet_bit.sh $2`;

# 新しい接続を追加する
sudo nmcli c add type ethernet ifname $ifname con-name $ifname;

# ipアドレスを変更する
sudo nmcli c m $ifname ipv4.method manual ipv4.addresses "$1/$submask" ipv4.gateway $3 connection.autoconnect "yes" ipv6.method ignore;

# 変更を反映する
sudo nmcli con down $ifname;
sudo nmcli con up $ifname;

#NetworkManager stop
sudo service NetworkManager-wait-online stop
sudo service NetworkManager stop

# django起動
sudo killall AMCF1-WebServer;
sudo python3 /home/toa/TOA_AM-CF1/Webserver/manage.py runserver --insecure 0.0.0.0:8000;

